/* Linux/Intel. from old MPW 3.3 version, Jun 2003. MPW p2c  */
/* from QFermat, Jan, Feb, Mar, Apr 2004. MPW p2c  */

/* version 3.4.7, Jul 2004. 3.5.3 Mar 2005. 3.5.6 Jun 2005
   3.6.9 Dec 2005.  3.8.0 Oct 2006

  initialize_2 useses with bblock and bblck1. beware of changing to long long */

#include <stddef.h>
#include <types.h>
#include <limits.h>
#include <setjmp.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "Builtins.h"
/*#include "PStrings.h"*/
#include "PSets.h"
#include <signal.h> 

#include <time.h>  /* Feb 2010 */

#include "ferm120.h"
#include "fer320.h"
#include "fer220.h"
#include "fer221.h"
#include "stash.h"


short i;
char xxx;  /* Jun 2003 */
jmp_buf buf98;
sigjmp_buf buf9999; /* Jul 2004 fix cntl-c problem */

double tx;
double ty;
long long tll;
long long tmm;

long badcnt;  /* Apr2 2011 */

 void showtime( )  /* Feb 2010 */
     {
       time_t ltime;         /* calendar time */  
       ltime = time(NULL);   /* get current cal time */  
       fprintf(stdout, "%s", asctime( localtime(&ltime) ) );
      }

/* void error(long x, tokentipe *bad); */

/**************************************************************************/

/*  void check_cmd_keys(void)
{   obsolete
  KeyMap mykeys;

  if (TickCount() % cmd_modder == 0) {
    GetKeys(&mykeys);
    if (mykeys[55])
      if (mykeys[56])
        error(0, &blank);
      else 
        error(-1, &blank);
  }

}  */

/********************************************************************************/

void check_and_assign(long k, quolyptr q )
{
  /* q nil or irrelevant on input */
  quolyptr x;

  x = &(*arp[BSR(k, 10)])[BAnd(k, tenmask)];
  if (*x == NULL) {
    quoly_set(0, x);
    uninit++;                                /* Jul 2002 */
    if (uninit < 21)
      fprintf(stdout, "Warning. Uninitialized array element has been set to 0.\n");
    else if (uninit == 21)
      fprintf(stdout, " ....etc...\n");
  }
  *q = *x;
}

/*************************************************************************/

void fermat_error(/*bigstring*/char * mess, Boolean push)
              /* there are two of these. Other is in fer320 */

{
  fprintf(stdout, "*** Fermat error. ");
  fprintf(stdout, "%s\n", mess);
  fflush(stdout);
  if (push) 
    error(-1, &blank);
}

/******************************************************************************/

void parse(textptr inf, quolyptr n, nameptr *flag);

/****************************************************************************/

void expre(textptr inf, quolyptr *qp, quolyptr n, colm_ptrptr *aux, LongIntPtr colpos, nameptr *flag);

/****************************************************************************/

void half_expre(textptr inf, quolyptr n, nameptr *flag);

/*Nov 1997*/

/*****************************************************************************/

void arr_parse(char x, textptr inf, quolyptr n, nameptr *flag);

/****************************************************************************/

void old_expre(textptr inf, quolyptr n, nameptr *flag);

/*Nov 1997*/

/****************************************************************************/

void error(long x, tokentipe *bad)
{
  
  /* report errors or push new command level.  If bad >= 0, we "go down" to the
     basic interpreter level.  If bad < 0, we "go up" to a new level. Going up can only
     be the result of a user command, whether explicit or via &e.  Going down results
     from an ordinary error (if were up in the first place), from &¹, or from &# =>
     bad = 0. Pushing is very tricky - the resetting of globals is subtle.  So is
     the timing: the three global arrays mytime, breaktime, and timeoff are used. */
  
  long i;                                         /* kill localtime*/
  long real_count;
  long line_count;   /* Jun 2011 */
	long old_func_def_count;
  statptr u;
  quoly newnum;
  tokentipe oldtok;
  Boolean old_tt_flag;
  Boolean old_done_load;
  Boolean shouldpush;
  Boolean old_doing_sys;
  Boolean old_lint;
  Boolean old_command_int;
  Boolean old_int_flag;
  Boolean old_mod_mode;
  Boolean firstpass;
  nameptr myzilch;
  bigstring message;
  char xx;  /* Jun 2003 */

  short cnt;    /* Jul 2007. These things added to prevent display of hundreds of identical names. */
  nametype pname;  /* Jul 2007 */
  
  /* fprintf(stdout, " err: %1d\n", x); */

  if (x == 0 && was_modulus > 0)
  /* Jul 2002. panic stop out of involuntary modularmode situation in
     which rat mode was turned on for the convenience of the user.  Put
     modularmode back.  Should now be just like it was before May 2002. */
  {
    modulus = was_modulus;
    /* a fail safe. Hope the user didn't do anything complicated while
       in rat mode. */
    modularmode = true;
    lintmode = true;
    was_modulus = -1;
  }
  
  myzilch = NULL;
  
  shouldpush = errorpush && (statcount > 0 || levelcount > 1);
  
  if (x >= 0 && using_new_polynames)              /*bug, May 1996*/
    resume_old_polynames();
  
  want_sparse = false;
  in_sys_func = false;     /* Apr 2007 */
  uninit = 0;                                     /* Jul 2002 */
  tripval = 20;                                   /* Dec 2003 */
  if (x >= 0) {
    reset_pseudo_poly();                          /* August 1996; mentioned May 1996 */
    minus_warning = false;                        /* August 1996 */
    total_cnt = 0;                                /* Nov 1996 */
    sp_total_cnt = 0;                             /* Nov 1996 */
    lagrangedepth = 0;                            /* Sep 1997 */
    c_cntcount = 0;                               /* Mar 2001 */
    c_cntdepth = 0;                               /* Dec 2003 */
    a_cntcount = 0;                               /* Dec 2001 */
    d_cntcount = 0;                               /* Dec 2001 */
    g_cntcount = 0;                               /* Nov 2002 */
    g_cutoff = default_gc;                                 /* Nov 2002 */
    dumpitt_length = 0;
    dumpitt_level = 0;
    alg_c_count = 0;           /* Mar 2008 */
		original_depth = 1;   /* Feb 2011 */
  }
  
  if (x > 0) {					/* standard error */
    was_modulus = -1;		    /* Jul 2002 */
    ustrcpy(blankone, " ");     /* May 2006, bug fix */
  }

  warn_cnt = 0;   /* Oct 2011 */
	
	if (extra_line) 
    fprintf(stdout, "\n");
  if (ustrcmp(bad->name, "¥") == 0)   /* the old omega */
    ustrcpy(bad->name, ";");
  if (x > 0)                                      /* standard error */
    if (levelcount == 1 || x != 19 && x != 22) {
      fprintf(stdout, "*** Inappropriate symbol: %s\n", bad->name);
      out_err_mess(x);
      if (x == 139) {
        fprintf(stdout, "that you have just deleted.  Any reference to this parameter \n");
        fprintf(stdout, "%s may crash Fermat. There may be other such dangling array parameters.\n", 
                bad->name);
      }
    } else {
      warning(x, bad->name);
      finish = NULL;
      return;
    }
  else if (x == 0) {
    fprintf(stdout, "*** Panic stop.\n");
    if (levelcount == 1 && statcount == 0) 
      fprintf(stdout, "    You were already at the lowest level.\n");  /* June 1997 */
    if (was_in_rat && modularmode) {              /* involuntary modularmode */
      fprintf(stdout, "\n");                      /* Jul 2002, part of message below */
      fprintf(stdout, "*** You have interrupted at a delicate time. You are now in modular arithmetic.  Beware!\n");
      fprintf(stdout, "    Your variables are unreadable and unusable.  If you wish\n");
      fprintf(stdout, "    to revert, do &(p=_i:) .\n");  /* Apr 2004 */
      fprintf(stdout, "\n");
    }
  } else 
    fprintf(stdout, "*** New command level.\n");
  
  if (x == 132) {
    fprintf(stdout, "Here is the last line read:\n");
    listrht(&Output, true, last_good_one, last_comm, 4);
    fprintf(stdout, "\n");
    fprintf(stdout, "*** Definition of %s cancelled.\n", current_func.name);
  }
  if (x == 103 || x == 38 || x == 129 && func_def_count > 0) {
    fprintf(stdout, "Here is the last line successfully read:\n");
    i = 0;
    listchars(&Output, last_attached, &i, &firstpass, false);  /* firstpass not mnemonic */
    fprintf(stdout, "\n");
    fprintf(stdout, "*** Definition of %s cancelled.\n", current_func.name);
  }
  
  if (x >= 0 && !tt_flag)                       /* were reading from a file */
                                                  /* Mar 2001; x>=0 */
    if (inpuf != NULL) {   /* bug fix from dickk, dick3 Feb 2011 */
			fprintf(stdout, "*** Stopped right before this:\n");  /* Mar 2001; Stopped */
			ufgets(message, sizeof(message)-1, inpuf);
			fprintf(stdout, "%s\n", message);
			ufgets(message, sizeof(message)-1, inpuf);
			fprintf(stdout, "%s\n", message);
			ufgets(message, sizeof(message)-1, inpuf);
			fprintf(stdout, "%s\n", message);
			if (close_inpuf) {                            /* Mar 2001 */
				fclose(inpuf);
				fprintf(stdout, "\n");
				fprintf(stdout, "*** Closing file %s\n", input_file_name);
				ustrcpy(input_file_name, "");
    }
  }
  
  if (x > 0 && tt_flag && finish != NULL) {
    fprintf(stdout, "*** Error occurred at this point:\n");
    s2 = start;
    while (true) {
      fprintf(stdout, "%s", s2->let.name);
      if (s2 == finish) 
        break;
      else 
        s2 = s2->next;
    }
    if (statcount > 0) 
      fprintf(stdout, "\n");
  }
  
  finish = NULL;
  leave_flag = false;
  exit_flag = false;
  cycle_flag = false;
  cancelflag = false;
  matrix_eval = 0;
  syst_dump = false;
  
  /* Manage the status information .*/
  if (statcount > 0) 
    fprintf(stdout, "*** The most recent function evaluations were:\n");
  if (statcount < statsize) 
    real_count = statcount;
  else 
    real_count = statsize;
  u = lastf;
  
  ustrcpy(pname, "");  /* Jul 2007. big change below */
  cnt = 0;  
  line_count = 0;     /* Jun 2011 */
	fprintf(stdout, " ");
  if (x == 0 || x > 0 && !shouldpush) {
    for (i = 1; i <= real_count; ++i) {             /* May 2003 */
      if (ustrcmp(pname, lastf->f->name.name) == 0) {   /* Jul 2007 */
				if (cnt >= 9) {
					cnt++;
					remove_args(lastf->f, true);
					lastf = lastf->prev;
					continue;
				}
				else {
					cnt++;
					line_count ++;   /* Jun 2011 */
					fprintf(stdout, "%s ", lastf->f->name.name);	
				}
			}
			else {
				if (cnt > 9) 
					fprintf(stdout, " ... %d more with this name. \n", cnt - 9);
				fprintf(stdout, "%s ", lastf->f->name.name);
				line_count ++;   /* Jun 2011 */
				ustrcpy(pname, lastf->f->name.name);
				cnt = 0;  
			}
			if (line_count % 20 == 0)  /* Jun 2011 */
				fprintf(stdout, "\n ");
      remove_args(lastf->f, true);
	    lastf = lastf->prev;
    }
    if (cnt > 9)   /* Jul 2007 */
	    fprintf(stdout, " ... %d more with this name. \n", cnt - 9);
  }

  else {
    for (i = 1; i <= real_count; ++i) {             /* May 2003 */
      if (ustrcmp(pname, u->f->name.name) == 0) {   /* Jul 2007 */
				if (cnt >= 9) {
					cnt++;
					u = u->prev;
					continue;
				}
				else {
					cnt++;
					line_count ++;   /* Jun 2011 */
					fprintf(stdout, "%s ", u->f->name.name);	
				}
	    }
			else {
				if (cnt > 9) 
					fprintf(stdout, " ... %d more with this name. \n", cnt - 9);
				fprintf(stdout, "%s ", u->f->name.name);
				ustrcpy(pname, u->f->name.name);
				line_count ++;   /* Jun 2011 */
				cnt = 0;  
			}
      u = u->prev;
			if (line_count % 20 == 0)  /* Jun 2011 */
				fprintf(stdout, "\n ");
    }
    if (cnt > 9)   /* Jul 2007 */
	    fprintf(stdout, " ... %d more with this name. \n", cnt - 9);
  }
  
  if (startexpr != NULL || prev_expr != NULL) {
    fprintf(stdout, "\n");                        /* Nov 2000 */
    fprintf(stdout, "*** Function was interrupted at:\n");
  }
  i = 0;
  while (prev_expr != NULL) {
    if (ustrcmp(prev_expr->let.name, "¥") != 0)   /* the old omega */
      fprintf(stdout, "%s", prev_expr->let.name);
    else 
      fprintf(stdout, ";");
    i += ustrlen(prev_expr->let.name);
    if (i > 68) {
      fprintf(stdout, "\n");
      i = 0;
    }
    prev_expr = prev_expr->next;
    if (prev_expr == NULL) 
      fprintf(stdout, "\n");
  }
  while (startexpr != NULL && startexpr != currentchar) {
    if (ustrcmp(startexpr->let.name, "¥") != 0)   /* the old omega */
      fprintf(stdout, "%s", startexpr->let.name);
    startexpr = startexpr->next;
  }
  if (extra_line) 
    fprintf(stdout, "\n");
  startexpr = NULL;
  prev_expr = NULL;
  currentchar = NULL;
  
  old_mod_mode = modularmode;
  if (mod_is_changed > 0) {
    modularmode = true;
    lintmode = true;
  }
  old_tt_flag = tt_flag;
  old_done_load = done_load;
  old_func_def_count = func_def_count;
  old_doing_sys = doing_sys_func;
  old_int_flag = integerflag;
  doing_sys_func = false;
  integerflag = false;
  old_lint = lintmode;
  
  tt_flag = true;
  func_def_count = 0;
  
  newnum = NULL;                                  /*more below */
  oldtok = token;
  
  if (x == 0 || x > 0 && !shouldpush) {
    statcount = 0;
    if (dupptr != NULL && ustrcmp(duparr->name.name, "dup") == 0) 
      for (i = 0; i <= duparr->stop; ++i) 
        free_quoly(&(*dupptr)[i]);
    dupptr = NULL;
    ustrcpy(duparr->name.name, "  ");
    mod_mode_matrix_in_use = false;
    using_spsort = false;    /* Sep2 2010 */
    if (lookupgcd > 0) 
      free_gcd_stash();
    if (globalpoly > 0) {                         /* June 1998 */
      fprintf(stdout, "\n");
      fprintf(stdout, "*** You have interrupted at a delicate time. The global poly table has been\n");
      fprintf(stdout, "    changed. Your variables that are polynomials are unreadable and unusable.\n");
      fprintf(stdout, "    Beware!  You should probably quit immediately.\n");
      fprintf(stdout, "\n");
      globalpoly = 0;
    }
  }
  
  if (x < 0 || x > 0 && shouldpush) {
    levelcount++;
    if (levelcount > 9) {
      fprintf(stdout, "*** Highest legal command level is 9.\n");
      error(0, &token);
    }
    
    if (was_in_rat && modularmode) {              /* involuntary modularmode */
      modularmode = false;                        /* May 2002 */
      lintmode = false;                           /* May 2002, message below too */
      was_modulus = modulus;                      /* July 2002 */
      fprintf(stdout, "\n");
      /* @ below Jul 2002 */
      fprintf(stdout, "*** You have interrupted at a delicate time. Fermat had switched\n");
      fprintf(stdout, "    internally to arithmetic mod p. It has switched back for your \n");
      fprintf(stdout, "    convenience during this interrupt. Do not do any significant \n");
      fprintf(stdout, "    polynomial computations.  To abort, enter &@ followed by  &(p=_i:) .\n");
      fprintf(stdout, "\n");  /*  above &(p=_i:)   Apr 2004 */
    }
    
    if (globalpoly > 0) {                         /* June 1998 */
      fprintf(stdout, "\n");
      fprintf(stdout, "*** You have interrupted at a delicate time. The global poly table has been\n");
      fprintf(stdout, "    changed. Your variables that are polynomials are unreadable and unusable.\n");
      fprintf(stdout, "    Beware! (You can use ZZ3 to display a variable.)\n");
      fprintf(stdout, "\n");  /* Dec 2009 */
    }
    
    RecordTime(breaktime,time_level-1); /*AAR*/
/*  breaktime[time_level - 1] = TickCount(); */
    time_level++;
    time_off[time_level - 1][0] = 0;  /*AAR*/
    time_off[time_level - 1][1] = 0;
    
    old_command_int = command_int;
    command_int = false;                          /*Dec 1997*/
    firstpass = true;
    
    if (x < 0)              /* will later pick it up again at this point. */
       /* too dangerous to try if x > 0.   GIVE UP ON THIS FOR NOW. Jun 2003  ???
         save_input_stream(&myzilch);   */  
       myzilch = NULL;  /* Jun 2004, I think we need this. */
  
    fflush(Output);
    if (prompt[0] != (char)13)
       fflush(stdout);
    fprintf(stdout, "%1d", levelcount);
    if (promptsize > 0) {
       fprintf(stdout, "%s", prompt);
       rewind(Input);   /*  Note! better than getc.  Jun 2003 */
    } else 
        trash = fgetc(stdin);
    ustrcpy(leftover, "");   
    
    /* interpretive loop */
    while (true) {
      scanner(&Input, &token, &zilch);
      if (firstpass) {
        command_int = old_command_int;            /*Dec 1997*/
        firstpass = false;
      }
      RecordTime(mytime,time_level-1); /*AAR */
/*    mytime[time_level - 1] = TickCount(); */
      
      xx = token.name[0];   /* Jun 2003 */
      if (ustrcmp(token.name, "Diag") == 0)
        xx = '~';
      if (ustrcmp(token.name, "Trans") == 0)
        xx = '"';

      switch (xx) {                    /*spar*//* ':',*/

        case '!':
        case ';':
          parse(&Input, &newnum, &zilch);
          break;
        case '~':
        case '[':
        case '"':
          arr_parse(xx, &Input, &newnum, &zilch);
          break;
        case 'A':
          if (ustrcmp(token.name, "Adjoint") == 0 || ustrcmp(token.name, "Altmult") == 0 ||
	      ustrcmp(token.name, "Altpower") == 0)
            arr_parse('A', &Input, &newnum, &zilch);
          else 
            old_expre(&Input, &newnum, &zilch);
          break;
        case 'M':
          if (ustrcmp(token.name, "MPowermod") == 0)   /* Mar 1999 */
            arr_parse('M', &Input, &newnum, &zilch);
          else 
            old_expre(&Input, &newnum, &zilch);
          break;
        default:
          parse(&Input, &newnum, &zilch);
          break;
        /* Nov 1997 expre(input, newnum, zilch) */
      }
      { unsigned long timetemps[1][2];  /*AAR*/  /* Feb 2010, unsigned */
        RecordTime(timetemps,0);
        mytime[time_level-1][0] = timetemps[0][0] - mytime[time_level-1][0]-time_off[time_level-1][0];
        mytime[time_level-1][1] = timetemps[0][1] - mytime[time_level-1][1]-time_off[time_level-1][1];
        time_off[time_level - 1][0] = 0;
        time_off[time_level - 1][1] = 0;
      }
/*
      mytime[time_level - 1] = (TickCount() - mytime[time_level - 1]) - time_off[time_level - 1];
      time_off[time_level - 1] = 0;
*/
      if (newnum == NULL) 
        quoly_set(0, &newnum);
      if (ustrcmp(token.name, ";") != 0 && ustrcmp(token.name, "¥") != 0 &&
          ustrcmp(token.name, "@") != 0 && ustrcmp(token.name, ":") != 0)
        error(129, &token);
      finish = NULL;
      /* cntcount := 0;  Mar 2001   remove this Aug 2001 */
      if (time_to_quit) {
        time_to_quit = false;
        if (was_modulus > 0) 
          modulus = was_modulus;                  /* Jul 2002. failsafe */
        was_modulus = -1;                         /* Jul 2002 */
        levelcount--;
        time_level--;
	{ unsigned long timetemps[1][2]; /*AAR*/  /* Feb 2010, unsigned */
          RecordTime(timetemps,0);
          time_off[time_level-1][0] += timetemps[0][0]-breaktime[time_level-1][0];
          time_off[time_level-1][1] += timetemps[0][1]-breaktime[time_level-1][1];
        }
        /* AAR
        time_off[time_level - 1] = time_off[time_level - 1] + TickCount() - breaktime[time_level - 1];
	*/
        fprintf(stdout, "*** Resuming earlier command level\n");
        fflush(stdout);
        free_quoly(&newnum);
        token = oldtok;
        tt_flag = old_tt_flag;
        done_load = old_done_load;
        func_def_count = old_func_def_count;
        doing_sys_func = old_doing_sys;
        integerflag = old_int_flag;
        lintmode = old_lint;
        modularmode = old_mod_mode;
        zilch = myzilch;
        break;
      }
      if (ustrcmp(token.name, ":") != 0) {
        if (syst_dump && noisy) 
          arrdisplay(&Output, true, false, &syst->name, syst, 0, syst->rows, 
                     (syst->stop + 1) / (syst->rows), addresser, addresser, 
                     syst->rows, 4, false, false, true, stash);
        if (extra_line) 
          fprintf(stdout, "\n");
        if (noisy) 
          fflush(stdout);
        dummy = 0;
        if (ustrcmp(token.name, "@") != 0 && noisy) 
          quoly_display(&Output, true, true, true, newnum, &dummy, 
                        &semicolon, polynames, false, true, false);
        if (polynames == NULL && noisy && extra_line) 
          fprintf(stdout, "\n");
      } else if (extra_line) 
        fprintf(stdout, "\n");
      syst_dump = false;
      if (timerflag) {
        ReportTime(mytime,time_level-1);
	/*  AAR
        fprintf(stdout, " Elapsed time: %ld\n",mytime[time_level]/1);
	*/
        if (extra_line) 
          fprintf(stdout, "\n");
      }
      fflush(Output);
      free_quoly(&prevnum);
      prevnum = newnum;
      newnum = NULL;
      if (prompt[0] != (char)13) 
         fflush(stdout);
      fprintf(stdout, "%1d", levelcount);
      if (promptsize > 0) {
         fprintf(stdout, "%s", prompt);
         getc(Input);
         for (i = 2; i <= promptsize; ++i) 
           trash = fgetc(stdin);
      } else 
         trash = fgetc(stdin);
    }
  } else {
    levelcount = 1;
    time_level = 1;
    time_off[0][0] = 0;
    time_off[0][1] = 0;
    /*time_off[0] = 0; AAR*/
    fflush(stdout);
    first_available = 1;
    mod_is_changed = 0;
    ustrcpy(token.name, "");                   /* these two lines?*/
    token.address = -1;
    sysnum = NULL;  /* BUG fix Apr 2006 */
    /* goto 9999 (in */
    siglongjmp(buf9999, 0 /* Jul 2004 */);
  }                                               /* main interpretive loop */
}

/***************************************************************************/

void new_worknode(LongIntPtr p, tokentipe *x)
{
  
  if (first_available > worksize) 
    error(88, x);
  else if (workhead[first_available - 1] == NULL) {
    new(workhead[first_available - 1]);
    first_available++;
  } else   /* has been used before. can assume nothing about the quoly pointers in it. */
    first_available++;
  
  *p = first_available - 1;
  if (*p < 1 || *p > worksize) 
    fermat_error("first available.", false);
}

/*****************************************************************************/

void calc_disp(Boolean ask, long size)
{
  
  long i;
  /* remove useless dsign Jun 2003 */
  quoly n;
  Boolean oldmodmode;

  if (ask) {
    fprintf(stdout, "Enter display size. \n");
    do_prompts();
    scanner(&Input, &token, &zilch);  /* Jun 2003 */
    check_modular(&oldmodmode);
    n = NULL;
    old_expre(&Input, &n, &zilch);
    if (!n->numb) 
       error(227, &token);
    disp_size = quoly_convert_to_int(n);
    fprintf(stdout, "new display size: %2d\n", disp_size);
    free_quoly(&n);
    restore_modular(oldmodmode);

  } else 
    disp_size = size;
  if (disp_size < 0) 
    disp_size = 0;
  if (disp_size >= 1000) 
    fprintf(stdout, "Warning.  Very large disp_size.\n");
  ustrcpy(token.name, "@");
  token.address = -1;
  if (lintmode) 
    return;
  free_num(&disp_cons);
  disp_cons.size = 0;
  setvalue(1, &disp_cons);
  for (i = 1; i <= disp_size; ++i) 
    fast_mult(&disp_cons, &tens_base, &disp_cons);
}

/*****************************************************************************/

void minors(quolyptr n, arrptr q, arrptr qrows, arrptr qcols, tokentipe *let, Boolean seestar); /* Jun 2009 */

/* Nov 2000 */

/******************************************************************************/

void evaluate(textptr inf, tokentipe *name, quolyptr n, nameptr *flag);

/*****************************************************************************/

void right_side(formptr *q, nametype stop, textptr inf, nameptr *flag, Boolean *once_more, tokentipe *realtok);

/*****************************************************************************/

void spec_right_side(formptr *q, textptr inf, nameptr *flag, nametype endflag);

/*****************************************************************************/

void eval_form(textptr inf, formptr q, quolyptr n);

/*****************************************************************************/

void call_sys_func(textptr inf, quolyptr n, nameptr *flag);

/*****************************************************************************/

void get_arr_arr(textptr inf, quolyptr n, nameptr *flag, LongIntPtr m)
{
  Boolean oldmodmode;

  scanner(inf, &token, flag);
  if (ustrcmp(token.name, "[") != 0) 
    error(217, &token);
  scanner(inf, &token, flag);
  check_modular(&oldmodmode);
  old_expre(inf, n, flag);                        /* Nov 1997 */
  if (ustrcmp(token.name, "]") != 0) 
    error(218, &token);
  if (!(*n)->numb) 
    error(219, &token);
  *m = quoly_convert_to_int(*n) - addresser;
  restore_modular(oldmodmode);
  if (*m < 0 || *m > arrstashsize - 1) 
    error(221, &token);
}

/****************************************************************************/

void iexpre(LongIntPtr n, nameptr *flag);

/****************************************************************************/

void ifact(lintptr *lp, LongIntPtr n, nameptr *flag);

/* Nov 1997 */

/****************************************************************************/

void iget_exponent(nameptr *flag, LongIntPtr m2)
{
  
  Boolean oldmodmode;
  lintptr lp;                                     /* Nov 1997 */

  check_modular(&oldmodmode);
  *flag = (*flag)->next;
  token = (*flag)->let;
  ifact(&lp, m2, flag);
  if (lp == NULL) 
    error(68, &token);
  *m2 = *lp;
  restore_modular(oldmodmode);
}

/******************************************************************************/

void old_iexpre(LongIntPtr n, nameptr *flag);

/* Nov 1997 */

/******************************************************************************/

void evalcoords(textptr inf, LongIntPtr r, LongIntPtr c, nameptr *flag, char ending, char separator, Boolean *c_is_there, Boolean creating);

/******************************************************************************/

void ievalcoords(LongIntPtr r, LongIntPtr c, nameptr *flag, Boolean *c_is_there)
{
  
  /* Nov 1997 */
  
  Boolean oldmodmode;

  check_modular(&oldmodmode);
  old_iexpre(r, flag);
  *c = addresser;
  if (ustrcmp(token.name, ",") == 0) {
    *flag = (*flag)->next;
    token = (*flag)->let;
    old_iexpre(c, flag);
    *c_is_there = true;
  } else 
    *c_is_there = false;
  restore_modular(oldmodmode);
  if (ustrcmp(token.name, "]") != 0) 
    error(61, &token);
}

/********************************************************************************/

void array_quoly_ptr(arrptr q, long r, long c, Boolean colflag, quolyptr *qp, tokentipe *x, Boolean its_syst)
{
  
  /* In sparse array, qp might be nil but qp^ is not.  In ordinary array, qp
     can't be nil but qp^ might be. 
     
     Nov 1997:  BUG. The above statement "qp might be nil but qp^ is not" means qp
     might be nil, but if it is not, then qp^ is not nil.  Yes, this procedure CAN
     return qp = nil.
     Callers beware! */
  
  colm_ptr t;
  sparseptr sp;
  long i;
  long forEnd_1;

  r -= addresser;
  c -= addresser;
  if (r < 0 || c < 0) 
    error(27, x);
  
  if (colflag && r > q->rows - 1) 
    error(27, x);
  if (q->spar == NULL) {
    c = q->start + r + c * (q->rows);
    if (c < q->start || c > q->stop) 
      error(27, x);
    if (its_syst) 
      *qp = &(*stash)[c];
    else 
      *qp = &(*arp[BSR(c, 10)])[BAnd(c, tenmask)];
  } else {
    if (colflag) 
      c++;                                        /*@@@ remove +1*/
    else {
      c = 1 + r / (q->rows);
      r %= q->rows;                               /*@@@ remove +1*/
    }
    if (c > quotient_of(&q->sizearr, q->rows))    /* Oct 2000 */
      error(27, x);
    sp = q->spar;
    forEnd_1 = r / sparsesize;
    for (i = 1; i <= forEnd_1; ++i) 
      sp = sp->next;
    t = sp->indx[1 + r % sparsesize - 1];
    while (t != NULL) 
      if (t->coord >= c)         /*@@@ added > */
        break;
      else 
        t = t->next;
    if (t == NULL) 
      *qp = NULL;
    else if (t->coord > c) 
      *qp = NULL;
    else 
      *qp = &t->val;
  }
}

/********************************************************************************/

void check_set_first_col(sparseptr sp, long *j, long r, tokentipe *x)

{ /*  Sep2 2010. Set up global spsort, check for no 0 in first col.  r+1 = number of rows in sp.  
	 pass back pointer j to last sparse block in sp^. */
  
  long i;
	long k;
	long endloop;
	
	if (using_spsort)
		error(371, x);
	if (r / sparsesize > sp_sort_size - 1)
		error(372, x);
	
	endloop = r / sparsesize;
	*j = endloop;
	for (k = 0; k <= endloop; ++k) {
		spsort[k] = sp;
    for (i = 0; i <= sparsesize - 1; ++i)
      if (i > r)
        break;
      else 
        if (sp->indx[i] == NULL) 
          error(370, x);
    sp = sp->next;
    r -= sparsesize;
  }
  
}

/********************************************************************************/

void check_set_cols(arrptr q0, arrptr q1)

{ /*  Oct 2010. Set up global spsort, check for no 0 in first col.  r+1 = number of rows in sp.  
	 pass back pointer j to last sparse block in sp^. */
  
  long i;
	long k;
	long r;
	long endloop;
	sparseptr sp;
	
	r = q0->rows - 1;
	endloop = r / sparsesize;
	sp = q0->spar;
	for (k = 0; k <= endloop; ++k) {
    for (i = 0; i <= sparsesize - 1; ++i)
      if (i > r)
        break;
      else 
        if (sp->indx[i] == NULL) 
          error(370, &q0->name);
    sp = sp->next;
    r -= sparsesize;
  }
  
	r = q1->rows - 1;
	endloop = r / sparsesize;
	sp = q1->spar;
	for (k = 0; k <= endloop; ++k) {
    for (i = 0; i <= sparsesize - 1; ++i)
      if (i > r)
        break;
      else 
        if (sp->indx[i] == NULL) 
          error(370, &q1->name);
    sp = sp->next;
    r -= sparsesize;
  }
  
}

/********************************************************************************/

void new_array_quoly_ptr(arrptr q, LongIntPtr r, LongIntPtr c, Boolean colflag, quolyptr *qp, tokentipe *x, colm_ptrptr *aux)
{
  /*   Nov 1997:  New version of array_quoly_ptr to accomodate new grammar.  Output
     aux is for the sparse case, in which case it is never nil. (For ordinary array, aux = nil). 
     aux^ might be nil, but that doesn't matter.  Some caller may use aux to attach a new 
     node to the array at spot (r,c). 
       Dec 1997:  changed r,c to var params -- it's c that counts.
       On entry qp can be unitialized.  Nov 2003.  */
  
  sparseptr sp;
  long i;
  colm_ptrptr t;
  long forEnd_2;

  *r -= addresser;
  *c -= addresser;
  if (*r < 0 || *c < 0) 
    error(27, x);
  
  if (colflag && *r > q->rows - 1) 
    error(27, x);
  if (q->spar == NULL) {      /* ordinary array; don't need new stuff for new grammar */
    *c = q->start + *r + (*c) * (q->rows);
    if (*c < q->start || *c > q->stop) 
      error(27, x);
    *qp = &(*arp[BSR(*c, 10)])[BAnd(*c, tenmask)];
    /* qp <> nil but qp^ might be */
    *aux = NULL;
  } else {
    if (colflag) 
      (*c)++;
    else {
      *c = 1 + (*r) / (q->rows);
      *r %= q->rows;
    }
    if (*c > quotient_of(&q->sizearr, q->rows))   /* Oct 2000 */
      error(27, x);
    sp = q->spar;
    forEnd_2 = (*r) / sparsesize;
    for (i = 1; i <= forEnd_2; ++i) 
      sp = sp->next;
    t = &sp->indx[*r % sparsesize];  /* Sep2 2010, 1 - 1 */
    *aux = t;
    while (*t != NULL) 
      if ((*t)->coord >= *c) 
        break;
      else 
        t = &(*t)->next;
    if (*t == NULL) 
      *qp = NULL;
    else if ((*t)->coord > *c) 
      *qp = NULL;
    else 
      *qp = &(*t)->val;      /* aux <> nil. aux^ might be nil. qp might be nil. */
  }
}

/*************************************************************************/

void spec_arretrieve(textptr inf, nameptr *flag, arrptr q, quolyptr *qp, colm_ptrptr *t, LongIntPtr colpos)
{
  /* only used for %.  changed Nov 1997
     On entry qp can be unitialized.  Nov 2003.   */
  
  long r;
  long c;
  Boolean colflag;            /* is a second coordinate present? */

  scanner(inf, &token, flag);
  evalcoords(inf, &r, &c, flag, ']', ',', &colflag, false);
  scanner(inf, &token, flag);
  
  new_array_quoly_ptr(q, &r, &c, colflag, qp, &arr_arrsign, t);  /* sets t, c, and qp */
  *colpos = c;            /* Dec 1997 */
  if (*qp != NULL)        /* qp = nil means sparse array, entry not there; i.e. it's 0 */
    if (**qp == NULL) {
      uninit++;                              /* Jul 2002 */
      if (uninit < 21) 
        fprintf(stdout, "Warning. Uninitialized array element in %% has been set to 0.\n");
      else if (uninit == 21) 
        fprintf(stdout, " ....etc...\n");
      quoly_set(0, *qp);
      (*(*qp))->variant.vc_1.arr_arg = false;     /* May 2001. failsafe */
    }
}

/****************************************************************************/

void retrieve(tokentipe *x, quolyptr *qp, quolyptr n, textptr inf, nameptr *flag)
{
  /* qp added Nov 1997. n is nil on entry, and usually on exit. return answer in qp,
     and don't make new storage unless sysfunc or odd final case below.  qp might be
     nil at end, if the name in x was not found.  Caller must deal with that. 
       n is unchanged here unless we call sys_func or we have an array - scalar 
     param error. 
       On entry qp can be unitialized.  Nov 2003. */
  
  varptr q;
  short i;

  if (x->address == -1) 
    i = hash(&x->name, 151);
  else 
    i = x->address;
  
  q = sca_store[i];
  while (q != NULL) 
    if (ustrcmp(q->let.name, x->name) == 0) 
      break;
    else 
      q = q->next;
  
  if (q == NULL) {
    if (ustrcmp(x->name, "for") == 0 || ustrcmp(x->name, "if") == 0 || ustrcmp(x->name, "while") == 0) 
      if (*flag == NULL) {
        sys_func_token = token;
        token = *x;
        doing_sys_func = true;
        call_sys_func(inf, n, flag);
        *qp = n;
        return;
      } else 
        error(225, x);
    else 
      *qp = NULL;
    return;
  } else 
    *qp = &q->val;

  if ((*(*qp))->numb)      /* check for array - scalar param error */
    if (q->val->variant.vc_1.arr_arg) {
      quoly_set(0, n);
      *qp = n;
      fprintf(stdout, "Warning. %s is an array parameter used as a scalar.\n", x->name);
      fprintf(stdout, "  Value 0 used for %s.\n", x->name);
      fflush(stdout);
    }
}

/****************************************************************************/

void iretrieve(tokentipe *x, quolyptr *qp)
{
  /*Nov 1997, big change.  Now can have q nil, i.e., no such var. */
  
  varptr q;
  short i;

  if (x->address == -1) 
    i = hash(&x->name, 151);
  else 
    i = x->address;
  
  q = sca_store[i];
  while (q != NULL) 
    if (ustrcmp(q->let.name, x->name) == 0) 
      break;
    else 
      q = q->next;
  
  if (q == NULL) 
    *qp = NULL;
  else if (q->val->numb) 
    *qp = &q->val;
  else 
    error(227, x);
}

/***********************************************************************************/

void arretrieve(textptr inf, tokentipe *x, nameptr *flag, quolyptr *qp);

/* Nov 1997 */

/*****************************************************************************/

long ifrom_table(long n, long r)
{
  /* integermode.  modularmode, lintmode, or not.  Best chance of being correct
     in modularmode. */
  long k;
  imptr mm;
  long value_ifrom_table;

  k = n / 3;       /* assume n <= 150 */
  if (r > n / 2) 
    r = n - r;     /* must be here! regardless of presence of similar statement
                      earlier in caller */
  if (Odd(k))
    k = ((k - 1) * (n - 1)) / 4;
  else 
    k = (k * (n - 4)) / 4;
  mm = (*binom)[r + k - 1];
  k = mm->head->value;
  if (modularmode)
    if (mm->size == 1) 
      value_ifrom_table = k % modulus;
    else 
      value_ifrom_table = modout(mm);
  else 
    value_ifrom_table = k;
  return value_ifrom_table;
}

/******************************************************************************/

void itrivial(long n, long r, LongIntPtr m)
{
  if (r == 1) 
    if (modularmode)
      *m = n % modulus;
    else 
      *m = n;
  else if (modularmode)
    *m = (n * (n - 1)) / 2 % modulus;
  else 
    *m = (n * (n - 1)) / 2;
}

/******************************************************************************/

static long mod_from_table(long n, long r)
{
  long k;                 /* Don't use the global k! Bug! */
  long value_mod_from_table;

  k = n / 3;            /* assume n <= 150 */
  if (r > n / 2)        /* sneaky! */
    r = n - r;
  if (Odd(k)) 
    k = ((k - 1) * (n - 1)) / 4;
  else 
    k = (k * (n - 4)) / 4;
  if (n <= 30) 
    value_mod_from_table = (*binom)[r + k - 1]->lint % modulus;
  else 
    value_mod_from_table = modout((*binom)[r + k - 1]);
  return value_mod_from_table;
}

/**************************************************************************/

void mod_binom(long n, long r, quolyptr m)
{
  
  /* must be in modularmode -- checked by the caller. n <= 30. Beware of overflow if
     change this! 
       Jun 2004: presumably makes no sense for finf */
  
  long ans;
  long k;

  if (r > n / 2) 
    r = n - r;
  if (r < modulus && mod_is_prime) {
    n %= modulus;
    if (n < r) {
      quoly_set(0, m);
      return;
    }
    if (r > n / 2) 
      r = n - r;
  }
  if (n > 150) 
    error(87, &token);
  if (r <= 0 || n <= 2) {
    if (n == 2 && r == 1) 
      if (modulus == 2) 
        quoly_set(0, m);
      else 
        quoly_set(2, m);
    else 
      quoly_set(1, m);
    return;
  } else if (r <= 2) {
    trivial(n, r, m);
    return;
  }
  
  /* now n > 2, r > 2 */
  k = n % 3;
  switch (k) { 
    case 0:
      ans = mod_from_table(n, r);
      break;
    case 1:
      ans = (mod_from_table(n - 1, r) + mod_from_table(n - 1, r - 1)) % modulus;
      break;
    case 2:
      k = mod_from_table(n - 2, r) + 2 * mod_from_table(n - 2, r - 1);
      ans = (k + mod_from_table(n - 2, r - 2)) % modulus;
      break;
  }
  
  free_quoly(m);
  newquoly(m);
  (*m)->numb = true;
  newimag(&(*m)->variant.vc_1.ncoef);
  (*m)->variant.vc_1.ncoef->size = 0;
  (*m)->variant.vc_1.ncoef->lint = ans;
}

/******************************************************************************/

void lint_binom(long n, long r, quolyptr m)
{
  
  long s;
  long n2;
  long r2;
  long i;

  if (r > n / 2) 
    r = n - r;
  if (r <= 0 || n <= 2) {
    if (n == 2 && r == 1) 
      quoly_set(2, m);
    else 
      quoly_set(1, m);
    return;
  }
  
  /* now n > 2 */
  if (n <= 30) 
    if (n % 3 == 0) 
      from_table(n, r, m);
    else {
      n2 = 3 * (n / 3);
      s = n - n2;
      r2 = r - s;
      if (r2 <= 0) 
        trivial(n, r, m);
      else {
        from_table(n2, r2, m);
        for (i = 1; i <= s; ++i) {
          (*m)->variant.vc_1.ncoef->lint = (n2 + i) * ((*m)->variant.vc_1.ncoef->lint);
          (*m)->variant.vc_1.ncoef->lint = ((*m)->variant.vc_1.ncoef->lint) / (r2 + i);
        }
      }
    }
  else 
    error(239, &token);
}

/******************************************************************************/

void dumbscanner(textptr inf, tokentipe *tok, nameptr *flag, Boolean *endline)
{ /* just take the next character. */
  
  char t;

  if (*flag == NULL) {
    if ((ungetc(getc(*inf), *inf) == '\n')) {
      fscanf(*inf,"%*[^\n]");
      getc(*inf);
      *endline = true;
      t = (char)13;
    } else {
      t = fgetc(*inf);
      *endline = false;
    }
    
    if (t == continuation) {                      /* & eoln(inf)*/
      fscanf(*inf,"%*[^\n]");
      getc(*inf);
      t = ' ';
    }

    ustrcpy(tok->name, " ");  /* bug Jun 2003 */
    tok->name[0] = t;
    
    tok->address = -1;
    if (finish == NULL) {
      ustrcpy(start->let.name, tok->name);
      finish = start;
    } else {
      finish = finish->next;
      ustrcpy(finish->let.name, tok->name);
      if (finish == start) 
        start = start->next;
    }
  }
  
  else {
    *flag = (*flag)->next;
    *tok = (*flag)->let;
    currentchar = (*flag)->next;
  }
}

/*******************************************************************************/

void fact(textptr inf, quolyptr *qp, quolyptr n, colm_ptrptr *aux, LongIntPtr colpos,
          nameptr *flag, Boolean leave_it);

/* Nov 1997; Sep 2000 */

/*****************************************************************************/

void old_fact(textptr inf, quolyptr n, nameptr *flag)
{
  
  /* Nov 1997 */
  quolyptr qp;
  colm_ptrptr aux;
  long colpos;
  Boolean eatstorage;

  eatstorage = token.name[0] == '*';              /* big revision, May 2001 */
  
  fact(inf, &qp, n, &aux, &colpos, flag, false);
  
  if (qp == NULL) 
    quoly_set(0, n);
  else if (*n == NULL) 
    if (eatstorage) {                             /* May 2001 */
      *n = *qp;
      *qp = NULL;
      quoly_set(1, qp);                           /* not 0! sparse arrays! */
      (*qp)->variant.vc_1.arr_arg = false;        /* definitely necessary */
    } else 
      quoly_assign(*qp, n);
  else if (eatstorage)                            /* Aug 2001 */
                           /* May 2002. apparently only happens when reference in above
                              call to fact was an entry in a sparse array that's not
                              there, i.e. 0. Do NOT want to set that to 1 anyway. */
    if (!quoly_iszero(*n)) 
      fermat_error("eatstorage and n <> nil in old_fact.", true);
}

/*****************************************************************************/

void poly_readin(textptr inf, polyptrr p, nameptr *flag, LongIntPtr depth);

struct poly_readin_EnvRec {
  quoly qq;
  poly *p;
  poly q;
  poly t;
  FILEPtr *inf;
  nameptr *flag;
  number m;
  Boolean oldmodmode;
  
  /*   Pass back depth = poly_depth of poly p.  This is the depth of the first
     poly var encountered. prev_depth = depth of last poly var encountered as
     the process of attaching goes on.
       If p is not nil upon entry, it and depth describe the first coefficient,
     already determinded elsewhere.
       No zeros allowed anywhere!   
       May 2001: added nomodpolyreadin.  Good, but the user might interrupt a long readin
     and do &n!  Then the restore_modular(oldmodmode) command won't be executed at the
     end. Won't bother to consider this bugaboo now. */

  long this_depth;
  poly r;
  long this_exp;
  long prev_depth;
  long *depth;
  Boolean same_t_q;
  long expon;
  Boolean minus_seen;
  jmp_buf poly_readin_exit;
};
typedef struct poly_readin_EnvRec poly_readin_EnvRec;

/***********************************************************/

static void free_stuff_1(long n, poly_readin_EnvRec *poly_readin_Env)
{
  
  free_quoly(&poly_readin_Env->qq);
  free_poly(poly_readin_Env->p);
  if (poly_readin_Env->q != NULL) {
    poly_readin_Env->t->next = NULL;
    free_poly(&poly_readin_Env->q);
  }
  error(n, &token);
}

/************************************************************/

static void stripoff(polyptrr p, long n)
{
  short i;

  for (i = 1; i <= n; ++i) {
    freepoly(*p,*p); /*AAR*/
/*AAR
    (*p)->next = polygarb;
    polygarb = *p;
*/
    *p = (*p)->variant.pcoef;
  }
}

/************************************************************/

static void get_fact(polyptrr p, poly_readin_EnvRec *poly_readin_Env)
{
  old_fact(poly_readin_Env->inf, &poly_readin_Env->qq, poly_readin_Env->flag);
  free_poly(p);
  quoly_to_poly(poly_readin_Env->qq, p);
}

/*************************************************/

struct get_constant_EnvRec {
  long dumm;            /* Jul 2002 */
};
typedef struct get_constant_EnvRec get_constant_EnvRec;

/*************************************************/

/* readin digits to form constant. */
static void get_one_cons(polyptrr p, poly_readin_EnvRec *poly_readin_Env, get_constant_EnvRec *get_constant_Env)
{
  new_readin(poly_readin_Env->inf, &poly_readin_Env->m, poly_readin_Env->flag, 
             &get_constant_Env->dumm);            /* Jul 2002 */
  scalar_to_poly(&poly_readin_Env->m, p);
  if (poly_iszero(*p)) 
    if (poly_readin_Env->q == NULL) {
      restore_modular(poly_readin_Env->oldmodmode);
      longjmp(poly_readin_Env->poly_readin_exit, -1);
        /*exit(::poly_readin) ~ up-level function exit*/
    } else 
      free_stuff_1(163, poly_readin_Env);
  poly_readin_Env->m.size = 0;
  if (poly_iszero(*p)) 
    free_stuff_1(163, poly_readin_Env);
}

/*******************************************************************/

static void get_constant(polyptrr p, poly_readin_EnvRec *poly_readin_Env)
{
  /* Read in a constant.
     minor space loss: p and r are not freed after some errors here. */
  
  poly r;
  get_constant_EnvRec get_constant_Env;

  r = NULL;
  if (token.name[0] >= '0' && token.name[0] <= '9') 
    get_one_cons(p, poly_readin_Env, &get_constant_Env);
}

/***************************************************************/

static void first_node(polyptrr q, poly_readin_EnvRec *poly_readin_Env)
{
  
  long i;
  long forEnd_3;

  if (poly_depth(*poly_readin_Env->p) <= poly_readin_Env->this_depth) 
    free_stuff_1(159, poly_readin_Env);

  base_poly(q, poly_readin_Env->this_depth);
  poly_readin_Env->r = *q;
  forEnd_3 = poly_readin_Env->this_depth - 1;
  for (i = 1; i <= forEnd_3; ++i) 
    poly_readin_Env->r = poly_readin_Env->r->variant.pcoef;
  poly_readin_Env->r->exp = poly_readin_Env->this_exp;
  free_poly(&poly_readin_Env->r->variant.pcoef);
  if (!(*poly_readin_Env->p)->numb) 
    stripoff(poly_readin_Env->p, poly_readin_Env->this_depth);
  poly_readin_Env->r->variant.pcoef = *poly_readin_Env->p;
  poly_readin_Env->t = poly_readin_Env->r;
}

/*****************************************************************/

struct attach_to_poly_EnvRec {
  /* Attach poly p as coefficient to var 'this_depth' with exponent
     'this_exp'.  expon = latest exponent seen. prev_depth = latest depth seen.
     Note well: p's storage is absorbed into the poly q being built up! */
  
  poly r;
};
typedef struct attach_to_poly_EnvRec attach_to_poly_EnvRec;

/*****************************************************************/

static void standard_attach(poly_readin_EnvRec *poly_readin_Env, attach_to_poly_EnvRec *attach_to_poly_Env)
{
  
  long i;
  long forEnd_4;

  newpoly(&poly_readin_Env->t->next);
  poly_readin_Env->t = poly_readin_Env->t->next;
  poly_readin_Env->t->numb = false;
  if (poly_readin_Env->this_depth == poly_readin_Env->prev_depth) {
    poly_readin_Env->t->exp = poly_readin_Env->this_exp;
    if (!(*poly_readin_Env->p)->numb) 
      stripoff(poly_readin_Env->p, poly_readin_Env->this_depth);
    poly_readin_Env->t->variant.pcoef = *poly_readin_Env->p;
  } else {
    poly_readin_Env->t->exp = 0;
    poly_readin_Env->t->next = NULL;
    poly_readin_Env->t->variant.pcoef = NULL;
    base_poly(&poly_readin_Env->t->variant.pcoef, poly_readin_Env->this_depth -
              poly_readin_Env->prev_depth);
    attach_to_poly_Env->r = poly_readin_Env->t;
    forEnd_4 = poly_readin_Env->this_depth - poly_readin_Env->prev_depth;
    for (i = 1; i <= forEnd_4; ++i) 
      attach_to_poly_Env->r = attach_to_poly_Env->r->variant.pcoef;
    attach_to_poly_Env->r->exp = poly_readin_Env->this_exp;
    free_poly(&attach_to_poly_Env->r->variant.pcoef);
    if (!(*poly_readin_Env->p)->numb) 
      stripoff(poly_readin_Env->p, poly_readin_Env->this_depth);
    attach_to_poly_Env->r->variant.pcoef = *poly_readin_Env->p;
    poly_readin_Env->t = attach_to_poly_Env->r;
  }
}

/********************************************************************/

static void attach_to_poly(poly_readin_EnvRec *poly_readin_Env)
{
  
  attach_to_poly_EnvRec attach_to_poly_Env;

  if (poly_readin_Env->q == NULL)                 /* first node */
    if (poly_readin_Env->this_depth == halfblock) {  /* p must be number */
      poly_readin_Env->q = *poly_readin_Env->p;
      poly_readin_Env->t = poly_readin_Env->q;
      *poly_readin_Env->depth = halfblock;
    } else {                                      /* a poly var was given */
      first_node(&poly_readin_Env->q, poly_readin_Env);
      *poly_readin_Env->depth = poly_readin_Env->this_depth;
    }
  else if (poly_readin_Env->this_depth == halfblock)   /* p must be number */
    if (poly_readin_Env->t->numb) {
      poly_readin_Env->t->next = NULL;
      if (poly_iszero(poly_readin_Env->t)) 
        free_stuff_1(163, poly_readin_Env);
      poly_readin_Env->same_t_q = poly_readin_Env->q == poly_readin_Env->t;
      best_poly_add(poly_readin_Env->t, *poly_readin_Env->p, &poly_readin_Env->t);
      if (poly_readin_Env->same_t_q) 
        poly_readin_Env->q = poly_readin_Env->t;
      *poly_readin_Env->p = NULL;
      if (poly_iszero(poly_readin_Env->t)) 
        free_stuff_1(163, poly_readin_Env);
    } else {
      poly_readin_Env->t->next = *poly_readin_Env->p;
      poly_readin_Env->t = *poly_readin_Env->p;
    }
  else {
  
    if (poly_depth(*poly_readin_Env->p) <= poly_readin_Env->this_depth) 
      free_stuff_1(159, poly_readin_Env);
    if (node_iszero(poly_readin_Env->t)) 
      free_stuff_1(163, poly_readin_Env);
    standard_attach(poly_readin_Env, &attach_to_poly_Env);
  }
  
  poly_readin_Env->expon = poly_readin_Env->this_exp;
  poly_readin_Env->prev_depth = poly_readin_Env->this_depth;
}

/***************************************************************/

static long leading_exp(poly p)
{
  while (p->exp == 0 && !p->numb) 
    p = p->variant.pcoef;
  return p->exp;
}

/**************************************************************/

static void finish_laurent(poly_readin_EnvRec *poly_readin_Env)
{
  
  poly q2;
  long next_depth;

  poly_readin_Env->t->next = NULL;
  q2 = NULL;
  first_node(&q2, poly_readin_Env);
  *poly_readin_Env->p = NULL;
  if (ustrcmp(token.name, "+") == 0 || ustrcmp(token.name, "-") == 0) {
    if (ustrcmp(token.name, "+") == 0) 
      scanner(poly_readin_Env->inf, &token, poly_readin_Env->flag);
    poly_readin(poly_readin_Env->inf, poly_readin_Env->p, poly_readin_Env->flag, 
                &next_depth);
    if (next_depth > poly_readin_Env->this_depth) 
      free_stuff_1(159, poly_readin_Env);
    else if (next_depth < poly_readin_Env->this_depth && leading_exp(*poly_readin_Env->p) >= 0) 
      free_stuff_1(159, poly_readin_Env);
    else if (next_depth == poly_readin_Env->this_depth) 
      if (leading_exp(*poly_readin_Env->p) >= poly_readin_Env->this_exp) 
        free_stuff_1(159, poly_readin_Env);
  }
  best_poly_add(poly_readin_Env->q, q2, &poly_readin_Env->q);
  if (poly_readin_Env->this_depth < *poly_readin_Env->depth) 
    *poly_readin_Env->depth = poly_readin_Env->this_depth;
  if (*poly_readin_Env->p != NULL) {
    best_poly_add(*poly_readin_Env->p, poly_readin_Env->q, poly_readin_Env->p);
    if (next_depth < *poly_readin_Env->depth) 
      *poly_readin_Env->depth = next_depth;
  } else 
    *poly_readin_Env->p = poly_readin_Env->q;
  restore_modular(poly_readin_Env->oldmodmode);
  longjmp(poly_readin_Env->poly_readin_exit, -1);
  /*exit(::poly_readin) ~ up-level function exit*/
}

/**************************************************/

/* Figure out this_depth and this_exp, to describe this term. */

static void getit(poly_readin_EnvRec *poly_readin_Env)
{
  long dumm;           /* Jul 2002 */
  Boolean oldmodmode;  /* Jul 2004 */

  check_modular(&oldmodmode);  /* Jul 2004 */
  new_readin(poly_readin_Env->inf, &poly_readin_Env->m, poly_readin_Env->flag, 
             &dumm);
  restore_modular(oldmodmode);
  poly_readin_Env->this_exp = convert_to_int(&poly_readin_Env->m);
  free_num(&poly_readin_Env->m);
  poly_readin_Env->m.size = 0;
  if (poly_readin_Env->this_exp == 0) 
    free_stuff_1(204, poly_readin_Env);
}

/*******************************************************/

static void get_var_and_expon(Boolean mustbe, poly_readin_EnvRec *poly_readin_Env)
{
  
  if (token.name[0] >= 'a' && token.name[0] <= 'z') 
    if (is_poly_name(&token.name, &poly_readin_Env->this_depth)) {
 
      scanner(poly_readin_Env->inf, &token, poly_readin_Env->flag);
      if (ustrcmp(token.name, "^") == 0) {
        scanner(poly_readin_Env->inf, &token, poly_readin_Env->flag);
        if (token.name[0] >= '0' && token.name[0] <= '9') 
          getit(poly_readin_Env);
        else if (ustrcmp(token.name, "-") == 0) 
          if (laurent) {
            scanner(poly_readin_Env->inf, &token, poly_readin_Env->flag);
            if (token.name[0] >= '0' && token.name[0] <= '9') 
              getit(poly_readin_Env);
            else 
              free_stuff_1(162, poly_readin_Env);
            poly_readin_Env->this_exp = -poly_readin_Env->this_exp;
          } else 
            free_stuff_1(165, poly_readin_Env);
        else 
          free_stuff_1(162, poly_readin_Env);
      } else 
        poly_readin_Env->this_exp = 1;
    } else 
      free_stuff_1(160, poly_readin_Env);
  else if (mustbe) 
    free_stuff_1(161, poly_readin_Env);
  else {
    poly_readin_Env->this_exp = 0;
    if (poly_readin_Env->this_depth == -1)        /* was not set yet */
      poly_readin_Env->this_depth = halfblock;    /* 'infinity' */
    if (poly_readin_Env->expon == 0 && poly_readin_Env->q != NULL) 
      /* Two numbers in a row is ok. 
         Don't do following error checks */
      return;
  }

  if (poly_readin_Env->q == NULL)                 /* first node */
                                                  /* no error */
    ;
    
  else { if (poly_readin_Env->this_depth < poly_readin_Env->prev_depth) 
    if (poly_readin_Env->this_exp < 0) 
      finish_laurent(poly_readin_Env);
    else free_stuff_1(159, poly_readin_Env);
  else if (poly_readin_Env->this_depth == poly_readin_Env->prev_depth &&
           poly_readin_Env->this_exp >= poly_readin_Env->expon)
    free_stuff_1(159, poly_readin_Env);
  else if (poly_readin_Env->expon < 0 && poly_readin_Env->this_depth > poly_readin_Env->prev_depth) 
    free_stuff_1(159, poly_readin_Env);

  }
}

/*****************************************************/

static void read_parenth(poly_readin_EnvRec *poly_readin_Env)
{
  long dummie;
  
  scanner(poly_readin_Env->inf, &token, poly_readin_Env->flag);
  poly_readin(poly_readin_Env->inf, poly_readin_Env->p, poly_readin_Env->flag, 
              &dummie);      /* don't really use this_depth here */
  if (poly_iszero(*poly_readin_Env->p)) 
    free_stuff_1(163, poly_readin_Env);
  if (ustrcmp(token.name, ")") != 0) 
    free_stuff_1(1, poly_readin_Env);
  else 
    scanner(poly_readin_Env->inf, &token, poly_readin_Env->flag);
}

/*****************************************************/

/* need means must have poly var following this coeff. */

static void get_the_coef(Boolean *need, poly_readin_EnvRec *poly_readin_Env)
{
  
  switch (token.name[0]) { 
    
    case '(':
      read_parenth(poly_readin_Env);
      *need = false;
      break;
    case '-':
      poly_readin_Env->minus_seen = true;         /* August 1996 */
      scanner(poly_readin_Env->inf, &token, poly_readin_Env->flag);
      get_the_coef(need, poly_readin_Env);
      poly_inplace(*poly_readin_Env->p);
      break;
    default:
      if (token.name[0] >= '0' && token.name[0] <= '9') {
        get_constant(poly_readin_Env->p, poly_readin_Env);
        *need = false;
      } else {
        poly_set(1, poly_readin_Env->p);
        *need = true;
      }
      break;
  }

}

/**************************************************************************/

void poly_readin(textptr inf, polyptrr p, nameptr *flag, LongIntPtr depth)
{
  Boolean need_var;
  poly_readin_EnvRec poly_readin_Env;

  if (setjmp(poly_readin_Env.poly_readin_exit))
    return;
  poly_readin_Env.depth = depth;
  poly_readin_Env.flag = flag;
  poly_readin_Env.inf = inf;
  poly_readin_Env.p = p;
  poly_readin_Env.q = NULL;        /* used to build up answer. t points to end node of answer.*/
  poly_readin_Env.r = NULL;
  poly_readin_Env.qq = NULL;                      /* a quoly */
  poly_readin_Env.m.size = 0;
  poly_readin_Env.minus_seen = false;             /* August 1996 */
  if (nomodpolyreadin)                            /* May 2001 */
    check_modular(&poly_readin_Env.oldmodmode);
  
  do {
    
    /* For each term, get the coefficient p. Get the poly var and exponent,
       this_depth and this_exp.  If no error, attach them to previous node. 
       expon and prev_depth describe the last node attached, except on very
       first entry to this loop. */
    
    poly_readin_Env.this_depth = -1;              /* I'm not sure we need this anymore. 2/91 */
    
    if (*p == NULL)                               /* almost always true */
      get_the_coef(&need_var, &poly_readin_Env);
    else {                                        /* p and depth are the first coef. */
      if (poly_iszero(*p)) 
        free_stuff_1(163, &poly_readin_Env);
      need_var = true;
      poly_readin_Env.this_depth = *depth;
    }
    get_var_and_expon(need_var, &poly_readin_Env);
    attach_to_poly(&poly_readin_Env);
    
    *p = NULL;
    if (ustrcmp(token.name, "+") == 0) 
      scanner(inf, &token, flag);
    else if (ustrcmp(token.name, "-") == 0)    /* nothing */
      ;
    else 
      break;
  } while (true);
  
  
  if (poly_readin_Env.minus_seen)                 /* August 1996 */
    if (mod_is_changed > 0 && minus_warning) {
      fprintf(stdout, "*** Warning. Negative value seen during poly readin in modular mode.\n");
      fprintf(stdout, "    Check your data carefully.\n");
      fprintf(stdout, "\n");
      minus_warning = false;
      fflush(stdout);
    }
  
  if (nomodpolyreadin)                            /* May 2001 */
    restore_modular(poly_readin_Env.oldmodmode);
  *p = poly_readin_Env.q;
  poly_readin_Env.t->next = NULL;
  free_quoly(&poly_readin_Env.qq);
}

/********************************************************************************/

void quoly_readin(textptr inf, quolyptr p, nameptr *flag, LongIntPtr depth)
{
  
  Boolean parenth;
  long dumm;

  free_quoly(p);
  newquoly(p);
  (*p)->numb = false;
  (*p)->variant.vc_2.numer = NULL;
  (*p)->variant.vc_2.denom = NULL;
  (*p)->variant.vc_2.rat = false;
  
  /* Opening parenthesis means either parens enclose numerator of quoly, or
     a poly happens to start with parens, like (u+1)w. */
  parenth = ustrcmp(token.name, "(") == 0;
  if (parenth) 
    scanner(inf, &token, flag);
  poly_readin(inf, &(*p)->variant.vc_2.numer, flag, depth);
  if (parenth) {
    if (ustrcmp(token.name, ")") != 0) 
      error(1, &token);
    scanner(inf, &token, flag);
    if (is_poly_name(&token.name, &dumm))          /* continue. p^.numer and depth 
                                                     are now input. */
      poly_readin(inf, &(*p)->variant.vc_2.numer, flag, depth);
  }
  if (ustrcmp(token.name, "/") == 0) {
    if (poly_iszero((*p)->variant.vc_2.numer)) 
      error(164, &quotsign);
    scanner(inf, &token, flag);
    parenth = ustrcmp(token.name, "(") == 0;
    if (parenth) 
      scanner(inf, &token, flag);
    poly_readin(inf, &(*p)->variant.vc_2.denom, flag, depth);
    if (parenth) {
      if (ustrcmp(token.name, ")") != 0) {
        free_quoly(p);
        error(1, &token);
      }
      scanner(inf, &token, flag);
      if (is_poly_name(&token.name, &dumm)) 
        poly_readin(inf, &(*p)->variant.vc_2.denom, flag, depth);
    }
    total_poly_modout(&(*p)->variant.vc_2.numer, polynames);
    total_poly_modout(&(*p)->variant.vc_2.denom, polynames);
    if (poly_iszero((*p)->variant.vc_2.denom)) {
      error(22, &quotsign);
      quoly_set(1, p);
    }
    check_quoly(p, laurent);                      /* bug fix; was 'true'. 5/94 */
    return;
  } else 
    total_poly_modout(&(*p)->variant.vc_2.numer, polynames);
  
  if ((*p)->variant.vc_2.numer->numb && (*p)->variant.vc_2.numer->next == NULL && (*p)->variant.vc_2.denom == NULL) 
    polynum_to_quoly(p);
}

/*****************************************************************************/

void iinsert(tokentipe *x, long num, varptr *q)
{
  
  short i;

  if (x->address == -1) 
    i = hash(&x->name, 151);
  else 
    i = x->address;
  
  *q = sca_store[i];
  while (*q != NULL) 
    if (ustrcmp((*q)->let.name, x->name) == 0) 
      break;
    else 
      *q = (*q)->next;
  
  if (*q != NULL) 
    if ((*q)->val->numb) 
      if (lintmode) 
        (*q)->val->variant.vc_1.ncoef->lint = num;
      else 
        (*q)->val->variant.vc_1.ncoef->head->value = num;
    else 
      quoly_set(num, &(*q)->val);
  else {
    *q = sca_store[i];
    if (var_garb == NULL) 
      new(sca_store[i]);
    else {
      sca_store[i] = var_garb;
      var_garb = var_garb->next;
    }
    sca_store[i]->let = *x;
    sca_store[i]->val = NULL;
    quoly_set(num, &sca_store[i]->val);
    sca_store[i]->next = *q;
    *q = sca_store[i];
  }
  (*q)->val->variant.vc_1.arr_arg = false;
}

/******************************************************************************/

void left_side(textptr inf, arrptr *q, LongIntPtr rows, LongIntPtr cols, LongIntPtr start, LongIntPtr total_rows, LongIntPtr firstrow, LongIntPtr firstcol, LongIntPtr target_rows, tokentipe *oldtok, nameptr *flag, Boolean systok);

/******************************************************************************/

struct set_up_for_loop_EnvRec {
  nameptr *p;
  FILEPtr *inf;
  quoly q;
  numptrptr *np;
  long *stop;
  numptr *spcol;
  long *init;
  long *increm;
  /* token is now irrelevant on entry. Nov 1997. 
       spcol, np added Dec 2000.
     on entry, spcol is nil or irrelevant.  At end, spcol is probably not
     nil, though it might be if the sparse col loop points to an empty row(s). In
     that case init and stop will control it OK.  spcol definitely IS nil 
     if it's an ordinary for-loop; then np is irrelevant. */
  
  tokentipe oldtok;
  varptr *r;
  Boolean oldmodmode;
  jmp_buf set_up_for_loop_exit;
};
typedef struct set_up_for_loop_EnvRec set_up_for_loop_EnvRec;

/***********************************************************************/

static void obtain_int(LongIntPtr num, long bad, set_up_for_loop_EnvRec *set_up_for_loop_Env)
{ /* Dec 2000: remove opening call to scanner. */
  if (integerflag) 
    old_iexpre(num, set_up_for_loop_Env->p);
  else {
    old_expre(set_up_for_loop_Env->inf, &set_up_for_loop_Env->q, set_up_for_loop_Env->p);
    if (!set_up_for_loop_Env->q->numb) {
      free_quoly(&set_up_for_loop_Env->q);
      error(bad, &token);
    }
    if (lintmode) 
      *num = set_up_for_loop_Env->q->variant.vc_1.ncoef->lint;
    else {
      if (set_up_for_loop_Env->q->variant.vc_1.ncoef->size != 1) 
        error(bad, &token);
      *num = set_up_for_loop_Env->q->variant.vc_1.ncoef->head->value;
    }
  }
}

/*********************************************************************/

struct sparse_col_loop_EnvRec {
  colm_ptr t;
};
typedef struct sparse_col_loop_EnvRec sparse_col_loop_EnvRec;

/*.............................................................*/

/* note how stop is built up. */
static void finish_t(sparse_col_loop_EnvRec *sparse_col_loop_Env, set_up_for_loop_EnvRec *set_up_for_loop_Env)
{
  while (sparse_col_loop_Env->t != NULL) {
    newnum(**set_up_for_loop_Env->np);
    *set_up_for_loop_Env->stop = sparse_col_loop_Env->t->coord;
    (*(*set_up_for_loop_Env->np))->value = *set_up_for_loop_Env->stop + addresser - 1; 
    /* BUG Jul 2003 */
    *set_up_for_loop_Env->np = &(*(*set_up_for_loop_Env->np))->next;
    sparse_col_loop_Env->t = sparse_col_loop_Env->t->next;
  }
  **set_up_for_loop_Env->np = NULL;
}

/**************************************************************************/

static void sparse_col_loop(set_up_for_loop_EnvRec *set_up_for_loop_Env)  /* new Dec 2000 */
{
  
  /*  spcol is nil on entry. Some comments added here, Aug 2003.
     syntax is, for example, for j = [x]i, k, m do ... od.  Find i^th row of [x].
     If not empty, create a list of numnodes containing the col coords
     of that row.  Set spcol to point to this list and np to point to the second 
     node; i.e. if the list is nonempty, np^ is the next field in the first entry.
     Then merge in the lists for k and m. Set increm to 1 (for sake of caller), 
     init and stop accordingly. r points to the index var, which is set to init. 
     There is no limit on the number of row coords. */
     
  /* bug fix Jul 2003:  add in  + addresser - 1  once above and three places below */
  
  arrptr qa;
  long rows;
  long j;
  long i;
  sparseptr sp;
  tokentipe arrtok;
  numptr u;
  long forEnd_5;
  sparse_col_loop_EnvRec sparse_col_loop_Env;

  left_side(set_up_for_loop_Env->inf, &qa, &rows, &i, &i, &i, &i, 
            &i, &i, &arrtok, set_up_for_loop_Env->p, false);
  if (qa == NULL) 
    error(28, &token);
  if (qa->spar == NULL) 
    error(335, &token);
  do {
    /* At the start of this loop, spcol points to a nilled sorted list of 
       number nodes.  This list is the merged list of col coords of some 
       (maybe none) rows of the matrix.  np is undefined or irrelevant.*/
    /* Get a new row coord. Then go to that row; set t to point to
       it. */
    old_expre(set_up_for_loop_Env->inf, &set_up_for_loop_Env->q, set_up_for_loop_Env->p);
    if (!set_up_for_loop_Env->q->numb) {
      free_quoly(&set_up_for_loop_Env->q);
      error(118, &token);
    }
    if (lintmode) 
      i = set_up_for_loop_Env->q->variant.vc_1.ncoef->lint;
    else {
      if (set_up_for_loop_Env->q->variant.vc_1.ncoef->size != 1) 
        error(27, &token);
      i = set_up_for_loop_Env->q->variant.vc_1.ncoef->head->value;
    }
    i -= addresser;
    if (i < 0 || i > rows - 1) 
      error(27, &token);
    sp = qa->spar;
    forEnd_5 = i / sparsesize;
    for (j = 1; j <= forEnd_5; ++j) 
      sp = sp->next;
    sparse_col_loop_Env.t = sp->indx[1 + i % sparsesize - 1];
    /* Now merge in the t row with spcol. np runs down spcol^. */
    *set_up_for_loop_Env->np = set_up_for_loop_Env->spcol;
    while (true) {
      /* merging loop. all values before np^ and t have been merged
         into spcol^. */
      if (**set_up_for_loop_Env->np == NULL) {
        finish_t(&sparse_col_loop_Env, set_up_for_loop_Env);
        break;
      } else if (sparse_col_loop_Env.t == NULL) 
        break;
      else if (sparse_col_loop_Env.t->coord + addresser - 1 ==
               (*(*set_up_for_loop_Env->np))->value) {
        *set_up_for_loop_Env->np = &(*(*set_up_for_loop_Env->np))->next;
        sparse_col_loop_Env.t = sparse_col_loop_Env.t->next;
      } else if (sparse_col_loop_Env.t->coord + addresser - 1 <
                 (*(*set_up_for_loop_Env->np))->value) {
        u = **set_up_for_loop_Env->np;
        newnum(**set_up_for_loop_Env->np);
        (*(*set_up_for_loop_Env->np))->value = sparse_col_loop_Env.t->coord + addresser - 1;
        (*(*set_up_for_loop_Env->np))->next = u;
        *set_up_for_loop_Env->np = &(*(*set_up_for_loop_Env->np))->next;
        sparse_col_loop_Env.t = sparse_col_loop_Env.t->next;
      } else 
        *set_up_for_loop_Env->np = &(*(*set_up_for_loop_Env->np))->next;
    }
    if (ustrcmp(token.name, ",") == 0) 
      scanner(set_up_for_loop_Env->inf, &token, set_up_for_loop_Env->p);
    else 
      break;
  } while (true);
  
  if (*set_up_for_loop_Env->spcol == NULL) {
    *set_up_for_loop_Env->init = addresser - 1;
    *set_up_for_loop_Env->stop = -2;
  } else {
    *set_up_for_loop_Env->init = (*set_up_for_loop_Env->spcol)->value;
    *set_up_for_loop_Env->np = &(*set_up_for_loop_Env->spcol)->next;
  }
  *set_up_for_loop_Env->increm = 1;
  if (lintmode) 
    set_up_for_loop_Env->q->variant.vc_1.ncoef->lint = *set_up_for_loop_Env->init;
  else 
    set_up_for_loop_Env->q->variant.vc_1.ncoef->head->value = *set_up_for_loop_Env->init;
  if (integerflag) 
    iinsert(&set_up_for_loop_Env->oldtok, *set_up_for_loop_Env->init, 
            set_up_for_loop_Env->r);
  else 
    insert_var(&set_up_for_loop_Env->oldtok, set_up_for_loop_Env->q, 
                set_up_for_loop_Env->r);
  /* don't free_quoly q! */
  restore_modular(set_up_for_loop_Env->oldmodmode);  /* BUG found, Oct 2002 */
  longjmp(set_up_for_loop_Env->set_up_for_loop_exit, -1);
  /*exit(::set_up_for_loop) ~ up-level function exit*/
}

/*********************************************************************/

void set_up_for_loop(textptr inf, nameptr *p, varptr *r, LongIntPtr init, LongIntPtr stop, LongIntPtr increm, numptrptr spcol, numptrptr *np)
{
  set_up_for_loop_EnvRec set_up_for_loop_Env;

  if (setjmp(set_up_for_loop_Env.set_up_for_loop_exit)) 
    return;
  set_up_for_loop_Env.r = r;
  set_up_for_loop_Env.increm = increm;
  set_up_for_loop_Env.init = init;
  set_up_for_loop_Env.spcol = spcol;
  set_up_for_loop_Env.stop = stop;
  set_up_for_loop_Env.np = np;
  set_up_for_loop_Env.inf = inf;
  set_up_for_loop_Env.p = p;
  set_up_for_loop_Env.q = NULL;
  
  *spcol = NULL;                                  /* Dec 2000 */
  /* scanner(inf, &set_up_for_loop_Env.oldtok, p);  changed to following Jul 2003 */
  set_up_for_loop_Env.oldtok = token;
  
  if (set_up_for_loop_Env.oldtok.name[0] < 'a' || set_up_for_loop_Env.oldtok.name[0] > 'z') 
    error(51, &set_up_for_loop_Env.oldtok);
  scanner(inf, &token, p);
  if (ustrcmp(token.name, ":") == 0) { /* Feb 2007. allow  for i := n ... */
	scanner(inf, &token, p);
	if (ustrcmp(token.name, "=") != 0)   
      error(77, &token);
  }
  else 
    if (ustrcmp(token.name, " from ") != 0 && ustrcmp(token.name, "from") != 0 &&
        ustrcmp(token.name, "=") != 0)   /* Nov 1997 */
      error(77, &token);
  
  check_modular(&set_up_for_loop_Env.oldmodmode);
  
  scanner(inf, &token, p);                        /* Dec 2000 */
  if (ustrcmp(token.name, "[") == 0) 
    sparse_col_loop(&set_up_for_loop_Env);        /* exits */
  else 
    obtain_int(init, 50, &set_up_for_loop_Env);
    
  if (ustrcmp(token.name, " to") != 0 && ustrcmp(token.name, ",") != 0) 
    error(49, &token);
    
  if (integerflag) 
    iinsert(&set_up_for_loop_Env.oldtok, *init, r);
  else 
    insert_var(&set_up_for_loop_Env.oldtok, set_up_for_loop_Env.q, r);
  
  set_up_for_loop_Env.q = NULL;           /* very necessary. changes in insert, Nov 1, 1994 */
  scanner(inf, &token, p);                /* Dec 2000 */
  obtain_int(stop, 52, &set_up_for_loop_Env);
  if (ustrcmp(token.name, " by") == 0 || ustrcmp(token.name, ",") == 0) {
    scanner(inf, &token, p);                      /* bug fix, Mar 2001 */
    obtain_int(increm, 53, &set_up_for_loop_Env);
  } else 
    *increm = 1;
  free_quoly(&set_up_for_loop_Env.q);
  restore_modular(set_up_for_loop_Env.oldmodmode);
	if (modularmode && *init < 0)  /* Nov 2010. bug fix. Note, r->val could still be negative! */
		(*r)->val->variant.vc_1.ncoef->lint = modulus + *init;
}

/******************************************************************************/

void adjust(varptr r, long i)
{
  if (abs(i) >= block) 
    error(47, &r->let);
  if (lintmode) 
    if (i < 0 && modularmode)   /* Nov 2010. bug fix. Note, r->val could still be negative!  */
			r->val->variant.vc_1.ncoef->lint = modulus + i;
	  else
			r->val->variant.vc_1.ncoef->lint = i;
		else 
			r->val->variant.vc_1.ncoef->head->value = i;
}

/*****************************************************************************/

void sum_mult_up(nametype sign, textptr inf, quolyptr n, nameptr *p, Boolean parse_only, 
                 LongIntPtr sum, /*CStrPtr -- AAR*/ char *mate)
{
  /* scanner(inf, token, p);  Nov 1997 */
  nameptr t;
  long i;                                         /* y, Aug 2001 */
  long stop;
  long increm;
  long negflag;
  long num;
  varptr r;
  formptr fp;                                     
  quoly s;
  Boolean recur;
  numptr spcol;                                   /* Dec 2000 */
  numptrptr np;
  nametype matey;

  scanner(inf, &token, p);  /* Jul 2003 */
  set_up_for_loop(inf, p, &r, &i, &stop, &increm, &spcol, &np);  /* Dec 2000 */
  if (increm < 0) {
    i = -i;
    stop = -stop;
    increm = -increm;
    negflag = -1;
  } else 
    negflag = 1;
  if (ustrcmp(token.name, ">") != 0) 
    error(78, &token);
  
  scanner(inf, &token, p);
  t = *p;
  recur = ustrcmp(token.name, "<") == 0;
  if (!recur && ustrcmp(token.name, "[") != 0 && ustrcmp(token.name, "(") != 0)   
    error(145, &token);
  
  if (!recur) 
    if (ustrcmp(token.name, "[") == 0)         /* user's choice */
      *mate = ']';
    else 
      *mate = ')';
      
  if (ustrcmp(sign, "*82") == 0)   /* Sigma. Dec 2007 */  /* Jul 2008, Oct 2009 Apr2 2011 */
    if (integerflag)
      *sum = 0;
    else 
      quoly_set(0, n);
  else if (integerflag) 
    *sum = 1;
  else 
    quoly_set(1, n);
  
  if (i > stop || parse_only) {     /* must parse all the rest, but can't actually execute. */
    s = NULL;
    if (recur) 
      sum_mult_up(sign, inf, &s, p, true, sum, mate);
    else {
      scanner(inf, &token, p);
      ustrcpy(matey, ";");   /* Jul 2003 */
      matey[0] = *mate;
      spec_right_side(&fp, inf, p, matey); /* a kludge. Pascal is so much easier! Jul 2003 */
      free_form(&fp);
      if (feof(*inf) && token.name[0] != *mate) 
        error(103, &token);
    }
    free_quoly(&s);
    return;
  }
  
  while (i <= stop) {
    *p = t;
    s = NULL;
    if (recur) 
      sum_mult_up(sign, inf, &s, p, false, &num, mate);
    else {
      scanner(inf, &token, p);
      if (integerflag) 
        old_iexpre(&num, p);                      /* Nov 1997 */
      else 
        old_expre(inf, &s, p);
    }
    if (ustrcmp(sign, "*82") == 0)   /* Dec 2007 */  /* Jul 2008, Oct 2009 Apr2 2011 */
      if (integerflag) {
        if (modularmode)
          *sum = mod_add(*sum, num, modulus);  /*  Apr 2004. OK for large modulus */
	    else
	      *sum += num;
      } else 
        best_quoly_add(n, s);
    else if (integerflag) 
      if (modularmode)  /*  Apr 2004. beware large modulus */
        *sum = modmult(*sum, num);                /* Aug 2001 */
      else 
        *sum *= num;
    else {
      fast_quoly_mult(n, &s);                     /* Dec 2001 */
      free_quoly(&s);
    }
    if (spcol == NULL)                            /* Dec 2000 */
      i += increm;
    else if (*np == NULL) 
      i = stop + 1;
    else {
      i = (*np)->value;
      np = &(*np)->next;
    }
    adjust(r, negflag * i);
  }
  if (spcol != NULL) {                            /* Dec 2000 */
    *np = numhead;  /*AAR can't use freenum here!!!*/
    numhead = spcol;
  }
}

/******************************************************************************/

long find_built_in(long start, long stop, nametype key)
{
  
  /* binary search */
  
  long mid;
  long value_find_built_in;

  while (stop >= start) {
    mid = (start + stop) / 2;
    if (ustrcmp(builtin[mid][0], key) == 0) {
      return mid;
    } else if (ustrcmp(builtin[mid][0], key) < 0) 
      start = mid + 1;
    else 
      stop = mid - 1;
  }
  return -1;
}

/*****************************************************************************/

void lookup(tokentipe *x, long r, long c, arrptr *q, quolyptr *qp, Boolean colflag);

/*****************************************************************************/

void arr_fact(textptr inf, quolyptr n, workptr arr, arr_descr *arr_facts, Boolean *arr_free, LongIntPtr rows, nameptr *flag, sparseptr *spar);

/*****************************************************************************/

struct total_eval_EnvRec {
  quoly *n2;
  /* target added Aug 1997.  Can now evaluate on just a contiguous range of vars,
     like x#(:q4 = s4, s3, s2, s1).  target-1 tells how many to skip, and to terminate 
     can simply stop the list, as in the example. 
     
      June 1998:  n2 nil on entry means get the data from an array. token is '['.
       On exit, n2 must point to freeable storage.   
       
     May 2001:  BUG fix.  Note this proc is called only by get_evalquoly.   */
  
  quoly p;
  quoly t;
  FILEPtr *inf;
  nameptr *flag;
  long count;
  Boolean *should_free;
};
typedef struct total_eval_EnvRec total_eval_EnvRec;

/*****************************************************/

static void free_n2s(total_eval_EnvRec *total_eval_Env)
{
  *total_eval_Env->n2 = total_eval_Env->p;
  total_eval_Env->p = total_eval_Env->p->next;    /* leave one n2 */
  while (total_eval_Env->p != NULL) {
    total_eval_Env->t = total_eval_Env->p->next;
    free_quoly(&total_eval_Env->p);
    total_eval_Env->p = total_eval_Env->t;
  }
}

/*****************************************************/

static void getfromArray(total_eval_EnvRec *total_eval_Env, Boolean *allnumbs)  
   /* all new, June 1998. allnumbs Mar 2005  */
{
  
  sparseptr spar;
  workptr arr;
  Boolean arr_free;
  arr_descr arr_facts;
  long i;
  quolyptr qp;                                    /* May 2001 */
  quoly t;
  long forEnd_6;

  new_worknode(&i, &token);
  arr = workhead[i - 1];
  i = 0;
  spar = NULL;                                    /* BUG, Oct 2000. and below */
  arr_facts.arrsize.size = 0;
  arr_fact(total_eval_Env->inf, total_eval_Env->n2, arr, &arr_facts, 
           &arr_free, &i, total_eval_Env->flag, &spar);
  /* May 2001.  BUG move should_free statement to below. */
  if (arr_free) 
    error(338, &token);                           /* May 2001 bug fix */
  if (ustrcmp(token.name, ")") != 0) 
    error(1, &token);
  total_eval_Env->count = arr_facts.arrsize.head->value;  /* can't be sparse, Oct 2000 */
  if (total_eval_Env->count > number_polys) 
    error(187, &token);                           /* new, Jun 2001 */
  if (total_eval_Env->count == 0) 
    error(41, &token);
  if (spar != NULL)                               /* BUG, Oct 2000 */
    error(259, &token);                           /* changed 259 */
  
  free_quoly(total_eval_Env->n2);
  forEnd_6 = total_eval_Env->count - 2;
  /* This is so easy it's amazing!  Link them up. ASSUMING NOBODY
     CARES ABOUT THESE LINKS! */
  for (i = 0; i <= forEnd_6; ++i) 
    if ((*arr)[i] == NULL) 
      error(48, &token);                          /* new error 48 */
    else 
      (*arr)[i]->next = (*arr)[i + 1];
  if ((*arr)[total_eval_Env->count - 1] == NULL) 
    error(48, &token);
  else 
    (*arr)[total_eval_Env->count - 1]->next = NULL;
  
  /* n2^ must be freeable storage!!  All of it!  arr is not freeable. May 2001 */
  quoly_assign((*arr)[0], total_eval_Env->n2);
  if (*allnumbs)  /* Mar 2005 */
    if ((*arr)[0]->numb) 
      *allnumbs = ((*arr)[0]->variant.vc_1.ncoef->lint == 0 || (*arr)[0]->variant.vc_1.ncoef->lint == 1);
    else
      *allnumbs = false;
  qp = &(*total_eval_Env->n2)->next;
  *qp = NULL;
  t = (*arr)[0]->next;
  while (t != NULL) {
    quoly_assign(t, qp);
    if (*allnumbs)  /* Mar 2005 */
      if (t->numb) 
        *allnumbs = (t->variant.vc_1.ncoef->lint == 0 || t->variant.vc_1.ncoef->lint == 1);
      else
        *allnumbs = false; 
    qp = &(*qp)->next;
    *qp = NULL;
    t = t->next;
  }
  
 /* *total_eval_Env->should_free = false;  Note! bug of May 2001. Don't free anything of n2^ here.
   BUG of Apr 2005; don't change should_free here!  The caller knows, else memory leak. */
  
  special_free(&arr_facts.arrsize);               /* Oct 2000 */

  free_work();
}

/*****************************************************/

void total_eval(textptr inf, quolyptr n, quolyptr n2, nameptr *flag, Boolean should_free, long target, Boolean leave_n)
{
  /* Upon entry the first time, token = ',' and n2 is the first of the arguments. 
     The first time, n2^.next = nil.  There are later calls when the whole thing
     is called from array parsing.  If n2^.next 
     is nil, we need to read all the others, ending with p pointing to a 
     linked list of them. If n2^.next is not nil, the reading was done earlier. 
       Mar 2005: added leave_n. If true, n is pointing to authenic storage AND it is read only.
     Yet, as before, the ptr n is used to return the answer.  This is a big speed-up. */
  
  quoly num;
  quoly num2;
  Boolean allnumbs_char2; /* Mar 2005 */
  total_eval_EnvRec total_eval_Env;

  total_eval_Env.should_free = &should_free;
  total_eval_Env.flag = flag;
  total_eval_Env.inf = inf;
  total_eval_Env.n2 = n2;
  allnumbs_char2 = modularmode && (finf || modulus == 2) && char2_degs1;  
       /* Mar 2005.  means all 0 or 1 in char 2, all modded by x^2 + ...  */

  if (*n2 == NULL) 
    getfromArray(&total_eval_Env, &allnumbs_char2);   
           /* June 1998. should_free has been changed to reflect the
              array holding the data!  But it's not a var param. May 2001
              Mar 2005, added allnumbs_char2 */
  
  total_eval_Env.p = *n2;
  if ((*n2)->next == NULL) {
    total_eval_Env.t = *n2;
    total_eval_Env.count = 1;
    while (ustrcmp(token.name, ",") == 0) {
      scanner(inf, &token, flag);
      *n2 = NULL;
      old_expre(inf, n2, flag);       /* June 1997; no more check for number */
      if (allnumbs_char2)  /* Mar 2005 */
        if ((*n2)->numb) 
          allnumbs_char2 = ((*n2)->variant.vc_1.ncoef->lint == 0 || (*n2)->variant.vc_1.ncoef->lint == 1);
        else
          allnumbs_char2 = false;
      total_eval_Env.t->next = *n2;
      total_eval_Env.t = *n2;
      total_eval_Env.count++;
    }

    total_eval_Env.t->next = NULL;
    *n2 = total_eval_Env.p;
    if (ustrcmp(token.name, ")") != 0) 
      error(1, &token);
    if (total_eval_Env.count > number_polys)      /* changed Aug 1997 */
      error(193, &token);
  }
  else { /* Mar 2005. must check allnumbs_char2 and count */
    total_eval_Env.count = 0;
    while (total_eval_Env.p != NULL) {
      if (allnumbs_char2)
        if (total_eval_Env.p->numb) 
          allnumbs_char2 = (total_eval_Env.p->variant.vc_1.ncoef->lint == 0 || 
                            total_eval_Env.p->variant.vc_1.ncoef->lint == 1);
        else
          allnumbs_char2 = false;
      total_eval_Env.count++;
      total_eval_Env.p = total_eval_Env.p->next;
    }
  }

  total_eval_Env.p = *n2; 

  if ((*n)->numb || (*n)->variant.vc_2.rat && !lintmode) {  /* June 1997 */
    if (should_free) 
      free_n2s(&total_eval_Env);
    if (leave_n) { /* Mar 2005 */
      num2 = NULL;
      quoly_assign(*n, &num2);
      *n = num2;
    }
    return;
  }
  
  num = NULL;
  
  if (allnumbs_char2)  /* Mar 2005 */
    tot_eval_poly2((*n)->variant.vc_2.numer, total_eval_Env.p, &num, 0, target - 1, total_eval_Env.count);
  else
    tot_eval_poly((*n)->variant.vc_2.numer, total_eval_Env.p, &num, 0, target - 1);
  if (!leave_n)  /* Mar 2005 */
    free_poly(&(*n)->variant.vc_2.numer);
  
  if ((*n)->variant.vc_2.denom != NULL) {
    num2 = NULL;
    if (allnumbs_char2)  /* Mar 2005 */
      tot_eval_poly2((*n)->variant.vc_2.denom, total_eval_Env.p, &num2, 0, target - 1, 
                     total_eval_Env.count);
    else
      tot_eval_poly((*n)->variant.vc_2.denom, total_eval_Env.p, &num2, 0, target - 1);
    fast_quoly_quot(&num, &num2, false);          /* Dec 2001 */
    free_quoly(&num2);
    if (!leave_n)  /* Mar 2005 */
      free_poly(&(*n)->variant.vc_2.denom);
  }
  
  if (leave_n) 
    *n = num;  /* Mar 2005 */
  else {
    (*n)->next = quolygarb;
    quolygarb = *n;
    *n = num;
  }
  
  if (should_free) 
    free_n2s(&total_eval_Env);
}

/*****************************************************************************/

void spec_quoly_eval(quolyptr n, quolyptr n2, long target)
{
  
  /* Aug 1997 */
  
  quoly num;
  quoly num2;

  if ((*n)->numb || (*n)->variant.vc_2.rat && !lintmode) 
    return;
  num = NULL;
  tot_eval_poly((*n)->variant.vc_2.numer, *n2, &num, 0, target - 1);
  free_poly(&(*n)->variant.vc_2.numer);
  
  if ((*n)->variant.vc_2.denom != NULL) {
    num2 = NULL;
    tot_eval_poly((*n)->variant.vc_2.denom, *n2, &num2, 0, target - 1);
    fast_quoly_quot(&num, &num2, false);          /* Dec 2001 */
    free_quoly(&num2);
    free_poly(&(*n)->variant.vc_2.denom);
  }
  
  (*n)->next = quolygarb;
  quolygarb = *n;
  *n = num;
}

/*****************************************************************************/

void horner_quoly_eval(quolyptr n, quolyptr n2, long target)
{
  
  /* Jan 2006. n2 is a quoly involving vars well above target.  target is low relative to n also.
     Just do Horner's method.  n2 is read only. */
  
  quoly num;
  quoly num2;
  poly q;
  poly s;
  long i;
  long degr;
  long nextexp;

  if ((*n)->numb || (*n)->variant.vc_2.rat && !lintmode) 
    return;
  
  num = NULL;
  s = NULL;
  q = (*n)->variant.vc_2.numer;
  degr = neg_two_to_31;
  max_degree(q, target, &degr);
  extract_coef(q, &s, (short) (target - 1), degr, degr == 0);
  use_up_poly(&s, &num);
  for (i = degr - 1; i >= 0; --i) {  /* Horner's method */
	fast_quoly_mult(&num, n2);       
	s = NULL;
	extract_coef(q, &s, (short) (target - 1), i, i == 0);
	num2 = NULL;
	use_up_poly(&s, &num2);
	best_quoly_add(&num, num2);
  }
  
  free_poly(&q);
  q = (*n)->variant.vc_2.denom;
  (*n)->next = quolygarb;
  quolygarb = *n;
  *n = num;  
  
  if (q != NULL) {
    num = NULL;
    s = NULL;
	degr = neg_two_to_31;
    max_degree(q, target, &degr);
    extract_coef(q, &s, (short) (target - 1), degr, degr == 0);
    use_up_poly(&s, &num);
    for (i = degr - 1; i >= 0; --i) {  /* Horner's method */
	  fast_quoly_mult(&num, n2);       
	  s = NULL;
	  extract_coef(q, &s, (short) (target - 1), i, i == 0);
	  num2 = NULL;
	  use_up_poly(&s, &num2);
	  best_quoly_add(&num, num2);
    }
	fast_quoly_quot(n, &num, false);        
    free_quoly(&num);
    free_poly(&q);
  }
  
}

/*****************************************************************************/

struct get_evalquoly_EnvRec {
  FILEPtr *inf;
  nameptr *flag;
  quoly *n2;
  long *target;
};
typedef struct get_evalquoly_EnvRec get_evalquoly_EnvRec;

struct get_polys_EnvRec {
  /* sets target and n2. rewritten Nov 1997, June 1998. simplified a lot Jul 2002. */
  
  long targ;
};
typedef struct get_polys_EnvRec get_polys_EnvRec;

/* have just seen a poly var */
static void check_and_finish(get_evalquoly_EnvRec *get_evalquoly_Env, get_polys_EnvRec *get_polys_Env)
{
  if (ustrcmp(token.name, "=") == 0) {
    scanner(get_evalquoly_Env->inf, &token, get_evalquoly_Env->flag);
    if (ustrcmp(token.name, "[") == 0)         /* June 1998. get n2 from array later */
      free_quoly(get_evalquoly_Env->n2);	   /* signal to total_eval. Apr 2005 BUG fix. */
    else 
      old_expre(get_evalquoly_Env->inf, get_evalquoly_Env->n2, get_evalquoly_Env->flag);
    *get_evalquoly_Env->target = get_polys_Env->targ;
  } else {
    base_quoly(get_evalquoly_Env->n2, get_polys_Env->targ);
    half_expre(get_evalquoly_Env->inf, get_evalquoly_Env->n2, get_evalquoly_Env->flag);
    *get_evalquoly_Env->target = 1;
  }
}

/**********************************************************/

static void get_polys(get_evalquoly_EnvRec *get_evalquoly_Env)
{
  
  get_polys_EnvRec get_polys_Env;

  old_expre(get_evalquoly_Env->inf, get_evalquoly_Env->n2, get_evalquoly_Env->flag);
  if (is_poly_var(*get_evalquoly_Env->n2, &get_polys_Env.targ))   /* Jul 2002 */
    check_and_finish(get_evalquoly_Env, &get_polys_Env);
  else 
    *get_evalquoly_Env->target = 1;
}

/******************************************************/

static Boolean needto(poly p, long depth)
{
  
  /* Is there a negative exponent in 'p' at depth 'depth'? 
     NOTE:  We don't check for ANY negative exponent, just the ones at 'depth'.*/
  
  Boolean test;
  Boolean value_needto;

  if (depth == 1) 
    while (p != NULL) 
      if (p->exp < 0) {
        return true;
      } else 
        p = p->next;
  
  else 
    while (p != NULL) {
      if (p->numb) 
        test = false;
      else 
        test = needto(p->variant.pcoef, depth - 1);
      if (test) {
        return true;
      } else 
        p = p->next;
    }
  
  return false;
}

/********************************************************/

void get_evalquoly(textptr inf, quolyptr n, quolyptr n2, LongIntPtr target, nameptr *flag, Boolean should_free,
                   Boolean leave_n)
{
  /* The nodes of input n can be changed or destroyed. n is also output.
     Possible space losing problem if error occurs during a call to this from
     arr_fact. */
  
  /* target = 1 means highest level poly var, or number */
  /* In the quoly n, replace a poly variable (to be read, whose depth is 'target') 
     with the quantity n2 (if nil, to be read and evaluated here, whose depth is 
     'source').   Return answer in n. Slightly inefficient in possible recomputation 
     of powers of n2.  n2 is freed by the caller.
     August 7, 1990: looks like n2 is always nil. will assume so. 
     August 9: no, not when called from downdate vars, or by array parsing routines.
     August 14: n2 must be poly, not quoly. 
     
     September 1, 1992:  modified so that things like p#(t/2) are legal in rat mode,
        so that n2 is not a polynomial. created d3, num_denom, den_denom to do so. 
        
     Aug 1997:  Can now do p#(:x=q) for any quoly q.  Many other changes. 
     
     Nov 1997:  It's now p#(x=q). 
     
     May 1998:  Fixed a bug, in the call to total_eval below.  Note that target is both 
        output and input, when the original calling statement is an array eval, 
        like [v]#(q4=3,....). In that case, this procedure is called many times inside 
        a loop. 
        
     June 1998: can now do p#(x=[a]) 
     
     Mar 2005:  added leave_n.  If true, n^ is authenic storage and read only.  (Somebody
        else is pointing to it.)  This is for the benefit of total_eval.  If we don't call 
        total_eval, we dupe the storage, which is equivalent to the way this proc was previously. */
  
  long source;
  poly n3;
  poly d3;
  poly exps;
  poly tail;
  poly num_denom;
  poly den_denom;
  Boolean newn3;
  get_evalquoly_EnvRec get_evalquoly_Env;
  quoly num2;  /* Mar 2005 */

  get_evalquoly_Env.target = target;
  get_evalquoly_Env.n2 = n2;
  get_evalquoly_Env.flag = flag;
  get_evalquoly_Env.inf = inf;
  if (*n2 == NULL) 
    if (ustrcmp(token.name, "(") == 0) {
      scanner(inf, &token, flag); 
      get_polys(&get_evalquoly_Env);              /* sets n2 and target. Nov 1997 */
      if (*n2 != NULL)                            /* n2 = nil means getting from array. May 2001 */
        (*n2)->next = NULL;                       /* necessary for total_eval, and future 
                                                     calls to get_evalquoly, if any */
      if (*n2 == NULL || ustrcmp(token.name, ",") == 0) {   /* changed lots of this, June 1997, for totaleval */
                                       /* n2 can now be nil, getting from array. June 1998 */
        total_eval(inf, n, n2, flag, should_free, *target, leave_n);
        if (ustrcmp(token.name, ")") != 0) 
          error(150, &token);
        scanner(inf, &token, flag);
        return;
      }
      if (ustrcmp(token.name, ")") != 0) 
        error(150, &token);
      scanner(inf, &token, flag);
    } else {
      *target = 1;
      old_fact(inf, n2, flag);
      (*n2)->next = NULL;
    }
  else if ((*n2)->next != NULL) {
    total_eval(inf, n, n2, flag, should_free, *target, leave_n);  /*1, May 1998 BUG */
    return;
  }
  
  if (leave_n) {  /* create new storage */
    num2 = NULL;
    quoly_assign(*n, &num2);
    *n = num2;
  }
  
  /* n2 must be 'poly', except number denom is ok in this version. 
     Aug 1997:  now ok to have any quoly.  denom <> number handled by 
     spec_quoly_eval. */
 d3 = NULL;
  if (!(*n2)->numb) 
    if ((*n2)->variant.vc_2.denom != NULL) 
      if ((*n2)->variant.vc_2.denom->numb) 
        d3 = (*n2)->variant.vc_2.denom;
      else { 
/* if (command_int)  */

		horner_quoly_eval(n, n2, *target);   /* Jan 2006 */
/* else
	spec_quoly_eval(n, n2, *target);  old way */
	  
        return;
      }
  
  /* Originally, the following was guaranteed to be true in total_eval. */
  if ((*n)->numb) 
    return;
  
  n3 = NULL;
  newn3 = (*n2)->numb;
  if (newn3) 
    quoly_to_poly(*n2, &n3);                      /* new storage */
  else 
    n3 = (*n2)->variant.vc_2.numer;
  
  source = poly_depth(n3);
  
  if (laurent) 
    if (needto((*n)->variant.vc_2.numer, *target)) {
      /* Remove all bad negative exponents from n -- for
         calls to actual_eval_poly. */
      clear_bads(&(*n)->variant.vc_2.numer, &exps, &tail, 0, halfblock);
      if ((*n)->variant.vc_2.denom == NULL) 
        poly_set(1, &(*n)->variant.vc_2.denom);
      eliminate_bads(&(*n)->variant.vc_2.denom, &exps, -1);
      freepoly(exps,tail); /*AAR*/
    }
  
  num_denom = NULL;
  den_denom = NULL;
  
  actual_eval_poly(&(*n)->variant.vc_2.numer, &num_denom, &n3, &d3, *target, source, polynames);
  
  if ((*n)->variant.vc_2.denom == NULL) 
    if (num_denom == NULL) {
      if ((*n)->variant.vc_2.numer->numb && (*n)->variant.vc_2.numer->next == NULL) 
        polynum_to_quoly(n);
    } else {
      (*n)->variant.vc_2.denom = num_denom;
      check_quoly(n, laurent);                    /* changed from true. 5/94 */
    }
  else {
    actual_eval_poly(&(*n)->variant.vc_2.denom, &den_denom, &n3, &d3, *target, source, polynames);
    if (poly_iszero((*n)->variant.vc_2.denom)) {
      error(22, &quotsign);
      quoly_set(1, n);
    }
    if (num_denom != NULL) 
      poly_mult(num_denom, (*n)->variant.vc_2.denom, &(*n)->variant.vc_2.denom, NULL);
    if (den_denom != NULL) 
      poly_mult(den_denom, (*n)->variant.vc_2.numer, &(*n)->variant.vc_2.numer, NULL);
    free_poly(&num_denom);
    free_poly(&den_denom);
    check_quoly(n, laurent);
  }
  
  if (newn3) 
    free_poly(&n3);
}

/*******************************************************************************/

void sparse_evalquoly(quolyptr n, sparseptr *spar, long rows, Boolean *arr_free, textptr inf, nameptr *flag)
{
  
  /* n is nil upon entry */
  
  long i;
  long k;
  long dumm;
  colm_ptrptr u;
  quoly n2;
  sparseptr spar2;
  sparseptr sp;
  long forEnd_7;
  long forEnd_8;

  if (*arr_free) 
    spar2 = *spar;
  else 
    copy_sparse(spar, &spar2, rows, false);
  
  *arr_free = true;

  sp = spar2;
  forEnd_8 = (rows - 1) / sparsesize;
  for (k = 0; k <= forEnd_8; ++k) {
    forEnd_7 = (k + 1) * sparsesize;
    for (i = 1 + k * sparsesize; i <= forEnd_7; ++i) 
      if (i > rows) 
        break;
      else {
        u = &sp->indx[(i - k * sparsesize) - 1];
        while (*u != NULL) {
          /* n is computed first time this is executed */
          get_evalquoly(inf, &(*u)->val, n, &dumm, flag, false, false);
          if (quoly_iszero((*u)->val)) 
            free_colm(u);
          else 
            u = &(*u)->next;
        }
      }
    sp = sp->next;
  }
  
  *spar = spar2;
  
  if (*n == NULL) {         /* still?  array is 0, i.e., empty */
    /* MUST call get_evalquoly at least once */
    n2 = NULL;
    quoly_set(0, &n2);
    get_evalquoly(inf, &n2, n, &dumm, flag, false, false);
    free_quoly(&n2);
  }
  
  if ((*n)->next != NULL)        /* total_eval was called by get_evalquoly */
    while (*n != NULL) {
      n2 = (*n)->next;
      free_quoly(n);
      *n = n2;
    }
  quoly_set(0, n);
}

/****************************************************************************/

void sparse_create(tokentipe *let, long r, long c, Boolean liner, Boolean init)
{
  
  /* June 1998: BUG.  need to have 'init' to prevent space-losing bug. Most
     of the callers didn't seem to realize that any storage was allocated here. */
  
  arrptr p;
  short i;

  if (r < 1 || c < 1) 
    error(27, let);
  /*  if sparse_oversize(r, c)
      then error(23, token);   June 1998. removed Oct 2000 */
  newarray(&p);                                   /* Oct 2000 */
  p->name = *let;
  p->start = 0;
  p->stop = -1;
  special_set_2(r, c, &p->sizearr);               /* Oct 2000 */
  p->rows = r;
  p->linear = liner;
  p->time = array_time;
  array_time++;
  
  if (let->address == -1) 
    i = hash(&let->name, 151);
  else 
    i = let->address;
  
  p->next = arr_store[i];
  arr_store[i] = p;
  
  if (init) 
    sparse_init(&p->spar, r);    /* June 1998 */
  else 
    p->spar = NULL;            /* probably not necessary */
}

/******************************************************************************/

extern void Cfunc(LongIntPtr param);

/******************************************************************************/

extern void Pfunc(LongIntPtr param);

/******************************************************************************/

#if 0
long rand_integer(void)
{
  
  /*extended*/ double rand_fract;
  long rand_int;

  random_ext = RandomX(&random_ext);
  rand_fract = random_ext / two_thirty1;
  rand_int = Num2Longint(halfblock * rand_fract);
  random_ext = RandomX(&random_ext);
  rand_fract = random_ext / two_thirty1;
  return Num2Longint(halfblock * rand_fract) + halfblock * rand_int;
}
#endif

/****************************************************************************/

void raise_quoly(quolyptr n, long k);

/****************************************************************************/

void lower_quoly(quolyptr n, long k)
{
  
  /* laurent ok. n is not a number. k <> 0. n is authenic. ~ beware poly mod out
     Oct 2005: NOTE long k is passed to add_pad.  */
  
  poly p;

  if (k < 0) 
    error(273, &token);
  if (depth_below((*n)->variant.vc_2.numer) + k > number_polys) 
    error(277, &token);
  if ((*n)->variant.vc_2.denom != NULL) 
    if (depth_below((*n)->variant.vc_2.denom) + k > number_polys) 
      error(277, &token);
  if (!((*n)->variant.vc_2.numer->numb && (*n)->variant.vc_2.numer->next == NULL))
    add_pad(&(*n)->variant.vc_2.numer, k);
  if ((*n)->variant.vc_2.denom != NULL) 
    if (!(*n)->variant.vc_2.denom->numb) 
      add_pad(&(*n)->variant.vc_2.denom, k);
}

/****************************************************************************/

void call_content(quolyptr x, quolyptr n, quolyptr m);

/* Aug 1997, Sep 2002 */

/****************************************************************************/

void check_for_monic_poly(long erno, quoly num, intptr n, lintptr expon, polyptrr p, polyptrr t)
{   /* above ptrs, Feb 2004 */
  if (num->numb)
    error(erno, &token);
  if (num->variant.vc_2.denom != NULL) 
    error(196, &token);
  *p = num->variant.vc_2.numer;
  *n = 1;
  *t = NULL;
  while ((*p)->exp == 0) {
    if ((*p)->numb) 
      error(198, &token);              /* was error to omit this*/
    (*n)++;
    *t = *p;                           /* trailer */
    *p = (*p)->variant.pcoef;
  }
  *expon = (*p)->exp;
  if (*expon < 0) 
    error(198, &token);
  if (!poly_eq_1((*p)->variant.pcoef)) 
    error(197, &token);
}

/******************************************************************************/

long fasterlookup(tokentipe *x, arrptr *q, textptr inf, nameptr *flag);

/****************************************************************************/

void get_quoly_ptr(quolyptr *qp, textptr inf, nameptr *flag)
{
  /* Return qp as a pointer to existing storage -- do not duplicate the storage.
     qp^ must be nil or irrelevant on input. August 1996 
     
       Nov 1997:  Beware!  qp might be nil at end, if we have a sparse array 
     with no entry present, i.e., 0.  Caller must check.
       Jan 1998:  also, qp^ might be nil; uninitialized ordinary array. 
       
       On entry qp can be unitialized.  Nov 2003.  */
  
  nameptr p;
  arrptr qa;
  varptr q;
  long row;
  long count;
  numptr np;
  Boolean sensitive;
  tokentipe oldtok;

  if (*flag != NULL && (*flag)->compiled) 
    switch ((*flag)->tipe) { 
      case one:
        *qp = (*flag)->qp;
        *flag = (*flag)->next;
        token = (*flag)->let;
        break;
      case two:
        *qp = (*flag)->qp;
        *flag = (*flag)->next->next;
        *flag = (*flag)->next->next;
        token = (*flag)->let;
        break;
      case three:
        p = *flag;
        *flag = (*flag)->next->next;
        token = (*flag)->let;
        ievalcoords(&row, &count, flag, &sensitive);
        *flag = (*flag)->next;
        token = (*flag)->let;
        np = (numptr)p->qp;
        row = np->value + row - addresser;        /* changed Oct 1993 */
        if (sensitive) 
          row += (count - addresser) * (np->next->value);
        *qp = &(*arp[BSR(row, 10)])[BAnd(row, tenmask)];
        break;
    }
  
  else {
    
    if (ustrcmp(token.name, "<") == 0)
      error(243, &token);
    
    oldtok = token;
    if (ustrcmp(token.name, "%") != 0) 
      scanner(inf, &token, flag);
    if (ustrcmp(token.name, "[") == 0 || ustrcmp(token.name, "%") == 0) {
      if (fasterlookup(&oldtok, &qa, inf, flag) == -1) 
        error(28, &oldtok);
      if (ustrcmp(oldtok.name, "%") == 0) {
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "[") != 0) 
          error(217, &token);
      }
      scanner(inf, &token, flag);
      evalcoords(inf, &row, &count, flag, ']', ',', &sensitive, false);
      array_quoly_ptr(qa, row, count, sensitive, qp, &oldtok, false);
      scanner(inf, &token, flag);
    } else {
      /* Lookup oldtok in symbol table. */
      if (oldtok.address == -1) 
        row = hash(&oldtok.name, 151);
      else 
        row = oldtok.address;
      q = sca_store[row];
      while (q != NULL) 
        if (ustrcmp(q->let.name, oldtok.name) == 0) 
          break;
        else 
          q = q->next;
      if (q == NULL) 
        error(19, &oldtok);
      else 
        *qp = &q->val;
    }
  }
}

/****************************************************************************/

void new_get_quoly_ptr(quolyptr *qp, textptr inf, nameptr *flag, Boolean *spars)
{
  /* Return qp as a pointer to existing storage -- do not duplicate the storage.
	 qp^ must be nil or irrelevant on input. August 1996 
	 
	 Nov 1997:  Beware!  qp might be nil at end, if we have a sparse array 
	 with no entry present, i.e., 0.  Caller must check.
	 Jan 1998:  also, qp^ might be nil; uninitialized ordinary array. 
	 
	 On entry qp can be unitialized.  Nov 2003. 
	 Aug 2010, new. return "spars" if it's a sparse array. */
  
  nameptr p;
  arrptr qa;
  varptr q;
  long row;
  long count;
  numptr np;
  Boolean sensitive;
  tokentipe oldtok;
	
	*spars = false;
	
  if (*flag != NULL && (*flag)->compiled) 
    switch ((*flag)->tipe) { 
      case one:
        *qp = (*flag)->qp;
        *flag = (*flag)->next;
        token = (*flag)->let;
        break;
      case two:
        *qp = (*flag)->qp;
        *flag = (*flag)->next->next;
        *flag = (*flag)->next->next;
        token = (*flag)->let;
        break;
      case three:
        p = *flag;
        *flag = (*flag)->next->next;
        token = (*flag)->let;
        ievalcoords(&row, &count, flag, &sensitive);
        *flag = (*flag)->next;
        token = (*flag)->let;
        np = (numptr)p->qp;
        row = np->value + row - addresser;        /* changed Oct 1993 */
        if (sensitive) 
          row += (count - addresser) * (np->next->value);
        *qp = &(*arp[BSR(row, 10)])[BAnd(row, tenmask)];
        break;
    }
  
  else {
    
    if (ustrcmp(token.name, "<") == 0)
      error(243, &token);
    
    oldtok = token;
    if (ustrcmp(token.name, "%") != 0) 
      scanner(inf, &token, flag);
    if (ustrcmp(token.name, "[") == 0 || ustrcmp(token.name, "%") == 0) {
      if (fasterlookup(&oldtok, &qa, inf, flag) == -1) 
        error(28, &oldtok);
      if (ustrcmp(oldtok.name, "%") == 0) {
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "[") != 0) 
          error(217, &token);
      }
			*spars = (qa->spar != NULL);
      scanner(inf, &token, flag);
      evalcoords(inf, &row, &count, flag, ']', ',', &sensitive, false);
      array_quoly_ptr(qa, row, count, sensitive, qp, &oldtok, false);
      scanner(inf, &token, flag);
    } else {
      /* Lookup oldtok in symbol table. */
      if (oldtok.address == -1) 
        row = hash(&oldtok.name, 151);
      else 
        row = oldtok.address;
      q = sca_store[row];
      while (q != NULL) 
        if (ustrcmp(q->let.name, oldtok.name) == 0) 
          break;
        else 
          q = q->next;
      if (q == NULL) 
        error(19, &oldtok);
      else 
        *qp = &q->val;
    }
  }
}

/*****************************************************************************/

void make_sparse(textptr inf, quolyptr n, nameptr *flag);

/******************************************************************************/

void do_total_degree(quolyptr n, arrptr q, long k);

/****************************************************************************/

void get_quoly(quolyptr n, textptr inf, nameptr *flag);

/*****************************************************************************/

void funcdef(textptr inf, nameptr *flag);

/*****************************************************************************/

void change_coef(textptr inf, quolyptr n, nameptr *flag);

/*****************************************************************************/

void namechange(textptr inf, quolyptr n, nameptr *flag);

/*****************************************************************************/

void create_array(textptr inf, quolyptr n, nameptr *flag);

/*****************************************************************************/

void new_pseudo(quolyptr n, arrptr oq, spar_arr *auxspar, workptr alpha, boolarray *want)
{
  
  /* July 1998. oq must be sparse. auxspar, want, and alpha are unused and probably 
     uninitialized. Duplicate oq.  Invoke Pseudet.  rational mode only, all entries 
     integer. Return n = 2 * abs.value of product of nonzero entries on diagonal. */
  
  arrptr q;
  quoly qq;
  long rows;
  long rank;
  long i;
  sparseptr spar;

  rows = oq->rows;
  spar = oq->spar;
  
  if (verbose) {
    fprintf(stdout, "\n");
    fprintf(stdout, " Precomputing pseudo-determinant, rows %2d:\n", rows);
  }

  if (spar == NULL) 
    error(122, &token);  /* was 319, Jun 2005 */
  
  newarray(&q);                                   /* Oct 2000 */
  num_assign(&oq->sizearr, &q->sizearr);          /* this proc is rational mode only; Oct 2000 */
  q->rows = rows;
  q->spar = NULL;
  
  copy_sparse(&spar, &q->spar, rows, false);
  
  colreduce(n, q, want, alpha, alpha, alpha, alpha, auxspar, true, block);
  
  spar = q->spar;
  rank = (*n)->variant.vc_1.ncoef->head->value;
  quoly_set(1, n);
  for (i = 1; i <= rank; ++i) {
    sparse_qq_set(i, &spar, &qq);
    fast_quoly_mult(n, &qq);                      /* Dec 2001 */
  }
  
  quoly_abs(*n);
  summ((*n)->variant.vc_1.ncoef, (*n)->variant.vc_1.ncoef, (*n)->variant.vc_1.ncoef, block);
  if (quoly_iszero(*n)) 
    fermat_error("zero value in new_pseudo", true);
  
  free_sparse(&q->spar, rows, true);
  q->next = arr_garb;
  arr_garb = q;
}

/**************************************************************************/

void swap_storage(textptr inf, quolyptr n, nameptr *flag)
{
  
  /* Sep 2000.  Big pain due to possibility of nil in sparse (or ordinary) array. 
     Basically, exchange the storage of two "variables": array, sparse array, array
     of arrays, whatever. 
       another subtlety: set the arr_arg! */
  
  quolyptr x;
  quolyptr y;
  colm_ptrptr auxx;
  colm_ptrptr auxy;
  long colposx;
  long colposy;

  free_quoly(n);
  scanner(inf, &token, flag);
  if (ustrcmp(token.name, "(") != 0) 
    error(177, &token);
  scanner(inf, &token, flag);
  fact(inf, &x, n, &auxx, &colposx, flag, true);
  if (*n != NULL) 
    error(316, &token);
  if (ustrcmp(token.name, ",") != 0) 

    error(202, &token);
  scanner(inf, &token, flag);
  fact(inf, &y, n, &auxy, &colposy, flag, true);
  if (*n != NULL)
    error(316, &token);
  if (x == NULL)                /* auxx, colposx name a spot in a sparse array that's logically 0. */
    if (y == NULL)              /* auxy, colposy name a spot in a sparse array that's logically 0. */
                               /* nothing -- 0 in two places in sparse array(s). */
      ;
    else if (*y == NULL || quoly_iszero(*y))      /* nothing */
      ;
    else {
      /* put a zero into x^. */
      sparse_zero_set(auxx, colposx, &x);
      *n = *x;
      *x = *y;                                    /* x^ is now fine. */
      *y = *n;
      /* if y is in a sparse array, must delete this new 0! */
      if (auxy != NULL)
        purge_sparse(auxy, colposy);
      else
        (*y)->variant.vc_1.arr_arg = false;    /* harmless if y^ is part of an array */
    }
  else if (y == NULL)     /* auxy, colposy name a spot in a sparse array that's logically 0 */
    if (*x == NULL || quoly_iszero(*x))     /* nothing */
      ;
    else {
      /* put a zero into y^. */
      sparse_zero_set(auxy, colposy, &y);
      *n = *y;
      *y = *x;                                    /* y^ is now fine. */
      *x = *n;
      /* if x is in a sparse array, must delete this new 0! */
      if (auxx != NULL)
        purge_sparse(auxx, colposx);
      else 
        (*x)->variant.vc_1.arr_arg = false;       /* harmless if x^ is part of an array */
    }
  else {                                          /* x <> nil and y <> nil */
    if (*x == NULL) 
      quoly_set(0, x);
    if (*y == NULL) 
      quoly_set(0, y);
    *n = *y;
    *y = *x;
    *x = *n;
    if (auxx != NULL)
      purge_sparse(auxx, colposx);
    else if ((*x)->numb) 
      (*x)->variant.vc_1.arr_arg = false;         /* harmless if x^ is in an array */
    if (auxy != NULL) 
      purge_sparse(auxy, colposy);
    else if ((*y)->numb) 
      (*y)->variant.vc_1.arr_arg = false;         /* harmless if y^ is in an array */
  }
  
  if (ustrcmp(token.name, ")") != 0) 
    error(1, &token);
  scanner(inf, &token, flag);
  *n = NULL;
  quoly_set(0, n);
}

/**************************************************************************/

void move_storage(textptr inf, quolyptr n, nameptr *flag)
{
  
  /* Sep 2000.  Big pain due to possibility of nil in sparse (or ordinary) array. 
     Basically, move the storage of two "variables": array, sparse array, array
     of arrays, whatever. 
       another subtlety: set the arr_arg! */
  
  quolyptr x;
  quolyptr y;
  colm_ptrptr auxx;
  colm_ptrptr auxy;
  long colposx;
  long colposy;

  free_quoly(n);
  scanner(inf, &token, flag);
  if (ustrcmp(token.name, "(") != 0) 
    error(177, &token);
  scanner(inf, &token, flag);
  fact(inf, &x, n, &auxx, &colposx, flag, true);
  if (*n != NULL) 
    error(316, &token);
  if (ustrcmp(token.name, ",") != 0) 
    error(202, &token);
  scanner(inf, &token, flag);
  fact(inf, &y, n, &auxy, &colposy, flag, true);
  if (*n != NULL) 
    error(316, &token);
  if (x == NULL)           /* auxx, colposx name a spot in a sparse array that's logically 0. */
    if (y == NULL)         /* auxy, colposy name a spot in a sparse array that's logically 0. */
                           /* nothing -- 0 in two places in sparse array(s). */
      ;
    else if (*y == NULL || quoly_iszero(*y))      /* nothing */
      ;
    else {
      /* put a zero into y^. */
      quoly_set(0, y);
      /* if y is in a sparse array, must delete this new 0! */
      if (auxy != NULL) 
        purge_sparse(auxy, colposy);
      else 
        (*y)->variant.vc_1.arr_arg = false;       /* harmless if y^ is part of an array */
    }
  else if (y == NULL)        /* auxy, colposy name a spot in a sparse array that's logically 0 */
    if (*x == NULL || quoly_iszero(*x))           /* nothing */
      ;
    else {
      /* put a zero into y^. */
      sparse_zero_set(auxy, colposy, &y);
      free_quoly(y);
      *y = *x;                                    /* y^ is now fine. */
      *x = NULL;
      quoly_set(0, x);
      /* if x is in a sparse array, must delete this new 0! */
      if (auxx != NULL)
        purge_sparse(auxx, colposx);
      else 
        (*x)->variant.vc_1.arr_arg = false;       /* harmless if x^ is part of an array */
    }
  else {                                          /* x <> nil and y <> nil */
    if (*x == NULL) 
      quoly_set(0, x);
    free_quoly(y);
    *y = *x;
    *x = NULL;
    quoly_set(0, x);
    if (auxx != NULL)
      purge_sparse(auxx, colposx);
    else 
      (*x)->variant.vc_1.arr_arg = false;         /* harmless if x^ is in an array */
    if (auxy != NULL) 
      purge_sparse(auxy, colposy);
    else if ((*y)->numb) 
      (*y)->variant.vc_1.arr_arg = false;         /* harmless if y^ is in an array */
  }
  
  if (ustrcmp(token.name, ")") != 0) 
    error(1, &token);
  scanner(inf, &token, flag);
  quoly_set(0, n);
}

/****************************************************************************/

/* split off from following proc, Sep 1997.
     Originally, input p was q^.numer of a valid quoly.  As of Sep 1997,
   that can no longer be assumed.  This proc is used to traverse a poly, check
   it is a monomial, and report the heights between vars. */

void height_next_var(polyptrr p, intptr height, long err)  /* Feb 2004 */
{

  while (true) {
    if ((*p)->next != NULL)              /* Note that this catches invalid Laurent input */
      error(err, &token);
    if ((*p)->numb) 
      break;
    else if ((*p)->exp == 0) {
      *p = (*p)->variant.pcoef;
      (*height)++;
    } else 
      break;
  }
}

/****************************************************************************/

void check_get_height(quoly q, intptr height, long err)  /* Feb 2004 */
{
  
  /* Check that q is a simple var to first power, and return 
     its height.  Aug 1997.  Revised Sep 1997.  */
  
  poly p;

  if (q->numb || q->variant.vc_2.denom != NULL) 
    error(err, &token);
  p = q->variant.vc_2.numer;
  *height = 0;
  height_next_var(&p, height, err);
  if (p->exp != 1) 
    error(err, &token);
  if (!poly_eq_1(p->variant.pcoef)) 
    error(err, &token);
}

/*****************************************************************************/

void leading_mon(quolyptr x, quolyptr y, quolyptr n)
{
  
  /* n, x and y gotten from get_the_data. y might be nil, else y^ must 
     be just a poly var. x^ is not a number. Pass back answer in n. Aug 1997
       Quite subtle in the case n = nil, because new storage must be created. 
     Also, the old zero-head-node bug-a-boo makes it quite subtle.  Compare
     procedure dump_mons in fer320. */
  
  short height;
  short i;
  polyptrr p;
  polyptrr q;
  poly s;

  if ((*x)->variant.vc_2.denom != NULL) 
    error(196, &token);
  
  if (y == NULL)                                  /* no height cutoff specified */
    height = halfblock;                           /* infinity */
  else 
    check_get_height(*y, &height, 282);
  
  if (*n == NULL) {                               /* note: x^ and n not pointing to same thing */
    s = (*x)->variant.vc_2.numer;                 /* the input */
    newquoly(n);
    (*n)->variant.vc_2.numer = NULL;
    (*n)->variant.vc_2.denom = NULL;
    (*n)->variant.vc_2.rat = false;
    (*n)->numb = false;
  }
  p = &(*n)->variant.vc_2.numer;
  q = &(*n)->variant.vc_2.numer;           /* q is for solving the zero-head-node problem. */
  i = 0;
  if (*p == NULL)                                 /* n was initially nil */
    while (i < height) {
      i++;
      newpoly(p);
      (*p)->variant.pcoef = NULL;
      (*p)->next = NULL;
      (*p)->numb = s->numb;
      (*p)->exp = s->exp;
      if (s->exp != 0) 
        q = &(*p)->variant.pcoef;
      if (s->numb) {
        init_poly_node(*p);
        if (lintmode) 
          (*p)->variant.ncoef->lint = s->variant.ncoef->lint;
        else 
          num_assign(s->variant.ncoef, (*p)->variant.ncoef);
        if (q != p) {                             /* there is a zero-head-node. */
          s = *p;
          *p = NULL;
          free_poly(q);
          *q = s;
          p = q;                                  /* so p^ is not nil */
        }
        break;
      } else 
        p = &(*p)->variant.pcoef;                 /* so p^ = nil */
      s = s->variant.pcoef;
    }
  else 
    while (i < height) {
      free_poly(&(*p)->next);
      i++;
      if ((*p)->exp != 0) 
        q = &(*p)->variant.pcoef;
      if ((*p)->numb) {
        if (q != p) {                             /* there is a zero-head-node. */
          s = *p;
          *p = NULL;
          free_poly(q);
          *q = s;
          p = q;                                  /* so p^ is not nil */
        }
        break;
      } else 
        p = &(*p)->variant.pcoef;                 /* p^ not nil */
    }
  
  if (*p == NULL) 
    poly_assign(s, p);
  
  if ((*n)->variant.vc_2.numer->numb && (*n)->variant.vc_2.numer->next == NULL) 
    polynum_to_quoly(n);
}

/***************************************************************************/

#if 0
/* p is not a number. called by matrix invert, which sometimes turns off 
   poly_mod_out, then needs to recheck the quolies at the end. */

void recheck(quolyptr p)
{
  
  total_poly_modout(&(*p)->variant.vc_2.numer, polynames);
  if ((*p)->variant.vc_2.denom != NULL) {
    total_poly_modout(&(*p)->variant.vc_2.denom, polynames);
    if (poly_iszero((*p)->variant.vc_2.denom)) {
      fprintf(stdout, " On converting a quoly to poly-mod-out, a denominator became 0.\n");
      fprintf(stdout, " The quoly was set to 0.\n");
      quoly_set(0, p);
      return;
    }
    check_quoly(p, laurent);                      /* was false. 5/94 */
  } else if ((*p)->variant.vc_2.numer->numb && (*p)->variant.vc_2.numer->next == NULL) 
    polynum_to_quoly(p);
}
#endif

#if 0
/*******************************************************************************/

/* doesn't mod out num! */

void quoly_set_lint(long num, quolyptr p)
{
  
  free_quoly(p);
  newquoly(p);
  (*p)->numb = true;
  newimag(&(*p)->variant.vc_1.ncoef);
  (*p)->variant.vc_1.ncoef->lint = num;
}
#endif

/***************************************************************************/

void array_seek(tokentipe *x, arrptr *q)
{
  
  short i;

  if (x->address == -1) 
    i = hash(&x->name, 151);
  else 
    i = x->address;
  
  *q = arr_store[i];
  while (*q != NULL) 
    if (ustrcmp((*q)->name.name, x->name) == 0) 
      break;
    else 
      *q = (*q)->next;
  if (*q == NULL) 
    error(28, x);
}

/********************************************************************************/

void new_arretrieve(textptr inf, tokentipe *x, nameptr *flag, quolyptr *qp, quolyptr n, 
                    colm_ptrptr *t, LongIntPtr colpos)  /* n added Oct 1999 */
{
  /* Nov 1997: all new special version of arretrieve to accomodate new grammar.  
     See new_array_quoly_ptr. 
     
       May 2001: opening if-stmt is obsolete, but apparently harmless. Note that
     n is mentioned only there, hence it's nil usually at end. 
     
       On entry qp can be unitialized.  Nov 2003. 
       
       BEWARE! n is usually nil on exit.  Oct 2005 */
  
  long r;
  long c;
  arrptr q;                                       /* arrptr for array named x */
  Boolean colflag;                                /* is a second coordinate present? */

  if (ustrcmp(x->name, "if") == 0 || ustrcmp(x->name, "while") == 0) {
    /* Oct 1999; new condition grammar */
    sys_func_token = token;
    token = *x;
    doing_sys_func = true;
    call_sys_func(inf, n, flag);
    *qp = n;
    return;
  } else 
    scanner(inf, &token, flag);
  
  if (integerflag) 
    ievalcoords(&r, &c, flag, &colflag);
  else 
    evalcoords(inf, &r, &c, flag, ']', ',', &colflag, false);
  scanner(inf, &token, flag);
  array_seek(x, &q);
  new_array_quoly_ptr(q, &r, &c, colflag, qp, x, t);  /* sets t, c and qp */
  *colpos = c;               /* Dec 1997 */
  if (*qp != NULL)           /* qp = nil means sparse array, entry not there; i.e. it's 0 */
    if (**qp == NULL) {
      quoly_set(0, *qp);
      (*(*qp))->variant.vc_1.arr_arg = false;     /* May 2001. failsafe */
    }
}

/****************************************************************************/

void call_sys_func(textptr inf, quolyptr n, nameptr *flag)
{
  nameptr p;
  nameptr copy;
  tokentipe oldtok;

  current_func = sys_func_tok;
  func_def_count++;
  last_good_one = NULL;
  last_attached = NULL;
  last_comm = NULL;
  
  in_sys_func = true;  /* Apr 2007 */
  spec_right_side(&sys_func, inf, flag, (unsigned char *)";");
  in_sys_func = false;  /* Apr 2007 */
  
 if (feof(*inf) && ustrcmp(token.name, ";") != 0) 
    error(103, &token);
  func_def_count--;
  oldtok = token;
  /* Now actually evaluate. */
  p = startexpr;
  copy = prev_expr;
  quoly_set(0, n);
  prev_expr = NULL;
  startexpr = NULL;
  eval_form(inf, sys_func, n);
  if (*n == NULL) 
    quoly_set(0, n);
  token = oldtok;
  integerflag = false;
  prev_expr = copy;
  startexpr = p;
  exit_flag = false;
  cycle_flag = false;
  leave_flag = false;
}

/*****************************************************************************/

struct set_coef_EnvRec {
  poly *n;
  imptr im;
};
typedef struct set_coef_EnvRec set_coef_EnvRec;

/********************************************************/

/* Set the expont coef of p to n2 or n3.  In second call of set_it, n2 = n3. */
static void set_it(Boolean itszero, poly p, poly t, poly n2, poly n3, long expont, set_coef_EnvRec *set_coef_Env)
{
  if (itszero) {                                  /* the new coef n2 is 0 */
                                                  /* remove p^ */
    if (t == NULL) 
      *set_coef_Env->n = p->next;
    else 
      t->next = p->next;
    if (n2 != NULL) 
      free_poly(&n2);
    p->next = NULL;
    free_poly(&p);
    if (*set_coef_Env->n == NULL) 
      poly_set(0, set_coef_Env->n);
  } else if (p->numb) 
    if (n2->numb && n2->next == NULL) {           /* want n2 */
      set_coef_Env->im = n2->variant.ncoef;
      n2->variant.ncoef = p->variant.ncoef;
      p->variant.ncoef = set_coef_Env->im;
      free_poly(&n2);
    } else {
      free_imag(&p->variant.ncoef);
      p->numb = false;
      p->variant.pcoef = n2;
    }
  else if (expont == 0 && n3->numb && n3->next == NULL) {
    if (t == NULL) 
      *set_coef_Env->n = n3;
    else 
      t->next = n3;
    n3->next = p->next;
    freepoly(p,p); /*AAR*/
/*AAR
    p->next = polygarb;
    polygarb = p;
*/
  } else if (n2 != NULL) {                        /* only from second call of set_it */
    free_poly(&p->variant.pcoef);
    p->variant.pcoef = n2;
  }
}

/*********************************************************/

void set_coef(polyptrr n, textptr inf, nameptr *flag, short level)
{
  
  /* Within n search for the term described by the exponents to be read.
     Then read the new coefficient for that term, and change n by inserting
     the new coef.  Don't change n until sure that no errors have occurred. 
     n could be nil on input, never on output. This procedure calls itself
     recursively. */
  
  poly p;
  poly t;
  poly n2;
  poly n3;
  Boolean itszero;
  Boolean itsthere;
  Boolean oldmodmode;
  long expont;
  quoly q;
  short i;
  short depth;
  set_coef_EnvRec set_coef_Env;

  set_coef_Env.n = n;
  if (ustrcmp(token.name, ",") == 0) {
    /* read the exponent */
    level++;
    scanner(inf, &token, flag);
    q = NULL;
    check_modular(&oldmodmode);
    old_expre(inf, &q, flag);
    if (q->numb) 
      expont = quoly_convert_to_int(q);
    else {
      free_quoly(&q);
      error(155, &token);
    }
    if (expont == neg_two_to_31) 
      error(156, &token);
    if (!laurent && expont < 0) 
      error(166, &token);
    free_quoly(&q);
    restore_modular(oldmodmode);
    if (*n == NULL) {
      set_coef(n, inf, flag, level);
      if (expont == 0 && (*n)->numb && (*n)->next == NULL)   /* nothing */
        ;
      else if (!poly_iszero(*n)) {
        newpoly(&n3);
        n3->exp = expont;
        n3->numb = false;
        n3->variant.pcoef = *n;
        n3->next = NULL;
        *n = n3;
      }
    } else {
      /* Search for expont in n. If found, p points to it;
         otherwise it's between t and p. */
      p = *n;
      t = NULL;
      while (p != NULL) 
        if (p->exp > expont) {
          t = p;
          p = p->next;
        } else 
          break;
      /* t still nil means p = n */
      
      n2 = NULL;
      itsthere = p != NULL && p->exp == expont;
      if (p == NULL) 
        set_coef(&n2, inf, flag, level);
      else if (p->exp == expont) 
        if (p->numb) 
          set_coef(&n2, inf, flag, level);
        else 
          set_coef(&p->variant.pcoef, inf, flag, level);
      else 
        set_coef(&n2, inf, flag, level);
      if (n2 == NULL) 
        itszero = poly_iszero(p->variant.pcoef);
      else 
        itszero = poly_iszero(n2);
      if (itsthere) 
        set_it(itszero, p, t, n2, p->variant.pcoef, expont, &set_coef_Env);
      else if (itszero) 
        free_poly(&n2);
      else {
        if (expont == 0 && n2->numb && n2->next == NULL)   /* nothing */
          ;
        else {                                    /* pad it */
          newpoly(&n3);
          n3->exp = expont;
          n3->numb = false;
          n3->variant.pcoef = n2;
          n2 = n3;
        }
        n2->next = p;
        if (t == NULL) 
          *n = n2;
        else 
          t->next = n2;
      }
    }
  }
  
  else {
    /* Read the new coefficient.  Convert to poly form in p. 
       If not a number, check for appropriateness. */
    if (ustrcmp(token.name, ")") != 0) 
      error(1, &token);
    scanner(inf, &token, flag);
    if (ustrcmp(token.name, ":") != 0) 
      error(152, &token);                         /* Dec 1997 */
    scanner(inf, &token, flag);
    if (ustrcmp(token.name, "=") != 0) 
      error(4, &token);
    scanner(inf, &token, flag);
    q = NULL;
    old_expre(inf, &q, flag);
    if (q->numb) 
      quoly_consume(&q, &p);
    else {
      if (q->variant.vc_2.denom != NULL) {
        free_quoly(&q);
        error(158, &token);
      }
      p = q->variant.vc_2.numer;
      /* check for and remove dummy exp = 0 nodes. */
      if (level == 0) 
        if (*n == NULL) 
          depth = 0;
        else 
          depth = 1;
      else 
        depth = level;
      for (i = 1; i <= depth; ++i) {
        if (p->exp != 0 || p->next != NULL) {
          free_quoly(&q);
          error(158, &token);
        }
        t = p;
        p = p->variant.pcoef;
      }
      if (depth == 0) {
        q->next = quolygarb;
        quolygarb = q;
      } else {
        t->variant.pcoef = NULL;
        free_quoly(&q);
      }
    }
    
    if (level == 0)       /* There was no recursion; leading coef desired. */
      if (*n == NULL) 
        *n = p;
      else 
        set_it(poly_iszero(p), *n, NULL, p, p, (*n)->exp, &set_coef_Env);
    else {
      if (*n != NULL) 
        free_poly(n);
      *n = p;
    }
  }
}

/******************************************************************************/

void evalcoords(textptr inf, LongIntPtr r, LongIntPtr c, nameptr *flag, char ending, char separator, Boolean *c_is_there, Boolean creating)
{
  
  quoly p;
  Boolean oldmodmode;

  p = NULL;
  check_modular(&oldmodmode);
  if (ustrncmp(token.name, &separator,1) == 0 && separator == '~') 
    *r = addresser;
  else {
    old_expre(inf, &p, flag);                     /* Nov 1997 */
    if (!p->numb) {
      free_quoly(&p);
      error(118, &token);
    }
    *r = convert_to_int(p->variant.vc_1.ncoef);
    if (creating && *r < 0) 
      error(314, &token);                         /* Oct 2000 */
    free_quoly(&p);
  }
  *c = addresser;
  *c_is_there = false;
  if (ustrncmp(token.name, &separator,1) == 0) {
    scanner(inf, &token, flag);
    if (separator == '~' && (ustrcmp(token.name, ",") == 0 || ustrcmp(token.name, "]") == 0)) 
      *c = -1;             /* subarray will set second row coord. to number of rows */
    else {
      old_expre(inf, &p, flag);               /* Nov 1997 */
      if (!p->numb) {
        free_quoly(&p);
        error(118, &token);
      }
      *c = convert_to_int(p->variant.vc_1.ncoef);
      if (creating && *c < 0) 
        error(314, &token);                       /* Oct 2000 */
      free_quoly(&p);
      *c_is_there = true;
    }
  }
  restore_modular(oldmodmode);
  if (ustrncmp(token.name, &ending,1) != 0 && ustrcmp(token.name, "]") != 0) 
    error(61, &token);
}

/******************************************************************************/


void get_exponent(textptr inf, nameptr *flag, imptr m2, Boolean factor)
{
  
  /* Assume m2 is nilled out and empty upon entry!  Note we do not check HERE
     that the exponent is in any particular range.  If lintmode, however, the
     call here to fact will return lintmode values!  That is, they will
     be less than 2^28 in abs. value (probably < 10^8) stored via n2^.ncoef^.lint.
        If factor = false, use expre and return m2 in rational format.  That's the
     caller's problem. */
  
  quoly n2;
  Boolean oldmodmode;
  Boolean oldlint;

  check_modular(&oldmodmode);
  scanner(inf, &token, flag);
  n2 = NULL;
  if (factor) 
    old_fact(inf, &n2, flag);
  else {
    /* if was in modularmode, convert format. sneaky! dangerous! */
    oldlint = lintmode;
    lintmode = false;
    old_expre(inf, &n2, flag);
    lintmode = oldlint;
  }
  if (!n2->numb) 
    error(116, &expsign);                     /*don't free_quoly(n2); too confusing */
  *m2 = *n2->variant.vc_1.ncoef;
  n2->variant.vc_1.ncoef->imag = imhead;
  imhead = n2->variant.vc_1.ncoef;
  n2->next = quolygarb;
  quolygarb = n2;
  restore_modular(oldmodmode);
}

/****************************************************************************/

struct builtin_func1_EnvRec {
  FILEPtr *inf;
  nameptr *flag;
  quoly *n;
  quoly bound;
  Boolean modular_stuff;
  long k;
  /* n is nil on entry */
  /* Sep 2000 */
  
  /* Split Jan 2002.  For MSmith_ and earlier, with a few more. */
  
  arrptr q;
  long rows;
  long cols;
  long start;
  long total_rows;
  long firstrow;
  long firstcol;
  long target_rows;
  tokentipe errorname;
  quolyptr x;
  workptr alpha;
  arr_descr arr_facts;
  Boolean oldm1;
  Boolean see_star;  /* Jun 2009. for read_command and Minors */
  quoly copy;
  quoly dum;
};
typedef struct builtin_func1_EnvRec builtin_func1_EnvRec;

/*******************************************************/

static void check_for_paren(builtin_func1_EnvRec *builtin_func1_Env)
{
  scanner(builtin_func1_Env->inf, &token, builtin_func1_Env->flag);
  if (ustrcmp(token.name, "(") != 0) 
    error(177, &token);
}

/********************************************************/

static void scanner_expre(builtin_func1_EnvRec *builtin_func1_Env)
{
  scanner(builtin_func1_Env->inf, &token, builtin_func1_Env->flag);
  if (ustrcmp(token.name, "^") == 0) 
    error(313, &token);                           /* Aug 1997 */
  old_expre(builtin_func1_Env->inf, builtin_func1_Env->n, builtin_func1_Env->flag);
}

/*********************************************************/

/* token = ^ on entry. Aug 1997 */
static void get_quolptr(quolyptr *x, builtin_func1_EnvRec *builtin_func1_Env)
{
  scanner(builtin_func1_Env->inf, &token, builtin_func1_Env->flag);
  get_quoly_ptr(x, builtin_func1_Env->inf, builtin_func1_Env->flag);  /* x might be nil! Nov 1997 */
}

/* yes, and x^ might be nil! Jan 1998 */

/******************************************************/

static void get_level_k(Boolean negcheck,         /* new in May 1997 */
                        builtin_func1_EnvRec *builtin_func1_Env)
{
  builtin_func1_Env->bound = NULL;
  scanner(builtin_func1_Env->inf, &token, builtin_func1_Env->flag);
  check_modular(&builtin_func1_Env->modular_stuff);
  old_expre(builtin_func1_Env->inf, &builtin_func1_Env->bound, builtin_func1_Env->flag);
  restore_modular(builtin_func1_Env->modular_stuff);
  if (!builtin_func1_Env->bound->numb) 
    error(227, &token);
  if (lintmode) 
    builtin_func1_Env->k = builtin_func1_Env->bound->variant.vc_1.ncoef->lint;
  else {
    builtin_func1_Env->k = builtin_func1_Env->bound->variant.vc_1.ncoef->head->value;
    if (builtin_func1_Env->bound->variant.vc_1.ncoef->size > 1) 
      error(314, &token);
  }
  free_quoly(&builtin_func1_Env->bound);
  if (negcheck && builtin_func1_Env->k < 0) 
    error(300, &token);
}

/********************************************************/

static void read_command(builtin_func1_EnvRec *builtin_func1_Env)
{
  check_for_paren(builtin_func1_Env);
  scanner(builtin_func1_Env->inf, &token, builtin_func1_Env->flag);
  if (ustrcmp(token.name, "*") == 0) {   /* Jun 2009. signal to cannibalize. */
    builtin_func1_Env->see_star = true;
    scanner(builtin_func1_Env->inf, &token, builtin_func1_Env->flag);
  }
  if (ustrcmp(token.name, "[") != 0) 
    error(178, &token);
  left_side(builtin_func1_Env->inf, &builtin_func1_Env->q, &builtin_func1_Env->rows, 
            &builtin_func1_Env->cols, &builtin_func1_Env->start, &builtin_func1_Env->total_rows, 
            &builtin_func1_Env->firstrow, &builtin_func1_Env->firstcol, 
            &builtin_func1_Env->target_rows, &builtin_func1_Env->errorname, 
            builtin_func1_Env->flag, false);
  if (builtin_func1_Env->q == NULL) 
    error(28, &builtin_func1_Env->errorname);
}

/*******************************************************/

static void read_with_comma(builtin_func1_EnvRec *builtin_func1_Env)
{
  check_for_paren(builtin_func1_Env);
  scanner_expre(builtin_func1_Env);
  if (ustrcmp(token.name, ",") != 0) 
    error(202, &token);
  scanner(builtin_func1_Env->inf, &token, builtin_func1_Env->flag);
}

/*******************************************************/

/* the old standard read. Aug 1997. */
static void simple_read(builtin_func1_EnvRec *builtin_func1_Env)
{
  check_for_paren(builtin_func1_Env);
  scanner_expre(builtin_func1_Env);
  if (ustrcmp(token.name, ")") != 0) 
    error(1, &token);
  scanner(builtin_func1_Env->inf, &token, builtin_func1_Env->flag);
}

/*******************************************************/

/* Aug 1997 */
static void get_the_data(quolyptr *x, quolyptr n, builtin_func1_EnvRec *builtin_func1_Env)
{
  if (ustrcmp(token.name, "^") == 0) {
    free_quoly(n);
    get_quolptr(x, builtin_func1_Env);
    if (*x == NULL || **x == NULL) {              /* Nov 1997; Jan 1998 */
      quoly_set(0, n);
      *x = n;
    }
  } else {
    old_expre(builtin_func1_Env->inf, n, builtin_func1_Env->flag);
    *x = n;
  }
}

/********************************************************/

/* significant change Aug 1997: now use x to point to input. */
static void standard_read(builtin_func1_EnvRec *builtin_func1_Env)
{
  check_for_paren(builtin_func1_Env);
  scanner(builtin_func1_Env->inf, &token, builtin_func1_Env->flag);
  get_the_data(&builtin_func1_Env->x, builtin_func1_Env->n, builtin_func1_Env);
  if (ustrcmp(token.name, ")") != 0) 
    error(1, &token);
  scanner(builtin_func1_Env->inf, &token, builtin_func1_Env->flag);
}

/***********************************************************/

static void read_quoly_ptr(quolyptr *x, quolyptr n,   /* Sep 2000 */
                           builtin_func1_EnvRec *builtin_func1_Env)
{
  scanner(builtin_func1_Env->inf, &token, builtin_func1_Env->flag);
  if (ustrcmp(token.name, "^") == 0)           /* irrelevant */
    scanner(builtin_func1_Env->inf, &token, builtin_func1_Env->flag);
  free_quoly(n);
  get_quoly_ptr(x, builtin_func1_Env->inf, builtin_func1_Env->flag);
  if (*x == NULL || **x == NULL) {
    quoly_set(0, n);
    *x = n;
  }
}

/***********************************************************/

static void read_quoly_ptr2(quolyptr *x, quolyptr n,   /* Jul 2002 */
                            builtin_func1_EnvRec *builtin_func1_Env)
{
  if (ustrcmp(token.name, "^") == 0)           /* irrelevant */
    scanner(builtin_func1_Env->inf, &token, builtin_func1_Env->flag);
  free_quoly(n);
  get_quoly_ptr(x, builtin_func1_Env->inf, builtin_func1_Env->flag);
  if (*x == NULL || **x == NULL) {
    quoly_set(0, n);
    *x = n;
  }
}

/***********************************************************/

static void basic_killden(builtin_func1_EnvRec *builtin_func1_Env)  /* Aug 2002 */
{
  get_quolptr(&builtin_func1_Env->x, builtin_func1_Env);
  if (ustrcmp(token.name, ")") != 0) 
    error(1, &token);
  if (builtin_func1_Env->x == NULL || *builtin_func1_Env->x == NULL)   /* Jan 1998 */
                                                  /* nothing */
                                                  /* Nov 1997 */
    ;
  else if ((*builtin_func1_Env->x)->numb)         /* nothing */
    ;
  else {
    free_poly(&(*builtin_func1_Env->x)->variant.vc_2.denom);
    if ((*builtin_func1_Env->x)->variant.vc_2.numer->numb && (*builtin_func1_Env->x)->variant.vc_2.numer->next == NULL) 
      polynum_to_quoly(builtin_func1_Env->x);
  }
  scanner(builtin_func1_Env->inf, &token, builtin_func1_Env->flag);
}

/***********************************************************/

static void array_killden(builtin_func1_EnvRec *builtin_func1_Env)  /* Aug 2002 */
{
  left_side(builtin_func1_Env->inf, &builtin_func1_Env->q, &builtin_func1_Env->rows, 
            &builtin_func1_Env->cols, &builtin_func1_Env->start, &builtin_func1_Env->total_rows, 
            &builtin_func1_Env->firstrow, &builtin_func1_Env->firstcol, 
            &builtin_func1_Env->target_rows, &builtin_func1_Env->errorname, 
            builtin_func1_Env->flag, false);
  if (builtin_func1_Env->q == NULL) 
    error(28, &builtin_func1_Env->errorname);
  if (builtin_func1_Env->start == -1) {           /* wasn't subarray */
    builtin_func1_Env->start = builtin_func1_Env->q->start;
    builtin_func1_Env->target_rows = builtin_func1_Env->total_rows;
  } else if (builtin_func1_Env->q->spar != NULL) 
    error(244, &builtin_func1_Env->errorname);
  killdenoms(builtin_func1_Env->q->spar, builtin_func1_Env->start, 
             builtin_func1_Env->total_rows, builtin_func1_Env->target_rows, 
             builtin_func1_Env->cols);
}

/***********************************************************/

static void finish_1(builtin_func1_EnvRec *builtin_func1_Env)
{
  free_arr(builtin_func1_Env->alpha, &builtin_func1_Env->arr_facts);
  free_work();
  special_free(&builtin_func1_Env->arr_facts.arrsize);  /* Oct 2000 */
  command_int = builtin_func1_Env->oldm1;
}

/***********************************************************/

static Boolean allnumbs(builtin_func1_EnvRec *builtin_func1_Env)
{
  long i;
  long forEnd_9;
  Boolean value_allnumbs = false;

  forEnd_9 = sqr(builtin_func1_Env->rows) - 1;
  for (i = 0; i <= forEnd_9; ++i) 
    if (!(*builtin_func1_Env->alpha)[i]->numb) 
      return value_allnumbs;
  return true;
}

/**********************************************************/

/* changes copy, dum.  dum = nil at end. */
static void do_int_determ(quolyptr m, long val, builtin_func1_EnvRec *builtin_func1_Env)
{
  if (builtin_func1_Env->bound == NULL) 
    quoly_set(-1, &builtin_func1_Env->copy);
  else {
    builtin_func1_Env->k = 1;
    builtin_func1_Env->dum = NULL;
    quoly_set(val, &builtin_func1_Env->dum);
    quoly_assign(builtin_func1_Env->bound, &builtin_func1_Env->copy);
    get_evalquoly(builtin_func1_Env->inf, &builtin_func1_Env->copy, 
                  &builtin_func1_Env->dum, &builtin_func1_Env->k, 
                  builtin_func1_Env->flag, false, false);
    free_quoly(&builtin_func1_Env->dum);
    if (!builtin_func1_Env->copy->numb) 
      error(238, &token);
    /* added Feb 2000, bug fix: */
    if (builtin_func1_Env->copy->variant.vc_1.ncoef->head->value == 0)   /* failsafe? */
      quoly_set(1, &builtin_func1_Env->copy);
    else if (builtin_func1_Env->copy->variant.vc_1.ncoef->head->value < 0) 
      in_place_neg(builtin_func1_Env->copy->variant.vc_1.ncoef);
  }
  int_determ(m, builtin_func1_Env->q, NULL, builtin_func1_Env->q->rows, 
             &builtin_func1_Env->copy);
}

/************************************************************************************/

void quoly_leading_coef(quolyptr x, quolyptr n)  
{
  /* Use x for input. n is either nil or x^ = n. x^ is not a number, has no denom.
     If n^ = nil, x^ is read-only. new Oct 2005.  */
  
  poly s;
  Boolean sensitive;
  
  if (*n == NULL)  {  /* x^ is a system data structure, var or array */
    leading_term(*x, n);
    s = (*n)->variant.vc_2.numer;
    if (!s->numb)
      while (s->exp == 0)  /* can't find a number this way */
        s = s->variant.pcoef;
  }
  else {  
    s = (*n)->variant.vc_2.numer;
    sensitive = false;
    while (s->exp == 0 && !s->numb && s->next == NULL) {
       s = s->variant.pcoef;
       sensitive = true;
    }
    free_poly(&s->next);
    if (laurent && sensitive && s->numb) {/* sneaky. get rid of dummy 0 nodes.  */
      poly_assign(s, &(*n)->variant.vc_2.numer);
      s = (*n)->variant.vc_2.numer; 
    }
  }
 
  if (!s->numb) {
      s->exp = 0;
      if (s->variant.pcoef->numb && s->variant.pcoef->next == NULL)   /* get rid of dummy head nodes */
        poly_assign(s->variant.pcoef, &(*n)->variant.vc_2.numer);
  }
  
  if ((*n)->variant.vc_2.numer->numb) 
    polynum_to_quoly(n);
 
}

/******************************************************************************/

void builtin_func1(textptr inf, quolyptr n, nameptr *flag, long index)
{
  
  arrptr q2[4];                                   /* Nov 2000 */
  long i;
  long j;
  tokentipe oldtok[6];                            /* Mar 1999 */
  Boolean wantmod;                                /* june 1998 */
  Boolean sparse;
  workptr beta[6];                                /* Mar 1999 */
  quoly m;
  quoly tr;
  quoly ci;
  quoly power;
  quoly cp;
  quolyptr y;
  boolarray want;
  number pseudodet;
  short height;
  short r2;
  short i2;
  sparseptr spar;
  spar_arr auxspar;                               /* June 1998 */
  long forEnd_10;
  long forEnd_11;
  long forEnd_12;
  long forEnd_13;
  long forEnd_14;
  long forEnd_15;
  long forEnd_16;
  long forEnd_17;
  builtin_func1_EnvRec builtin_func1_Env;
  numptr p;  /* Sep 2008 */
  unsigned long uj;  /* Sep 2008 */

  builtin_func1_Env.n = n;
  builtin_func1_Env.flag = flag;
  builtin_func1_Env.inf = inf;
  builtin_func1_Env.arr_facts.arrsize.size = 0;   /* Oct 2000 */
  builtin_func1_Env.see_star = false;   /* Jun 2009 */
  
  switch (index) { 
    case Numb_:
    case Rat_:
      standard_read(&builtin_func1_Env);
      if (index == Numb_) 
        if ((*builtin_func1_Env.x)->numb) 
          i = 1;
        else 
          i = 0;
      else if (!(*builtin_func1_Env.x)->numb && (*builtin_func1_Env.x)->variant.vc_2.rat && ! 
               lintmode) 
        i = 1;
      else 
        i = 0;
      quoly_set(i, n);
      break;
    
    case Iszero_:
      ustrcpy(builtin_func1_Env.errorname.name, "Iszero");
      new_worknode(&i, &builtin_func1_Env.errorname);
      builtin_func1_Env.alpha = workhead[i - 1];
      scanner(inf, &token, flag);
      spar = NULL;
      arr_fact(inf, n, builtin_func1_Env.alpha, &builtin_func1_Env.arr_facts, 
               &wantmod, &builtin_func1_Env.rows, flag, &spar);
      if (builtin_func1_Env.arr_facts.arrsize.head->value == 0)   /* Oct 2000 */
        error(184, &builtin_func1_Env.errorname);
      j = 1;
      if (spar == NULL) {
        forEnd_10 = builtin_func1_Env.arr_facts.arrsize.head->value - 1;
        for (i = 0; i <= forEnd_10; ++i) {        /* Oct 2000 */
          if (!quoly_iszero((*builtin_func1_Env.alpha)[i])) {
            j = 0;
            break;
          }
        }
      } else 
        sparse_iszero(spar, builtin_func1_Env.arr_facts.rows, &j);  /*@@@*/
      if (wantmod)                                /* not mnemonic */
        if (spar == NULL) 
          free_arr(builtin_func1_Env.alpha, &builtin_func1_Env.arr_facts);
        else 
          free_sparse(&spar, builtin_func1_Env.arr_facts.rows, true);
      free_work();
      quoly_set(j, n);
      break;
    
    case Isprime_:   /* BIG revision, Sep 2008 */
      standard_read(&builtin_func1_Env);
      if (!(*builtin_func1_Env.x)->numb) 
        error(227, &token);
      if (lintmode) 
        builtin_func1_Env.k = (*builtin_func1_Env.x)->variant.vc_1.ncoef->lint;
      else {
        builtin_func1_Env.k = (*builtin_func1_Env.x)->variant.vc_1.ncoef->head->value;
        if ((*builtin_func1_Env.x)->variant.vc_1.ncoef->size > 1) 
          if ((*builtin_func1_Env.x)->variant.vc_1.ncoef->size > 3)   /* Feb 1997 */
            error(289, &token);
		  else if ((*builtin_func1_Env.x)->variant.vc_1.ncoef->size == 3)
		    if (builtin_func1_Env.k > 127) 
			  error(289, &token);
			else 
			  {  i = builtin_func1_Env.k;
			     p = (*builtin_func1_Env.x)->variant.vc_1.ncoef->head->next;
			     uj = longg_is_prime(i, p->value, p->next->value);
				 if (uj < block)
				   quoly_set(uj, n);
				 else 
				   { quoly_set(block, n);
				     power = NULL;
					 quoly_set(uj / block, &power);
					 fast_mult(power->variant.vc_1.ncoef, (*n)->variant.vc_1.ncoef, power->variant.vc_1.ncoef);
					 quoly_set(uj % block, n);
					 best_quoly_add(n, power);
					 power = NULL;
					}
				 break;
			    }
          else if (builtin_func1_Env.k > 7) {      /* 7 = 2^31-1 div 2^28 (= block) */
            j = longg_is_prime(0, builtin_func1_Env.k, (*builtin_func1_Env.x)->variant.vc_1.ncoef->head->next->value);          /* was error(289, &token); */
			quoly_set(j, n);
			break;
		 }
          else 
            builtin_func1_Env.k = builtin_func1_Env.k * block + 
                        (*builtin_func1_Env.x)->variant.vc_1.ncoef->head->next->value;
      }
      if (builtin_func1_Env.k < 2) 
        j = 0;      /* Sep 2008. was error(289, &token); */
      else
	    j = long_is_prime(builtin_func1_Env.k);    /* Sep 2008 */
	  quoly_set(j, n);
      break;
    
    case Cfunc_:
    case Pfunc_:
      check_for_paren(&builtin_func1_Env);
      scanner(inf, &token, flag);
      if (integerflag) 
        iexpre(&builtin_func1_Env.k, flag);
      else {
        old_expre(inf, n, flag);
        if (!(*n)->numb) 
          error(91, &token);
        if (lintmode) 
          builtin_func1_Env.k = (*n)->variant.vc_1.ncoef->lint;
        else 
          builtin_func1_Env.k = (*n)->variant.vc_1.ncoef->head->value;
      }
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      scanner(inf, &token, flag);

      quoly_set(builtin_func1_Env.k, n);
      break;
    
    case Numer_:
    case Denom_:
      standard_read(&builtin_func1_Env);
      if (index == Denom_) 
        if ((*builtin_func1_Env.x)->numb) 
          quoly_set(1, n);
        else if ((*builtin_func1_Env.x)->variant.vc_2.denom == NULL) 
          quoly_set(1, n);
        else {
          if (*n == NULL) {                       /* see standard_read */
            base_quoly(n, 1);                     /* arbitrary initialization */
            poly_assign((*builtin_func1_Env.x)->variant.vc_2.denom, 
                        &(*n)->variant.vc_2.numer);
          } else {
            free_poly(&(*n)->variant.vc_2.numer);
            (*n)->variant.vc_2.numer = (*n)->variant.vc_2.denom;
            (*n)->variant.vc_2.denom = NULL;
          }
          /* bug fix. Aug 30 1994 */
          if ((*n)->variant.vc_2.numer->numb) 
            polynum_to_quoly(n);
        }
      else {
        if (*n == NULL) {                         /* see standard_read */
          quoly_set(0, n);                        /* arbitrary initialization */
          if ((*builtin_func1_Env.x)->numb) 
            num_assign((*builtin_func1_Env.x)->variant.vc_1.ncoef, 
                       (*n)->variant.vc_1.ncoef);
          else 
            p_q_assign((*builtin_func1_Env.x)->variant.vc_2.numer, 
                       n);
        }
        if ((*n)->numb)                           /* nothing */
          ;
        else {
          free_poly(&(*n)->variant.vc_2.denom);
          if ((*n)->variant.vc_2.numer->numb && (*n)->variant.vc_2.numer->next == NULL) 
            polynum_to_quoly(n);
        }
      }
      break;
    
    case Killden_:
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, "[") == 0) 
        array_killden(&builtin_func1_Env);
      else {
        if (ustrcmp(token.name, "(") != 0) 
          error(177, &token);
        basic_killden(&builtin_func1_Env);
      }
      quoly_set(0, n);
      break;
    
    case Level_:
      standard_read(&builtin_func1_Env);
      if ((*builtin_func1_Env.x)->numb) 
        quoly_set(0, n);
      else 
        quoly_set(poly_level((*builtin_func1_Env.x)->variant.vc_2.numer), n);
      break;
    
    case Mono_:  /* Jul 2006, Dec 2006 here */
      check_for_paren(&builtin_func1_Env);
      scanner(inf, &token, flag);
      get_the_data(&builtin_func1_Env.x, n, &builtin_func1_Env);
      if (ustrcmp(token.name, ",") != 0) 
        error(202, &token);
      scanner(inf, &token, flag);
      m = NULL;
      get_the_data(&y, &m, &builtin_func1_Env);
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      if ((*builtin_func1_Env.x)->numb && *n == NULL) 
        quoly_assign(*builtin_func1_Env.x, n);
      if ((*y)->numb && m == NULL) 
        quoly_assign(*y, &m);
	  wantmod = false;  /* 'wantmod' not mnemonic */
      if ((*builtin_func1_Env.x)->numb) 
        sparse = true;  /* 'sparse' not mnemonic */
      else if ((*y)->numb)
	    sparse = false;
	  else sparse = mon_less((*builtin_func1_Env.x)->variant.vc_2.numer, (*y)->variant.vc_2.numer, &wantmod);
      if (sparse || wantmod)
	    quoly_set(1, n);
      else quoly_set(0, n);
      free_quoly(&m);
      scanner(inf, &token, flag);
      break;

    case Array_:
      create_array(inf, n, flag);                 /* Nov 1997 */
      break;
    
    case GCD_:
      check_for_paren(&builtin_func1_Env);
      scanner(inf, &token, flag);
      get_the_data(&builtin_func1_Env.x, n, &builtin_func1_Env);
      if (ustrcmp(token.name, ",") != 0) 
        error(202, &token);
      scanner(inf, &token, flag);
      m = NULL;
      get_the_data(&y, &m, &builtin_func1_Env);
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      builtin_func1_Env.copy = NULL;
      if ((*builtin_func1_Env.x)->numb && *n == NULL) 
        quoly_assign(*builtin_func1_Env.x, n);
      if ((*y)->numb && m == NULL) 
        quoly_assign(*y, &m);
      if ((*builtin_func1_Env.x)->numb && (*y)->numb) 
        gcdnum(n, &m);
      else if ((*builtin_func1_Env.x)->numb) 
        if (quoly_iszero(*builtin_func1_Env.x))   /* Jul 2001 */
          gcd_0_poly(y, n);
        else {
          base_quoly(&builtin_func1_Env.copy, 1);  /* arbitrary initialization */
          gcd_coefs((*y)->variant.vc_2.numer, &builtin_func1_Env.copy->variant.vc_2.numer);
          polynum_to_quoly(&builtin_func1_Env.copy);
          gcdnum(n, &builtin_func1_Env.copy);
          free_quoly(&builtin_func1_Env.copy);
        }
      else if ((*y)->numb) 
        if (quoly_iszero(*y))                     /* Jul 2001 */
          gcd_0_poly(builtin_func1_Env.x, n);
        else {
          base_quoly(&builtin_func1_Env.copy, 1);  /* arbitrary initialization */
          gcd_coefs((*builtin_func1_Env.x)->variant.vc_2.numer,
	             &builtin_func1_Env.copy->variant.vc_2.numer);
          polynum_to_quoly(&builtin_func1_Env.copy);
          gcdnum(&builtin_func1_Env.copy, &m);
          free_quoly(n);
          *n = builtin_func1_Env.copy;
        }

      else {
        if ((*builtin_func1_Env.x)->variant.vc_2.denom != NULL || (*y)->variant.vc_2.denom != NULL) 
		  if (verbose)  /* Jan 2007 */
		    fprintf(stdout, "Warning. An argument to GCD is a rational function. Denominators ignored. \n");
		if (*n == NULL) 
          base_quoly(n, 1);                       /* arbitrary initialization */
        Lpolygcd2(&(*builtin_func1_Env.x)->variant.vc_2.numer, &(*y)->variant.vc_2.numer, 
                  &(*n)->variant.vc_2.numer, polynames);
        if ((*n)->variant.vc_2.numer->numb && (*n)->variant.vc_2.numer->next == NULL) 
          polynum_to_quoly(n);
      }
      scanner(inf, &token, flag);
      free_quoly(&m);
      break;
    
    case False_:
      scanner(inf, &token, flag);
      quoly_set(0, n);
      break;
    
    case LCM_:
      read_command(&builtin_func1_Env);           /* sets q, rows, cols, start */
      if (builtin_func1_Env.start == -1) {        /* wasn't subarray */
        builtin_func1_Env.start = builtin_func1_Env.q->start;
        builtin_func1_Env.target_rows = builtin_func1_Env.total_rows;
      } else if (builtin_func1_Env.q->spar != NULL) 
        error(244, &builtin_func1_Env.errorname);
      if (ustrcmp(token.name, ")") != 0) 
        error(70, &token);
      scanner(inf, &token, flag);
      if (lintmode) {
        if (*flag == NULL) 
          fprintf(stdout, " Warning.  LCM called in longint/modular mode.\n");
        quoly_set(1, n);
      } else 
        findlcm(n, builtin_func1_Env.q->spar, builtin_func1_Env.start, 
                builtin_func1_Env.total_rows, builtin_func1_Env.target_rows, 
                builtin_func1_Env.cols);
      break;
    
    case Log2_:
      standard_read(&builtin_func1_Env);
      quoly_set(quoly_max_digits(*builtin_func1_Env.x), n);
      break;
    
    case Lcoef_:
    case Nlcoef_:   /* big changes Oct 2005 */
    case Ntcoef_:   /* Jul 2008 */
    case Zncoef_:   /* Jul 2008 */
    case Flcoef_:
      standard_read(&builtin_func1_Env);
      if (!(*builtin_func1_Env.x)->numb) {
        if ((*builtin_func1_Env.x)->variant.vc_2.denom != NULL)
          error(186, &token);
        if (index == Nlcoef_ || (index == Flcoef_ && field_depth == 0) )  /* Oct 2005 */
          quoly_leading_num_coef(builtin_func1_Env.x, n);   
        else if (index == Flcoef_)
          quoly_field_leading_coef(builtin_func1_Env.x, n);  /* Nov 1996 */
        else if (index == Ntcoef_)
          quoly_trail_num_coef(builtin_func1_Env.x, n);  /* Jul 2008 */
        else if (index == Zncoef_)
          quoly_z_num_coef(builtin_func1_Env.x, n);  /* Jul 2008 */
        else 
          quoly_leading_coef(builtin_func1_Env.x, n);  /* Oct 2005 */
      }
      else if (*n == NULL) 
        quoly_assign(*builtin_func1_Env.x, n);
      break;

    case Nmcoef_:   /* Jul 2008 */
      check_for_paren(&builtin_func1_Env);
      scanner(inf, &token, flag);
      get_the_data(&builtin_func1_Env.x, n, &builtin_func1_Env);
      if (ustrcmp(token.name, ",") != 0) 
        error(202, &token);
      scanner(inf, &token, flag);
      m = NULL;
      get_the_data(&y, &m, &builtin_func1_Env);
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      if ((*builtin_func1_Env.x)->numb && *n == NULL) 
        quoly_assign(*builtin_func1_Env.x, n);
      if (!(*builtin_func1_Env.x)->numb) 
        if ((*builtin_func1_Env.x)->variant.vc_2.denom != NULL)
          error(186, &token);
	  if ((*y)->numb && m == NULL) 
        quoly_assign(*y, &m);
	  if (!(*y)->numb) {
        if ((*y)->variant.vc_2.denom != NULL)
          error(186, &token);		  
	    if (!monomial((*y)->variant.vc_2.numer))  /* Aug 2008 */
	      error(192, &token);
	  } 
	  if ((*builtin_func1_Env.x)->numb && (*y)->numb)   /* Aug 2008. do nothing */
	    ;
	  else if ((*y)->numb)
	    quoly_z_num_coef(builtin_func1_Env.x, n);
	  else if ((*builtin_func1_Env.x)->numb)
		quoly_set(0, n);
	  else /* the real case at last */
	    quoly_mono_num_coef(builtin_func1_Env.x, n, (*y)->variant.vc_2.numer);  /* Jul 2008 */

	  free_quoly(&m);
	  scanner(inf, &token, flag);
	  break;

    case Lmon_:
      check_for_paren(&builtin_func1_Env);
      scanner(inf, &token, flag);
      get_the_data(&builtin_func1_Env.x, n, &builtin_func1_Env);
      m = NULL;
      y = NULL;
      if (ustrcmp(token.name, ",") == 0) {
        scanner(inf, &token, flag);
        get_the_data(&y, &m, &builtin_func1_Env);
      }
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      if (!(*builtin_func1_Env.x)->numb) 
        leading_mon(builtin_func1_Env.x, y, n);
      else if (*n == NULL) 
        quoly_assign(*builtin_func1_Env.x, n);
      scanner(inf, &token, flag);
      free_quoly(&m);
      break;
    
    case Height_:
      standard_read(&builtin_func1_Env);
      if ((*builtin_func1_Env.x)->numb) 
        quoly_set(0, n);
      else 
        quoly_set(poly_height((*builtin_func1_Env.x)->variant.vc_2.numer), n);
      break;
    
    case Equal_:
    case Equalneg_:
      check_for_paren(&builtin_func1_Env);
      scanner(inf, &token, flag);         /* implement Numer, Denom. Jul 2002. all new */
      want[0] = ustrcmp(token.name, "Numer") == 0;
      want[1] = ustrcmp(token.name, "Denom") == 0;
      if (want[0] || want[1]) {
        check_for_paren(&builtin_func1_Env);
        scanner(inf, &token, flag);
      }
      read_quoly_ptr2(&builtin_func1_Env.x, n, &builtin_func1_Env);
      if (want[0] || want[1]) {
        if (ustrcmp(token.name, ")") != 0) 
          error(1, &token);
        scanner(inf, &token, flag);
      }
      if (ustrcmp(token.name, ",") != 0) 
        error(202, &token);
      m = NULL;
      scanner(inf, &token, flag);
      want[2] = ustrcmp(token.name, "Numer") == 0;
      want[3] = ustrcmp(token.name, "Denom") == 0;
      if (want[2] || want[3]) {
        check_for_paren(&builtin_func1_Env);
        scanner(inf, &token, flag);
      }
      read_quoly_ptr2(&y, &m, &builtin_func1_Env);
      if (want[2] || want[3]) {
        if (ustrcmp(token.name, ")") != 0) 
          error(1, &token);
        scanner(inf, &token, flag);
      }
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      scanner(inf, &token, flag);
      free_quoly(&m);
      finish_equal(index, n, builtin_func1_Env.x, y, &want);
      break;
    
    case Raise_:
    case Lower_:
      check_for_paren(&builtin_func1_Env);
      scanner_expre(&builtin_func1_Env);
      if (ustrcmp(token.name, ",") == 0) {
        scanner(inf, &token, flag);
        check_modular(&builtin_func1_Env.modular_stuff);
        m = NULL;
        old_expre(inf, &m, flag);
        if (!m->numb) 
          error(227, &token);
        builtin_func1_Env.k = quoly_convert_to_int(m);
        free_quoly(&m);
        restore_modular(builtin_func1_Env.modular_stuff);
      } else 
        builtin_func1_Env.k = 1;
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      scanner(inf, &token, flag);
      if (!(*n)->numb && builtin_func1_Env.k != 0) 
        if (index == Lower_) 
          lower_quoly(n, builtin_func1_Env.k);
        else 
          raise_quoly(n, builtin_func1_Env.k);
      break;
    
    case Content_:
      check_for_paren(&builtin_func1_Env);
      scanner(inf, &token, flag);
      get_the_data(&builtin_func1_Env.x, n, &builtin_func1_Env);
      m = NULL;
      if (ustrcmp(token.name, ",") == 0) {
        scanner(inf, &token, flag);
        old_expre(inf, &m, flag);
        if (!m->numb)  /* BUG  Sep 2005 */
          if (m->variant.vc_2.denom != NULL) 
            error(196, &token);
      }
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      if ((*builtin_func1_Env.x)->numb && *n == NULL) 
        quoly_assign(*builtin_func1_Env.x, n);
      call_content(builtin_func1_Env.x, n, &m);
      free_quoly(&m);
      scanner(inf, &token, flag);
      break;
    
    case Divides_:  /* separate from next two, Jan 2007 */
	  read_with_comma(&builtin_func1_Env);
      if (!(*n)->numb && (*n)->variant.vc_2.denom != NULL) 
        error(280, &token);
      if (quoly_iszero(*n)) {
        error(22, &token);
        quoly_set(1, n);
      }
      m = NULL;
      old_expre(inf, &m, flag);
      if (!m->numb && m->variant.vc_2.denom != NULL) 
        error(280, &token);
      if (ustrcmp(token.name, ")") == 0) 
        wantmod = false;              /* don't want quotient; includes PDivide */
      else 
        if (ustrcmp(token.name, ",") == 0) {
          wantmod = true;
          scanner(inf, &token, flag);
        } else 
          error(1, &token);

      builtin_func1_Env.oldm1 = true;     /* Dec 2001; not mnemonic */
      trial_divide(n, &m, wantmod,    /* means want quotient */
                   false, false, &builtin_func1_Env.oldm1);
		   /* May 2001 */
      /* n is now 0 or 1; m is the quotient if wantmod, but in that case if divide
         failed, m could be almost anything, but must be freeable.  Also, if it
         worked, m could be illegal numer numb. */
      if (wantmod) {                              /* includes SDivide */
        if (quoly_iszero(*n))                     /* doesn't divide */
          quoly_set(1, &m);                       /* change to 1, May 2001 */
        else if (!m->numb)    /* BUG!  m might be a number. Aug 2003 */
               if (m->variant.vc_2.numer->numb && m->variant.vc_2.numer->next == NULL) 
                  polynum_to_quoly(&m);
        set_quotient(m, inf, flag, 1, ')');             /* will use up m */
      } else 
        free_quoly(&m);
      scanner(inf, &token, flag);
      break;

		case Split_:  /* Aug 2010. code-wise, sort of a blend of Remquot and SDivide. */
			/* very delicate due mainly to sparse arrays */
	    check_for_paren(&builtin_func1_Env);
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, "^") == 0) 
        scanner(inf, &token, flag);      /*  Allow it, for god's sake! Sheesh. */
			m = NULL;
			new_get_quoly_ptr(&builtin_func1_Env.x, inf, flag, &sparse);
			/* get_quoly_ptr reads a variable name. If the name marks no declared variable, error has occured 
			 inside get_quoly_ptr.  x or x^ NULL means sparse array or ordinary array entry is not yet
			 assigned. sparse = does x point into a sparse array? */			   
			if (builtin_func1_Env.x == NULL) /* sparse array entry not there */
				error(29, &token);                 
			else if (*builtin_func1_Env.x == NULL) 
				quoly_set(0, &m);                
			else {                             /* May 2001, Set the authenic storage to 1,*/
				m = *builtin_func1_Env.x;               /* a failsafe in case user interrupts */
				if (!m->numb && m->variant.vc_2.denom != NULL) 
					error(196, &token);
				*builtin_func1_Env.x = NULL;            /* and looks at it. Don't use 0! */
				quoly_set(1, builtin_func1_Env.x);      /* sparse array entries! */
				(*builtin_func1_Env.x)->variant.vc_1.arr_arg = false;
			}
			/* m is now the first argument, i.e. the poly to be split. */
      if (ustrcmp(token.name, ",") != 0) 
        error(202, &token);
			scanner(inf, &token, flag);
			old_expre(inf, n, flag);			
			/* n must be an integer */
			if (!(*n)->numb)
				error(227, &token);
			if (lintmode) 
				i = (*n)->variant.vc_1.ncoef->lint;
			else {
				i = (*n)->variant.vc_1.ncoef->head->value;
				if ((*n)->variant.vc_1.ncoef->size > 1)
					error(32, &token);
			}
		  if (i < 0)
				error(366, &token);
			
			/* do the arithmetic. m gets the mod, n gets the quotient */
			split_poly(&m, n);
			
			if (ustrcmp(token.name, ")") == 0) 
				free_quoly(n);            /* don't want quotient (i.e. first half) */
			else if (ustrcmp(token.name, ",") == 0) {
				scanner(inf, &token, flag);
				set_quotient(*n, inf, flag, 1, ')');      /* will use up n */
			} 
			else 
				error(1, &token);
			if (sparse && quoly_iszero(m))  /* can't put 0 into a sparse array */
				error(365, &token);
			free_quoly(builtin_func1_Env.x);      /* placeholder 1 from above */
			*builtin_func1_Env.x = m;
			if (m->numb) 
				(*builtin_func1_Env.x)->variant.vc_1.arr_arg = false;
			scanner(inf, &token, flag);
			*n = NULL;
			quoly_set(0, n);
			break;
			
 		case Splice_:  /* Aug 2010. dual to Split. */
	    check_for_paren(&builtin_func1_Env);
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, "^") == 0) 
        scanner(inf, &token, flag);      /*  Allow it, for god's sake! Sheesh. */
			m = NULL;
			get_quoly_ptr(&builtin_func1_Env.x, inf, flag);
			/* get_quoly_ptr reads a variable name. If the name marks no declared variable, error has occured 
			 inside get_quoly_ptr.  x or x^ NULL means sparse array or ordinary array entry is not yet
			 assigned. sparse = does x point into a sparse array? */			   
			if (builtin_func1_Env.x == NULL) /* sparse array entry not there */
				error(29, &token);                 
			else if (*builtin_func1_Env.x == NULL) 
				quoly_set(0, &m);                
			else {                             /* May 2001, Set the authenic storage to 1,*/
				m = *builtin_func1_Env.x;               /* a failsafe in case user interrupts */
				if (!m->numb && m->variant.vc_2.denom != NULL) 
					error(196, &token);
				*builtin_func1_Env.x = NULL;            /* and looks at it. Don't use 0! */
				quoly_set(1, builtin_func1_Env.x);      /* sparse array entries! */
				(*builtin_func1_Env.x)->variant.vc_1.arr_arg = false;
			}
			/* m is now the first argument, i.e. the poly to be tacked onto. */
      if (ustrcmp(token.name, ",") != 0) 
        error(202, &token);
			scanner(inf, &token, flag);
			if (ustrcmp(token.name, "^") == 0) 
        scanner(inf, &token, flag);      /*  Allow it, for god's sake! Sheesh. */
			get_quoly_ptr(&y, inf, flag);
			/* get_quoly_ptr reads a variable name. If the name marks no declared variable, error has occured 
			 inside get_quoly_ptr.  x or x^ NULL means sparse array or ordinary array entry is not yet
			 assigned. sparse = does x point into a sparse array? */			   
			if (y == NULL) /* sparse array entry not there */
				error(29, &token);                 
			else if (*y == NULL) 
				quoly_set(0, y);                
			else {                             /* May 2001, Set the authenic storage to 1,*/
				if (!(*y)->numb && (*y)->variant.vc_2.denom != NULL) 
					error(196, &token);
				(*y)->variant.vc_1.arr_arg = false;
			}						
	    if (ustrcmp(token.name, ",") != 0) 
        error(202, &token);
			scanner(inf, &token, flag);
			ci = NULL;
			old_expre(inf, &ci, flag);			
			/* ci must be an integer */
			if (!ci->numb)
				error(227, &token);
			if (lintmode) 
				i = ci->variant.vc_1.ncoef->lint;
			else {
				i = ci->variant.vc_1.ncoef->head->value;
				if (ci->variant.vc_1.ncoef->size > 1)
					error(32, &token);
			}
		  if (i < 1)
				error(367, &token);
			/* if (!m->numb && m->variant.vc_2.numer->exp >= i)
			 error(368, &token);  368 unused. */
			
			/* do the arithmetic. m gets the output spliced poly, y gets used, set to 1 */
			splice_poly(&m, y, i);
			
			if (ustrcmp(token.name, ")") != 0) 
				error(1, &token);			
			free_quoly(builtin_func1_Env.x);      /* placeholder 1 from above */
			*builtin_func1_Env.x = m;
			scanner(inf, &token, flag);
			free_quoly(&ci);
			quoly_set(0, n);
			break;
			
    case PDivides_:  /* Jan 2007 */
    case SDivide_:
	  check_for_paren(&builtin_func1_Env);
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, "^") == 0) 
        scanner(inf, &token, flag);   /* Jan 2007. Allow it, for god's sake! Sheesh. */
      old_expre(inf, n, flag);
      if (ustrcmp(token.name, ",") != 0) 
        error(202, &token);
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, "^") == 0) 
        scanner(inf, &token, flag);   /* Jan 2007. Allow it, for god's sake! Sheesh. */
      if (!(*n)->numb && (*n)->variant.vc_2.denom != NULL) 
        error(280, &token);
      if (quoly_iszero(*n)) {
        error(22, &token);
        quoly_set(1, n);
      }
      m = NULL;
      if (index == SDivide_) {                    /* August 1996 */
        get_quoly_ptr(&builtin_func1_Env.x, inf, flag);
        if (builtin_func1_Env.x == NULL) 
          quoly_set(0, &m);                       /* Nov 1997 */
        else if (*builtin_func1_Env.x == NULL) 
          quoly_set(0, &m);                /* Jan 1998; leave x^ nil */
        else {                             /* May 2001, Set the authenic storage to 1,*/
          m = *builtin_func1_Env.x;               /* a failsafe in case user interrupts */
          *builtin_func1_Env.x = NULL;            /* and looks at it. Don't use 0! */
          quoly_set(1, builtin_func1_Env.x);      /* sparse array entries! */
          (*builtin_func1_Env.x)->variant.vc_1.arr_arg = false;
        }
      } else 
        old_expre(inf, &m, flag);
      if (!m->numb && m->variant.vc_2.denom != NULL) 
        error(280, &token);
      if (ustrcmp(token.name, ")") == 0) 
        wantmod = index == SDivide_;              /* don't want quotient; includes PDivide */
      else if (index == Divides_) 
        if (ustrcmp(token.name, ",") == 0) {
          wantmod = true;
          scanner(inf, &token, flag);
        } else 
          error(1, &token);
      else
        error(1, &token);
      builtin_func1_Env.oldm1 = true;     /* Dec 2001; not mnemonic */
      trial_divide(n, &m, wantmod,    /* means want quotient */
                   index == PDivides_, index == SDivide_, &builtin_func1_Env.oldm1);
		   /* May 2001 */
      /* n is now 0 or 1; m is the quotient if wantmod, but in that case if divide
         failed, m could be almost anything, but must be freeable.  Also, if it
         worked, m could be illegal numer numb. */
      if (wantmod) {                              /* includes SDivide */
        if (quoly_iszero(*n))                     /* doesn't divide */
          quoly_set(1, &m);                       /* change to 1, May 2001 */
        else if (!m->numb)    /* BUG!  m might be a number. Aug 2003 */
               if (m->variant.vc_2.numer->numb && m->variant.vc_2.numer->next == NULL) 
                  polynum_to_quoly(&m);
        if (index == SDivide_) 
          if (builtin_func1_Env.x == NULL) 
            free_quoly(&m);                       /* Nov 1997 */
          else {                                  /* May 2001. the important case. */
            free_quoly(builtin_func1_Env.x);      /* placeholder 1 from above */
            *builtin_func1_Env.x = m;
            if (m->numb) 
              (*builtin_func1_Env.x)->variant.vc_1.arr_arg = false;
          }
        else 
          set_quotient(m, inf, flag, 1, ')');             /* will use up m */
      } else 
        free_quoly(&m);
      scanner(inf, &token, flag);
      break;

   case EGCD_:  /* Nov 2004 */
        check_for_paren(&builtin_func1_Env);
	scanner(inf, &token, flag);
        get_the_data(&builtin_func1_Env.x, n, &builtin_func1_Env);
	if (ustrcmp(token.name, ",") != 0)
	   error(202, &token);
	scanner(inf, &token, flag);
	m = NULL;
	get_the_data(&y, &m, &builtin_func1_Env);
	if (ustrcmp(token.name, ",") != 0)
	   error(202, &token);
	scanner(inf, &token, flag);
	if ((*builtin_func1_Env.x)->numb && *n == NULL)
	   quoly_assign(*builtin_func1_Env.x, n);
	if ((*y)->numb && m == NULL)
	   quoly_assign(*y, &m);
	if ((*builtin_func1_Env.x)->numb && (*y)->numb)
	   egcd_nums(n, &m, inf, flag);
	else if ((*builtin_func1_Env.x)->numb)
	   egcd_num_poly(n, y, inf, flag, true);
	else if ((*y)->numb) {
	   egcd_num_poly(&m, builtin_func1_Env.x, inf, flag, false);
	   free_quoly(n);
	   *n = m;
	   m = NULL;
	}
	else if ((*builtin_func1_Env.x)->variant.vc_2.denom != NULL ||
	         (*y)->variant.vc_2.denom != NULL)
	   error(203, &token);
	else {
	   if (*n == NULL)
	      base_quoly(n, 1);  /* arbitrary initialization */
	   egcd_polys((*builtin_func1_Env.x)->variant.vc_2.numer,
	          (*y)->variant.vc_2.numer, &(*n)->variant.vc_2.numer, inf, flag, false);
	   if ((*n)->variant.vc_2.numer->numb && (*n)->variant.vc_2.numer->next == NULL)
	      polynum_to_quoly(n);
	}
	scanner(inf, &token, flag);
	free_quoly(&m);
	break;

    case Factor_:
    case Sqfree_:
      if (index == Factor_ && !modularmode) 
        error(284, &token);
      if (modularmode && !mod_is_prime)
        error(293, &token);
      if (lintmode && !modularmode)               /* Oct 1996 */
        error(62, &token);
      read_with_comma(&builtin_func1_Env);
      if (!(*n)->numb) {
        if ((*n)->variant.vc_2.denom != NULL) 
          error(186, &token);
        if (laurent)
          if (anynegs((*n)->variant.vc_2.numer)) 
            error(198, &token);
        if (cant_factor((*n)->variant.vc_2.numer, &builtin_func1_Env.k, 
                        index == Factor_))        /* Oct 1996 */
          error(builtin_func1_Env.k, &token);
      }
      if (ustrcmp(token.name, "[") != 0) 
        error(178, &token);
      left_side(inf, &q2[0], &j, &builtin_func1_Env.k, &builtin_func1_Env.start, 
                &builtin_func1_Env.total_rows, &builtin_func1_Env.firstrow, 
                &builtin_func1_Env.firstcol, &builtin_func1_Env.target_rows, 
                &oldtok[0], flag, false);
      /* A new array by the name oldtok[0] will be created. We don't care about j, k,
         or q2[1]. */
      if (builtin_func1_Env.start != -1) 
        error(182, &token);
      if (ustrcmp(oldtok[0].name, "%") == 0) 
        error(296, &oldtok[0]);
      if (ustrcmp(token.name, ",") == 0 && index == Factor_) 
        get_level_k(true, &builtin_func1_Env);
	  /* user is specifying a level to restrict factoring */
      else 
        builtin_func1_Env.k = -1;
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      scanner(inf, &token, flag);
      
      /* following use of n^.denom is a bit weird!  j := number of factors. 
         Also, note special cases n^.numb and n^.denom remaining nil. */
      if ((*n)->numb) 
        j = 1;                                    /* insertarr needs this */
      else {
        if (index == Factor_) 
          factor_poly(&(*n)->variant.vc_2.numer, &(*n)->variant.vc_2.denom, 
                      &j, false, (*flag == NULL && verbose), builtin_func1_Env.k);
		      /* Jul 2003 */
        else 
          total_sq_free(&(*n)->variant.vc_2.numer, &(*n)->variant.vc_2.denom, 
                        &j, true, polynames);
        /* n^.numer might be nil now. Nov 1996. */
        if ((*n)->variant.vc_2.denom == NULL)  /* field_depth > 0 and n^.numer invertible */
          j = 1;
      }
      
      insertarr(&oldtok[0], j, 2, false);
      if (oldtok[0].address == -1) 
        builtin_func1_Env.k = hash(&oldtok[0].name, 151);
      else 
        builtin_func1_Env.k = oldtok[0].address;
      q2[0] = arr_store[builtin_func1_Env.k];
      if ((*n)->numb) 
        j = 0;
      else if ((*n)->variant.vc_2.denom == NULL)   /* field_depth > 0 and n^.numer invertible */
        j = 0;
      poly_to_array(j, q2[0]->start, &(*n)->variant.vc_2.denom);
      /* if not n^.numb, n^.denom is now nil in all cases. */
      quoly_set(j, n);
      break;
    
    case Deriv_:
      read_with_comma(&builtin_func1_Env);        /* gets n, token */
      m = NULL;
      old_expre(inf, &m, flag);
      /* will use 'dum' below; kind of dangerous. dum points into m. */
      newquoly(&builtin_func1_Env.dum);
      check_for_monic_poly(282, m, &height, &builtin_func1_Env.k, 
                           &builtin_func1_Env.dum->variant.vc_2.numer, 
                           &builtin_func1_Env.dum->variant.vc_2.denom);
      if (builtin_func1_Env.dum->variant.vc_2.numer->next != NULL) 
        error(282, &token);
      builtin_func1_Env.dum->next = quolygarb;
      quolygarb = builtin_func1_Env.dum;
      builtin_func1_Env.dum = NULL;
      free_quoly(&m);
      if (ustrcmp(token.name, ",") != 0) 
        error(202, &token);
      if (builtin_func1_Env.k != 1) 
        error(282, &token);
      scanner(inf, &token, flag);
      check_modular(&builtin_func1_Env.modular_stuff);
      old_expre(inf, &builtin_func1_Env.dum, flag);
      if (!builtin_func1_Env.dum->numb) 
        error(227, &token);
      builtin_func1_Env.k = quoly_convert_to_int(builtin_func1_Env.dum);
      free_quoly(&builtin_func1_Env.dum);
      restore_modular(builtin_func1_Env.modular_stuff);
      if (builtin_func1_Env.k < 0) 
        error(283, &token);
      if (ustrcmp(token.name, ")") == 0) 
        scanner(inf, &token, flag);
      else 
        error(1, &token);
      if (builtin_func1_Env.k > 0) 
        differentiate(n, height, builtin_func1_Env.k);
      break;
    
    case Irred_:
      if (!modularmode) 
        error(284, &token);
      if (!mod_is_prime) 
        error(293, &token);
      check_for_paren(&builtin_func1_Env);
      scanner_expre(&builtin_func1_Env);
      if (ustrcmp(token.name, ",") == 0) 
        get_level_k(true, &builtin_func1_Env);
      else 
        builtin_func1_Env.k = -1;
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      scanner(inf, &token, flag);
      irreducible_poly(n, builtin_func1_Env.k);
      break;
    
    case Det__:
      /* Apr 1998 */
      arr_parse('L', inf, n, flag);
      break;
    
    /* Nov 2000 */
    
    case Colreduce_:
    case Normalize_:
    case Hermite_:
    case Pseudet_:
    case Smith_:
    case MSmith_:
    case Redrowech_:
    case Minors_:
    case Rowreduce_:
      if (lintmode)                               /* July 1998 */
        if (index == Hermite_ || index == Smith_ || index == MSmith_) 
          error(183, &token);
      read_command(&builtin_func1_Env);   /* sets q, rows, cols, start, maybe see_star. Jun 2009 */
      for (i = 1; i <= 4; ++i) 
        want[i - 1] = false;
      /* no reason to init auxspar; June 1998 */
      switch (index) { 
        case Pseudet_:
          ustrcpy(builtin_func1_Env.errorname.name, "Pseudet");  /* August 1996 */
          break;
        case Normalize_:
          ustrcpy(builtin_func1_Env.errorname.name, "Normalize");
          break;
        case Colreduce_:
          ustrcpy(builtin_func1_Env.errorname.name, "Colreduce");
          break;
        case Rowreduce_:
          ustrcpy(builtin_func1_Env.errorname.name, "Rowreduce");  /* Nov 2000 */
          break;
        case Smith_:
          ustrcpy(builtin_func1_Env.errorname.name, "Smith");  /* July 1998 */
          break;
        case MSmith_:
          ustrcpy(builtin_func1_Env.errorname.name, "MSmith");  /* July 1998 */
          break;/* MHermite_:  errorname.name := 'MHermite';  July 1998, killed Mar 1999 */
        
        case Hermite_:
          ustrcpy(builtin_func1_Env.errorname.name, "Hermite");
          break;
        case Minors_:
          ustrcpy(builtin_func1_Env.errorname.name, "Minors");  /* Nov 2000 */
          break;
        case Redrowech_:
          ustrcpy(builtin_func1_Env.errorname.name, "Redrowech");  /* Oct 2000 */
          break;
      }
      
      if (index != Minors_ && builtin_func1_Env.see_star)  /* Jun 2009 */
	 fprintf(stdout, " *** Warning. leading * in argument list makes no sense here and was ignored.\n");
      if (builtin_func1_Env.start != -1) 
        error(182, &builtin_func1_Env.errorname);  /*  moved this */
      if (builtin_func1_Env.q->spar == NULL) {    /* Nov 2000 */
        if (index == Rowreduce_) 
          error(333, &token);
      } else 
        switch (index) { 
          case Pseudet_:
          case Hermite_:
          case Minors_:
            /* fine*/
            break;
          case Smith_:
          case MSmith_:
          case Rowreduce_:
          case Redrowech_:
            /* fine */
            /* Nov 2000 */
            break;
          default:
            error(242, &builtin_func1_Env.errorname);
            break;
        }
      sparse = builtin_func1_Env.q->spar != NULL && index != Pseudet_;  /* June 1998 */
      wantmod = index == MSmith_;                 /* July 1998 */
      if (wantmod)                                /* July 1998 */
        if (ustrcmp(token.name, ")") == 0) 
          quoly_set(0, n);
        else {
          if (ustrcmp(token.name, ",") != 0) 
            error(70, &token);
          scanner_expre(&builtin_func1_Env);
          if (ustrcmp(token.name, ")") != 0) 
            error(1, &token);
          if (!(*n)->numb) 
            error(227, &token);
          if ((*n)->variant.vc_1.ncoef->head->value <= 0) 
            error(134, &token);
        }
      
      builtin_func1_Env.k = block;                /* May 2001, default for Pseudet */
      /* Jul 2002: Explaining k for Pseudet: k might be changed in the following loop 
         when i=1, by left_side. It is then the number of columns of an existing [c], as in
         Pseudet([m3],[c]). If no [c] exists, q2[1]=nil and k is not changed by left_side.
         It might also be changed when i=2, which is what was intended. */
      for (i = 1; i <= 4; ++i) 
        if (ustrcmp(token.name, ")") == 0) 
          break;
        else {
          /* Get names of auxiliary arrays into oldtok[i]. */
          if (ustrcmp(token.name, ",") != 0) 
            error(70, &token);
          if (index == Pseudet_) 
            if (i == 2)                           /* May 2001 */
              if (ustrcmp(token.name, "[") == 0) 
                error(306, &token);
              else {
                scanner_expre(&builtin_func1_Env);
                builtin_func1_Env.k = quoly_convert_to_int(*n);
                builtin_func1_Env.k = builtin_func1_Env.k + 1 - addresser;
                continue;
              }
            else if (i >= 3) 
              error(306, &token);                 /* August 1996 */
          /* kill error 242 here. June 1998 */
          if (index == Redrowech_ && i >= 3) 
             error(325, &token);    /* Oct 2000. BUG, Sep 2009, was 326 */
          if (index == Minors_ && i == 4) 
            error(327, &token);                   /* Nov 2000 */
          scanner(inf, &token, flag);
          if (ustrcmp(token.name, ",") != 0) {
            if (ustrcmp(token.name, "[") != 0) 
              error(178, &token);
            left_side(inf, &q2[i - 1], &j, &builtin_func1_Env.k, &builtin_func1_Env.start, 
                      &builtin_func1_Env.total_rows, &builtin_func1_Env.firstrow, 
                      &builtin_func1_Env.firstcol, &builtin_func1_Env.target_rows, 
                      &oldtok[i - 1], flag, false);  /* only want oldtok[i] */
            /* only want oldtok[i] */
            /* Nov 2000: no, Minors wants both q2[1] and q2[2] */
            if (builtin_func1_Env.start != -1) 
              error(182, &token);
            if (ustrcmp(oldtok[i - 1].name, "%") == 0) 
              error(296, &oldtok[i - 1]);
            want[i - 1] = true;
            if (index == Pseudet_)                /* Jul 2002. BUG. Don't want THIS k. */
              builtin_func1_Env.k = block;
          }
        }
      
      /* Don't change k before invocation of colreduce and sparse_rowreduce, May 2001 */
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      scanner(inf, &token, flag);
      
      if (index == Minors_) 
        for (i = 1; i <= 3; ++i) 
          if (want[i - 1])                        /* nothing */
            ;
          else 
            error(327, &token);
      else if (!sparse) 
        for (i = 1; i <= 4; ++i) 
          if (want[i - 1]) {
            new_worknode(&j, &builtin_func1_Env.errorname);
            beta[i - 1] = workhead[j - 1];
          }
      
      pseudodet.size = 0;
      if (wantmod) {         /* July 1998 */
                             /* July 1998: no longer need rows=cols, now use Pseudet*/
        if (quoly_iszero(*n)) 
          new_pseudo(n, builtin_func1_Env.q, &auxspar, builtin_func1_Env.alpha, &want);
        pseudodet = *(*n)->variant.vc_1.ncoef;
        (*n)->variant.vc_1.ncoef->size = 0;
        setvalue(0, (*n)->variant.vc_1.ncoef);
      }
      
      switch (index) { 
        case Normalize_:
          normalize(n, builtin_func1_Env.q, &want, beta[0], beta[1], beta[2], beta[3]);
          break;
        case Smith_:
        case MSmith_:
          intnormal(n, builtin_func1_Env.q, &want, beta[0], beta[1],
                    beta[2], beta[3], wantmod, &pseudodet, &auxspar, index);  /* July 1998 */
          break;
        case Pseudet_:
        case Colreduce_:
          colreduce(n, builtin_func1_Env.q, &want, beta[0], beta[1],
                    beta[2], beta[3], &auxspar, index == Pseudet_,
                    builtin_func1_Env.k);
          break;
        case Rowreduce_:
          if (builtin_func1_Env.k == 0)  /* Sep 2009, bug fix. It can only be 0 if some of the aux arrays do not exist yet. But passing 0 below is dumb. */
		     builtin_func1_Env.k = block;
          sparse_rowreduce(n, builtin_func1_Env.q, false, &want, beta[0], 
                           &auxspar, builtin_func1_Env.k);  /* Nov 2000 */
          break;
        case Minors_:
          minors(n, builtin_func1_Env.q, q2[0], q2[1], &oldtok[2], builtin_func1_Env.see_star);  /* Nov 2000, Jun 2009 */
          return;
          break;
        case Redrowech_:
          red_row_ech(n, builtin_func1_Env.q, &want, beta[0],  beta[1], &auxspar);   /* Nov 2000 */
          break;
        case Hermite_:
          intcolred(n, builtin_func1_Env.q, &want, beta[0], beta[1],
                    beta[2], beta[3], &auxspar, wantmod, &pseudodet);/* July 1998 */
          break;
      }

      free_num(&pseudodet);

      for (i = 1; i <= 4; ++i)
        if (want[i - 1]) {
          if (index == Pseudet_)                  /* June 1998 */
            j = 2;
          else if (index == Redrowech_)           /* Oct 2000 */
            j = builtin_func1_Env.rows;
          else if (Odd(i))
            j = builtin_func1_Env.rows;
          else
            j = builtin_func1_Env.cols;
          if (index == Pseudet_)                  /* June 1998; lots below */
            builtin_func1_Env.k = convert_to_int((*n)->variant.vc_1.ncoef);
          else
            builtin_func1_Env.k = j;
          if (j > 0 && builtin_func1_Env.k > 0) { /* Jun 2005 bug fix  */
	     if (sparse)
		 sparse_create(&oldtok[i - 1], j, builtin_func1_Env.k,
                            false, false);
            else
              insertarr(&oldtok[i - 1], j, builtin_func1_Env.k, false);
            if (oldtok[i - 1].address == -1)
              builtin_func1_Env.start = hash(&oldtok[i - 1].name, 151);
            else
              builtin_func1_Env.start = oldtok[i - 1].address;
            q2[0] = arr_store[builtin_func1_Env.start];
            if (sparse)
              q2[0]->spar = auxspar[i - 1];
            else
              fillup(j, builtin_func1_Env.k, q2[0]->start, beta[i - 1]);
	  }
	  else if (verbose)
	     fprintf(stdout, " Warning. An auxiliary matrix that you wanted would have no rows or columns.\n");

          if (!sparse)                            /* and above; June 1998 */
            free_work();
        }
      break;

    case STrans_:     /* Dec 2007. in place transpose of Sparse only.  */
	    scanner(inf, &token, flag);
      if (ustrcmp(token.name, "[") != 0) 
        error(178, &token);
      left_side(inf, &builtin_func1_Env.q, &builtin_func1_Env.rows, 
								&builtin_func1_Env.cols, &builtin_func1_Env.start, &builtin_func1_Env.total_rows, 
								&builtin_func1_Env.firstrow, &builtin_func1_Env.firstcol, 
								&builtin_func1_Env.target_rows, &builtin_func1_Env.errorname, 
								flag, false);
      if (builtin_func1_Env.q == NULL) 
				error(28, &builtin_func1_Env.errorname);   /* Sep 2010. stupid bug */
			ustrcpy(builtin_func1_Env.errorname.name, "STrans");
			if (builtin_func1_Env.start != -1) 
				error(182, &builtin_func1_Env.q->name); 
			if (builtin_func1_Env.q->spar == NULL) 
			  error(333, &builtin_func1_Env.q->name);  /* changed error 333. Dec 2007 */
			trans_sparse(&builtin_func1_Env.q->spar, builtin_func1_Env.rows, builtin_func1_Env.cols);
			builtin_func1_Env.q->rows = builtin_func1_Env.cols;
			/* scanner(inf, &token, flag); */
      quoly_set(0, n);
	    break;
			
		case Reverse_:     /* Apr2 2011 */
	    scanner(inf, &token, flag);
      if (ustrcmp(token.name, "[") != 0) 
        error(178, &token);
      left_side(inf, &builtin_func1_Env.q, &builtin_func1_Env.rows, 
								&builtin_func1_Env.cols, &builtin_func1_Env.start, &builtin_func1_Env.total_rows, 
								&builtin_func1_Env.firstrow, &builtin_func1_Env.firstcol, 
								&builtin_func1_Env.target_rows, &builtin_func1_Env.errorname, 
								flag, false);
      if (builtin_func1_Env.q == NULL) 
				error(28, &builtin_func1_Env.errorname);  
			ustrcpy(builtin_func1_Env.errorname.name, "Reverse");
			if (builtin_func1_Env.start != -1) 
				error(182, &builtin_func1_Env.q->name); 
			if (builtin_func1_Env.q->spar == NULL) 
				reverse_array(builtin_func1_Env.q);
			else
				reverse_sparse(&builtin_func1_Env.q->spar, builtin_func1_Env.rows);
			/* scanner(inf, &token, flag); */
			quoly_set(0, n);
	    break;
			
		case Poly_:     /* Apr2 2011 */
	    scanner(inf, &token, flag);
			if (number_polys == 0 )
				error(213, &token);
      if (ustrcmp(token.name, "[") != 0) 
        error(178, &token);
      left_side(inf, &builtin_func1_Env.q, &builtin_func1_Env.rows, 
								&builtin_func1_Env.cols, &builtin_func1_Env.start, &builtin_func1_Env.total_rows, 
								&builtin_func1_Env.firstrow, &builtin_func1_Env.firstcol, 
								&builtin_func1_Env.target_rows, &builtin_func1_Env.errorname, 
								flag, false);
      if (builtin_func1_Env.q == NULL) 
				error(28, &builtin_func1_Env.errorname);  
			ustrcpy(builtin_func1_Env.errorname.name, "Poly");
			if (builtin_func1_Env.start != -1) 
				error(182, &builtin_func1_Env.q->name); 
			if (builtin_func1_Env.q->spar == NULL) 
				arr_to_poly(builtin_func1_Env.q, n);
			else
				arr_to_poly_sparse(builtin_func1_Env.q->spar, builtin_func1_Env.rows, n);
	    break;
			
		case Sort_:		/* Sort, Sep 2010 */
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, "[") != 0) 
        error(178, &token);
      left_side(inf, &q2[0], &builtin_func1_Env.rows, 
								&builtin_func1_Env.cols, &builtin_func1_Env.start, &builtin_func1_Env.total_rows, 
								&builtin_func1_Env.firstrow, &builtin_func1_Env.firstcol, 
								&builtin_func1_Env.target_rows, &builtin_func1_Env.errorname, flag, false);
      if (q2[0] == NULL) 
				error(28, &builtin_func1_Env.errorname);
      if (q2[0]->spar == NULL) {  /* Sep2 2010 */
				ustrcpy(builtin_func1_Env.errorname.name, "Sort");
				new_worknode(&j, &builtin_func1_Env.errorname);
				beta[0] = workhead[j - 1];
				j = 0;
				for (i = q2[0]->start; i <= q2[0]->stop; ++i) {
					(*beta[0])[j] = (*arp[BSR(i, 10)])[BAnd(i, tenmask)];
					if ((*beta[0])[j] == NULL && j < builtin_func1_Env.rows)
						error(369, &builtin_func1_Env.errorname);
					j ++;
				}
				arraysort(*beta[0], 0, builtin_func1_Env.rows - 1, builtin_func1_Env.rows, builtin_func1_Env.cols);
				fillup(builtin_func1_Env.rows, builtin_func1_Env.cols,  q2[0]->start, beta[0]);
				free_work();
			}
			else {  /* Sep2 2010 */
				check_set_first_col(q2[0]->spar, &j, builtin_func1_Env.rows - 1, &builtin_func1_Env.errorname);
				/* error may have occurred in check_set_first_col. */
				using_spsort = true;
				sparse_arraysort(0, 0, builtin_func1_Env.rows - 1, j);
				using_spsort = false;
			}
			quoly_set(0, n);
      break;
	
		case Synth_:		/* Synth, Oct 2010 */
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, "(") != 0) 
        error(177, &token);
			scanner(inf, &token, flag);
			if (ustrcmp(token.name, "[") != 0) 
        error(178, &token);
      left_side(inf, &q2[0], &builtin_func1_Env.rows, 
								&builtin_func1_Env.cols, &builtin_func1_Env.start, &builtin_func1_Env.total_rows, 
								&builtin_func1_Env.firstrow, &builtin_func1_Env.firstcol, 
								&builtin_func1_Env.target_rows, &builtin_func1_Env.errorname, flag, false);
      if (q2[0] == NULL) 
				error(28, &builtin_func1_Env.errorname);
      if (q2[0]->spar == NULL) 
			  error(333, &builtin_func1_Env.errorname);
		  if (builtin_func1_Env.start != -1) 
				error(182, &builtin_func1_Env.errorname); 
			if (ustrcmp(token.name, ",") != 0) 
				error(70, &token);
			scanner(inf, &token, flag);
			if (ustrcmp(token.name, "[") != 0) 
        error(178, &token);
			left_side(inf, &q2[1], &builtin_func1_Env.rows, 
								&builtin_func1_Env.cols, &builtin_func1_Env.start, &builtin_func1_Env.total_rows, 
								&builtin_func1_Env.firstrow, &builtin_func1_Env.firstcol, 
								&builtin_func1_Env.target_rows, &builtin_func1_Env.errorname, flag, false);
      if (q2[1] == NULL) 
				error(28, &builtin_func1_Env.errorname);
      if (q2[1]->spar == NULL) 
			  error(333, &builtin_func1_Env.errorname);
		  if (builtin_func1_Env.start != -1) 
				error(182, &builtin_func1_Env.errorname); 
			if (ustrcmp(token.name, ",") != 0) 
				error(70, &token);
			scanner(inf, &token, flag);
			m = NULL;
      old_expre(inf, &m, flag); 
			if (!m->numb) 
        error(227, &token);
      j = quoly_convert_to_int(m);
      if (j != 0 && j != 1 && j != 2) 
        error(373, &token);
			free_quoly(&m);  
			if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
			scanner(inf, &token, flag);
			check_set_cols(q2[0], q2[1]);
			switch (j) {
				case 0:
					j = intersect(q2[0], q2[1]);
					break;
			  case 1:
				  j = synth_union(q2[0], q2[1]);
					break;
				case 2:
					j = synth_merge(q2[0], q2[1]);
					break;
			}
			quoly_set(j, n);
      break;
			
    case FFLU_:
    case FFLUC_:
      read_command(&builtin_func1_Env);           /* sets q, rows, cols, start */
      for (i = 1; i <= 6; ++i) 
        want[i - 1] = false;
      if (index == FFLU_) 
        ustrcpy(builtin_func1_Env.errorname.name, "FFLU");
      else 
        ustrcpy(builtin_func1_Env.errorname.name, "FFLUC");
      if (builtin_func1_Env.start != -1) 
        error(182, &builtin_func1_Env.errorname);
      if (builtin_func1_Env.q->spar != NULL) 
        error(242, &builtin_func1_Env.errorname);
      sparse = builtin_func1_Env.q->spar != NULL;  /* useless at the moment */
      /* auxiliaries must be: lower, pivot, alpha, alphainv, beta, betainv.
         alpha is row perms, beta is col perms. No beta, betainv allowed for FFLU. */
      for (i = 1; i <= 6; ++i) 
        if (ustrcmp(token.name, ")") == 0) 
          break;
        else {
          /* Get names of auxiliary arrays into oldtok[i]. */
          if (ustrcmp(token.name, ",") != 0) 
            error(70, &token);
          if (index == FFLU_ && i == 5) 
            error(325, &token);
          scanner(inf, &token, flag);
          if (ustrcmp(token.name, ",") != 0) {
            if (ustrcmp(token.name, "[") != 0) 
              error(178, &token);
            /* only want oldtok[i] */
            left_side(inf, &q2[0], &j, &builtin_func1_Env.k, &builtin_func1_Env.start, 
                      &builtin_func1_Env.total_rows, &builtin_func1_Env.firstrow, 
                      &builtin_func1_Env.firstcol, &builtin_func1_Env.target_rows, 
                      &oldtok[i - 1], flag, false);
            if (builtin_func1_Env.start != -1) 
              error(182, &token);
            if (ustrcmp(oldtok[i - 1].name, "%") == 0) 
              error(296, &oldtok[i - 1]);
            want[i - 1] = true;
          }
        }
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      if (!(want[0] && want[1]))
        error(324, &token);
      scanner(inf, &token, flag);
      
      if (!sparse) 
        for (i = 1; i <= 6; ++i) 
          if (want[i - 1]) {
            new_worknode(&j, &builtin_func1_Env.errorname);
            beta[i - 1] = workhead[j - 1];
          }
      
      fract_free_lu(index == FFLUC_, n, builtin_func1_Env.q, &want, 
                    beta[0], beta[1], beta[2], beta[3], beta[4], beta[5]);  /* Sep 2010 */
      
      for (i = 1; i <= 6; ++i) 
        /* order is pivot, lower, alpha (= R), alphinv, beta (= C), betinv */
        if (want[i - 1]) {
          if (i < 5) 
            j = builtin_func1_Env.rows;
          else 
            j = builtin_func1_Env.cols;
          if (i == 1) 
            builtin_func1_Env.k = 1;
          else 
            builtin_func1_Env.k = j;
          insertarr(&oldtok[i - 1], j, builtin_func1_Env.k, false);
          if (oldtok[i - 1].address == -1) 
            builtin_func1_Env.start = hash(&oldtok[i - 1].name, 151);
          else 
            builtin_func1_Env.start = oldtok[i - 1].address;
          q2[0] = arr_store[builtin_func1_Env.start];
          fillup(j, builtin_func1_Env.k, q2[0]->start, beta[i - 1]);
          free_work();
        }
      break;
    
    case Hampath_:
      /* Nov 1996 */
      arr_parse('H', inf, n, flag);
      break;
    
    case Func_:
    case Function_:
      scanner(inf, &token, flag);
      if (token.name[0] >= 'A' && token.name[0] <= 'Z') 
        funcdef(inf, flag);
      else 
        error(11, &token);
      quoly_set(0, n);
      break;
    
    case Chpoly_:
      if (polynames == NULL) 
        error(213, &token);
      read_command(&builtin_func1_Env);           /* sets q, rows, cols, start */
      if (builtin_func1_Env.start != -1) 
        error(182, &builtin_func1_Env.errorname);
      if (builtin_func1_Env.rows != builtin_func1_Env.cols)
        error(212, &builtin_func1_Env.errorname);  /*  errorname, and above*/
      builtin_func1_Env.bound = NULL;             /* used by do_int_determ */
      builtin_func1_Env.copy = NULL;              /* used by do_int_determ */
      if (ustrcmp(token.name, ",") == 0) {
        scanner(inf, &token, flag);
        old_expre(inf, &builtin_func1_Env.bound, flag);
      }
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      ustrcpy(builtin_func1_Env.errorname.name, "Chpoly");
      scanner(inf, &token, flag);
      
      if (builtin_func1_Env.q->spar != NULL) {
        /* Oct 1999. use bound to select method. */
        if (builtin_func1_Env.bound == NULL) 
          builtin_func1_Env.k = 0;
        else 
          builtin_func1_Env.k = quoly_convert_to_int(builtin_func1_Env.bound);
        if (builtin_func1_Env.k == 0) { /* Use mat_invert.  method will depend on
                                           values for &K, &L etc already set. */
          base_quoly(&builtin_func1_Env.copy, 1);
          quoly_inplace(builtin_func1_Env.copy);
          add_to_diag(builtin_func1_Env.copy, builtin_func1_Env.q->spar, 
                      builtin_func1_Env.rows);
          new_worknode(&i, &builtin_func1_Env.errorname);
          builtin_func1_Env.alpha = workhead[i - 1];
          /* don't really care about alpha */
          quoly_set(1, n);
          spar = builtin_func1_Env.q->spar;
          /* can't pass q^.spar to mat_invert!  danger! */
          mat_invert(builtin_func1_Env.alpha, builtin_func1_Env.alpha, false, false, builtin_func1_Env.rows,
                     n, false, true, &spar, NULL, -1,-1, -1, false, 0);   /* Jan 2008 */
          free_work();
          /* put matrix back */
          quoly_inplace(builtin_func1_Env.copy);
          add_to_diag(builtin_func1_Env.copy, builtin_func1_Env.q->spar, 
                      builtin_func1_Env.rows);
          free_quoly(&builtin_func1_Env.copy);
        } else {        /* Leverrier-Fedeev; any k but 0 */
          if (lintmode && modulus <= builtin_func1_Env.rows)
            error(36, &builtin_func1_Env.errorname);
          sparse_chpoly(builtin_func1_Env.q->spar, builtin_func1_Env.rows, n);
        }
        free_quoly(&builtin_func1_Env.bound);
        return;
      }
      
      new_worknode(&i, &builtin_func1_Env.errorname);
      builtin_func1_Env.alpha = workhead[i - 1];
      builtin_func1_Env.oldm1 = command_int;
      if (lintmode && !modularmode) 
        error(62, &builtin_func1_Env.errorname);
      
      /* copy matrix to alpha. */
      builtin_func1_Env.k = builtin_func1_Env.q->start;
      forEnd_11 = sqr(builtin_func1_Env.rows) - 1;
      for (i = 0; i <= forEnd_11; ++i) {
        (*builtin_func1_Env.alpha)[i] = NULL;
        check_and_assign(builtin_func1_Env.k, &builtin_func1_Env.copy);
        quoly_assign(builtin_func1_Env.copy, &(*builtin_func1_Env.alpha)[i]);
        builtin_func1_Env.k++;
      }
      builtin_func1_Env.copy = NULL;              /* important!*/
      special_set_2(builtin_func1_Env.rows, builtin_func1_Env.rows, 
                    &builtin_func1_Env.arr_facts.arrsize);  /* needed for finish. Oct 2000 */
      builtin_func1_Env.arr_facts.rows = builtin_func1_Env.rows;
      
      m = NULL;
      spar = NULL;
      if (modularmode)
        builtin_func1_Env.modular_stuff = !finf && builtin_func1_Env.rows <= modulus + 1 &&
	                                        mod_is_prime && !chpoly_block; /* Jul 2004 */
      else 
        builtin_func1_Env.modular_stuff = true;
      
      if (!(allnumbs(&builtin_func1_Env) && builtin_func1_Env.rows >= 4 &&
          builtin_func1_Env.rows <= full_charpol + 2 && builtin_func1_Env.modular_stuff))
	  {     /* ordinary way */
                 /* above condition now redundant */
        base_quoly(&m, 1);
        quoly_set(1, n);
        forEnd_12 = builtin_func1_Env.rows - 1;
        for (i = 0; i <= forEnd_12; ++i) 
          better_quoly_sub((*builtin_func1_Env.alpha)[i * (builtin_func1_Env.rows + 1)], 
                         m, &(*builtin_func1_Env.alpha)[i*(builtin_func1_Env.rows + 1)]);
        mat_invert(builtin_func1_Env.alpha, builtin_func1_Env.alpha, true, true,
                   builtin_func1_Env.rows, n, false, true, &spar, NULL, -1,-1, -1, false, 0);    /* Jan 2008 */
        free_quoly(&m);                           /* true, true above */
        free_quoly(&builtin_func1_Env.bound);
        finish_1(&builtin_func1_Env);
        return;
      }

      tr = NULL;
      builtin_func1_Env.k = builtin_func1_Env.q->start;
      quoly_assign((*arp[BSR(builtin_func1_Env.k, 10)])[BAnd(builtin_func1_Env.k,
                    tenmask)], &tr);
      builtin_func1_Env.k = builtin_func1_Env.k + builtin_func1_Env.rows + 1;
      while (builtin_func1_Env.k <= builtin_func1_Env.q->stop) {
        better_quoly_add(tr, (*arp[BSR(builtin_func1_Env.k,10)])[BAnd(builtin_func1_Env.k,
                         tenmask)], &tr);
        builtin_func1_Env.k = builtin_func1_Env.k + builtin_func1_Env.rows + 1;
      }

      set_min_cut(builtin_func1_Env.rows);

      /* find determinant, call it m. */
      dumpitt_level++;
      if (verbose)
        dumpitt("Lagrange interpolation, degree ", builtin_func1_Env.rows,
                true, true, true);

      command_int = builtin_func1_Env.oldm1 && danger_ok;
      if (verbose)
        dumpitt(" ", 1, false, false, true);
      if (modularmode) {
        quoly_set(1, &m);
        mat_invert(builtin_func1_Env.alpha, builtin_func1_Env.alpha, false, false,
                   builtin_func1_Env.rows, &m, false, true, &spar, NULL, -1,-1, -1, false, 0);   /* Jan 2008 */
      } else 
        do_int_determ(&m, 0, &builtin_func1_Env);  /* bound */
      command_int = builtin_func1_Env.oldm1;
      
      /* put matrix back. */
      builtin_func1_Env.k = builtin_func1_Env.q->start;
      if (!modularmode) {
        forEnd_13 = sqr(builtin_func1_Env.rows) - 1;
        for (i = 0; i <= forEnd_13; ++i) {
          quoly_assign((*builtin_func1_Env.alpha)[i], &(*arp[BSR(builtin_func1_Env.k, 
                         10)])[BAnd(builtin_func1_Env.k, tenmask)]);
          builtin_func1_Env.k++;
        }
      }
      
      ci = NULL;
      power = NULL;
      cp = NULL;
      quoly_set(0, n);
      
      /* Compute Sigma(i=1,rows-2)[ C(i)*pol[rows-3,i] ] */
      r2 = builtin_func1_Env.rows;
      forEnd_17 = builtin_func1_Env.rows - 2;
      for (i = 1; i <= forEnd_17; ++i) {
        /* compute c[i]. Start by subtracting denom[i] from diag. */
        builtin_func1_Env.k = builtin_func1_Env.q->start;
        if (modularmode) {
          quoly_set(1, &ci);
          forEnd_14 = builtin_func1_Env.rows - 1;
          for (j = 0; j <= forEnd_14; ++j) 
            better_quoly_sub((*builtin_func1_Env.alpha)[j * (builtin_func1_Env.rows +
	       1)], denom[i-1], &(*builtin_func1_Env.alpha)[j * (builtin_func1_Env.rows
	       + 1)]);
        } else 
          for (j = 1; j <= builtin_func1_Env.rows; ++j) {
            builtin_func1_Env.x = &(*arp[BSR(builtin_func1_Env.k, 
                                  10)])[BAnd(builtin_func1_Env.k, tenmask)];
            better_quoly_sub(*builtin_func1_Env.x, denom[i - 1], builtin_func1_Env.x);
            builtin_func1_Env.k = builtin_func1_Env.k + builtin_func1_Env.rows + 1;
          }
        command_int = builtin_func1_Env.oldm1 && danger_ok;
        if (verbose) 
          dumpitt(" ", i + 1, false, false, true);
        if (modularmode)
          mat_invert(builtin_func1_Env.alpha, builtin_func1_Env.alpha, false, false, builtin_func1_Env.rows, 
		             &ci, false, true, &spar, NULL, -1,-1, -1, false, 0);   /* Jan 2008 */
        else
          do_int_determ(&ci, i, &builtin_func1_Env);       
        command_int = builtin_func1_Env.oldm1;    /*moved these*/
        better_quoly_sub(ci, m, &ci);
        quoly_assign(denom[i - 1], &power);
        quoly_compute_power(&power, builtin_func1_Env.rows - 1);
        builtin_func1_Env.dum = NULL;    /* dum^ gets eaten up below on each pass. */
        quoly_sub(denom[i - 1], tr, &builtin_func1_Env.dum);
        fast_quoly_mult(&builtin_func1_Env.dum, &power);  /*XXXXX*/
                                                  /* Dec 2001 */
        if (Odd(builtin_func1_Env.rows)) 
          quoly_inplace(builtin_func1_Env.dum);
        better_quoly_sub(ci, builtin_func1_Env.dum, &ci);
        fast_quoly_quot(&ci, &denom[i - 1], false);  /* Dec 2001 */
        
        /* cumulative sum in n */
        i2 = i;
        if (builtin_func1_Env.rows - 2 <= in_house_charpol)  /* when comparing to other versions
                                              recall that in_house_charpol = char_pol here */
          cp = (*pol)[builtin_func1_Env.rows - 3][i - 1];
        else 
          compute_char_poly(builtin_func1_Env.rows - 2, i, &cp);
        quoly_mult(ci, cp, &builtin_func1_Env.dum);
        if (builtin_func1_Env.rows - 2 > in_house_charpol && builtin_func1_Env.rows - 2 <= charpol) 
          free_quoly(&cp);
        best_quoly_add(n, builtin_func1_Env.dum);
        
        /* put matrix back. */
        builtin_func1_Env.k = builtin_func1_Env.q->start;
        if (modularmode) {
          forEnd_15 = builtin_func1_Env.rows - 1;
          for (j = 0; j <= forEnd_15; ++j) 
            better_quoly_add((*builtin_func1_Env.alpha)[j * (builtin_func1_Env.rows + 1)], 
                             denom[i - 1], &(*builtin_func1_Env.alpha)[j * (builtin_func1_Env.rows
			     + 1)]);
        } else {
          forEnd_16 = builtin_func1_Env.rows * builtin_func1_Env.cols - 1;
          for (j = 0; j <= forEnd_16; ++j) {
            quoly_assign((*builtin_func1_Env.alpha)[j], &(*arp[BSR(builtin_func1_Env.k, 
                           10)])[BAnd(builtin_func1_Env.k, tenmask)]);
            builtin_func1_Env.k++;
          }
        }
      }
      
      if (verbose) 
        dumpitt(" ", builtin_func1_Env.rows, false, false, true);
      builtin_func1_Env.dum = NULL;
      base_quoly(&builtin_func1_Env.dum, 1);
      base_quoly(&power, 1);
      quoly_compute_power(&power, builtin_func1_Env.rows - 1);
      best_quoly_sub(&builtin_func1_Env.dum, tr);
      fast_quoly_mult(&builtin_func1_Env.dum, &power);  /* Dec 2001 */
      if (Odd(builtin_func1_Env.rows)) 
        quoly_inplace(builtin_func1_Env.dum);
      base_quoly(&power, 1);
      fast_quoly_mult(n, &power);                 /* Dec 2001 */
      best_quoly_add(n, builtin_func1_Env.dum);
      best_quoly_add(n, m);                       /* m is the determinant */

      decr_dumpitt(builtin_func1_Env.rows, true, verbose);  /* Mar 2004 */
      free_quoly(&power);
      free_quoly(&builtin_func1_Env.bound);
      free_quoly(&builtin_func1_Env.copy);
      free_quoly(&ci);
      if (builtin_func1_Env.rows - 2 > charpol) 
        free_quoly(&cp);
      
      finish_1(&builtin_func1_Env);
      break;
    
    default:
      fprintf(stdout, "not implemented\n");
      /* goto 9999 */
      siglongjmp(buf9999, 0 /* Jul 2004 */);
      break;
    
  }
  
  special_free(&builtin_func1_Env.arr_facts.arrsize);  /* Oct 2000 */
  
}

/****************************************************************************/

struct get_coef_EnvRec {

  poly n2;
  poly *ans;
};

typedef struct get_coef_EnvRec get_coef_EnvRec;

static void pad(get_coef_EnvRec *get_coef_Env)
{
  newpoly(&get_coef_Env->n2);
  get_coef_Env->n2->exp = 0;
  get_coef_Env->n2->numb = false;
  get_coef_Env->n2->next = NULL;
  get_coef_Env->n2->variant.pcoef = *get_coef_Env->ans;
  *get_coef_Env->ans = get_coef_Env->n2;
}

/**************************************************************************/

void get_coef(poly n, polyptrr ans, textptr inf, nameptr *flag, Boolean ok)
{  /* n is input and n^ can't be changed. ans is output. Sink into the poly n
     recursively. Changed Dec 1994 to cooperate with quoly_get_coef not wasting
     time copying storage.
        token.name is ',' on entry unless user wanted leading coefficient.
        ans must be nil on entry.
        n may become nil along the way. Must keep going to read all the coefficients
     the user has given.
        Read the comments on get_quoly.
        Very delicate!  Very recursive.  Syntax of call can be (x,1,2,2,3,4,0,2).
        Changed Oct 1996. */

  quoly q;
  long expont;
  Boolean oldmodmode;
  get_coef_EnvRec get_coef_Env;

  get_coef_Env.ans = ans;
  if (ustrcmp(token.name, ",") == 0) {
    /* read next desired exponent */
    scanner(inf, &token, flag);
    q = NULL;
    check_modular(&oldmodmode);
    old_expre(inf, &q, flag);
    if (q->numb) 
      expont = quoly_convert_to_int(q);
    else if (ok) {
      restore_modular(oldmodmode);
      general_coef(n, ans, q, inf, flag);         /* Oct 1996 */
      /* q has been freed */
      return;
    } else {
      free_quoly(&q);
      error(155, &token);
    }
    if (expont == neg_two_to_31) 
      error(156, &token);
    free_quoly(&q);
    restore_modular(oldmodmode);
  } else                   /* only possible if user wanted leading coefficient. */
    expont = n->exp;
  
  /* search for expont in the poly n */
  while (n != NULL) 
    if (n->exp > expont) 
      n = n->next;
    else 
      break;
  
  if (n == NULL)                                  /* nothing */
    ;
  else if (n->exp < expont) 
    n = NULL;                                     /* signal end of sinking */
  
  if (ustrcmp(token.name, ",") == 0) 
    if (n == NULL) 
      get_coef(n, ans, inf, flag, false);         /* ans must become 0 */
    else if (n->numb) {
      /* sneaky!  Beware Laurents! */
      get_coef_Env.n2 = n->next;
      n->next = NULL;
      get_coef(n, ans, inf, flag, false);
      /* ans must be genuine number */
      n->next = get_coef_Env.n2;
    } else {
      get_coef(n->variant.pcoef, ans, inf, flag, false);
      if (!(*ans)->numb || (*ans)->next != NULL) 
        pad(&get_coef_Env);
    }
  else if (n == NULL) 
    poly_set(0, ans);
  else if (n->numb) {
    /* sneaky!  Beware Laurents! */
    newpoly(ans); /*AAR ??????????*/
    (*ans)->exp = 0;
    (*ans)->numb = true;
    (*ans)->next = NULL;
    newimag(&(*ans)->variant.ncoef);
    (*ans)->variant.ncoef->imag = NULL;
    (*ans)->variant.ncoef->size = 0;
    num_assign(n->variant.ncoef, (*ans)->variant.ncoef);
  } else {
    poly_assign(n->variant.pcoef, ans);
    if (!(*ans)->numb || (*ans)->next != NULL) 
      pad(&get_coef_Env);
  }
}

/****************************************************************************/

static void cullout(poly n, poly p, polyptrr s, short height)
{
  /* p^.exp is always <> 0 on entry.  Pass back answer in s. s = nil means answer
     is 0, and this is the ONLY way to signal s = 0. May 1998. */
  poly t;
  polyptrr pp;
  long expo;

  *s = NULL;
  pp = s;
  if (height == 0) {
    expo = p->exp;
    p = p->variant.pcoef;
    height_next_var(&p, &height, 307);
    while (n != NULL) {
      if (n->exp < expo) 
        break;
      t = NULL;
      if (p->numb) 
        poly_assign(n->variant.pcoef, &t);
      else 
        cullout(n->variant.pcoef, p, &t, height);
      if (t != NULL) {                            /* bring it up to this level */
        fluff_out(&t, n->exp - expo);
        *pp = t;
        pp = &t->next;
      }
      n = n->next;
    }
  } else 
    while (n != NULL) {
      if (!n->numb) {
        t = NULL;
        cullout(n->variant.pcoef, p, &t, height - 1);
        if (t != NULL) {                          /* bring it up to this level */
          fluff_out(&t, n->exp);
          *pp = t;
          pp = &t->next;
        }
      }
      n = n->next;
    }
}

/*********************************************************************/

static void extract(poly n, poly p, poly r, polyptrr s);

struct extract_EnvRec {
  poly *s;
  poly *n;
  /* Rewritten Dec 1998. p and r are authenic on first call. Pass back answer  
     in s. p <> nil; r <> nil. trivial case is when both p and r are numbers. */
  
  long expo;
  poly *p;
  poly *r;
  jmp_buf extract_exit;
};
typedef struct extract_EnvRec extract_EnvRec;

/*****************************************************************/

static void pass_level(poly p1, poly r1, extract_EnvRec *extract_Env)
{
  /* s is nil on entry. p1 and r1 are the next p and r to pass on
     (one level down). They can't both be numbers. All new, Dec 1998. */
  poly t;
  polyptrr pp;

  pp = extract_Env->s;
  while (*extract_Env->n != NULL) {
    t = NULL;
    if (!(*extract_Env->n)->numb) {
      extract((*extract_Env->n)->variant.pcoef, p1, r1, &t);
      if (poly_iszero(t)) 
        free_poly(&t);
      else {
        fluff_out(&t, (*extract_Env->n)->exp);
        *pp = t;
        pp = &t->next;
      }
    } else if (p1->numb) {                        /* subtle */
      node_assign(*extract_Env->n, &t);
      *pp = t;
      pp = &t->next;
    }
    *extract_Env->n = (*extract_Env->n)->next;
  }
  if (*extract_Env->s == NULL) 
    poly_set(0, extract_Env->s);
  longjmp(extract_Env->extract_exit, -1);
  /*exit(::extract) ~ up-level function exit*/
}

/*****************************************************************/

static void r_is_numb(extract_EnvRec *extract_Env)
{
  extract_Env->expo = (*extract_Env->p)->exp;
  if (extract_Env->expo == 0) 
    pass_level((*extract_Env->p)->variant.pcoef, *extract_Env->r, 
               extract_Env);                      /* exits */
  while (*extract_Env->n != NULL) 
    if ((*extract_Env->n)->exp > extract_Env->expo) 
      *extract_Env->n = (*extract_Env->n)->next;
    else 
      break;
  if (*extract_Env->n == NULL) 
    poly_set(0, extract_Env->s);
  else if ((*extract_Env->n)->exp < extract_Env->expo) 
    poly_set(0, extract_Env->s);
  else {                                          /* n can't be a number */
    extract((*extract_Env->n)->variant.pcoef, (*extract_Env->p)->variant.pcoef, 
            *extract_Env->r, extract_Env->s);
    if (!(*extract_Env->s)->numb) 
      add_pad(extract_Env->s, 1);
  }
}

/*****************************************************************/

/* the new tricky part, Dec 1998 */
static void p_is_numb(extract_EnvRec *extract_Env)
{
  if ((*extract_Env->r)->exp == 0) 
    pass_level(*extract_Env->p, (*extract_Env->r)->variant.pcoef, 
               extract_Env);                      /* exits */
  /* r^.exp <> 0 means we want this level with expo = 0 */
  while (*extract_Env->n != NULL) 
    if ((*extract_Env->n)->exp > 0) 
      *extract_Env->n = (*extract_Env->n)->next;
    else 
      break;
  if (*extract_Env->n == NULL) 
    poly_set(0, extract_Env->s);
  else if ((*extract_Env->n)->exp < 0) 
    poly_set(0, extract_Env->s);
  else if ((*extract_Env->n)->numb) 
    node_assign(*extract_Env->n, extract_Env->s);
  else {
    extract((*extract_Env->n)->variant.pcoef, *extract_Env->p, (*extract_Env->r)->variant.pcoef, 
            extract_Env->s);
    if (!(*extract_Env->s)->numb) 
      add_pad(extract_Env->s, 1);
  }
}

/*****************************************************************/

static void extract(poly n, poly p, poly r, polyptrr s)
{ /* of extract. Dec 1998, all new. s = nil on entry. */
  
  extract_EnvRec extract_Env;

  if (setjmp(extract_Env.extract_exit)) 
    return;
  extract_Env.r = &r;
  extract_Env.p = &p;
  extract_Env.n = &n;
  extract_Env.s = s;
  if (p->numb && r->numb) 
    poly_assign(n, s);
  else if (p->numb) 
    p_is_numb(&extract_Env);
  else if (r->numb) 
    r_is_numb(&extract_Env);
  else {
    extract_Env.expo = p->exp;
    if (extract_Env.expo == 0 && r->exp == 0) 
      pass_level(p->variant.pcoef, r->variant.pcoef, &extract_Env);  /* exits */
    /* look for expo in n, even if expo = 0. */
    while (n != NULL) 
      if (n->exp > extract_Env.expo) 
        n = n->next;
      else 
        break;
    if (n == NULL) 
      poly_set(0, s);
    else if (n->exp < extract_Env.expo) 
      poly_set(0, s);
    else if (n->numb) 
      poly_set(0, s);
    else {            /* the right expo for the var at this level is here. */
      extract(n->variant.pcoef, p->variant.pcoef, r->variant.pcoef, 
              s);
      if (!(*s)->numb) 
        add_pad(s, 1);
    }
  }
}

/************************************************************************/

void get_Mcoef(poly n, polyptrr ans, textptr inf, nameptr *flag, Boolean mcoef)
{
  
  /* A variation of get_coef; see the doc on that proc.  This one allows the
     syntax Mcoef(x, t^3*u^2..), where the second arg is a monomial.  New error
     192.  Sep 1997.
        ans = nil on input.
        So now q is a monomial.  That's better, BUT 
     it doesn't solve the zero exponent problem.  If the user wants (x, t, 0) 
     (old style) he will have to use Coef instead.  t^0 = 1 !! 
     
        May 1998: Added Mfact, via mcoef and cullout.  
        mcoef = want Mcoef, else want Mfact.
        rewritten Dec 1998 to solve the exponent = 0 problem. A second "reference 
      monomial" is read to specify variables that must have 0 exponent. Quite subtle.
      Also, it's now ok for the (first) monomial to be a number in Mfact. */
  
  quoly q;
  short height;
  poly p;                                         /* Dec 1998 */
  poly r;
  poly p2;

  if (ustrcmp(token.name, ",") != 0) 
    error(192, &token);
  
  /* read desired monomial */
  scanner(inf, &token, flag);
  q = NULL;
  old_expre(inf, &q, flag);
  p = NULL;
  if (q->numb)                                    /* Dec 1998. lots new here */
    poly_set(1, &p);
  else {
    if (q->variant.vc_2.denom != NULL) 
      error(307, &token);
    p = q->variant.vc_2.numer;      /* should be a monomial; its coeff is irrelevant. */
    q->variant.vc_2.numer = NULL;
    if (!monomial(p))                     /* Dec 1998 */
      error(307, &token);
  }
  free_quoly(&q);
  r = NULL;
  if (ustrcmp(token.name, ",") == 0) { /* Dec 1998; 2nd monomial to solve the exponent=0 problem */
    if (!mcoef) 
      error(320, &token);  /* was 321 Jun 2005 */
    /* get second, or reference, monomial. all new Dec 1998 */
    scanner(inf, &token, flag);
    old_expre(inf, &q, flag);
    if (q->numb)
      poly_set(1, &r);
    else if (q->variant.vc_2.denom == NULL) {
      r = q->variant.vc_2.numer;
      q->variant.vc_2.numer = NULL;
      if (!monomial(r)) 
        error(307, &token);
    } else 
      error(307, &token);
    free_quoly(&q);
  } else 
    poly_set(1, &r);                              /* for Mcoef, irrelevant for Mfact */
  
  if (mcoef)                                      /* May 1998; Dec 1998 */
    extract(n, p, r, ans);
  else if (p->numb) 
    poly_assign(n, ans);
  else {
    p2 = p;                                       /* Dec 1998; much is new here */
    height = 0;
    height_next_var(&p2, &height, 307);
    if (anynegs(p2)) 
      error(321, &token);  /* was 322, Jun 2005 */
    /* p2 can't be nil. p2^ is the first node of nonzero exponent. */
    cullout(n, p2, ans, height);
    if (*ans == NULL) 
      poly_set(0, ans);
  }
  
  free_poly(&p);
  free_poly(&r);
}

/*********************************************************************************/

void quoly_get_coef(textptr inf, quolyptr n, nameptr *flag, Boolean mcoef, Boolean mfact)
{
  
  /* n is initially read only!  Somebody else is pointing to n^.  Changed 
     December 1994. 
        Read the comments on get_quoly.  
        Changed Sep 1997 to allow mcoef.
        May 1998: added mfact, relevant only if mcoef = true.
        Dec 1998: now it is ok for n^.numb and mcoef (but not mfact).  */
  
  poly p2;
  poly p3;

  p3 = NULL;
  if ((*n)->numb && !mcoef) {                     /* Dec 1998 */
    newpoly(&p2);
    p2->next = NULL;
    p2->exp = 0;
    p2->numb = true;
    p2->variant.ncoef = (*n)->variant.vc_1.ncoef;
    get_coef(p2, &p3, inf, flag, true);
    freepoly(p2,p2); /*AAR*/
/*AAR

    p2->next = polygarb;
    polygarb = p2;
*/
    poly_consume(&p3, n);
  } else {
    if (mcoef) 
      if ((*n)->numb) {                           /* Dec 1998 */
        quoly_to_poly(*n, &p2);
        get_Mcoef(p2, &p3, inf, flag, !mfact);
        free_poly(&p2);
      } else 
        get_Mcoef((*n)->variant.vc_2.numer, &p3, inf, flag, !mfact);
    else 
      get_coef((*n)->variant.vc_2.numer, &p3, inf, flag, true);
    /* Remember, n is initially read only!  Somebody else is pointing to n^ */
    newquoly(n);
    if (p3->numb && p3->next == NULL) {
      (*n)->numb = true;
      (*n)->variant.vc_1.ncoef = p3->variant.ncoef;
      freepoly(p3,p3); /*AAR*/
/*AAR
      p3->next = polygarb;
      polygarb = p3;
*/
    } else {
      (*n)->variant.vc_2.denom = NULL;
      (*n)->numb = false;
      (*n)->variant.vc_2.rat = false;
      (*n)->variant.vc_2.numer = p3;
    }
  }
}

/*********************************************************************************/

long nth_prime(quolyptr n)                        /* Nov 2002 */
{
  long m;
  long value_nth_prime;

  m = quoly_convert_to_int(*n);
  if (m < 1 || m > small_prime_size) 
    error(346, &token);
  else 
    value_nth_prime = (*small_prime)[m - 1];
  return value_nth_prime;
}

/******************************************************************************/

struct builtin_func2_EnvRec {
  FILEPtr *inf;
  nameptr *flag;
  quoly *n;
  quoly bound;
  Boolean modular_stuff;
  long k;
  /* n is nil on entry */
  /* Sep 2000.  split off Jan 2002. */
  
  arrptr q;
  long rows;
  long cols;
  long start;
  long total_rows;
  long firstrow;
  long firstcol;
  long target_rows;
  tokentipe errorname;
  quolyptr x;
  workptr alpha;
  arr_descr arr_facts;
  Boolean oldm1;
};
typedef struct builtin_func2_EnvRec builtin_func2_EnvRec;

/**********************************************************************/

static void check_for_paren_1(builtin_func2_EnvRec *builtin_func2_Env)
{
  scanner(builtin_func2_Env->inf, &token, builtin_func2_Env->flag);
  if (ustrcmp(token.name, "(") != 0) 
    error(177, &token);
}

/********************************************************/

static void scanner_expre_1(builtin_func2_EnvRec *builtin_func2_Env)
{
  scanner(builtin_func2_Env->inf, &token, builtin_func2_Env->flag);
  if (ustrcmp(token.name, "^") == 0) 
    error(313, &token);                           /* Aug 1997 */
  old_expre(builtin_func2_Env->inf, builtin_func2_Env->n, builtin_func2_Env->flag);
}

/**************************************************************/

/* token = ^ on entry. Aug 1997 */
static void get_quolptr_1(quolyptr *x, builtin_func2_EnvRec *builtin_func2_Env)
{
  scanner(builtin_func2_Env->inf, &token, builtin_func2_Env->flag);
  get_quoly_ptr(x, builtin_func2_Env->inf, builtin_func2_Env->flag);  /* x might be nil! Nov 1997 */
}

/* yes, and x^ might be nil! Jan 1998 */

/**************************************************************/

static void get_level_k_1(Boolean negcheck,       /* new in May 1997 */
                          builtin_func2_EnvRec *builtin_func2_Env)
{
  builtin_func2_Env->bound = NULL;
  scanner(builtin_func2_Env->inf, &token, builtin_func2_Env->flag);
  check_modular(&builtin_func2_Env->modular_stuff);
  old_expre(builtin_func2_Env->inf, &builtin_func2_Env->bound, builtin_func2_Env->flag);
  restore_modular(builtin_func2_Env->modular_stuff);
  if (!builtin_func2_Env->bound->numb) 
    error(227, &token);
  if (lintmode) 
    builtin_func2_Env->k = builtin_func2_Env->bound->variant.vc_1.ncoef->lint;
  else {
    builtin_func2_Env->k = builtin_func2_Env->bound->variant.vc_1.ncoef->head->value;
    if (builtin_func2_Env->bound->variant.vc_1.ncoef->size > 1) 
      error(314, &token);
  }
  free_quoly(&builtin_func2_Env->bound);
  if (negcheck && builtin_func2_Env->k < 0) 
    error(300, &token);
}

/********************************************************/

static void read_command_1(builtin_func2_EnvRec *builtin_func2_Env)
{
  check_for_paren_1(builtin_func2_Env);
  scanner(builtin_func2_Env->inf, &token, builtin_func2_Env->flag);
  if (ustrcmp(token.name, "[") != 0) 
    error(178, &token);
  left_side(builtin_func2_Env->inf, &builtin_func2_Env->q, &builtin_func2_Env->rows, 
            &builtin_func2_Env->cols, &builtin_func2_Env->start, &builtin_func2_Env->total_rows, 
            &builtin_func2_Env->firstrow, &builtin_func2_Env->firstcol, 
            &builtin_func2_Env->target_rows, &builtin_func2_Env->errorname, 
            builtin_func2_Env->flag, false);
  if (builtin_func2_Env->q == NULL) 
    error(28, &builtin_func2_Env->errorname);
}

/*******************************************************/

static void read_with_comma_1(builtin_func2_EnvRec *builtin_func2_Env)
{
  check_for_paren_1(builtin_func2_Env);
  scanner_expre_1(builtin_func2_Env);
  if (ustrcmp(token.name, ",") != 0) 
    error(202, &token);
  scanner(builtin_func2_Env->inf, &token, builtin_func2_Env->flag);
}

/*******************************************************/

/* the old standard read. Aug 1997. */
static void simple_read_1(builtin_func2_EnvRec *builtin_func2_Env)
{
  check_for_paren_1(builtin_func2_Env);
  scanner_expre_1(builtin_func2_Env);
  if (ustrcmp(token.name, ")") != 0) 
    error(1, &token);
  scanner(builtin_func2_Env->inf, &token, builtin_func2_Env->flag);
}

/*******************************************************/

/* Aug 1997 */
static void get_the_data_1(quolyptr *x, quolyptr n, builtin_func2_EnvRec *builtin_func2_Env)
{
  if (ustrcmp(token.name, "^") == 0) {
    free_quoly(n);
    get_quolptr_1(x, builtin_func2_Env);
    if (*x == NULL || **x == NULL) {              /* Nov 1997; Jan 1998 */
      quoly_set(0, n);
      *x = n;
    }
  } else {
    old_expre(builtin_func2_Env->inf, n, builtin_func2_Env->flag);
    *x = n;
  }
}

/**************************************************************/

/* significant change Aug 1997: now use x to point to input. */
static void standard_read_1(builtin_func2_EnvRec *builtin_func2_Env)
{
  check_for_paren_1(builtin_func2_Env);
  scanner(builtin_func2_Env->inf, &token, builtin_func2_Env->flag);
  get_the_data_1(&builtin_func2_Env->x, builtin_func2_Env->n, builtin_func2_Env);
  if (ustrcmp(token.name, ")") != 0) 
    error(1, &token);
  scanner(builtin_func2_Env->inf, &token, builtin_func2_Env->flag);
}

/***************************************************************/

static void read_quoly_ptr_1(quolyptr *x, quolyptr n,   /* Sep 2000 */
                             builtin_func2_EnvRec *builtin_func2_Env)
{
  scanner(builtin_func2_Env->inf, &token, builtin_func2_Env->flag);
  if (ustrcmp(token.name, "^") == 0)           /* irrelevant */
    scanner(builtin_func2_Env->inf, &token, builtin_func2_Env->flag);
  free_quoly(n);
  get_quoly_ptr(x, builtin_func2_Env->inf, builtin_func2_Env->flag);
  if (*x == NULL || **x == NULL) {
    quoly_set(0, n);
    *x = n;
  }
}

/***********************************************************/

static void finish_2(builtin_func2_EnvRec *builtin_func2_Env)
{
  free_arr(builtin_func2_Env->alpha, &builtin_func2_Env->arr_facts);
  free_work();
  special_free(&builtin_func2_Env->arr_facts.arrsize);  /* Oct 2000 */
  command_int = builtin_func2_Env->oldm1;
}

/************************************************************/

void builtin_func2(textptr inf, quolyptr n, nameptr *flag, long index)
{
  
  arrptr q2[4];                                   /* Nov 2000 */
  long i;
  long j;
  tokentipe oldtok[6];                            /* Mar 1999 */
  Boolean wantmod;                                /* june 1998 */
  Boolean old_doline;             /* Dec 2009.  was sparse. unused */
  workptr beta[6];                                /* Mar 1999 */
  quoly m;
  quoly tr;
  quoly ci;
  quoly power;
  quoly dum;
  quoly cp;
  quoly copy;
  quolyptr y;
  boolarray want;
  number pseudodet;
  short height;
  short r2;
  short i2;
  sparseptr spar;
  spar_arr auxspar;                               /* June 1998 */
  builtin_func2_EnvRec builtin_func2_Env;

  builtin_func2_Env.n = n;
  builtin_func2_Env.flag = flag;
  builtin_func2_Env.inf = inf;
  builtin_func2_Env.arr_facts.arrsize.size = 0;   /* Oct 2000 */

  polypt mq; /* Nov 2005 */
  
  switch (index) { 
    case Numb_:
    case Rat_:
      standard_read_1(&builtin_func2_Env);
      if (index == Numb_) 
        if ((*builtin_func2_Env.x)->numb) 
          i = 1;
        else 
          i = 0;
      else if (!(*builtin_func2_Env.x)->numb && (*builtin_func2_Env.x)->variant.vc_2.rat &&
               !lintmode)
        i = 1;
      else 
        i = 0;
      quoly_set(i, n);
      break;
    
    case Modmode_:
      if (modularmode)
        quoly_set(1, n);
      else 
        quoly_set(0, n);
      scanner(inf, &token, flag);
      break;
    
    case Modulus_:
      quoly_set(modulus, n);
      scanner(inf, &token, flag);
      break;
    
    case Return_:
      simple_read_1(&builtin_func2_Env);
      if (*flag == NULL) 
        fprintf(stdout, " *** Warning. \'Return\' ignored.\n");
      else 
        exit_flag = true;
      break;
    
    case Sparse_:
      make_sparse(inf, n, flag);
      break;
    
    case True_:
      scanner(inf, &token, flag);
      quoly_set(1, n);
      break;
    
    case Terms_:
    case Termsf_:   /* Mar 2009 */
      standard_read_1(&builtin_func2_Env);
      if ((*builtin_func2_Env.x)->numb) 
        quoly_set(1, n);
      else 
        if (index == Terms_)
		  quoly_set(numterms(*builtin_func2_Env.x), n);
		else 
		  quoly_set(f_numterms(*builtin_func2_Env.x), n);
      break;
    
    case Move_:
      /* Sep 2000 */
      move_storage(inf, n, flag);
      break;
    
    case Swap_:
      /* Sep 2000 */
      swap_storage(inf, n, flag);
      break;
    
    case Mcoef_:
    case Mfact_:
      check_for_paren_1(&builtin_func2_Env);
      scanner(inf, &token, flag);
      get_the_data_1(&builtin_func2_Env.x, n, &builtin_func2_Env);
      if (*n == NULL)        /* very delicate here; careful */
        m = *builtin_func2_Env.x;
      else 
        m = *n;
      /* Don't use n below!  Danger! */
      quoly_get_coef(inf, &m, flag, true, index == Mfact_);
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      free_quoly(n);
      *n = m;
      scanner(inf, &token, flag);
      break;
    
    case Numvars_:
      scanner(inf, &token, flag);
      quoly_set(number_polys, n);
      break;
    
    case Vars_:  /* Jan 2010. ignore any denom.  */
      standard_read_1(&builtin_func2_Env);
      if ((*builtin_func2_Env.x)->numb) 
        quoly_set(0, n);
      else 
	    quoly_set(driver_poly_vars((*builtin_func2_Env.x)->variant.vc_2.numer), n);
      break;
    
    case Prime_:
      standard_read_1(&builtin_func2_Env);
      if ((*builtin_func2_Env.x)->numb) 
        quoly_set(nth_prime(builtin_func2_Env.x), n);
      else 
        error(227, &token);
      break;
    
    case ZZ1_:  /* Nov 2005.  ZZ1 = crude display with vars. ZZ2 = crude display with blanks, no vars. */
    case ZZ2_:
      standard_read_1(&builtin_func2_Env);
      if ((*builtin_func2_Env.x)->numb) {
        dummy = 0;
        quoly_display(&Output, true, true, true, *builtin_func2_Env.x, &dummy, 
                      &semicolon, polynames, false, true, false);
      }
      else {
        if (index == ZZ1_)
          mq = polynames;
        else {
          mq = NULL;
          noisy = false;
        }
        crude_poly_disp(&Output, true, (*builtin_func2_Env.x)->variant.vc_2.numer, 1, mq);
        fprintf(stdout, "\n");
        crude_poly_disp(&Output, true, (*builtin_func2_Env.x)->variant.vc_2.denom, 1, mq);
      }
      break;
    
    case ZZ3_:  /* Nov 2005. display with dodo vars. */ 
      standard_read_1(&builtin_func2_Env);
      if (number_polys <= 78) {   /* Dec 2009, big rewrite. */
	      old_doline = do_line_sup;
		    do_line_sup = false;
        dummy = 0;
        quoly_display(&Output, true, true, true, *builtin_func2_Env.x, &dummy, &semicolon, 
                      dodo, false, true, false);
        do_line_sup = old_doline;
	    }
	    else
	      fprintf(stdout, "*** Warning: too many variables (> 78). Can't do ZZ3.\n");
	    quoly_set(0, n);
      break;
    
    case X_:  /* Jan 2011. reset main garbage lists. */ 
      scanner(inf, &token, flag);  /* Jun 2004 */
			numhead = NULL;
			imhead = NULL;
			polygarb = NULL;
			quolygarb = NULL;
	    quoly_set(0, n);
      break;
			
    case Totdeg_:
      read_with_comma_1(&builtin_func2_Env);
      if (!(*n)->numb) 
        if ((*n)->variant.vc_2.denom != NULL) 
          error(186, &token);
      if (ustrcmp(token.name, "[") != 0) 
        error(178, &token);
      left_side(inf, &q2[0], &j, &builtin_func2_Env.k, &builtin_func2_Env.start, 
                &builtin_func2_Env.total_rows, &builtin_func2_Env.firstrow, 
                &builtin_func2_Env.firstcol, &builtin_func2_Env.target_rows, 
                &oldtok[0], flag, false);
      if (q2[0] == NULL) 
        error(28, &oldtok[0]);
      if (builtin_func2_Env.start != -1) 
        error(182, &token);
      if (ustrcmp(oldtok[0].name, "%") == 0) 
        error(296, &oldtok[0]);
      if (ustrcmp(token.name, ",") == 0) 
        get_level_k_1(false, &builtin_func2_Env);
      else 
        error(202, &token);
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      scanner(inf, &token, flag);
      if ((*n)->numb) 
        if (builtin_func2_Env.k == 0)             /* nothing */
          ;
        else 
          quoly_set(0, n);
      else 
        do_total_degree(n, q2[0], builtin_func2_Env.k);
      break;
    
    case Mons_:
      check_for_paren_1(&builtin_func2_Env);
      scanner(inf, &token, flag);
      get_the_data_1(&builtin_func2_Env.x, n, &builtin_func2_Env);
      if (ustrcmp(token.name, ",") != 0) 
        error(202, &token);
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, "[") != 0) 
        error(178, &token);
      left_side(inf, &q2[0], &j, &builtin_func2_Env.k, &builtin_func2_Env.start, 
                &builtin_func2_Env.total_rows, &builtin_func2_Env.firstrow, 
                &builtin_func2_Env.firstcol, &builtin_func2_Env.target_rows, 
                &oldtok[0], flag, false);
      /* A new array by the name oldtok[0] will be created. We don't care
         about j, k, or q2[1]. */
      if (builtin_func2_Env.start != -1) 
        error(182, &token);
      if (ustrcmp(oldtok[0].name, "%") == 0) 
        error(296, &oldtok[0]);
      if (ustrcmp(token.name, ",") == 0) 
        get_level_k_1(false, &builtin_func2_Env);  /* 1 means strip off numerical coeffs */
      else 
        builtin_func2_Env.k = 0;
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      
      if ((*builtin_func2_Env.x)->numb) 
        j = 1;
      else if ((*builtin_func2_Env.x)->variant.vc_2.denom != NULL) 
        error(196, &token);
      else 
        j = numterms(*builtin_func2_Env.x);
      
      sparse_create(&oldtok[0], j, 1, true, true);  /* Dec 2000; Aug 2002 */
      if (oldtok[0].address == -1) 
        i = hash(&oldtok[0].name, 151);
      else 
        i = oldtok[0].address;
      q2[0] = arr_store[i];
      dump_mons(arr_store[i], *builtin_func2_Env.x, builtin_func2_Env.k == 1);
      scanner(inf, &token, flag);
      quoly_set(j, n);
      break;
    
    case Sumup_:
      arr_parse('S', inf, n, flag);
      break;
    
    case Numcon_:
      standard_read_1(&builtin_func2_Env);
      if (quoly_iszero(*builtin_func2_Env.x)) 
        quoly_set(0, n);
      else if ((*builtin_func2_Env.x)->numb) 
        if (lintmode) 
          quoly_set(1, n);
        else {
          if (*n == NULL) 
            quoly_assign(*builtin_func2_Env.x, n);
          if ((*n)->variant.vc_1.ncoef->head->value < 0) 
            quoly_inplace(*n);
        }
      else if (!lintmode && (*builtin_func2_Env.x)->variant.vc_2.rat) {
        if (*n == NULL) 
          quoly_assign(*builtin_func2_Env.x, n);
        if ((*n)->variant.vc_2.numer->variant.ncoef->head->value < 0) 
          quoly_inplace(*n);
      } else if ((*builtin_func2_Env.x)->variant.vc_2.denom == NULL) {
         /* in lintmode assume prime modulus */
        if (*n == NULL) {
          base_quoly(n, 1);
          gcd_coefs((*builtin_func2_Env.x)->variant.vc_2.numer, &(*n)->variant.vc_2.numer);
        } else 
          gcd_coefs((*n)->variant.vc_2.numer, &(*n)->variant.vc_2.numer);
        polynum_to_quoly(n);
      }
      
      else 
        error(196, &token);
      break;
    
    case Rcoef_:
      change_coef(inf, n, flag);                  /* Nov 1997 */
      break;
    
    case Rname_:
      namechange(inf, n, flag);                   /* Nov 1997 */
      quoly_set(0, n);  /* Dec 2007 */
      break;
    
    case Toot_:                      /* Feb 2010 */
      scanner(inf, &token, flag);
      quoly_set(0, n);
      fprintf(stdout, "\a");
      break;
    
    case Time_:                      /* Feb 2010 */
      scanner(inf, &token, flag);
      quoly_set(0, n);
      showtime();
      break;
    
    case PRoot_:
      if (!modularmode) 
        error(284, &token);
      if (!mod_is_prime) 
        error(293, &token);
      standard_read_1(&builtin_func2_Env);
      if (*n == NULL) 
        quoly_assign(*builtin_func2_Env.x, n);
      if (!(*n)->numb) {
        if ((*n)->variant.vc_2.denom != NULL) 
          error(186, &token);
        if (laurent) 
          if (anynegs((*n)->variant.vc_2.numer)) 
            error(198, &token);
        if (field_depth == 0) 
          error(301, &token);
        quoly_pth_root(n);
      }
      break;
    
    case Powermod_:
      if (lintmode && !modularmode) 
        error(62, &token);
      check_for_paren_1(&builtin_func2_Env);
      scanner_expre_1(&builtin_func2_Env);
      if (ustrcmp(token.name, ",") != 0) 
        error(202, &token);
      if (!(*n)->numb) 
        if ((*n)->variant.vc_2.denom != NULL) 
          error(286, &token);
      /* pseudodet below not a pnemonic name. don't need to initialize it. */
      get_exponent(inf, flag, &pseudodet, false);
      /* pseudodet is in rational format in all cases! */
      m = NULL;
      if (ustrcmp(token.name, ",") == 0) {
        scanner(inf, &token, flag);
        old_expre(inf, &m, flag);
        if (!m->numb) 
          if (m->variant.vc_2.denom != NULL) 
            error(288, &token);
        if (lintmode) 
          if (m->numb) 
            error(188, &token);
          else                                    /* nothing */
            ;
        else if (m->numb && m->variant.vc_1.ncoef->head->value <= 0) 
          error(288, &token);
      }
      /* else m is still nil -- no explicit modulus */
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      if (m == NULL && !lintmode && (*n)->numb) 
        error(292, &token);
      powermod(n, &m, &pseudodet, false);
      scanner(inf, &token, flag);
      free_quoly(&m);
      free_num(&pseudodet);
      break;
    
    case Trace_:
      arr_parse('T', inf, n, flag);
      break;
    
    case Remquot_:
      read_with_comma_1(&builtin_func2_Env);
      m = NULL;
      old_expre(inf, &m, flag);
      if (ustrcmp(token.name, ",") != 0) 
        error(202, &token);
      scanner(inf, &token, flag);
      quoly_mod_and_quot(n, &m);
      set_quotient(m, inf, flag, 1, ')');      /* will use up m */
      scanner(inf, &token, flag);
      break;
    
    case Switchcol_:
    case Switchrow_:
      read_command_1(&builtin_func2_Env);         /* sets q, rows, cols, start */
      if (builtin_func2_Env.start == -1) {        /* wasn't subarray */
        builtin_func2_Env.start = builtin_func2_Env.q->start;
        builtin_func2_Env.target_rows = builtin_func2_Env.total_rows;
      } else if (builtin_func2_Env.q->spar != NULL) 
        error(244, &builtin_func2_Env.errorname);
      if (index == Switchrow_ && builtin_func2_Env.target_rows != builtin_func2_Env.total_rows) 
        error(180, &builtin_func2_Env.errorname);
      if (index == Switchcol_ && !is_product_of(&builtin_func2_Env.q->sizearr, 
                                                builtin_func2_Env.total_rows, builtin_func2_Env.cols))
        error(181, &builtin_func2_Env.errorname);
      if (ustrcmp(token.name, ",") != 0) 
        error(202, &token);
      check_modular(&builtin_func2_Env.modular_stuff);
      scanner_expre_1(&builtin_func2_Env);
      /* June 1998. BUG. massive changes here. */
      j = quoly_convert_to_int(*n);
      if (ustrcmp(token.name, ",") != 0) 
        error(70, &token);
      scanner_expre_1(&builtin_func2_Env);
      builtin_func2_Env.k = quoly_convert_to_int(*n);
      if (ustrcmp(token.name, ")") != 0) 
        error(70, &token);
      restore_modular(builtin_func2_Env.modular_stuff);
      if (builtin_func2_Env.q->spar == NULL)      /* June 1998 */
        i = 0;
      else 
        i = 1;                                    /* i is a sparse/ordinary converter */
      j = j - addresser + i;
      builtin_func2_Env.k = builtin_func2_Env.k - addresser + i;
      if (j < i || builtin_func2_Env.k < i) 
        error(179, &token);
      if (index == Switchrow_ && (j >= builtin_func2_Env.total_rows + i || builtin_func2_Env.k >=
                                  builtin_func2_Env.total_rows + i))
        error(179, &token);
      if (index == Switchcol_ && (j >= builtin_func2_Env.cols + i || builtin_func2_Env.k >=
                                  builtin_func2_Env.cols + i))
        error(179, &token);
      if (builtin_func2_Env.k < j) {              /* BUG, July 1998 */
        i = j;
        j = builtin_func2_Env.k;
        builtin_func2_Env.k = i;
      }
      if (j != builtin_func2_Env.k) 
        if (builtin_func2_Env.q->spar == NULL) 
          switchrow_col(index, j, builtin_func2_Env.k, builtin_func2_Env.start, 
                        builtin_func2_Env.total_rows, builtin_func2_Env.target_rows, 
                        builtin_func2_Env.cols);
        else if (index == Switchrow_) 
          sp_switchrow(builtin_func2_Env.q->spar, j, builtin_func2_Env.k);
        else 
          sp_switchcol(builtin_func2_Env.q->spar, j, builtin_func2_Env.k, 
                       builtin_func2_Env.q->rows, 1);
      scanner(inf, &token, flag);
      quoly_set(0, n);
      break;
    
    case Minpoly_:
      if (polynames == NULL) 
        error(213, &token);
      read_command_1(&builtin_func2_Env);         /* sets q, rows, cols, start */
      if (builtin_func2_Env.start != -1) 
        error(182, &builtin_func2_Env.errorname);
      if (builtin_func2_Env.rows != builtin_func2_Env.cols) 
        error(212, &builtin_func2_Env.errorname);
      if (builtin_func2_Env.q->spar == NULL) 
        error(252, &builtin_func2_Env.errorname);
      if (builtin_func2_Env.rows > millsize) 
        error(245, &builtin_func2_Env.errorname);
      builtin_func2_Env.bound = NULL;
      check_modular(&builtin_func2_Env.modular_stuff);
      if (ustrcmp(token.name, ",") == 0) {
        scanner(inf, &token, flag);
        old_expre(inf, &builtin_func2_Env.bound, flag);
      } else 
        error(202, &token);
      restore_modular(builtin_func2_Env.modular_stuff);
      if (!builtin_func2_Env.bound->numb) 
        error(257, &token);
      if (lintmode) 
        builtin_func2_Env.k = builtin_func2_Env.bound->variant.vc_1.ncoef->lint;
      else 
        builtin_func2_Env.k = builtin_func2_Env.bound->variant.vc_1.ncoef->head->value;
      if (builtin_func2_Env.k < 0 || builtin_func2_Env.k > 3) 
        error(257, &token);
      if (ustrcmp(token.name, ",") == 0) {
        scanner(inf, &token, flag);
        old_expre(inf, &builtin_func2_Env.bound, flag);
      } else 
        gershgorn(&builtin_func2_Env.bound, builtin_func2_Env.q, builtin_func2_Env.rows);
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      scanner(inf, &token, flag);
      Mills(builtin_func2_Env.q, builtin_func2_Env.rows, builtin_func2_Env.k, 
            &builtin_func2_Env.bound, n, &wantmod);
      if (!wantmod) {
        fprintf(stdout, " *** Warning: Minpoly failed. Integers in answer are too large\n");
        quoly_set(0, n);
      }
      free_quoly(&builtin_func2_Env.bound);
      break;
    
    default:
      fprintf(stdout, "not implemented\n");
      /* goto 9999 */
      siglongjmp(buf9999, 0 /* Jul 2004 */);
      break;
    
  }
  
  special_free(&builtin_func2_Env.arr_facts.arrsize);  /* Oct 2000 */
  
}

/***************************************************************************/

/* created Jan 2002 to split the big one */

void builtin_func(textptr inf, quolyptr n, nameptr *flag, long index)
{
  
  if (index <= MSmith_) 
    builtin_func1(inf, n, flag, index);
  else 
    switch (index) { 
      case Rat_:
      case Pfunc_:
      case Numer_:
      case Nlcoef_:  /* Oct 2005 */
      case Ntcoef_:  /* Jul 2008 */
      case Nmcoef_:   /* Jul 2008 */
      case Zncoef_:  /* Jul 2008 */
      case Reverse_:  /* Apr2 2011 */
        builtin_func1(inf, n, flag, index);
        break;
      case Raise_:
      case Split_:   /* Aug 2010 */
      case Splice_:  /* Aug 2010 */
      case PDivides_:
      case SDivide_:
        builtin_func1(inf, n, flag, index);
        break;
      case Mono_:   /* Jul 2006, Dec 2006 */
      case Poly_:  /* Apr2 2011 */
	      builtin_func1(inf, n, flag, index);
        break;
      case Sqfree_:
      case Normalize_:
      case Pseudet_:
      case Rowreduce_:  /* Jun 2004  BUG fix */
        builtin_func1(inf, n, flag, index);
        break;
      case Smith_:
      case Redrowech_:
      case Minors_:
      case Sort_:  /* Sep 2010  */
	    case Synth_:  /* Oct 2010  */
	    case STrans_:   /* Dec 2007 */
        builtin_func1(inf, n, flag, index);
        break;
      default:
        builtin_func2(inf, n, flag, index);
        break;
    }
}

/****************************************************************************/

struct raise_quoly_EnvRec {
  long *k;
};
typedef struct raise_quoly_EnvRec raise_quoly_EnvRec;

/* laurent ok. n is not a number. k <> 0. n is authenic. ~ beware poly mod out */

static void raise_poly(polyptrr q, raise_quoly_EnvRec *raise_quoly_Env)
{
  polyptrr pt;
  long i;
  poly p;

  if ((*q)->numb && (*q)->next == NULL) 
    return;
  pt = q;
  for (i = 1; i <= *raise_quoly_Env->k; ++i) 
    if (!(*pt)->numb && (*pt)->exp == 0 && (*pt)->next == NULL) 
      pt = &(*pt)->variant.pcoef;
    else 
      error(275, &token);
  p = *pt;
  *pt = NULL;
  free_poly(q);
  *q = p;
}

/****************************************************************************/

void raise_quoly(quolyptr n, long k)
{
  
  raise_quoly_EnvRec raise_quoly_Env;

  raise_quoly_Env.k = &k;
  if (k < 0) 
    error(273, &token);
  raise_poly(&(*n)->variant.vc_2.numer, &raise_quoly_Env);
  if ((*n)->variant.vc_2.denom != NULL) 
    raise_poly(&(*n)->variant.vc_2.denom, &raise_quoly_Env);
}

/****************************************************************************/

void call_content(quolyptr x, quolyptr n, quolyptr m)
{
  
  /* laurents ok ~
     Aug 1997:  x^ points to the input. n <> nil means x^ = n.  n = nil means x is 
     pointing into a symbol table.  output goes in n.   See builtin function.
       Sep 2002: added m to specify poly var. m can be nil, which means it's 1, else 
     m can be either an integer or a poly var.  Other changes too. 
       Nov 2002: sped up by calling general_content. */
  
  poly p;                                         /* Sep 2002 */
  poly exps;
  poly tail;
  poly q;
  poly t;
  polypt pt;
  short h;                                        /* Sep 2002 */
  short i;
  long depth;                                     /* Sep 2002 */
  Boolean n_nil;
  Boolean dumm;   /* Feb 2006 */

  n_nil = *n == NULL;
  if ((*x)->numb) 
    if (lintmode || (*x)->variant.vc_1.ncoef->head->value == 0) 
      quoly_set(1, n);
    else {
      if (n_nil) 
        quoly_assign(*x, n);
      if ((*n)->variant.vc_1.ncoef->head->value < 0) 
        quoly_inplace(*n);
    }
  
  else if (!lintmode && (*x)->variant.vc_2.rat) {
    if (n_nil) 
      quoly_assign(*x, n);
    if ((*n)->variant.vc_2.numer->variant.ncoef->head->value < 0) 
      quoly_inplace(*n);
  }
  
  else if ((*x)->variant.vc_2.denom != NULL) 
    error(196, &token);
  
  else {
    pt = polynames;
    p = (*x)->variant.vc_2.numer;
    q = p;                                        /* Sep 2002, and a lot of stuff below */
    if (!n_nil) 
      (*n)->variant.vc_2.numer = NULL;            /* prepare n for later call to content */
    else if (laurent) 
      error(312, &token);
    if (laurent) 
      clear_bads(&p, &exps, &tail, 0, halfblock);
    else 
      exps = NULL;
    
    /* find height of x^^.numer, the input. In the default case,
       we want p to move down past the 0-exponent head nodes.  But
       if the user has specified a depth (via m) > h, we need to revert
       to the top level, using q. Sep 2002 */
    h = 1;
    while (p->exp == 0) {
      t = p;                                      /* t trails p. Sep 2002 */
      p = p->variant.pcoef;
      h++;
      pt = pt->next;
    }
    
    if (*m == NULL)                               /* Sep 2002 */
      depth = h;                                  /* the default */
    else if ((*m)->numb) 
      depth = convert_to_int((*m)->variant.vc_1.ncoef);
    else if (is_poly_var(*m, &depth))             /* fine, depth is set */
      ;
    else 
      error(282, &token);
    
    if (depth > number_polys || depth < 1) 
      error(345, &token);
    
    if (field_depth > 0 && depth >= field_depth) 
      error(344, &token);
    
    if (depth < h) {                              /* Sep 2002 */
      if (n_nil) 
        quoly_assign(*x, n);                      /* else just use n */
      else 
        (*n)->variant.vc_2.numer = q;             /* restore n */
      /* note that we don't try to "normalize" n */
      return;
    }
    
    if (n_nil) {
      base_quoly(n, 1);                           /* initialize it to something */
      free_poly(&(*n)->variant.vc_2.numer);       /* n is now same as "if not n_nil" case above */
    } else if (depth == h && h > 1)
    /* Sep 2002, space losing bug found. must free nodes passed over by p. */
    {
      freepoly(q,t); /*AAR*/
/*AAR
      t->next = polygarb;
      polygarb = q;
*/
      for (i = 3; i <= h; ++i) {
        q->next = q->variant.pcoef;
        q = q->variant.pcoef;
      }
    }
    
    dumm = true;  /* Feb 2006 */
    if (depth == h)                               /* default case */
      content(p, &(*n)->variant.vc_2.numer, pt, true, true, n_nil);  /* Jun 2005. stupid BUG fix Sep 2005 */
    else                                          /* new version, Nov 2002. so simple! */
      general_content(p, (short)depth - h + 1, &(*n)->variant.vc_2.numer, pt, &dumm, true);  /* Feb 2006, Mar 2006 */
    
    if ((*n)->variant.vc_2.numer->numb)
      polynum_to_quoly(n);
    else if (depth == h) 
      add_pad(&(*n)->variant.vc_2.numer, h);
    else
      add_pad(&(*n)->variant.vc_2.numer, h - 1);  /* Nov 2002 */
    if (!n_nil) 
      free_poly(&p);                              /* Nov 2002 */
    if (exps != NULL) {
      freepoly(exps,tail); /*AAR*/
/*AAR
      tail->next = polygarb;
      polygarb = exps;
*/
    }
  }
}

/*****************************************************************************/

void basic_form(condexptr *q, comptr *comm, nametype endflag, textptr inf, nameptr *flag, Boolean *once_more, 
               tokentipe *realtok);

/*****************************************************************************/

struct right_side_EnvRec {
  /*nametype *stop; AAR */ unsigned char **stop;
};
typedef struct right_side_EnvRec right_side_EnvRec;

static Boolean time_to_quit_1(right_side_EnvRec *right_side_Env)  /* Nov 1997 */
{
  Boolean value_time_to_quit;

  if (ustrcmp(token.name, *right_side_Env->stop) == 0) 
    value_time_to_quit = true;
  else if (ustrcmp(*right_side_Env->stop, "elfi*") == 0) 
    value_time_to_quit = ustrcmp(token.name, "else") == 0 || ustrcmp(token.name, "fi") == 0;
  else 
    value_time_to_quit = false;
  return value_time_to_quit;
}

/****************************************************************************/

void right_side(formptr *q, nametype stop, textptr inf, nameptr *flag, Boolean *once_more, tokentipe *realtok)
{
  /* A right_side is a sequence of basic forms separated by semicolons */
  
  formptr last;
  Boolean first;
  Boolean quick; /* Apr 2007. control new short cut syntax, in which terminating od and fi can be left off in sysfunc. */
                 /* Building of the function must be allowed, and a reasonable sysfunction must be built that will execute */
			     /* transparently to the user.  It will contain a series of vacuous  0;  commands. */
  right_side_EnvRec right_side_Env;

  right_side_Env.stop = &stop;
  first = true;
  *q = NULL;
  semicount = 0;          /* used for not falling into infinite loop if no ã */
  last = NULL;
  while (true) {              /* was token.name <> stop, Nov 1997 */
    if (first) {
      newform(q);
      (*q)->comms = NULL;
      last = *q;
      first = false;
    } else {
      newform(&last->next);
      last->next->comms = NULL;
      last = last->next;
    }
 
    basic_form(&last->cptr, &last->comms, stop, inf, flag, once_more, 
               realtok);
    if (ustrcmp(token.name, ";") == 0 && tt_flag) 
      semicount++;
    else 
      semicount = 0;

     quick = in_sys_func && tt_flag && semicount == 12;   /* Apr 2007. coordinate with the call to error 132 below, and spec_right_side. */
    if (quick)                                           /* Note there can only be 11 commands within a loop in sysfunc! */
      quick = ustrcmp(stop, "od") == 0 || ustrcmp(stop, "elfi*") == 0 || ustrcmp(stop, "fi") == 0; 

    if (semicount == 1 || quick) {
      last_good_one = last->cptr;
      last_comm = last->comms;
    }
	
    if (semicount == 15)    /* Apr 2007. was 10 */
      error(132, &token);

    if (quick)  {  /* Apr 2007 */
	  semicount = 0;
	  break;
	}
	  
    if (time_to_quit_1(&right_side_Env))          /* Nov 1997 */
      break;
    else if (ustrcmp(token.name, ";") == 0)
      if (feof(*inf)) 
        break;
      else {
        scanner(inf, &token, flag);
	if (time_to_quit_1(&right_side_Env))  /* Jun 2005. allow semicolon before fi, od, else*/
          break;
	  }
    else if (ustrcmp(token.name, "{") == 0) 
      error(35, &token);
    else
      error(38, &token);
  }
  if (last != NULL) 
    last->next = NULL;
}

/******************************************************************************/

void spec_right_side(formptr *q, textptr inf, nameptr *flag, nametype endflag)  

{
  formptr last;
  Boolean dummy;
  tokentipe oltok;
  
  semicount = 0;        /* used for not falling into infinite loop if no ã */
  last = NULL;
  newform(q);
  (*q)->comms = NULL;
  last = *q;
  
  basic_form(&last->cptr, &last->comms, endflag, inf, flag, &dummy, &oltok);
  
  if (ustrcmp(token.name, ";") == 0 && tt_flag) 
    semicount++;
  else 
    semicount = 0;
	
 /* fprintf(stdout, "here in spec, %d, %s\n", semicount, token.name);   Apr 2007 */

  if (semicount == 1 || semicount == 13) {  /* Apr 2007. coordinate with 12 and 15 in right_side. */
    last_good_one = last->cptr;
    last_comm = last->comms;
  }
  if (semicount == 15)   /* Apr 2007 */
    error(132, &token);
  if (last != NULL) 
    last->next = NULL;
}

/**************************************************************************/

void obtain_expression(textptr inf, nameptr *flag, nameptr *p, nametype brace)
{
  nameptr t;
  Boolean first;
  short count;
  char mate;

  count = 1;
  first = true;
  if (brace[0] == '[') 
    mate = ']';
  else 
    mate = ')';
  while (count > 0) {
    if (first) 
      newname(p);
    else 
      newname(&t->next);
    if (first) 
      t = *p;
    else 
      t = t->next;
    first = false;
    t->let = token;
    if (ustrcmp(t->let.name, brace) == 0) 
      count++;
    else if (t->let.name[0] == mate) 
      count--;
    else if (ustrcmp(t->let.name, ";") == 0 || ustrcmp(t->let.name, "¥") == 0) 
      error(274, &semicolon);
    if (count > 0) 
      scanner(inf, &token, flag);
  }
  
  t->next = NULL;
}

/******************************************************************************/

void obtain_sum(textptr inf, nameptr *flag, nameptr *p)
{
  
  /* token = Sum or Prod at beginning */
  nameptr t;
  Boolean first;
  Boolean done;

  if (*flag == NULL) {
    scanner(inf, &token, flag);
    if (ustrcmp(token.name, "<") != 0) 
      error(144, &token);
    first = true;
    done = false;
    while (!done) {
      if (first) 
        newname(p);
      else 
        newname(&t->next);
      if (first) 
        t = *p;
      else 
        t = t->next;
      first = false;
      t->let = token;
      if (ustrcmp(t->let.name, ">") == 0) {
        scanner(inf, &token, flag);
        done = ustrcmp(token.name, "[") == 0 || ustrcmp(token.name, "(") == 0;
        if (!done && ustrcmp(token.name, "<") != 0) 
          error(145, &token);
      } else if (ustrcmp(t->let.name, ";") == 0 || ustrcmp(t->let.name, "¥") == 0) 
        error(81, &semicolon);
      else 
        scanner(inf, &token, flag);
    }
    newname(&t->next);
    t = t->next;
    t->let = token;
    scanner(inf, &token, flag);
    obtain_expression(inf, flag, &t->next, t->let.name);
  } else 
    *p = (*flag)->next;
}

/*******************************************************************************/

void square_root(imptr n, imptr n2)
{  /* Note:  This is called only by procedure fact, in which n2 = n.  Unsure why it is set up with 
		two parameters here, though int_sqrt does need two params because of its own recursion.
		Sep 2010 */
  
  if (finf)  /* Jul 2004 */
    if (n->lint < 0 || n->lint >= modulus)
      error(37, &sqrtsign);
    else
      if (f256)
        n2->lint = f256sqr[n->lint];
      else
        n2->lint = f2t16sqr[n->lint];
			else
				if (modularmode)   /* changed to work in lintmod, Sep 2010 */
					if (mod_is_prime && Odd(modulus))   /* Aug 2011 */
						n->lint = modular_sqrt(n->lint);
					else
						error(34, &sqrtsign);
				else if (lintmode) 
					if (n->lint < 0)  /* note, this is possible and should be allowed for. */
						error(37, &sqrtsign);
					else
						n->lint = sqrt(n->lint);
				else if (n->head->value < 0) 
						error(37, &sqrtsign);
					else 
						int_sqrt(n, n2, true);
}

/****************************************************************************/

void get_quoly(quolyptr n, textptr inf, nameptr *flag)
{
  
  /* Return n as a pointer to existing storage -- do not duplicate the storage. 
     n must be nil or irrelevant on input. 
       It is very dangerous to do this, to have n pointing to some other storage.
     Especially beware that n may be the system's main quoly, sysnum. 
     Beware any procedure that uses this one, especially if that procedure could
     have an error!  
       Are we sure n cannot be nil at end?  As long as prevnum is not nil. 
     BEWARE! 
     
        Nov 1997:  Beware indeed!  n can be nil - sparse array.  Caller beware! 
		
	   Note: if ustrcmp(token.name, "^") == 0 we just move on, ignore it.  We never duplicate
	 storage here.  Jan 2007 */
  
  quolyptr qp;
  nameptr p;
  arrptr qa;
  varptr q;
  long row;
  long count;
  numptr np;
  Boolean sensitive;
  Boolean its_syst;
  tokentipe oldtok;

  if (*flag != NULL && (*flag)->compiled) 
    switch ((*flag)->tipe) { 
      case one:
        *n = *(*flag)->qp;
        *flag = (*flag)->next;
        token = (*flag)->let;
        break;
      case two:
        *n = *(*flag)->qp;
        *flag = (*flag)->next->next;
        *flag = (*flag)->next->next;
        token = (*flag)->let;
        break;
      case three:
        p = *flag;
        *flag = (*flag)->next->next;
        token = (*flag)->let;

        ievalcoords(&row, &count, flag, &sensitive);
        *flag = (*flag)->next;
        token = (*flag)->let;
        np = (numptr)p->qp;
        row = np->value + row - addresser;        /* changed Oct 1993 */
        if (sensitive) 
          row += (count - addresser) * (np->next->value);
        qp = &(*arp[BSR(row, 10)])[BAnd(row, tenmask)];
        *n = *qp;
        break;
    }
  
  else {
    
    if (ustrcmp(token.name, "<") == 0)
      its_syst = true;
    else if (polynames != NULL && its_a_polyname(&token.name)) 
      error(125, &token);
    else 
      its_syst = false;
    
    if (ustrcmp(token.name, "^") == 0)         /* Nov 2002.  ignore it. */
      scanner(inf, &token, flag);
    
    oldtok = token;
    if (ustrcmp(token.name, "%") != 0) 
      scanner(inf, &token, flag);
    if (ustrcmp(token.name, "[") == 0 || ustrcmp(token.name, "%") == 0) {
      if (fasterlookup(&oldtok, &qa, inf, flag) == -1) 
        error(28, &oldtok);
      if (ustrcmp(oldtok.name, "%") == 0) {
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "[") != 0) 
          error(217, &token);
      }
      scanner(inf, &token, flag);
      evalcoords(inf, &row, &count, flag, ']', ',', &sensitive, false);
      array_quoly_ptr(qa, row, count, sensitive, &qp, &oldtok, its_syst);
      if (qp == NULL) 
        *n = NULL;
      else 
        *n = *qp;                                 /* Nov 1997 */
      /* might be nil either way; Jan 1998 */
      scanner(inf, &token, flag);
    } else if (its_syst) 
      *n = prevnum;
    else {
      /* Lookup oldtok in symbol table. */
      if (oldtok.address == -1) 
        row = hash(&oldtok.name, 151);
      else 
        row = oldtok.address;
      q = sca_store[row];
      while (q != NULL) 
        if (ustrcmp(q->let.name, oldtok.name) == 0) 
          break;
        else 
          q = q->next;
      if (q == NULL) 
        error(19, &oldtok);
      else 
        *n = q->val;
    }
  }
}

/****************************************************************************/

void quoly_at_matrix(textptr inf, quoly nq, workptr arr, arr_descr *arr_facts, Boolean *arr_free, LongIntPtr rows, nameptr *flag, sparseptr *spar);

/******************************************************************************/

long fasterlookup(tokentipe *x, arrptr *q, textptr inf, nameptr *flag)
{
  
  /* Many callers need fasterlookup to return q^.start, even for sparse's that have
     genuine arp storage as well. <<<<*/
  
  long m;
  quoly n;
  long value_fasterlookup;

  if (ustrcmp(x->name, "%") == 0) {
    n = NULL;
    get_arr_arr(inf, &n, flag, &m);
    free_quoly(&n);
    *q = (*arrstash)[m];
    if (*q == NULL) {
      error(220, &token);
      value_fasterlookup = -1;
    } else 
      value_fasterlookup = (*q)->start;
  } else if (ustrcmp(x->name, "<") == 0) {
    *q = syst;
    value_fasterlookup = 0;                       /* check all invocations*/
  } else 
    value_fasterlookup = fastestlookup(x, q);
  return value_fasterlookup;
}

/****************************************************************************/


struct fact_EnvRec {
  FILEPtr *inf;
  nameptr *flag;
  quoly *n;
  quolyptr *qp;
};
typedef struct fact_EnvRec fact_EnvRec;

static void do_parens(fact_EnvRec *fact_Env)  /* Dec 1998, to fix the Ž bug */
{
  scanner(fact_Env->inf, &token, fact_Env->flag);
  old_expre(fact_Env->inf, fact_Env->n, fact_Env->flag);
  if (ustrcmp(token.name, ")") != 0) 
    error(1, &token);
  else 
    scanner(fact_Env->inf, &token, fact_Env->flag);
  *fact_Env->qp = fact_Env->n;
}

/**********************************************************************************/

void fact(textptr inf, quolyptr *qp, quolyptr n, colm_ptrptr *aux, LongIntPtr colpos, nameptr *flag, Boolean leave_it)
{
  /*   Big changes, Nov 1997.  Now returns qp, n, aux, and colpos. 
  
     Basic idea: qp^ is the value being returned.  If n = nil, qp is pointing to
     storage in some system-wide data structure.  If n <> nil, qp^ = n.
     
     qp might be nil, but only when a sparse array is accessed with no entry -- 
     i.e., the entry "is 0." In that case (aux, colpos) then points to the place where 
     a value should be inserted if this is part of an assignment statement.  
     n = nil also.
     
     More about aux and colpos: aux points to the entry in the array indx which is
     the row where this array ref belongs, and colpos is its coordinate.  Note that at
     first glance it seems that all we need is a colm_ptrptr to point to the previous
     colm_ptr in the sparse array row list where the entry will later be placed. For example,
     if it is x[3,4] that is not present, let aux point to the colm_ptr in the previous
     node in row 3.  BUT by the time we need it, that node may no longer be there!!  
     Sneaky!  Hence the much safer method of passing back both aux and colpos.
     
     aux is not nil for ALL sparse array refs.  It is usually nil otherwise.  When aux 
     <> nil, the caller cannot use qp -- can't take the chance that qp has been changed
     in the mean time.  n = nil also then.
     
     If qp <> nil (usually true), then qp^ is the value being returned. If n = nil
     then qp is pointing to storage in one of the system data structures.  If
     n <> nil then new storage for n was created here, and qp points to n.
           
     The caller must first check if qp = nil.  If so, aux and colpos may be of use.
     If qp <> nil, the caller may want to check if n = nil.
     
     aux is usually nil (and colpos is undefined) unless it's a sparse reference, so then
     n = nil too.  If n <> nil, caller will not care about aux.  If n = nil,
     aux and colpos are valid. 
     
     Sep 2000: added leave_it.
     
     May 2001: added eatstorage. Clarification:  q := q + z is NOT an error if q does not 
     exist prior to the statement.  This is due to the changes made in Nov 97 with the new 
     syntax q := etc.  When a new (scalar) var is encountered on the left, it is added to the 
     symbol table with a 0 value.  So q := *q + z is also OK.  But a := q + z is an error if
     q does not exist.  Note added Oct 2005, I think it is added with a value of 1. */

  tokentipe oldtok;
  quoly n2;
  number m;
  number m2;
  number m3;
  long row;
  long count;
  long expont;
  Boolean negative;
  Boolean sensitive;
  Boolean old_modmode;
  Boolean eatstorage;
  arrptr q;
  nameptr p;
  nameptr copy;
  polypt pol;
  varptr vp;                                      /* Nov 1997 */
  numptr np;
  sparseptr spar;
  char mate;
  short height;                                   /* May 1998 */
  fact_EnvRec fact_Env;
  poly pp;  /* Oct 2005 */

  fact_Env.qp = qp;
  fact_Env.n = n;
  fact_Env.flag = flag;
  fact_Env.inf = inf;
  m.size = 0;
  m2.size = 0;
  
  if (*n != NULL) 
    free_quoly(n);                                /* Nov 1997 */
  
  *aux = NULL;                                    /* default */
  
  if (ustrcmp(token.name, "*") == 0) {     /* May 2001 */
    scanner(inf, &token, flag);
    if (token.name[0] >= 'a' && token.name[0] <= 'z') 
      eatstorage = true;
    else 
      error(337, &token);
  } else 
    eatstorage = false;
  
  if (*flag != NULL && (*flag)->compiled) 
    switch ((*flag)->tipe) { 
      case one:
        *qp = (*flag)->qp;
        *flag = (*flag)->next;
        token = (*flag)->let;
        break;
      case two:
        *qp = (*flag)->qp;
        *flag = (*flag)->next->next;
        do 
          *flag = (*flag)->next;
        while (ustrcmp((*flag)->let.name, "]") != 0);
        *flag = (*flag)->next;
        token = (*flag)->let;
        break;
      case three:
        p = *flag;
        *flag = (*flag)->next->next;
        token = (*flag)->let;
        ievalcoords(&row, &count, flag, &sensitive);
        *flag = (*flag)->next;
        token = (*flag)->let;
        np = (numptr)p->qp;
        row = np->value + row - addresser;        /* changed Oct 1993 */
        if (sensitive) 
          row += (count - addresser) * (np->next->value);
        *qp = &(*arp[BSR(row, 10)])[BAnd(row, tenmask)];
        break;
    }
  else if (token.name[0] >= 'a' && token.name[0] <= 'z') 
    if (polynames != NULL && its_a_polyname(&token.name)) {
      if (eatstorage)  /* Jan 2009 */
        error(363, &token);
      is_poly_name2(&token.name, &count, &pol);
      if (pol->p != NULL && pol->expon == 1)      /*@@@*/
        p_q_assign(pol->p, n);
      else 
        base_quoly(n, count);
      *qp = n;
      scanner(inf, &token, flag);
    } else {
      oldtok = token;
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, "[") == 0) {
        new_arretrieve(inf, &oldtok, flag, qp, n, aux, colpos);
        if (*qp == NULL)                          /* sparse array and entry isn't there; i.e. 0 */
          if (leave_it || ustrcmp(token.name, ":") == 0)   /* Sep 2000 */
                          /*aux, colpos are set, leave n nil for assignment*/
            ;
          else {
            quoly_set(0, n);
            *qp = n;
          }
      }
      /* else nothing */
      else {
        retrieve(&oldtok, qp, n, inf, flag);
        if (*qp == NULL)                          /* var not defined */
          if (ustrcmp(token.name, ":") == 0) {  /* assignment, new form. Nov 1997 */
                                                  /* also includes no-print command */
            quoly_set(0, n);
            insert_var(&oldtok, *n, &vp);
            *qp = &vp->val;
            *n = NULL;
          } 
		 else if (ustrcmp(oldtok.name, "quit") == 0) {  /* OK, I added it.  Sep 2005 */
                        fprintf(stdout, " The quit command is &q.\n");
	                quoly_set(0, n);
                        *qp = n;
		      }
		 else error(19, &oldtok);
      }
    }
  /* else n probably is nil */
  
  else if (token.name[0] >= '0' && token.name[0] <= '9') {
    new_readin(inf, &m, flag, &expont);           /* Jul 2002 */
    scalar_to_quoly(&m, n);
    if (ustrcmp(token.name, ".") == 0) {       /* Jul 2002 */
      n2 = NULL;
      get_decimal_part(&n2, inf, flag);
      best_quoly_add(n, n2);
      n2 = NULL;
    }
    *qp = n;
  }
  
  else if (token.name[0] >= 'A' && token.name[0] <= 'Z') {
    count = find_built_in(0, numbuiltins, token.name);
    
/*fprintf(stdout, "%d", count);
  fprintf(stdout, " %s", token.name);
  fprintf(stdout, " %s", builtin[count][0]);
  fprintf(stdout, " %s\n", builtin[count][1]); */  
  
    if (count == -1) 
      evaluate(inf, &token, n, flag);
    else if (builtin[count][1][0] == '*') {
      ustrcpy(token.name, builtin[count][1]);
      fact(inf, qp, n, aux, colpos, flag, false);
    }
    /* must return new storage in n */
    else 
      builtin_func(inf, n, flag, count);
    *qp = n;
  }
  
  else if (ustrcmp(token.name, "*103") == 0) {   /* Var Dec 2007 Jul 2008. Mar 2009  Oct 2009  Feb 2010 Aug 2010 Sep 2010 Oct 2010 Apr2 2011 */
         check_modular(&old_modmode);
         scanner(inf, &token, flag);
         if (ustrcmp(token.name, "(") == 0)     /* Dec 1998 */
           do_parens(&fact_Env);                   /* gets qp, n */
         else 
           fact(inf, qp, n, aux, colpos, flag, false);
         if (*qp == NULL) 
           error(278, &token);
         else if (!(*(*qp))->numb) 
           error(227, &token);
         row = convert_to_int((*(*qp))->variant.vc_1.ncoef);
         free_quoly(n);                            /* added July 1996 */
         restore_modular(old_modmode);
         if (row <= 0 || row > number_polys) 
           error(278, &token);
         base_quoly(n, row);
         *qp = n;
        }
  
  else if (ustrcmp(token.name, "*89") == 0) {   /* Sqrt Dec 2007 */  /* Jul 2008  Oct 2009 Aug 2010 Sep 2010 Apr2 2011*/
        scanner(inf, &token, flag);
        fact(inf, qp, n, aux, colpos, flag, false);
        if (*qp == NULL) 
          quoly_set(0, n);
        else if (*n == NULL) 
          quoly_assign(**qp, n);
        if (!(*n)->numb) 
          if ((*n)->variant.vc_2.rat && !lintmode) 
            quoly_great_int(n);
          else {
            free_quoly(n);
            error(115, &sqrtsign);
          }
        num_assign((*n)->variant.vc_1.ncoef, &m);
        m3.size = 0;
        square_root(&m, &m);
        scalar_to_quoly(&m, n);
        *qp = n;
       }
  
  else if (ustrcmp(token.name, "*70") == 0) {   /* Rand */  /* Jul 2008 Apr2 2011 */
         scanner(inf, &token, flag);  /* Jun 2004 */
         sensitive = false;
         randomize(sensitive, n);
         *qp = n;
      }     
  
   else if (ustrcmp(token.name, "*68") == 0) {   /* RRand */  /* Jul 2008 Apr2 2011 */
         scanner(inf, &token, flag);  /* Jun 2004 */
         sensitive = true;
         randomize(sensitive, n);
         *qp = n;
      }     
  
   else if (ustrcmp(token.name, "*1") == 0) {   /* Bin */     
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "(") != 0) 
          error(177, &token);
        scanner(inf, &token, flag);
        check_modular(&sensitive);
        old_expre(inf, n, flag);
        if (ustrcmp(token.name, ",") != 0) 
          error(202, &token);
        row = quoly_convert_to_int(*n);           /* bug of Feb 1998 */
        scanner(inf, &token, flag);
        old_expre(inf, n, flag);
        if (ustrcmp(token.name, ")") != 0) 
          error(1, &token);
        scanner(inf, &token, flag);
        count = quoly_convert_to_int(*n);         /* bug of Feb 1998 */
        free_quoly(n);                            /* Nov 1997; failsafe */
        restore_modular(sensitive);
        if (count < 0 || count > row) 
          quoly_set(0, n);
        else if (modularmode)
          mod_binom(row, count, n);
        else if (lintmode) 
          lint_binom(row, count, n);
        else 
          rat_binom(row, count, n);
        *qp = n;
       }
  
  else if (ustrcmp(token.name, "*66") == 0 || ustrcmp(token.name, "*82") == 0){  /* Jul 2008, Oct 2009 Apr2 2011 */
       /* Sigma, Prod   Oct 2005   Dec 2006, Oct 2009 */
        oldtok = token;
        obtain_sum(inf, flag, &p);
        copy = p;
        token = p->let;
        if (ustrcmp(token.name, "<") != 0) 
          error(144, &token);
        sum_mult_up(oldtok.name, inf, n, &p, false, &count, &mate);
		    if (integerflag)   /* Dec 2010. bug fix */
			    quoly_set(count, n);
		    if (*flag == NULL) 
          freename(copy);                         /* copy not changed */
        else 
          *flag = p;
        if (token.name[0] != mate) 
          error(274, &token);
        scanner(inf, &token, flag);
        *qp = n;
        }

  else if (ustrcmp(token.name, "*12") == 0) {   /* Det */   
         arr_parse('7', inf, n, flag);  /* note Det symbol = 7, May 2004  Jun 2003 */
         *qp = n;
        }
  
  else if (ustrcmp(token.name, "*79") == 0) {   /* SDet Apr2 2011 */    
         arr_parse('8', inf, n, flag);  /* Oct 2009 */
         *qp = n;
        }

  else if (ustrcmp(token.name, "*101") == 0) {   /* Trans */  /* Jul 2008. Mar 2009  Oct 2009  Feb 2010 Aug 2010 Sep 2010 Oct 2010 Apr2 2011 */
         arr_parse('"', inf, n, flag);  /* note Det symbol  Jun 2003  Nov 2009*/
         *qp = n;
        }
  
  else if (ustrcmp(token.name, "*14") == 0) {   /* Diag */   
         arr_parse('~', inf, n, flag);  /* note Det symbol  Jun 2003 */
         *qp = n;
        }
  
  else if (ustrcmp(token.name, "*7") == 0) {   /* Cols */  
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "[") != 0)
          error(96, &token);
        scanner(inf, &token, flag);
        count = fasterlookup(&token, &q, inf, flag);  /*spar*/
        if (count == -1) 
          error(28, &token);
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "]") != 0) 
          error(97, &token);
        setvalue(quotient_of(&q->sizearr, q->rows), &m);  /* Oct 2000 */
        scalar_to_quoly(&m, n);
        scanner(inf, &token, flag);
        *qp = n;
       }
  
  else if (ustrcmp(token.name, "*4") == 0 || ustrcmp(token.name, "*9") == 0){ /* Deg, Codeg */
        negative = ustrcmp(token.name, "*4") == 0;
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "[") == 0) {
          if (negative)
            error(276, &token);
          scanner(inf, &token, flag);
          count = fasterlookup(&token, &q, inf, flag);  /*spar*/
          if (count == -1) 
            error(28, &token);
          scanner(inf, &token, flag);
          if (ustrcmp(token.name, "]") != 0) 
            error(99, &token);
          spec_scalar_quoly(&q->sizearr, n);      /* Oct 2000 */
          scanner(inf, &token, flag);
        } else if (ustrcmp(token.name, "(") == 0) {
          scanner(inf, &token, flag);
          if (ustrcmp(token.name, "^") == 0) {  /* Nov 1997. reference param. */
            scanner(inf, &token, flag);
            get_quoly_ptr(qp, inf, flag);
            if (*qp == NULL || **qp == NULL) {
              quoly_set(0, n);
              *qp = n;                            /* Jan 1998 */
            }
          } else {
            old_expre(inf, n, flag);
            *qp = n;                              /* Jan 1998 */
          }
          if (ustrcmp(token.name, ")") == 0) 
            if ((*(*qp))->numb) 
              quoly_set(0, n);
            else if (negative) 
              quoly_set(codegree((*(*qp))->variant.vc_2.numer, 1), n);
            else 
              quoly_set((*(*qp))->variant.vc_2.numer->exp, n);
          else {
            if (ustrcmp(token.name, ",") != 0) 
              error(202, &token);
            scanner(inf, &token, flag);
            check_modular(&old_modmode);
            n2 = NULL;
            old_expre(inf, &n2, flag);            /* Nov 1997 */
            restore_modular(old_modmode);
            if (ustrcmp(token.name, ")") != 0) 
              error(1, &token);
            if (n2->numb) 
              expont = quoly_convert_to_int(n2);  /* really a level */
            else {                                /* May 1998 */
              check_get_height(n2, &height, 282);
              expont = height + 1;
            }
            free_quoly(&n2);
            if (expont <= 0 || expont > number_polys) 
              error(273, &token);
            generalized_degree(*qp, n, expont, negative);
          }
          scanner(inf, &token, flag);
        } else {
          get_quoly(&n2, inf, flag);              /* n2 is just a pointer! */
          if (n2 == NULL)                         /* failsafe */
            quoly_set(0, n);
          else if (n2->numb) 
            quoly_set(0, n);
          else if (negative) 
            quoly_set(codegree(n2->variant.vc_2.numer, 1), n);
          else 
            quoly_set(n2->variant.vc_2.numer->exp, n);
        }
        *qp = n;
       }
  
  else if (ustrcmp(token.name, "*5") == 0) {   /* Coef, Coef_ */ 
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "(") != 0) 
          error(154, &token);
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "^") == 0)   /* Oct 2005. At least it's not an error anymore.  */
          scanner(inf, &token, flag);
        /* Don't use n below!  Danger! */
        get_quoly(&n2, inf, flag);
        if (n2 == NULL) 
          quoly_set(0, &n2);                      /* Nov 1997 */
        quoly_get_coef(inf, &n2, flag, false, false);
        if (ustrcmp(token.name, ")") != 0) 
          error(1, &token);
        *n = n2;
        scanner(inf, &token, flag);
        *qp = n;
       }
  
  else if (ustrcmp(token.name, "*40") == 0) {   /* Lterm.  big changes below Jan 2007. */
		scanner(inf, &token, flag);
        if (ustrcmp(token.name, "(") != 0) 
          error(177, &token);
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "^") == 0) {
          free_quoly(n);
		  scanner(inf, &token, flag);
          get_quoly_ptr(qp, inf, flag); 
          if (*qp == NULL || **qp == NULL) {  
            quoly_set(0, n);
            *qp = n;
          }
         } else {
           old_expre(inf, n, flag);
           *qp = n;
         }  
        if (ustrcmp(token.name, ")") != 0) 
          error(1, &token);
        scanner(inf, &token, flag);
  
        if ((*(*qp))->numb || (*(*qp))->variant.vc_2.rat && !lintmode) 
          if (*n == NULL) 
            quoly_assign(**qp, n);
          else      /* nothing */
            ;
        else {
          if ((*(*qp))->variant.vc_2.denom != NULL) 
            if (!(*(*qp))->variant.vc_2.denom->numb) 
              error(186, &token);
          if (*n == NULL) /* qp^ is a system data structure, var or array */
            leading_term(**qp, n);
          else {  /* Oct 2005. make Lterm actually work for once. */
            pp = (*n)->variant.vc_2.numer;
            sensitive = false;
            while (pp->exp == 0 && !pp->numb && pp->next == NULL) {
              pp = pp->variant.pcoef;
              sensitive = true;
            }
            free_poly(&pp->next);
            if (laurent && sensitive && pp->numb) /* sneaky. get rid of dummy 0 nodes.  */
              poly_assign(pp, &(*n)->variant.vc_2.numer);
          }
          if ((*n)->variant.vc_2.denom == NULL) {  /* must be NULL in lintmode */
            if ((*n)->variant.vc_2.numer->numb) 
              polynum_to_quoly(n);
          } else 
            check_quoly(n, false);
        }
        *qp = n;
       }

  else switch(token.name[0]) {
      
      case '.':
        get_decimal_part(n, inf, flag);
        *qp = n;
        break;
      
      case '_':
        old_modmode = modularmode;  /* simplified Jul 2003 */
        if (modularmode)
           mod_is_changed++;
        modularmode = false;                      /* lintmode still on */
        scanner(inf, &token, flag);
        fact(inf, qp, n, aux, colpos, flag, false);
        if (*qp == NULL) 
           quoly_set(0, n);
        else if (*n == NULL) 
           quoly_assign(**qp, n);
        *qp = n;
        modularmode = old_modmode;
        if (modularmode)
           mod_is_changed--;
        break;
      
      case '-':
        scanner(inf, &token, flag);
        fact(inf, qp, n, aux, colpos, flag, false);
        if (*qp == NULL) 
          quoly_set(0, n);
        else if (*n == NULL) 
          quoly_makeneg(**qp, n);
        else 
          quoly_inplace(*n);
        *qp = n;
        break;
      
      case '(':
        do_parens(&fact_Env);                     /* gets qp, n */
        break;
      
      case '|':
        scanner(inf, &token, flag);
        fact(inf, qp, n, aux, colpos, flag, false);
        if (ustrcmp(token.name, "|") != 0) 
          error(63, &token);
        if (*qp == NULL) 
          quoly_set(0, n);
        else if (*n == NULL) 
          quoly_assign(**qp, n);
        quoly_abs(*n);
        *qp = n;
        scanner(inf, &token, flag);
        break;
      
      case '$':
        scanner(inf, &token, flag);
        fact(inf, qp, n, aux, colpos, flag, false);
        if (*qp == NULL) 
          quoly_set(0, n);
        else if (*n == NULL) 
          quoly_assign(**qp, n);
        quoly_great_int(n);   /* Nov4 2011 */
        *qp = n;
        break;
      
      case '%':   
        get_arr_arr(inf, n, flag, &count);
        free_quoly(n);                            /* Nov 1997. all new below. */
        if ((*arrstash)[count] == NULL) 
          error(220, &token);
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "[") != 0) 
          error(217, &token);
        spec_arretrieve(inf, flag, (*arrstash)[count], qp, aux, colpos);
        if (*qp == NULL)         /* sparse array and entry isn't there; i.e. 0 */
          if (leave_it || ustrcmp(token.name, ":") == 0)   /* Sep 2000 */
                        /* aux, colpos are set, leave n nil for assignment*/
            ;
          else {
            quoly_set(0, n);
            *qp = n;
          }
        break;
      
       /*  case 'Š':  quoly read in.  move to after & Jun 2003 */
            
       /* Jun 2004. kill, move later case ' ':  system function.  Try &<F  */
      
      case '\'':   /* character string */
        dumbscanner(inf, &token, flag, &sensitive);
        /* sensitive is a dummy here */
        setvalue(token.name[0], &m);
        dumbscanner(inf, &token, flag, &sensitive);
        if (ustrcmp(token.name, "\'") != 0) 
          error(109, &token);
        scalar_to_quoly(&m, n);
        scanner(inf, &token, flag);
        *qp = n;
        break;
      
      case '<':   /* system var or Function */
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "[") == 0) {
          if (syst->stop == -1) 
            error(175, &token);
          scanner(inf, &token, flag);
          if (integerflag) 
            ievalcoords(&row, &count, flag, &sensitive);
          else 
            evalcoords(inf, &row, &count, flag, ']', ',', &sensitive, 
                       false);
          array_quoly_ptr(syst, row, count, sensitive, qp, &token, 
                          true);
          if (*qp == NULL)                        /* probably impossible, Nov 1997 */
            quoly_set(0, n);
          else {
            if (**qp == NULL) {
              uninit++;                      /* Jul 2002 */
              if (uninit < 21) 
                fprintf(stdout, "Warning. Uninitialized array element in [<] has been set to 0.\n");
              else if (uninit == 21) 
                fprintf(stdout, " ....etc...\n");
              quoly_set(0, *qp);
              (*(*qp))->variant.vc_1.arr_arg = false;  /* May 2001. failsafe */
            }
            quoly_assign(**qp, n);
          }
          scanner(inf, &token, flag);
        } else if (ustrcmp(token.name, "F") == 0) { /* Jun 2004 system function */
            if (sys_func == NULL) 
              error(222, &token);
            if (*flag != NULL) 
              error(225, &token);
            p = startexpr;
            copy = prev_expr;
            quoly_set(0, n);
            prev_expr = NULL;
            startexpr = NULL;
            eval_form(inf, sys_func, n);
            if (*n == NULL) 
              quoly_set(0, n);
            integerflag = false;
            prev_expr = copy;
            startexpr = p;
            exit_flag = false;
            cycle_flag = false;
            leave_flag = false;
            scanner(inf, &token, flag);
            *qp = n;
        } else 
           quoly_assign(prevnum, n);
        *qp = n;
        break;
      
      case '@':
      case '&':
      case '!':
      case '?':
        parse(inf, n, flag);
        if (*n == NULL) 
          quoly_set(0, n);
        *qp = n;
        break;
      
      default:
        error(2, &token);
        break;
    }
  
  if (ustrcmp(token.name, "^") == 0) {
    m2.size = 0;
    get_exponent(inf, flag, &m2, true);
    if (*qp == NULL) 
      quoly_set(0, n);
    else if (*n == NULL) 
      quoly_assign(**qp, n);
    raise_to_power(n, &m2);
    free_num(&m2);
    m2.size = 0;
    *qp = n;
    
  } else if (ustrcmp(token.name, "!") == 0) {
    m.size = 0;
    if (*qp == NULL) 
      quoly_set(0, n);
    else if (*n == NULL) 
      quoly_assign(**qp, n);
    if ((*n)->numb) 
      num_assign((*n)->variant.vc_1.ncoef, &m);
    else {
      free_quoly(n);
      error(130, &factsign);
    }
    scanner(inf, &token, flag);
    factorial(&m);
    scalar_to_quoly(&m, n);
    *qp = n;
    
  } else if (ustrcmp(token.name, "#") == 0) {  /* evaluation */
    scanner(inf, &token, flag);
    if (ustrcmp(token.name, "[") == 0) 
      if (matrix_eval > 0) {                      /* Somebody is signalling. */
                                                  /* Return to arr_fact, which just called fact. */
        matrix_eval--;
        return;
      } else {                                    /* must call quoly_at_matrix here, with stash */
        spar = NULL;
        expont = syst->rows;
        new_worknode(&count, &bulletsign);
        /*   spare := workhead[count];  FAILS!!  @@@? */
        /* need spare because of maybe x#[<] */
        if (*qp == NULL) {                        /* Nov 1997 */
          quoly_set(0, n);
          *qp = n;
        }
        quoly_at_matrix(inf, **qp, workhead[count - 1], &sys_arr_facts, 
                        &sensitive, &syst->rows, flag, &spar);
        if (syst_dump) {
          if (*flag == NULL) 
            fprintf(stdout, "Warning. System array was changed before it could be displayed.\n");
        } else 
          syst_dump = true;
        if (syst->spar == NULL) 
          for (row = 0; row <= syst->stop; ++row) 
            free_quoly(&(*stash)[row]);
        else 
          free_sparse(&syst->spar, expont, true);
        syst->stop = sys_arr_facts.arrsize.head->value - 1;  /* Oct 2000 */
        spec_num_assign(&sys_arr_facts.arrsize, &syst->sizearr);
        syst->linear = syst->rows == 1 || quotient_of(&syst->sizearr, 
                                                      syst->rows) == 1;
        if (spar != NULL) 
          if (sensitive) 
            syst->spar = spar;
          else 
            copy_sparse(&spar, &syst->spar, syst->rows, false);
        else if (sensitive) 
          for (row = 0; row <= syst->stop; ++row) 
            (*stash)[row] = (*workhead[count - 1])[row];
        else 
          for (row = 0; row <= syst->stop; ++row) 
            quoly_assign((*workhead[count - 1])[row], &(*stash)[row]);
        quoly_set(0, n);
        *qp = n;
        free_work();
      }
    else {
      n2 = NULL;                                  /* flag to get_evalquoly */
      if (*qp == NULL) 
        quoly_set(0, n);
      else if (*n == NULL) 
        if (eatstorage) {                         /* May 2001 */
          *n = **qp;
          **qp = NULL;
          quoly_set(1, *qp);                      /* not 0! */
          (*(*qp))->variant.vc_1.arr_arg = false;
        } else 
          *n = **qp;
          /* quoly_assign(**qp, n)   change, Mar 2005 */ ;
      get_evalquoly(inf, n, &n2, &count, flag, true, true);  /* Mar 2005 */
      free_quoly(&n2);
      *qp = n;
    }
  }
  
  while (ustrcmp(token.name, "\"") == 0) {  /* derivative Jul 2003, was `*/
    if (*qp == NULL) 
      quoly_set(0, n);
    else if (*n == NULL) 
      if (eatstorage) {                           /* May 2001 */
        *n = **qp;
        **qp = NULL;
        quoly_set(1, *qp);                        /* not 0! sparse arrays. */
        (*(*qp))->variant.vc_1.arr_arg = false;
      } else 
        quoly_assign(**qp, n);                    /* Nov 1997 */
    quoly_differen_once(n, 1);
    *qp = n;
    scanner(inf, &token, flag);
  }
}

/****************************************************************************/

void old_term(textptr inf, quolyptr n, nameptr *flag)
{
  
  quoly n2;
  char key;
  Boolean nogcd;                                  /* May 2002 */

  old_fact(inf, n, flag);
  
  n2 = NULL;
  key = token.name[0];
  
  while ((PSet_Test(term_set, sizeof(term_set)/2, key)) || key >= 'a' && key <= 'z'  /*@@@*/
         || key >= 'A' && key <= 'Z') 
    
    switch (key) { 
      case '*':
      case '\\':
      case '|':
      case '/':
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "/") == 0)     /* May 2002 */
          if (key == '/') {
            nogcd = true;
            scanner(inf, &token, flag);
          } else 
            error(339, &token);
        else 
          nogcd = false;
        old_fact(inf, &n2, flag);
        if (key == '*') 
          fast_quoly_mult(n, &n2);                /* Dec 2001 */
        else if (key == '/') 
          fast_quoly_quot(n, &n2, nogcd);         /* Dec 2001, May 2002 */
        else 
          quoly_mod_or_div(*n, n2, n, key);
        free_quoly(&n2);
        key = token.name[0];
        break;
      default:
        if (ustrcmp(token.name, "or") == 0 || ustrcmp(token.name, "and") == 0)
	/* Oct 1999 */
          return;
        old_fact(inf, &n2, flag);
        fast_quoly_mult(n, &n2);                  /* Dec 2001 */
        free_quoly(&n2);
        key = token.name[0];
        break;
    }
}

/****************************************************************************/

void old_expre(textptr inf, quolyptr n, nameptr *flag)
{
  
  /* Nov 1997.  Check all invocations of expre and replace most with this. */
  
  quoly n2;
  tokentipe oldtoken;

  old_term(inf, n, flag);
  
  while (ustrcmp(token.name, "+") == 0 || ustrcmp(token.name, "-") == 0) {
    oldtoken = token;
    scanner(inf, &token, flag);
    n2 = NULL;
    old_term(inf, &n2, flag);
    if (ustrcmp(oldtoken.name, "+") == 0) 
      best_quoly_add(n, n2);
    else 
      best_quoly_sub(n, n2);
  }
}

/****************************************************************************/

void term(textptr inf, quolyptr *qp, quolyptr n, colm_ptrptr *aux, LongIntPtr colpos, nameptr *flag)
{
  
  /* Nov 1997. all new. */
  
  quoly n2;
  char key;
  quolyptr qp2;
  Boolean call_fast;        /* Dec 2001. means: can we call fast_quoly_mult, quot? */
  Boolean nogcd;
  /* May 2002, nogcd */

  fact(inf, qp, n, aux, colpos, flag, false);
  
  n2 = NULL;
  key = token.name[0];
  
  call_fast = *n != NULL && *qp != NULL;          /* Dec 2001 */
  
  while ((PSet_Test(term_set, sizeof(term_set)/2, key)) || key >= 'a' && key <= 'z' ||
          key >= 'A' && key <= 'Z')
    
    switch (key) {
      case '*':
      case '\\':
      case '|':
      case '/':
        scanner(inf, &token, flag);
        if (*qp == NULL) {
          quoly_set(0, n);
          *qp = n;
          call_fast = true;                       /* Dec 2001 */
        }
        if (ustrcmp(token.name, "/") == 0)     /* May 2002 */
          if (key == '/') {
            nogcd = true;
            scanner(inf, &token, flag);
          } else 
            error(339, &token);
        else 
          nogcd = false;
        fact(inf, &qp2, &n2, aux, colpos, flag, false);
        if (qp2 == NULL) {
          quoly_set(0, &n2);
          qp2 = &n2;
        }
        if (key == '*') 
          if (call_fast)                          /* Dec 2001 */
            fast_quoly_mult(n, qp2);
          else 
            quoly_mult(**qp, *qp2, n);
        else if (key == '/') 
          if (call_fast)                          /* Dec 2001 */
            fast_quoly_quot(n, qp2, nogcd);
          else 
            quoly_quot(**qp, *qp2, n, nogcd);
        else 
          quoly_mod_or_div(**qp, *qp2, n, key);
        if (n2 != NULL) 
          free_quoly(&n2);
        *qp = n;
        call_fast = true;                         /* Dec 2001 */
        key = token.name[0];
        break;
      
      default:
        if (ustrcmp(token.name, "or") == 0 || ustrcmp(token.name, "and") == 0)
	/* Oct 1999; new  grammar */
          return;
        if (*qp == NULL) {
          quoly_set(0, n);
          *qp = n;
          call_fast = true;                       /* Dec 2001 */
        }
        fact(inf, &qp2, &n2, aux, colpos, flag, false);
        if (qp2 == NULL) {
          quoly_set(0, &n2);
          qp2 = &n2;
        }
        if (call_fast)                            /* Dec 2001 */
          fast_quoly_mult(n, qp2);
        else 
          quoly_mult(**qp, *qp2, n);
        if (n2 != NULL) 
          free_quoly(&n2);
        *qp = n;
        call_fast = true;                         /* Dec 2001 */
        key = token.name[0];
        break;
    }
}

/********************************************************************************/

void half_fact(textptr inf, quolyptr n, nameptr *flag)
{
  
  /* Nov 1997.  part of the grammar revision. n is a poly var equiv on input. */
  
  quoly n2;
  number m;
  long dumm;

  m.size = 0;
  if (ustrcmp(token.name, "^") == 0) {
    get_exponent(inf, flag, &m, true);
    raise_to_power(n, &m);
    free_num(&m);
  } else if (ustrcmp(token.name, "!") == 0) {
    if ((*n)->numb) 
      num_assign((*n)->variant.vc_1.ncoef, &m);
    else 
      error(130, &factsign);
    scanner(inf, &token, flag);
    factorial(&m);
    scalar_to_quoly(&m, n);
  } else if (ustrcmp(token.name, "#") == 0) {
    scanner(inf, &token, flag);
    n2 = NULL;                                    /* flag to get_evalquoly */
    get_evalquoly(inf, n, &n2, &dumm, flag, true, false);
    free_quoly(&n2);
  }
  
  while (ustrcmp(token.name, "\"") == 0) {  /* BUG Mar 2005 */
    quoly_differen_once(n, 1);
    scanner(inf, &token, flag);
  }
}

/********************************************************************************/

void half_term(textptr inf, quolyptr n, nameptr *flag)
{
  
  /* Nov 1997.  part of the grammar revision.  */
  
  quoly n2;
  char key;
  Boolean nogcd;                                  /* May 2002 */

  n2 = NULL;
  key = token.name[0];
  
  while ((PSet_Test(term_set, sizeof(term_set)/2, key)) || key >= 'a' && key <= 'z' || key >= 'A'
          && key <= 'Z')
    
    switch (key) { 
      case '*':
      case '\\':
      case '|':
      case '/':
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "/") == 0)     /* May 2002 */
          if (key == '/') {
            nogcd = true;
            scanner(inf, &token, flag);
          } else 
            error(339, &token);
        else 
          nogcd = false;
        old_fact(inf, &n2, flag);
        if (key == '*') 
          fast_quoly_mult(n, &n2);                /* Dec 2001 */
        else if (key == '/') 
          fast_quoly_quot(n, &n2, nogcd);         /* Dec 2001, May 2002 */
        else 
          quoly_mod_or_div(*n, n2, n, key);
        if (n2 != NULL) 
          free_quoly(&n2);
        key = token.name[0];
        break;
      default:
        old_fact(inf, &n2, flag);
        fast_quoly_mult(n, &n2);                  /* Dec 2001 */
        if (n2 != NULL) 
          free_quoly(&n2);
        key = token.name[0];
        break;
    }
}

/******************************************************************************/

void imod_binom(long n, long r, LongIntPtr m)
{
  /* must be in modularmode -- checked by the caller. integermode. 
     Jun 2004: makes no sense for finf */
  
  long ans;
  long k;

  if (r > n / 2) 
    r = n - r;
  if (r < modulus && mod_is_prime) {
    n %= modulus;
    if (n < r) {
      *m = 0;
      return;
    }
    if (r > n / 2) 
      r = n - r;
  }
  
  if (n > 150) 
    error(279, &token);
  if (r <= 0 || n <= 2) {
    if (n == 2 && r == 1) 
      if (modulus == 2) 
        *m = 0;
      else 
        *m = 2;
    else 
      *m = 1;
    return;
  } else if (r <= 2) {
    itrivial(n, r, m);
    return;
  }
  
  /* now n > 2, r > 2 */
  k = n % 3;
  switch (k) { 
    case 0:
      *m = ifrom_table(n, r);
      break;
    case 1:
      *m = (ifrom_table(n - 1, r) + ifrom_table(n - 1, r - 1)) % modulus;
      break;
    case 2:
      k = ifrom_table(n - 2, r) + 2 * ifrom_table(n - 2, r - 1);
      *m = (k + ifrom_table(n - 2, r - 2)) % modulus;
      break;
  }
}

/******************************************************************************/

void ilint_binom(long n, long r, LongIntPtr m)
{
  
  long s;
  long n2;
  long r2;
  long i;

  if (r > n / 2) 
    r = n - r;
  if (r <= 0 || n <= 2) {
    if (n == 2 && r == 1) 
      *m = 2;
    else 
      *m = 1;
    return;
  }
  
  /* now n > 2 */
  if (n <= 150) 
    if (n % 3 == 0) 
      *m = ifrom_table(n, r);
    else {
      n2 = 3 * (n / 3);
      s = n - n2;
      r2 = r - s;
      if (r2 <= 0) 
        itrivial(n, r, m);
      else {
        *m = ifrom_table(n2, r2);
        for (i = 1; i <= s; ++i) 
          *m = ((n2 + i) * (*m)) / (r2 + i);
      }
    }
  else 
    error(279, &token);
}

/****************************************************************************/

struct expre_EnvRec {
  FILEPtr *inf;
  nameptr *flag;
};
typedef struct expre_EnvRec expre_EnvRec;

/***********************************************************************/

static void get_incr_needto(LongIntPtr incr, Boolean *need, quolyptr n, expre_EnvRec *expre_Env)
{
  /* need true means we later have to create and set n.
     If integerflag, we never touch n.  Notice incr could be 0. 
     integerflag stuff changed, Nov 1997.  n (if set here) is the increment. */
  
  char key;
  Boolean minus;
  lintptr lp;                                     /* Nov 1997 */

  minus = ustrcmp(token.name, "-") == 0;
  scanner(expre_Env->inf, &token, expre_Env->flag);
  key = token.name[0];
  *need = true;
  if (key >= 'a' && key <= 'z' || key >= '0' && key <= '9' || key == '(') 
    if (integerflag) {
      ifact(&lp, incr, expre_Env->flag);
      if (lp == NULL) 
        error(68, &token);
      *incr = *lp;
    } else {
      old_fact(expre_Env->inf, n, expre_Env->flag);
      if (!(*n)->numb) 
        error(223, &token);
      if (!lintmode && (*n)->variant.vc_1.ncoef->size > 1) 
        error(224, &token);
      *need = false;                              /* because we just got n */
      if (lintmode) 
        *incr = (*n)->variant.vc_1.ncoef->lint;
      else 
        *incr = (*n)->variant.vc_1.ncoef->head->value;
    }
  else 
    *incr = 1;
  if (minus) 
    *incr = -*incr;
}

/**********************************************************************/

struct increment_EnvRec {
  /* incr already set. If needto, we don't actually have n yet.  
     It's now ok to increment a poly (July 1995), even a laurent. 
     Nov 1997: changed incr to var parameter, to allow output. */
  
  imptr im;
  long *incr;
  long val;
};
typedef struct increment_EnvRec increment_EnvRec;

/***********************************************************************/

static void add_to_im(increment_EnvRec *increment_Env)
/* sets val to new value of the (numerical) variable. */
{
  Boolean neg;
  Boolean notze;

  if (modularmode) {  /* Apr 2004. OK for large modulus */
    if (finf && verbose) { /* Aug 2004 */
			warn_cnt ++;   /* Oct 2011 */
      if (warn_cnt < 11)
				fprintf(stdout, "*** Warning. increment makes no sense over finite field GF(2^n).\n");
		}
    if (*increment_Env->incr >= 0)  /* evidently incr is assumed to be a vaild modular value */
       increment_Env->im->lint = mod_add(increment_Env->im->lint, *increment_Env->incr, modulus);
    else {
       increment_Env->im->lint += *increment_Env->incr;
       if (increment_Env->im->lint < 0)
          increment_Env->im->lint += modulus;
    }
    increment_Env->val = increment_Env->im->lint;
  } else if (lintmode) {
    increment_Env->im->lint += *increment_Env->incr;
    increment_Env->val = increment_Env->im->lint;
  } else {
    notze = increment_Env->im->size > 1;
    if (notze) 
      neg = BTst(increment_Env->im->head->value, 31);
    increment_Env->im->tail->value = increment_Env->im->tail->value + *increment_Env->incr;
        /* tail!*/
    increment_Env->val = increment_Env->im->tail->value;
    if (abs(increment_Env->val) >= block) 
      error(294, &token);
    /* notze true means overflow may have happened */
    if (notze) 
      if (increment_Env->val != 0) 
        if (neg != BTst(increment_Env->val, 31)) 
          error(294, &token);
  }
}

/*********************************************************************/

static void do_poly(polyptrr n, increment_EnvRec *increment_Env)
{
  /* n is not a number (only), so incrementing it cannot make it 0.
     Nov 1997: changed so that incr = 0 is allowed.  This was an inconsistency,
     in that val is supposed to be the new value of the numerical part of the
     variable.  This procedure sets val. */
  polyptrr s;
  poly t;

  s = n;
  while ((*s)->exp > 0) {
    s = &(*s)->next;
    if (*s == NULL) 
      break;
  }
  if (*s == NULL) {
    if (*increment_Env->incr != 0) 
      poly_set(*increment_Env->incr, s);
    increment_Env->val = *increment_Env->incr;
  } else if ((*s)->exp < 0) {
    if (*increment_Env->incr != 0) {
      t = *s;
      *s = NULL;
      poly_set(*increment_Env->incr, s);
      (*s)->next = t;
    }
    increment_Env->val = *increment_Env->incr;
  } else if ((*s)->numb) {
    increment_Env->im = (*s)->variant.ncoef;
    add_to_im(increment_Env);                     /* sets val */
    if (node_iszero(*s)) {
      t = (*s)->next;
      (*s)->next = NULL;
      free_poly(s);
      *s = t;
    }
  } else 
    do_poly(&(*s)->variant.pcoef, increment_Env);  /* it can't become 0 */
}

/********************************************************************/

static void increment(quolyptr qp, quolyptr n, Boolean needto, LongIntPtr incr)
{
  
  increment_EnvRec increment_Env;

  increment_Env.incr = incr;
  if ((*qp)->numb) {
    increment_Env.im = (*qp)->variant.vc_1.ncoef;
    add_to_im(&increment_Env);
  } else if ((*qp)->variant.vc_2.denom != NULL) 
    error(196, &token);                           /* change below, drop an 'else', Nov 1997 */
  else 
    do_poly(&(*qp)->variant.vc_2.numer, &increment_Env);
  if (needto)                                     /* Nov 1997 */
    quoly_set(increment_Env.val, n);
  else if (lintmode) 
    (*n)->variant.vc_1.ncoef->lint = increment_Env.val;
  else 
    (*n)->variant.vc_1.ncoef->head->value = increment_Env.val;
  *incr = increment_Env.val;                      /* Nov 1997 */
}

/***********************************************************************/

void expre(textptr inf, quolyptr *qp, quolyptr n, colm_ptrptr *aux, LongIntPtr colpos, nameptr *flag)
{
  /* massive changes Nov 1997. assignment and increment statements now handled here. */
  
  quoly n2;
  Boolean plus;
  Boolean needto;
  long incval;
  expre_EnvRec expre_Env;

  expre_Env.flag = flag;
  expre_Env.inf = inf;
  term(inf, qp, n, aux, colpos, flag);
  
  if (ustrcmp(token.name, ":") == 0) {
    /* Nov 1997. assignment statement, or final ':' for no-print */
    scanner(inf, &token, flag);
    incval = 1;
    if (ustrcmp(token.name, "=") == 0) {
      if (*n != NULL) 
        error(316, &token);
      scanner(inf, &token, flag);
      old_expre(inf, n, flag);
      if (*qp == NULL) 
        sparse_zero_set(*aux, *colpos, qp);
      free_quoly(*qp);
      **qp = *n;
      if ((*n)->numb) {
        (*n)->variant.vc_1.arr_arg = false;       /* sneaky */
        if (lintmode) 
          incval = (*n)->variant.vc_1.ncoef->lint;
        else 
          incval = (*n)->variant.vc_1.ncoef->head->value;
      }
      /* else incval = 1 */
      *n = NULL;
      if (*flag == NULL) 
        quoly_assign(**qp, n);
      else 
        quoly_set(0, n);
    } else if (ustrcmp(token.name, "+") == 0 || ustrcmp(token.name, "-") == 0) {
      if (*n != NULL) 
        error(316, &token);
      get_incr_needto(&incval, &needto, n, &expre_Env);
      if (*qp == NULL) 
        sparse_zero_set(*aux, *colpos, qp);
      increment(*qp, n, needto, &incval);
    }
    /* n is the new value of the numerical part of the variable. */
    else if (ustrcmp(token.name, ";") == 0 && *flag == NULL) {
      /* quoly_set(0, n); <- remove!  BUG of May 1999 */
      if (*qp == NULL) 
        quoly_set(0, n);
      else if (*n == NULL) 
        quoly_assign(**qp, n);
      ustrcpy(token.name, ":");                /* the no-display signal */
    } else 
      error(317, &token);
    if (*aux != NULL && incval == 0) 
      purge_sparse(*aux, *colpos);
    *qp = n;
    return;
  }
  
  while (ustrcmp(token.name, "+") == 0 || ustrcmp(token.name, "-") == 0) {
    plus = ustrcmp(token.name, "+") == 0;
    scanner(inf, &token, flag);
    if (*n == NULL) 
      if (*qp == NULL) 
        quoly_set(0, n);
      else 
        quoly_assign(**qp, n);
    n2 = NULL;
    term(inf, qp, &n2, aux, colpos, flag);
    if (*qp == NULL) {
      quoly_set(0, &n2);
      *qp = &n2;
    }
    if (plus) 
      if (n2 == NULL) 
        better_quoly_add(*n, **qp, n);
      else 
        best_quoly_add(n, n2);
    else if (n2 == NULL) 
      better_quoly_sub(*n, **qp, n);
    else 
      best_quoly_sub(n, n2);
    *qp = n;
  }
}

/********************************************************************************/

void half_expre(textptr inf, quolyptr n, nameptr *flag)
{
  
  /* Nov 1997,  new grammar. n is already partially defined. */
  
  quoly n2;
  tokentipe oldtoken;

  switch (token.name[0]) { 
    case '^':
    case '#':
    case '!':
    case '"':  /* Jul 2003 derivative, I think */
      half_fact(inf, n, flag);
      break;
    default:
      /* nothing */
      break;
  }
  
  half_term(inf, n, flag);
  
  while (ustrcmp(token.name, "+") == 0 || ustrcmp(token.name, "-") == 0) {
    oldtoken = token;
    scanner(inf, &token, flag);
    n2 = NULL;
    old_term(inf, &n2, flag);
    if (ustrcmp(oldtoken.name, "+") == 0) 
      best_quoly_add(n, n2);
    else 
      best_quoly_sub(n, n2);
  }
}

/*****************************************************************************/

struct namechange_EnvRec {
  jmp_buf namechange_exit;
};
typedef struct namechange_EnvRec namechange_EnvRec;

static void call_error(long bad, tokentipe *tok, namechange_EnvRec *namechange_Env)
{
  error(bad, tok);
  longjmp(namechange_Env->namechange_exit, -1);
  /*exit(::namechange) ~ up-level function exit*/
}

/******************************************************************************/

void namechange(textptr inf, quolyptr n, nameptr *flag)  /* Nov 1997 */
{
  
  long dummy;
  long j;
  arrptr r;
  arrptr u;
  tokentipe oldtok;
  namechange_EnvRec namechange_Env;
  
  if (setjmp(namechange_Env.namechange_exit)) 
    return;
  scanner(inf, &token, flag);

  if (ustrcmp(token.name, "[") != 0) 
    call_error(100, &token, &namechange_Env);
  scanner(inf, &oldtok, flag);
  scanner(inf, &token, flag);  

  if (*flag != NULL) 
    while (token.name[0] >= 'a' && token.name[0] <= 'z') {
      ustrcat(oldtok.name,token.name); /*AAR*/
      scanner(inf, &token, flag);
    }
  if (ustrcmp(token.name, "]") != 0) 
    call_error(101, &token, &namechange_Env);
  scanner(inf, &token, flag);
  if (ustrcmp(token.name, ":") != 0)           /* Dec 1997 */
    call_error(152, &token, &namechange_Env);
  scanner(inf, &token, flag);  

  if (ustrcmp(token.name, "=") != 0)           /* deletions here, Nov 1997 */
    call_error(4, &token, &namechange_Env);
  scanner(inf, &token, flag);
  if (ustrcmp(token.name, "\'") != 0) 
    call_error(102, &token, &namechange_Env);
  scanner(inf, &token, flag);
  if (ustrcmp(token.name, "[") != 0) 
    call_error(100, &token, &namechange_Env);
  scanner(inf, &token, flag);
  if (token.name[0] < 'a' || token.name[0] > 'z') 
    call_error(40, &token, &namechange_Env);
  
  /* find oldtok */
  j = hash(&oldtok.name, 151);
  r = arr_store[j];
  u = NULL;
  while (r != NULL) {
    if (ustrcmp(r->name.name, oldtok.name) == 0) 
      break;
    u = r;
    r = r->next;
  }

  if (r == NULL) 
    call_error(28, &oldtok, &namechange_Env);
  if (r->time < 0)                                /* array parameter */
    call_error(140, &oldtok, &namechange_Env);
  
  oldtok = token;                                 /* the new name */
  scanner(inf, &token, flag);

  if (ustrcmp(token.name, "]") != 0) 
    call_error(101, &token, &namechange_Env);
  scanner(inf, &token, flag);
  if (ustrcmp(token.name, "\'") != 0) 
    call_error(102, &token, &namechange_Env);
  
  /* install in new position */
  if (u == NULL) 
    arr_store[j] = arr_store[j]->next;
  else 
    u->next = r->next;
  j = hash(&oldtok.name, 151);
  oldtok.address = j;
  r->next = arr_store[j];
  r->name = oldtok;
  arr_store[j] = r;  
  quoly_set(0, n);  /* Jun 2005.  wasn't here !!! */
  
  scanner(inf, &token, flag);  

}

/*****************************************************************************/

void iarretrieve(tokentipe *x, quolyptr *qp, nameptr *flag, Boolean *sparse);

/* Nov 1997 */

/****************************************************************************/

void ifact(lintptr *lp, LongIntPtr n, nameptr *flag)
{
  
  /* Changed Nov 1997.  np <> nil and points to the value, unless it's an
     assignment to a sparse array element.  In that case, np = nil and flag 
     is reset so that iexpre can reparse it.  np might point to n or it 
     might point to a storage longint, shouldn't matter to the caller,
     who will not directly use n in any event. */
  
  number m;
  quoly q;
  long row;
  long count;
  tokentipe oldtok;
  nameptr p;
  nameptr copy;
  numptr np;
  quolyptr qp;
  colm_ptrptr aux;                                /* Nov 1997 */
  varptr vp;                                      /* Nov 1997 */
  long colpos;
  char mate;
  Boolean colflag;
  Boolean negative;
  Boolean old_modmode;

  if ((*flag)->compiled) 
    switch ((*flag)->tipe) { 
      case one:
        if (lintmode) 
          *lp = &(*(*flag)->qp)->variant.vc_1.ncoef->lint;
        else 
          *lp = &(*(*flag)->qp)->variant.vc_1.ncoef->head->value;
        *flag = (*flag)->next;
        token = (*flag)->let;
        break;
      case two:
        if (lintmode) 
          *lp = &(*(*flag)->qp)->variant.vc_1.ncoef->lint;
        else 
          *lp = &(*(*flag)->qp)->variant.vc_1.ncoef->head->value;
        *flag = (*flag)->next->next;
        do 
          *flag = (*flag)->next;
        while (ustrcmp((*flag)->let.name, "]") != 0);
        *flag = (*flag)->next;
        token = (*flag)->let;
        break;
      case three:
        p = *flag;
        *flag = (*flag)->next->next;
        token = (*flag)->let;
        ievalcoords(&row, &count, flag, &colflag);
        *flag = (*flag)->next;
        token = (*flag)->let;
        np = (numptr)p->qp;
        row = np->value + row - addresser;
        if (colflag) 
          row += (count - addresser) * (np->next->value);
        if (lintmode) 
          *lp = &(*arp[BSR(row, 10)])[BAnd(row, tenmask)]->variant.vc_1.ncoef->lint;
        else 
          *lp = &(*arp[BSR(row, 10)])[BAnd(row, tenmask)]->variant.vc_1.ncoef->head->value;
        break;
    }
    
  else if (token.name[0] >= 'a' && token.name[0] <= 'z') {
    oldtok = token;
    copy = *flag;
    *flag = (*flag)->next;
    token = (*flag)->let;
    if (ustrcmp(token.name, "[") == 0) {       /* Nov 1997, all new */
      iarretrieve(&oldtok, &qp, flag, &negative);
      if (negative && ustrcmp(token.name, ":") == 0) {  /* sparse assign */
        *lp = NULL;                               /* set up for iexpre to reparse */
        *flag = copy;                             /* note: we don't reset token */
      } else if (qp == NULL) {                    /* sparse array, in an expression */
        *n = 0;
        *lp = n;
      } else if (lintmode) 
        *lp = &(*qp)->variant.vc_1.ncoef->lint;
      else 
        *lp = &(*qp)->variant.vc_1.ncoef->head->value;
    } else {
      iretrieve(&oldtok, &qp);                    /* Nov 1997 */
      if (qp == NULL)                             /* var not defined */
        if (ustrcmp(token.name, ":") == 0) {   /* assignment, new form. Nov 1997 */
          q = NULL;
          quoly_set(0, &q);
          insert_var(&oldtok, q, &vp);
          q = NULL;
          qp = &vp->val;
        } else 
          error(19, &oldtok);
      if (lintmode) 
        *lp = &(*qp)->variant.vc_1.ncoef->lint;
      else 
        *lp = &(*qp)->variant.vc_1.ncoef->head->value;
    }
    
  } else if (token.name[0] >= '0' && token.name[0] <= '9') {
    m.size = 0;
    new_readin(&Input, &m, flag, &row);           /* Jul 2002 */
    if (lintmode) 
      *n = m.lint;
    else 
      *n = m.head->value;
    *lp = n;
    free_num(&m);
    
  } else if (ustrcmp(token.name, "(") == 0) {
    *flag = (*flag)->next;
    token = (*flag)->let;
    old_iexpre(n, flag);                          /* Nov 1997 */
    *lp = n;
    if (ustrcmp(token.name, ")") != 0) 
      error(1, &token);
    else {
      *flag = (*flag)->next;
      token = (*flag)->let;
    }
  }
  
  else if (ustrcmp(token.name, "-") == 0) {
    *flag = (*flag)->next;
    token = (*flag)->let;
    ifact(lp, n, flag);
    if (*lp == NULL) 
      error(68, &token);
    if (finf && modularmode) { /* Jul 2004 */
       *n = **lp;
       *lp = n;
    }
    else {
      *n = -**lp;
      *lp = n;
      if (modularmode && *n < 0)
        *n += modulus;
    }
  }
  
  else if (ustrcmp(token.name, "_") == 0) {
    old_modmode = modularmode;
    if (modularmode)     /* simplified Jul 2003 */
       mod_is_changed++;
    modularmode = false;           /* lintmode still on */
    *flag = (*flag)->next;
    token = (*flag)->let;
    ifact(lp, n, flag);
    if (*lp == NULL) 
      error(68, &token);
    *lp = n;
    modularmode = old_modmode;
    if (modularmode)
       mod_is_changed--;
  }
  
  else if (ustrcmp(token.name, "*66") == 0 || ustrcmp(token.name, "*82") == 0){ /* Jul 2008, Oct 2009 Apr2 2011 */
    /* Sigma, Prod Oct 2005 */
    oldtok = token;
    obtain_sum(&Input, flag, &p);
    copy = p;
    token = p->let;
    if (ustrcmp(token.name, "<") != 0) 
      error(144, &token);
    q = NULL;                                     /* q will not be touched */
    sum_mult_up(oldtok.name, &Input, &q, &p, false, n, &mate);
    if (*flag == NULL)
      freename(copy);                             /* copy not changed */
    else 
      *flag = p;
    if (token.name[0] != mate) 
      error(274, &token);
    *lp = n;
    *flag = (*flag)->next;
    token = (*flag)->let;
    
  } else if (ustrcmp(token.name, "|") == 0) {
    *flag = (*flag)->next;
    token = (*flag)->let;
    ifact(lp, n, flag);
    if (*lp == NULL) 
      error(68, &token);
    if (ustrcmp(token.name, "|") != 0) 
      error(63, &token);
    *n = abs(**lp);
    *lp = n;
    *flag = (*flag)->next;
    token = (*flag)->let;
    
  } else if (ustrcmp(token.name, "GCD") == 0) {
    *flag = (*flag)->next;
    token = (*flag)->let;
    if (ustrcmp(token.name, "(") != 0) 
      error(177, &token);
    *flag = (*flag)->next;
    token = (*flag)->let;
    ifact(lp, n, flag);
    if (*lp == NULL) 
      error(68, &token);
    *n = **lp;
    if (ustrcmp(token.name, ",") != 0) 
      error(202, &token);
    *flag = (*flag)->next;
    token = (*flag)->let;
    ifact(lp, &row, flag);                        /* 'row' is not pnemonic */
    if (*lp == NULL) 
      error(68, &token);
    row = **lp;
    if (ustrcmp(token.name, ")") != 0) 
      error(1, &token);
    *flag = (*flag)->next;
    token = (*flag)->let;
    *n = abs(*n);
    row = abs(row);
    if (*n == 0) 
      *n = row;
    else if (row == 0)                            /* nothing */
      ;
    else 
      *n = smallgcd(*n, row);
    *lp = n;
    
  } else if (token.name[0] >= 'A' && token.name[0] <= 'Z') {
    count = find_built_in(0, numbuiltins, token.name);
    q = NULL;
    if (count == -1) 
      evaluate(&Input, &token, &q, flag);
    else if (builtin[count][1][0] == '*') {  /*Bug fix. Jul 2004 */
      ustrcpy(token.name, builtin[count][1]);
      fact(&Input, &qp, &q, &aux, &colpos, flag, false);
    } else 
      builtin_func(&Input, &q, flag, count);
    if (q == NULL)                                /* not sure this is possible */
      *n = 0;
    else {
      if (!q->numb) 
        error(227, &token);
      if (lintmode) 
        *n = q->variant.vc_1.ncoef->lint;
      else 
        *n = q->variant.vc_1.ncoef->head->value;
      free_quoly(&q);
    }
    *lp = n;
  }
  
  else if (ustrcmp(token.name, "*4") == 0 || ustrcmp(token.name, "*9") == 0 || 
           ustrcmp(token.name, "*7") == 0){ /* Deg, Codeg, Cols */
    q = NULL;
    fact(&Input, &qp, &q, &aux, &colpos, flag, false);
    if (q == NULL)                                /* not sure this is possible */
      *n = 0;
    else {
      if (!q->numb) 
        error(227, &token);
      if (lintmode) 
        *n = q->variant.vc_1.ncoef->lint;
      else 
        *n = q->variant.vc_1.ncoef->head->value;
      free_quoly(&q);
    }
    *lp = n; 
  }
  
  else if (ustrcmp(token.name, "*70") == 0) {    /* June 2004 was *65 */  /* Jul 2008 Apr2 2011 */
    *n = rand_integer2() % block;
    *flag = (*flag)->next;
    token = (*flag)->let;
    if (modularmode)
      *n %= modulus;
    *lp = n;
  }

  else if (ustrcmp(token.name, "*68") == 0) {    /* June 2004 add RRand */   /* Jul 2008 Apr2 2011 */
    *n = rand_integer2() % block;
    *flag = (*flag)->next;
    token = (*flag)->let;    
    *n = abs((*n) * TickCount % block);
    if (modularmode)
      *n %= modulus;
    *lp = n;
  }
  
  else if (ustrcmp(token.name, "*1") == 0) { /* Bin */ 
    *flag = (*flag)->next;
    token = (*flag)->let;
    if (ustrcmp(token.name, "(") != 0) 
      error(177, &token);
    *flag = (*flag)->next;
    token = (*flag)->let;
    check_modular(&old_modmode);
    old_iexpre(&row, flag);                       /* Nov 1997 */
    if (ustrcmp(token.name, ",") != 0) 
      error(202, &token);
    *flag = (*flag)->next;
    token = (*flag)->let;
    old_iexpre(&count, flag);                     /* Nov 1997 */
    if (ustrcmp(token.name, ")") != 0) 
      error(1, &token);
    *flag = (*flag)->next;
    token = (*flag)->let;
    restore_modular(old_modmode);
    if (count < 0 || count > row) 
      *n = 0;
    else if (modularmode)
      imod_binom(row, count, n);
    else 
      ilint_binom(row, count, n);
    *lp = n;
  }
  
  else if (ustrcmp(token.name, "%") == 0) {
    q = NULL;
    copy = *flag;
    oldtok = token;
    get_arr_arr(&Input, &q, flag, &count);
    if ((*arrstash)[count] == NULL) 
      error(220, &token);
    *flag = (*flag)->next;
    token = (*flag)->let;
    if (ustrcmp(token.name, "[") != 0) 
      error(217, &token);
    spec_arretrieve(&Input, flag, (*arrstash)[count], &qp, &aux, &colpos);
    if (aux != NULL && ustrcmp(token.name, ":") == 0) {  /* sparse assign */
      *lp = NULL;                                 /* set up for iexpre to reparse */
      *flag = copy;
    } else if (qp == NULL) {                      /* all this new, Nov 1997 */
      *n = 0;
      *lp = n;
    } else if (lintmode) 
      *lp = &(*qp)->variant.vc_1.ncoef->lint;
    else 
      *lp = &(*qp)->variant.vc_1.ncoef->head->value;
    free_quoly(&q);
    
  } else if (ustrcmp(token.name, "*12") == 0) {  /* determinant */
    q = NULL;
    arr_parse('7', &Input, &q, flag);
    if (q == NULL)                                /* not sure this is possible */
      *n = 0;
    else {
      if (lintmode) 
        *n = q->variant.vc_1.ncoef->lint;
      else 
        *n = q->variant.vc_1.ncoef->head->value;
      free_quoly(&q);
    }
    *lp = n;
    
  } else if (ustrcmp(token.name, "<") == 0) {  /*  system variable */
    *flag = (*flag)->next;
    token = (*flag)->let;
    if (ustrcmp(token.name, "[") == 0) {
      if (syst->stop == -1) 
        error(175, &token);
      *flag = (*flag)->next;
      token = (*flag)->let;
      ievalcoords(&row, &count, flag, &colflag);
      array_quoly_ptr(syst, row, count, colflag, &qp, &token, true);
      if (qp == NULL) 
        *n = 0;                                   /* probably impossible. Nov 1997 */
      else {
        if (*qp == NULL) {
          uninit++;                          /* Jul 2002 */
          if (uninit < 21) 
            fprintf(stdout, "Warning. Uninitialized array element in [<] has been set to 0.\n");
          else if (uninit == 21) 
            fprintf(stdout, " ....etc...\n");
          quoly_set(0, qp);
          (*qp)->variant.vc_1.arr_arg = false;    /* May 2001. failsafe */
        }
        if (lintmode) 
          *n = (*qp)->variant.vc_1.ncoef->lint;
        else 
          *n = (*qp)->variant.vc_1.ncoef->head->value;
      }
      *flag = (*flag)->next;
      token = (*flag)->let;
    } else if (lintmode) 
      *n = prevnum->variant.vc_1.ncoef->lint;
    else 
      *n = prevnum->variant.vc_1.ncoef->head->value;
    *lp = n;
    
  } else 
    switch (token.name[0]) { /*':',*/
      
      case '@':
      case '&':
      case '!':
      case '?':  /* removed degree and cols from here */
        q = NULL;
        parse(&Input, &q, flag);
        if (q == NULL)                            /* definitely is possible */
          *n = 0;
        else {
          if (!q->numb) 
            error(227, &token);
          if (lintmode) 
            *n = q->variant.vc_1.ncoef->lint;
          else 
            *n = q->variant.vc_1.ncoef->head->value;
          free_quoly(&q);
        }
        *lp = n;
        break;
      default:
        error(226, &token);
        break;
    }
  
  if (ustrcmp(token.name, "^") == 0) {
    iget_exponent(flag, &count);
    *n = **lp;
    inumber_power(n, &count);
    *lp = n;
    
  } else if (ustrcmp(token.name, "!") == 0) {
    m.size = 0;
    setvalue(**lp, &m);
    factorial(&m);
    if (lintmode) 
      *n = m.lint;
    else 
      *n = m.head->value;
    free_num(&m);
    *lp = n;
    *flag = (*flag)->next;
    token = (*flag)->let;
  }
}

/****************************************************************************/

void iterm(lintptr *lp, LongIntPtr n, nameptr *flag)
{
  
  /* Nov 1997, big changes */
  
  long n2;                                        /* y killed, Aug 2001 */
  char key;

  ifact(lp, n, flag);
  
  key = token.name[0];
  while (PSet_Test(iterm_set, sizeof(iterm_set)/2, key)) {
    /* lp can't be nil. */
    *flag = (*flag)->next;
    token = (*flag)->let;
    if (ustrcmp(token.name, "/") == 0)         /* May 2002 */
      error(340, &token);
    *n = **lp;
    ifact(lp, &n2, flag);
    if (*lp == NULL) 
      error(68, &token);                          /* Nov 1997 */
    n2 = **lp;
    if (key == '*') 
      if (modularmode)
        *n = modmult(*n, n2);                     /* Aug 2001 */
      else 
        *n *= n2;
    else if (n2 == 0) 
      error(22, &token);
    else if (key == '/') 
      if (modularmode)
        *n = modmult(*n, imod_inverse(n2));       /* Aug 2001 */
      else 
        *n /= n2;
    else if (key == '|') {
      *n %= n2;
      if (pos_mod && *n < 0) 
        if (n2 > 0)                               /* BUG; 30 July 1998 */
          *n += n2;
        else 
          *n -= n2;
    } else 
      *n /= n2;
    key = token.name[0];
    *lp = n;
  }
}

/****************************************************************************/

void old_iexpre(LongIntPtr n, nameptr *flag)
{
  /* Nov 1997 */
  
  long n2;
  Boolean plus;
  lintptr lp;

  iterm(&lp, n, flag);
  if (lp == NULL) 
    error(129, &token);
  else 
    *n = *lp;
  
  while (token.name[0] == '+' || token.name[0] == '-') {
    plus = token.name[0] == '+';
    *flag = (*flag)->next;
    token = (*flag)->let;
    
    iterm(&lp, &n2, flag);
    if (lp == NULL) 
      error(129, &token);
    else 
      n2 = *lp;
    if (plus) 
	    if (modularmode)
		   *n = mod_add(*n, n2, modulus);  /* Nov 2004 */
		 else *n += n2;
	 else {
      if (finf && modularmode) /* Jul 2004 */
        *n = *n ^ n2;
      else {
        *n -= n2;
        if (*n < 0 && modularmode) 
          *n += modulus;
      }
    }
  }
}

/****************************************************************************/

struct iexpre_EnvRec {
  nameptr *flag;
  long r;
  long c;
  Boolean colflag;
  arrptr q;
};
typedef struct iexpre_EnvRec iexpre_EnvRec;

/***********************************************************************/

static void get_incr(LongIntPtr incr, iexpre_EnvRec *iexpre_Env)
{
  /* Notice incr could be 0.
     integerflag stuff changed, Nov 1997. */
  
  char key;
  Boolean minus;
  lintptr lp2;                                    /* Nov 1997 */

  minus = ustrcmp(token.name, "-") == 0;
  *iexpre_Env->flag = (*iexpre_Env->flag)->next;
  token = (*iexpre_Env->flag)->let;
  key = token.name[0];
  if (key >= 'a' && key <= 'z' || key >= '0' && key <= '9' || key == '(') {
    ifact(&lp2, incr, iexpre_Env->flag);
    if (lp2 == NULL) 
      error(68, &token);
    *incr = *lp2;
  } else 
    *incr = 1;
  if (minus) 
    *incr = -*incr;
}

/***********************************************************************/

static void reparse_sparse(iexpre_EnvRec *iexpre_Env)
{
  tokentipe oldtok;

  oldtok = token;
  *iexpre_Env->flag = (*iexpre_Env->flag)->next;
  token = (*iexpre_Env->flag)->let;
  if (ustrcmp(token.name, "[") != 0) 
    fermat_error("reparse sparse failure, 1 ", true);
  *iexpre_Env->flag = (*iexpre_Env->flag)->next;
  token = (*iexpre_Env->flag)->let;
  ievalcoords(&iexpre_Env->r, &iexpre_Env->c, iexpre_Env->flag, &iexpre_Env->colflag);
  *iexpre_Env->flag = (*iexpre_Env->flag)->next;
  token = (*iexpre_Env->flag)->let;
  array_seek(&oldtok, &iexpre_Env->q);
  /* q can't be nil */
  if (iexpre_Env->q == NULL) 
    fermat_error("reparse sparse failure, 2 ", true);
  if (iexpre_Env->q->spar == NULL) 
    fermat_error("reparse sparse failure, 3 ", true);
  if (ustrcmp(token.name, ":") != 0) 
    fermat_error("reparse sparse failure, 4 ", true);
}

/***********************************************************************/

void iexpre(LongIntPtr n, nameptr *flag)
{
  /* massive changes, Nov 1997, to accomodate new Maple-like syntax */
  
  long n2;
  lintptr lp;
  Boolean plus;
  iexpre_EnvRec iexpre_Env;

  iexpre_Env.flag = flag;
  iterm(&lp, n, flag);
  
  if (ustrcmp(token.name, ":") == 0) {         /* Nov 1997. assignment statement */
    if (lp == NULL) {
      token = (*flag)->let;                       /* flag was reset by ifact, but not token */
      reparse_sparse(&iexpre_Env);                /* sets q, r, c, colflag; lp still nil */
    }
    *flag = (*flag)->next;
    token = (*flag)->let;
    if (ustrcmp(token.name, "=") == 0) {
      *flag = (*flag)->next;
      token = (*flag)->let;
      old_iexpre(n, flag);
      if (lp == NULL) 
        isparse_insert(iexpre_Env.r, iexpre_Env.c, *n, iexpre_Env.q, iexpre_Env.colflag, true);
      else 
        *lp = *n;
    } else if (ustrcmp(token.name, "+") == 0 || ustrcmp(token.name, "-") == 0) {
      get_incr(n, &iexpre_Env);
      if (lp == NULL) 
        isparse_insert(iexpre_Env.r, iexpre_Env.c, *n, iexpre_Env.q, iexpre_Env.colflag, false);
      else {  /* Apr2 2011. Fix ABSURD BUG!! mod out!!  Duh!!  Note I did not fix the previous case of lp = null. */
        *lp = *lp + *n;
				if (modularmode)
					if (*lp >= modulus) 
					  *lp -= modulus;
			    else if (*lp < 0) 
					  *lp += modulus;				
			}
    } else if (ustrcmp(token.name, "*") == 0) {  /* Apr2 2011. allow  x :* a */
      get_incr(n, &iexpre_Env);
      if (lp == NULL) 
        ;   /* Nothing! */
      else 
				*lp = modmult(*lp, *n);
    }
		else 
      error(317, &token);            /* Note, the no-display signal ':' is not allowed */
    *n = 0;
    return;
  }
  
  while (token.name[0] == '+' || token.name[0] == '-') {
    plus = token.name[0] == '+';
    *flag = (*flag)->next;
    token = (*flag)->let;
    /* lp can't be nil */
    *n = *lp;
    iterm(&lp, &n2, flag);
    if (lp == NULL) 
      error(68, &token);                          /* Nov 1997 */
    n2 = *lp;
    if (finf && modularmode)  /* Jul 2004 */
      *n = *n ^ n2;
    else 
    if (plus) {
      *n += n2;  /* Apr 2004 OK since integerflag => modulus < 2^28 */
      if (*n >= modulus && modularmode) 
        *n -= modulus;
    } else {
      *n -= n2;
      if (*n < 0 && modularmode) 
        *n += modulus;
    }
    lp = n;
  }
}

/******************************************************************************/

void subarray(textptr inf, arrptr q, LongIntPtr start, LongIntPtr rows, LongIntPtr cols, LongIntPtr firstrow, LongIntPtr firstcol, LongIntPtr total_rows, nameptr *flag)
{
  /* firstrow and firstcol are coordinates.  the others are numbers.
     the subarray is rows X cols, initial spot at address 'start' in arp. 
     total_rows is number of rows in parent matrix. firstrow, firstcol are coords
     of upper-left-most spot. 
        Note subtlety in last line in dealing with sparse arrays. */
  
  long lastrow;
  long lastcol;
  Boolean colflag;

  scanner(inf, &token, flag);
  if (ustrcmp(token.name, ",") == 0) {         /* rows get default values */
    *firstrow = addresser;
    lastrow = q->rows + addresser - 1;
  } else {
    evalcoords(inf, firstrow, &lastrow, flag, ',', '~', &colflag, 
               false);
    if (!colflag) 
      if (lastrow == addresser) 
        lastrow = *firstrow;
      else 
        lastrow = q->rows + addresser - 1;
    if (q->rows < *firstrow || *firstrow < addresser || q->rows + addresser - 1 < lastrow || lastrow < addresser) 
      error(56, &q->name);
    if (*firstrow > lastrow) 
      error(57, &q->name);
  }
  
  *cols = quotient_of(&q->sizearr, q->rows);      /* Oct 2000 */
  
  *firstcol = addresser;
  lastcol = *cols + addresser - 1;                /* default values */
  if (ustrcmp(token.name, ",") == 0) {
    scanner(inf, &token, flag);
    if (ustrcmp(token.name, "]") == 0) 
      colflag = true;
    else 
      evalcoords(inf, firstcol, &lastcol, flag, ']', '~', &colflag, 
                 false);
    if (!colflag)                                 /* means the second col coord was not there. */
      if (lastcol == addresser) 
        lastcol = *firstcol;
      else 
        lastcol = *cols + addresser - 1;
    if (*cols < *firstcol || *firstcol < addresser || *cols + addresser - 1 < lastcol || lastcol <
        addresser)
      error(58, &q->name);
    if (*firstcol > lastcol) 
      error(59, &q->name);
  }
  
  scanner(inf, &token, flag);
  *total_rows = q->rows;
  *rows = lastrow - *firstrow + 1;
  *cols = lastcol - *firstcol + 1;
  if (q->spar == NULL) 
    *start = q->start;
  else 
    *start = 0;
  *start = *start + (*firstcol - addresser) * (*total_rows) + *firstrow - addresser;
}

/*******************************************************************************/

void arr_expre(textptr inf, quolyptr n, workptr arr, arr_descr *arr_facts, Boolean *arr_free,
               LongIntPtr rows, nameptr *flag, sparseptr *spar, Boolean callterm);

/* Nov 1997 */

/******************************************************************************/

void sparse_read(textptr inf, quolyptr n, nameptr *flag, arr_descr *arr_facts, Boolean *arr_free, 
                 Boolean *errcode, sparseptr *spar);

/* Jan 1997 */

/******************************************************************************/

struct spec_scanner_EnvRec {
  /* end_ln_seen is set during every call. */
  
  char t;
  FILEPtr *inf;
  Boolean *end_ln_seen;
};
typedef struct spec_scanner_EnvRec spec_scanner_EnvRec;

/*****************************************************************************/

static void mygetchar(spec_scanner_EnvRec *spec_scanner_Env)
{
  
  do {
    spec_scanner_Env->t = ' ';
    while ((PSet_Test(throwaways, sizeof(throwaways)/2, spec_scanner_Env->t)) &&
           !(feof(*spec_scanner_Env->inf) || (ungetc(getc(*spec_scanner_Env->inf),
	   *spec_scanner_Env->inf) == '\n')))
      spec_scanner_Env->t = fgetc(*spec_scanner_Env->inf);
    
    if ((ungetc(getc(*spec_scanner_Env->inf), *spec_scanner_Env->inf) == '\n') &&
        spec_scanner_Env->t == ' ')
      if (tt_flag) 
        spec_scanner_Env->t = ';';
      else {
        spec_scanner_Env->t = fgetc(*spec_scanner_Env->inf);
        *spec_scanner_Env->end_ln_seen = true;
      }
    
    if (spec_scanner_Env->t == continuation) {    /*& eoln(inf)*/
      fscanf(*spec_scanner_Env->inf,"%*[^\n]");
      getc(*spec_scanner_Env->inf);
      *spec_scanner_Env->end_ln_seen = true;
      semicount = 0;
      spec_scanner_Env->t = ' ';
    }
  } while (PSet_Test(throwaways, sizeof(throwaways)/2, spec_scanner_Env->t));
}

/***********************************************************/

void spec_scanner(textptr inf, tokentipe *tok, nameptr *flag, Boolean *end_ln_seen)
{
  int len; /*AAR*/
  
  spec_scanner_EnvRec spec_scanner_Env;

  spec_scanner_Env.end_ln_seen = end_ln_seen;
  spec_scanner_Env.inf = inf;

  *end_ln_seen = false;
  
  if (*flag == NULL) {
    ustrcpy(tok->name, "");
    tok->address = -1;
    if (ustrcmp(leftover, "") == 0) 
      mygetchar(&spec_scanner_Env);
    else 
      spec_scanner_Env.t = leftover[0];
    
    if (spec_scanner_Env.t >= 'a' && spec_scanner_Env.t <= 'z' || spec_scanner_Env.t >= 'A' &&
        spec_scanner_Env.t <= 'Z') {
      do {
        len = ustrlen(tok->name);
        tok->name[len++] = spec_scanner_Env.t;
        tok->name[len] = 0;
        mygetchar(&spec_scanner_Env);
        if (ustrlen(tok->name) == namelength) 
          break;
      } while (!((spec_scanner_Env.t < 'a' || spec_scanner_Env.t > 'z') && (spec_scanner_Env.t <
               'A' || spec_scanner_Env.t > 'Z')
              && (spec_scanner_Env.t < '0' || spec_scanner_Env.t > '9') && spec_scanner_Env.t !=
	         '_'));  /* Dec 1997 */
      ustrcpy(leftover, " ");
      leftover[0] = spec_scanner_Env.t;  /* bug fix Jun 2003 */
      
    } else {
      ustrcpy(tok->name, " ");
      tok->name[0] = spec_scanner_Env.t;  /* bug fix Jun 2003 */
      ustrcpy(leftover, "");
    }
    if (finish == NULL) {
      ustrcpy(start->let.name, tok->name);
      finish = start;
    } else {
      finish = finish->next;
      ustrcpy(finish->let.name, tok->name);
      if (finish == start) 
        start = start->next;
    }
  }
  
  else {
    *flag = (*flag)->next;
    *tok = (*flag)->let;
    currentchar = (*flag)->next;
  }
}

/******************************************************************************/

struct arr_fact_EnvRec {
  long *rows;
  FILEPtr *inf;
  nameptr *flag;
  quoly *n;
  long m;
  sparseptr *spar;
  arr_descr *arr_facts;
  Boolean *arr_free;
  long start;
  long cols;
  long firstrow;
  long firstcol;
  long total_rows;
  long j;
  long locat;
  workarray *arr;
  /* rows is sometimes an INPUT to this procedure, at least for diagonal_matrix.  It 
     is, of course, always an output.  Also an INPUT rarely is arr_facts[1], needed if 
     we find [1] or [Rand].
       Looks like arr is assumed empty on entry. July 1994. 
       Yes, but arr MUST EXIST.  You can't pass it an uninitialized arr pointer. 
     Nov 1994.
       sparse_read_error added Jan 1997 so that a sparse matrix can be assigned an
     ordinary one read from the terminal.  The method used is a Kludge!  It will fail if
     the matrix has one column or if in modularmode and the first element of the matrix
     is not just a polynomial. */
  
  long i;
  nameptr t;
  nameptr p;
  quoly n3;
  varptr s;
  long k;
  varptr r;
};
typedef struct arr_fact_EnvRec arr_fact_EnvRec;

/*******************************************************************************/

void sparse_random(Boolean rrand, arr_fact_EnvRec *arr_fact_Env)   /* Sep 2011. patterned after diagonal_matrix and mult_sparses. */
{
  
  long i;
	long j;
  long k;
  long cols;
	long startrow;
	colm_ptrptr u;
  quoly n2;
  sparseptr sp;
  long forEnd_7;
  long forEnd_8;
	
	cols = quotient_of(&arr_fact_Env->arr_facts->arrsize, *arr_fact_Env->rows);	
	n2 = NULL;
	startrow = 0;
	forEnd_8 = (*arr_fact_Env->rows - 1) / sparsesize;
  for (k = 0; k <= forEnd_8; ++k) {
    if (k == 0) {
      newsparse(arr_fact_Env->spar);
      sp = *arr_fact_Env->spar;
    } else {
      newsparse(&sp->next);
      sp = sp->next;
    }
    sp->next = NULL;                              /* July 1998, new convention!! */
    forEnd_7 = startrow + sparsesize;
    for (i = 1 + startrow; i <= forEnd_7; ++i) 
      if (i > *arr_fact_Env->rows) 
        break;
      else {
				u = &sp->indx[i - startrow - 1];
				for (j = 1; j <= cols; ++j) {
					randomize(rrand, &n2);
					if (quoly_iszero(n2))
						free_quoly(&n2);
					else {
						newcolmm(*u);
						(*u)->coord = j;
						(*u)->val = n2;
						n2 = NULL;
						u = &(*u)->next;
					}
				}
				*u = NULL;
			}		
		startrow += sparsesize;
  }
  
  *arr_fact_Env->arr_free = true;
  
}

/****************************************************************/

static void diagonal_matrix(arr_fact_EnvRec *arr_fact_Env)
{
  /* make a sparse matrix */
  long i;
  long k;
  Boolean neg;
  Boolean itszero;
  colm_ptr s;
  sparseptr sp;
  long forEnd_18;
  long forEnd_19;

  if (*arr_fact_Env->rows == 0) 
    error(45, &token);
  /*  if rows * rows > arr_limit
        then error(43, token);  */
  /* <<<< */
  neg = ustrcmp(token.name, "-") == 0;
  if (neg) 
    scanner(arr_fact_Env->inf, &token, arr_fact_Env->flag);
  quoly_readin(arr_fact_Env->inf, arr_fact_Env->n, arr_fact_Env->flag, 
               &arr_fact_Env->m);
  if (neg) 
    quoly_inplace(*arr_fact_Env->n);
  itszero = quoly_iszero(*arr_fact_Env->n);
  forEnd_19 = (*arr_fact_Env->rows - 1) / sparsesize;
  for (k = 0; k <= forEnd_19; ++k) {
    if (k == 0) {
      newsparse(arr_fact_Env->spar);
      sp = *arr_fact_Env->spar;
    } else {
      newsparse(&sp->next);
      sp = sp->next;
    }
    sp->next = NULL;                              /* July 1998, new convention!! */
    forEnd_18 = (k + 1) * sparsesize;
    for (i = 1 + k * sparsesize; i <= forEnd_18; ++i) 
      if (i > *arr_fact_Env->rows) 
        break;
      else if (itszero) 
        sp->indx[(i - k * sparsesize) - 1] = NULL;
      else {
        newcolm(&sp->indx[(i - k * sparsesize) - 1]);
        s = sp->indx[(i - k * sparsesize) - 1];
        s->next = NULL;
        s->coord = i;
        s->val = NULL;
        quoly_assign(*arr_fact_Env->n, &s->val);
      }
  }
  
  special_set_2(*arr_fact_Env->rows, *arr_fact_Env->rows, &arr_fact_Env->arr_facts->arrsize);
  /* Oct 2000 */
  arr_fact_Env->arr_facts->rows = *arr_fact_Env->rows;
  *arr_fact_Env->arr_free = true;
}

/****************************************************************************/

static void fillit_1(arrptr q, arr_fact_EnvRec *arr_fact_Env)
{
  
  long i;
  long k;
  long forEnd_20;
  long forEnd_21;

  scanner(arr_fact_Env->inf, &token, arr_fact_Env->flag);
  if (ustrcmp(token.name, "[") == 0) {         /* subarray */
    subarray(arr_fact_Env->inf, q, &arr_fact_Env->start, arr_fact_Env->rows, 
             &arr_fact_Env->cols, &arr_fact_Env->firstrow, &arr_fact_Env->firstcol, 
             &arr_fact_Env->total_rows, arr_fact_Env->flag);
    special_set_2(*arr_fact_Env->rows, arr_fact_Env->cols, &arr_fact_Env->arr_facts->arrsize);
    /* Oct 2000 */
    arr_fact_Env->arr_facts->rows = *arr_fact_Env->rows;
  } else {
    spec_num_assign(&q->sizearr, &arr_fact_Env->arr_facts->arrsize);  /* Oct 2000 */
    arr_fact_Env->arr_facts->rows = q->rows;
    *arr_fact_Env->rows = q->rows;
    arr_fact_Env->start = q->start;
    arr_fact_Env->total_rows = *arr_fact_Env->rows;
    arr_fact_Env->cols = quotient_of(&arr_fact_Env->arr_facts->arrsize, 
                                     *arr_fact_Env->rows);  /* Oct 2000 */
  }
  arr_fact_Env->j = 0;
  
  *arr_fact_Env->arr_free = false;                /* <- Note! */
  forEnd_21 = arr_fact_Env->cols - 1;
  
  for (i = 0; i <= forEnd_21; ++i) {
    forEnd_20 = *arr_fact_Env->rows - 1;
    for (k = 0; k <= forEnd_20; ++k) {
      arr_fact_Env->locat = arr_fact_Env->start + k + i * arr_fact_Env->total_rows;
      check_and_assign(arr_fact_Env->locat, &(*arr_fact_Env->arr)[arr_fact_Env->j]);
      arr_fact_Env->j++;
    }
  }
}

/**********************************************************/

/*uses lots of globals */
static void load_up(arr_fact_EnvRec *arr_fact_Env)  /* June 1998 */
{
  while (arr_fact_Env->i <= *arr_fact_Env->rows) {
    while (arr_fact_Env->j <= arr_fact_Env->cols) {
      arr_fact_Env->locat = arr_fact_Env->i - addresser + (arr_fact_Env->j - addresser) *
          arr_fact_Env->firstrow;
      arr_fact_Env->t = arr_fact_Env->p;
      token = arr_fact_Env->p->let;
      currentchar = arr_fact_Env->p->next;
      arr_fact_Env->n3 = NULL;
      old_expre(arr_fact_Env->inf, &arr_fact_Env->n3, &arr_fact_Env->t);
      (*arr_fact_Env->arr)[arr_fact_Env->locat] = arr_fact_Env->n3;
      arr_fact_Env->j += arr_fact_Env->m;
      if (arr_fact_Env->s != NULL) 
        adjust(arr_fact_Env->s, arr_fact_Env->j);
    }
    arr_fact_Env->i += arr_fact_Env->k;
    arr_fact_Env->j = arr_fact_Env->start;
    if (arr_fact_Env->s != NULL) 
      adjust(arr_fact_Env->s, arr_fact_Env->j);
    adjust(arr_fact_Env->r, arr_fact_Env->i);
  }
}

/***********************************************************/

static void sparse_load_up(arr_fact_EnvRec *arr_fact_Env)  /* June 1998 */
{
  /* uses lots of globals: spar, i, j, k,rows,cols,start, s, r, m, p, t, n3. 
     n3 is left dangling. */
  colm_ptrptr u;
  sparseptr sp;
  long c;
  long spot;
  long forEnd_22;

  sparse_init(arr_fact_Env->spar, *arr_fact_Env->rows);
  sp = *arr_fact_Env->spar;
  spot = arr_fact_Env->i;
  while (arr_fact_Env->i <= *arr_fact_Env->rows) {
    /* make sure spot is between 1 and sparsesize */
    if (spot > sparsesize) {
      forEnd_22 = (spot - 1) / sparsesize;
      for (c = 1; c <= forEnd_22; ++c) 
        sp = sp->next;
      spot = 1 + (spot - 1) % sparsesize;
    }
    /* at this point spot is congruent to i mod sparsesize. */
    u = &sp->indx[spot - 1];
    while (arr_fact_Env->j <= arr_fact_Env->cols) {
      arr_fact_Env->t = arr_fact_Env->p;
      token = arr_fact_Env->p->let;
      currentchar = arr_fact_Env->p->next;
      arr_fact_Env->n3 = NULL;
      old_expre(arr_fact_Env->inf, &arr_fact_Env->n3, &arr_fact_Env->t);
      if (quoly_iszero(arr_fact_Env->n3)) 
        free_quoly(&arr_fact_Env->n3);
      else {
        newcolm(u);
        (*u)->coord = arr_fact_Env->j;
        (*u)->val = arr_fact_Env->n3;
        u = &(*u)->next;
      }
      arr_fact_Env->j += arr_fact_Env->m;
      if (arr_fact_Env->s != NULL) 
        adjust(arr_fact_Env->s, arr_fact_Env->j);
    }
    *u = NULL;
    arr_fact_Env->i += arr_fact_Env->k;
    spot += arr_fact_Env->k;
    arr_fact_Env->j = arr_fact_Env->start;
    if (arr_fact_Env->s != NULL) 
      adjust(arr_fact_Env->s, arr_fact_Env->j);
    adjust(arr_fact_Env->r, arr_fact_Env->i);
  }
}

/***************************************************************************/

void arr_fact(textptr inf, quolyptr n, workptr arr, arr_descr *arr_facts, Boolean *arr_free, LongIntPtr rows, nameptr *flag, sparseptr *spar)
{
  long expont;
  arrptr q;
  workptr arr2;
  workptr arr3;
  tokentipe oldtok;
  Boolean double_1;
  Boolean even;
  Boolean arr2_free;
  Boolean sparse_read_error;
  number m2;
  sparseptr spar2;
  numptr spcol;                                   /* Dec 2000 */
  numptrptr np;
  long forEnd_23;
  long forEnd_24;
  long forEnd_25;
  long forEnd_26;
  long forEnd_27;
  long forEnd_28;
  long forEnd_29;
  long forEnd_30;
  long forEnd_31;
  long forEnd_32;
  long forEnd_33;
  arr_fact_EnvRec arr_fact_Env;

  arr_fact_Env.arr = arr;
  arr_fact_Env.arr_free = arr_free;
  arr_fact_Env.arr_facts = arr_facts;
  arr_fact_Env.spar = spar;
  arr_fact_Env.n = n;
  arr_fact_Env.flag = flag;
  arr_fact_Env.inf = inf;
  arr_fact_Env.rows = rows;

  if (ustrcmp(token.name, "(") == 0) {
    scanner(inf, &token, flag);
    arr_expre(inf, n, arr, arr_facts, arr_free, rows, flag, spar, 
              true);
    if (ustrcmp(token.name, ")") != 0) 
      error(1, &token);
    else 
      scanner(inf, &token, flag);
      
  } else if (ustrcmp(token.name, "-") == 0) {
    scanner(inf, &token, flag);
    arr_fact(inf, n, arr, arr_facts, arr_free, rows, flag, spar);
    if (arr_facts->arrsize.head->value == 0) 
      quoly_inplace(*n);
    else if (*spar == NULL) 
      if (*arr_free) {
        forEnd_23 = arr_facts->arrsize.head->value - 1;
        for (arr_fact_Env.i = 0; arr_fact_Env.i <= forEnd_23; ++arr_fact_Env.i) 
          quoly_inplace((*arr)[arr_fact_Env.i]);
      } else {
        forEnd_24 = arr_facts->arrsize.head->value - 1;
        for (arr_fact_Env.i = 0; arr_fact_Env.i <= forEnd_24; ++arr_fact_Env.i) {
          arr_fact_Env.n3 = NULL;
          quoly_makeneg((*arr)[arr_fact_Env.i], &arr_fact_Env.n3);
          (*arr)[arr_fact_Env.i] = arr_fact_Env.n3;
        }
        *arr_free = true;
      }
    else 
      sparse_makeneg(spar, *rows, arr_free);
      
  } else if (ustrcmp(token.name, "Trans") == 0) {  /* transpose matrix */
    oldtok = token;
    scanner(inf, &token, flag);
    new_worknode(&arr_fact_Env.i, &token);
    arr2 = workhead[arr_fact_Env.i - 1];
    arr_fact(inf, n, arr2, arr_facts, arr_free, rows, flag, spar);
    if (arr_facts->arrsize.head->value == 0) 
      error(72, &oldtok);
    arr_fact_Env.cols = arr_facts->rows;
    arr_facts->rows = quotient_of(&arr_facts->arrsize, arr_fact_Env.cols);
    *rows = arr_facts->rows;
    if (*spar == NULL) {
      forEnd_26 = *rows - 1;
      for (arr_fact_Env.i = 0; arr_fact_Env.i <= forEnd_26; ++arr_fact_Env.i) {
        forEnd_25 = arr_fact_Env.cols - 1;
        for (arr_fact_Env.j = 0; arr_fact_Env.j <= forEnd_25; ++arr_fact_Env.j) {
          arr_fact_Env.locat = arr_fact_Env.i + arr_fact_Env.j * (*rows);
          arr_fact_Env.k = arr_fact_Env.j + arr_fact_Env.i * arr_fact_Env.cols;
          if (*arr_free) 
            (*arr)[arr_fact_Env.locat] = (*arr2)[arr_fact_Env.k];
          else {            /* have to do this because of :[x]=ª[x] */
            (*arr)[arr_fact_Env.locat] = NULL;
            quoly_assign((*arr2)[arr_fact_Env.k], &(*arr)[arr_fact_Env.locat]);
          }
        }
      }
    } else if (*arr_free) 
      trans_sparse(spar, arr_fact_Env.cols, *rows);
    else {
      copy_sparse(spar, &spar2, arr_fact_Env.cols, false);
      trans_sparse(&spar2, arr_fact_Env.cols, *rows);
      *spar = spar2;
    }
    
    free_work();
    *arr_free = true;
    
  } else if (ustrcmp(token.name, "Diag") == 0) {  /* extract diagonal */
    oldtok = token;
    scanner(inf, &token, flag);
    new_worknode(&arr_fact_Env.i, &token);
    arr2 = workhead[arr_fact_Env.i - 1];
    arr_fact(inf, n, arr2, arr_facts, arr_free, rows, flag, spar);
    if (arr_facts->arrsize.head->value == 0) 
      error(74, &oldtok);                         /* Nov 1997 */
    extract_diagonal(arr, arr2, arr_facts, *arr_free, rows, spar);
    free_work();
    
  } else if (ustrcmp(token.name, "$") == 0) {
    scanner(inf, &token, flag);
    arr_fact(inf, n, arr, arr_facts, arr_free, rows, flag, spar);
    if (arr_facts->arrsize.head->value == 0) 
      quoly_great_int(n);
    else if (*spar == NULL) {
      forEnd_27 = arr_facts->arrsize.head->value - 1;
      for (arr_fact_Env.i = 0; arr_fact_Env.i <= forEnd_27; ++arr_fact_Env.i) 
        if (*arr_free) 
          quoly_great_int(&(*arr)[arr_fact_Env.i]);
        else {
          arr_fact_Env.n3 = NULL;
          quoly_assign((*arr)[arr_fact_Env.i], &arr_fact_Env.n3);
          quoly_great_int(&arr_fact_Env.n3);
          (*arr)[arr_fact_Env.i] = arr_fact_Env.n3;
        }
    } else 
      sparse_great_abs(spar, *rows, *arr_free, false);
    *arr_free = true;
    
  } else if (ustrcmp(token.name, "|") == 0) {
    scanner(inf, &token, flag);
    arr_fact(inf, n, arr, arr_facts, arr_free, rows, flag, spar);
    if (ustrcmp(token.name, "|") != 0) {
      if (*arr_free) 
        if (*spar == NULL) 
          free_arr(arr, arr_facts);
        else 
          free_sparse(spar, *rows, true);
      error(63, &token);
    }
    scanner(inf, &token, flag);
    if (arr_facts->arrsize.head->value == 0) 
      quoly_abs(*n);
    else if (*spar == NULL) {
      forEnd_28 = arr_facts->arrsize.head->value - 1;
      for (arr_fact_Env.i = 0; arr_fact_Env.i <= forEnd_28; ++arr_fact_Env.i) 
        if (*arr_free) 
          quoly_abs((*arr)[arr_fact_Env.i]);
        else {
          arr_fact_Env.n3 = NULL;
          quoly_assign((*arr)[arr_fact_Env.i], &arr_fact_Env.n3);
          quoly_abs(arr_fact_Env.n3);
          (*arr)[arr_fact_Env.i] = arr_fact_Env.n3;
        }
    } else 
      sparse_great_abs(spar, *rows, *arr_free, true);
    *arr_free = true;
  }
  
  else if (ustrcmp(token.name, "[") == 0) {
    scanner(inf, &token, flag);
    if (token.name[0] >= '0' && token.name[0] <= '9' || ustrcmp(token.name, "-") == 0)   
    /*try to create diagonal square matrix, rows X rows */
    
      diagonal_matrix(&arr_fact_Env);
    else if (token.name[0] >= 'a' && token.name[0] <= 'z') 
      if (is_poly_name(&token.name, &arr_fact_Env.m)) 
        diagonal_matrix(&arr_fact_Env);
      else {
        if (token.address == -1) 
          arr_fact_Env.i = hash(&token.name, 151);
        else 
          arr_fact_Env.i = token.address;
        
        q = arr_store[arr_fact_Env.i];
        while (q != NULL) 
          if (ustrcmp(q->name.name, token.name) == 0) 
            break;
          else 
            q = q->next;
        if (q == NULL) 
          error(28, &token);
        if (q->spar == NULL) 
          fillit_1(q, &arr_fact_Env);
        else {
          scanner(inf, &token, flag);
          if (ustrcmp(token.name, "[") == 0) 
            error(244, &token);
          *spar = q->spar;
          *arr_free = false;                      /* <- Note! */
          spec_num_assign(&q->sizearr, &arr_facts->arrsize);  /*Oct 2000*/
          arr_facts->rows = q->rows;
          *rows = q->rows;
        }
      }
    
    else if (ustrcmp(token.name, "%") == 0) {
      get_arr_arr(inf, n, flag, &arr_fact_Env.m);
      if ((*arrstash)[arr_fact_Env.m] == NULL) 
        error(220, &token);
      if ((*arrstash)[arr_fact_Env.m]->spar == NULL) 
        fillit_1((*arrstash)[arr_fact_Env.m], &arr_fact_Env);
      else {
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "[") == 0) 
          error(244, &token);
        *spar = (*arrstash)[arr_fact_Env.m]->spar;
        *arr_free = false;                        /* <- Note! */
        spec_num_assign(&(*arrstash)[arr_fact_Env.m]->sizearr, &arr_facts->arrsize);
        arr_facts->rows = (*arrstash)[arr_fact_Env.m]->rows;
        *rows = (*arrstash)[arr_fact_Env.m]->rows;
      }
    }
    
    else if (ustrcmp(token.name, "(") == 0 || ustrcmp(token.name, "[") == 0) 
    /* array is being filled by a list. '[' indicates matrix. */
    {
      arr_fact_Env.j = 0;
      double_1 = ustrcmp(token.name, "[") == 0;
      if (double_1 && want_sparse) {  /* Sep 2011: want_sparse is a global */
        arr_facts->rows = *rows;                  /* arr_facts[1] already set */
        sparse_read(inf, n, flag, arr_facts, arr_free, &sparse_read_error, spar);
        if (sparse_read_error) {
          (*arr)[arr_fact_Env.j] = *n;
          *n = NULL;
          even = false;                           /* for later statement */
          quoly_set(0, n);                        /* necessary? */
          arr_fact_Env.j = 1;                     /* continue with loop below */
        } else 
          return;
      } else 
        sparse_read_error = false;
      arr_fact_Env.cols = 0;                      /* means don't know cols yet; will find out 
                                                     when read ã or end of line */
      do {
        if (arr_fact_Env.j > arr_limit - 1) {
          special_set(arr_limit, &arr_facts->arrsize);
          free_arr(arr, arr_facts);
          error(71, &comma);
        }
        if (sparse_read_error) 
          sparse_read_error = false;
        else if (double_1) 
          spec_scanner(inf, &token, flag, &even);
        else 
          scanner(inf, &token, flag);
        /* even means ã (or end of line) was seen. */
        if (double_1 && even && arr_fact_Env.cols == 0) 
          arr_fact_Env.cols = arr_fact_Env.j;
        (*arr)[arr_fact_Env.j] = NULL;
        old_expre(inf, &(*arr)[arr_fact_Env.j], flag);
        arr_fact_Env.j++;
        special_set(arr_fact_Env.j, &arr_facts->arrsize);  /* Oct 2000 */
        if (ustrcmp(token.name, ",") != 0 && (double_1 || ustrcmp(token.name, ")") != 0) &&
	   (!double_1 || ustrcmp(token.name, "]") != 0)) {
          free_arr(arr, arr_facts);
          error(70, &token);
        }
      } while (!(double_1 && ustrcmp(token.name, "]") == 0 || !double_1 && ustrcmp(token.name, ")")
           == 0));
      scanner(inf, &token, flag);
      if (double_1 && arr_fact_Env.cols == 0) 
        arr_fact_Env.cols = 1;
      if (double_1) 
        if (arr_fact_Env.j % arr_fact_Env.cols != 0) {
          free_arr(arr, arr_facts);
          error(173, &token);
        } else 
          *rows = arr_fact_Env.j / arr_fact_Env.cols;
      else {
        *rows = 1;
        arr_facts->rows = 1;
      }
      if (double_1) {                             /* must transpose */
        new_worknode(&arr_fact_Env.i, &token);
        arr2 = workhead[arr_fact_Env.i - 1];
        arr_facts->rows = *rows;
        forEnd_30 = *rows - 1;
        for (arr_fact_Env.i = 0; arr_fact_Env.i <= forEnd_30; ++arr_fact_Env.i) {
          forEnd_29 = arr_fact_Env.cols - 1;
          for (arr_fact_Env.j = 0; arr_fact_Env.j <= forEnd_29; ++arr_fact_Env.j) {
            arr_fact_Env.locat = arr_fact_Env.i + arr_fact_Env.j * (*rows);
            arr_fact_Env.k = arr_fact_Env.j + arr_fact_Env.i * arr_fact_Env.cols;
            (*arr2)[arr_fact_Env.locat] = (*arr)[arr_fact_Env.k];
          }
        }
        forEnd_31 = arr_facts->arrsize.head->value - 1;
        for (arr_fact_Env.i = 0; arr_fact_Env.i <= forEnd_31; ++arr_fact_Env.i) 
          (*arr)[arr_fact_Env.i] = (*arr2)[arr_fact_Env.i];
        free_work();
      }
      
      *arr_free = true;
    }
    
    else if (ustrcmp(token.name, "<") == 0) {  /* loop(s) to fill array, or system array */
      /* Nov 1997 */
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, "]") == 0)  /* Jul 2003. system array moved here */
        if (syst->stop == -1) 
           error(175, &token);
        else {
          /* scanner(inf, &token, flag); Jul 2003. don't need now */
          if (ustrcmp(token.name, "[") == 0) 
            error(83, &token);
          special_set(syst->stop + 1, &arr_facts->arrsize);
          *rows = syst->rows;
          arr_facts->rows = *rows;
          *arr_free = true;
          /* The duplication of space here is essential. */
          copy_syst(arr, *rows, spar);              /* Nov 1997 */
        }    
      
      else {
      
        set_up_for_loop(inf, flag, &arr_fact_Env.r, &arr_fact_Env.i, 
                      rows, &arr_fact_Env.k, &spcol, &np);  /* Dec 2000 */
        if (spcol != NULL)                          /* Dec 2000 */
          error(336, &token);
        if (ustrcmp(token.name, ">") != 0) 
          error(78, &token);
        if (arr_fact_Env.i < addresser) 
          error(79, &arr_fact_Env.r->let);
        if (*rows < addresser) 
          error(80, &arr_fact_Env.r->let);
        if (arr_fact_Env.k < 1) 
          error(82, &arr_fact_Env.r->let);
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "<") == 0) {
          /* Nov 1997 */
          scanner(inf, &token, flag);  /* Jul 2003 */
          set_up_for_loop(inf, flag, &arr_fact_Env.s, &arr_fact_Env.j, 
                          &arr_fact_Env.cols, &arr_fact_Env.m, &spcol, 
                          &np);                     /* Dec 2000 */
          if (spcol != NULL)                        /* Dec 2000 */
            error(336, &token);
          if (ustrcmp(token.name, ">") != 0) 
            error(78, &token);
          if (arr_fact_Env.j < addresser) 
            error(79, &arr_fact_Env.s->let);
          if (arr_fact_Env.cols < addresser) 
            error(80, &arr_fact_Env.s->let);
          if (arr_fact_Env.m < 1) 
            error(82, &arr_fact_Env.s->let);
          scanner(inf, &token, flag);
        } else {
          arr_fact_Env.j = addresser;
          arr_fact_Env.cols = addresser;
          arr_fact_Env.m = 1;
          arr_fact_Env.s = NULL;
        }
      
        obtain_expression(inf, flag, &arr_fact_Env.p, (unsigned char *)"[");
        arr_fact_Env.start = arr_fact_Env.j;
        arr_fact_Env.firstrow = *rows + 1 - addresser;  /* actual number of rows */
        /* 'firstrow' not pnemonic here */
        if (want_sparse)                /* BUG May 1998, June 1998 */
                                        /*if sparse_oversize(firstrow, cols + 1 - addresser) 
                                            then error(23, token)
                                            else  Oct 2000, removed */
          ;
        else if (oversize(arr_fact_Env.firstrow, arr_fact_Env.cols + 1 - addresser)) 
          error(43, &token);
        special_set(arr_fact_Env.firstrow * (arr_fact_Env.cols + 1 - addresser), 
                    &arr_facts->arrsize);
        arr_facts->rows = arr_fact_Env.firstrow;
      
        if (want_sparse)                            /* June 1998 */
          sparse_load_up(&arr_fact_Env);
        else 
          load_up(&arr_fact_Env);
      
        *rows = arr_fact_Env.firstrow;
        *arr_free = true;
        freename(arr_fact_Env.p);                   /* p is not changed */
      }
    
    }  /* end token = '<' */
    
    else if (ustrcmp(token.name, "Rand") == 0 || ustrcmp(token.name, "RRand") == 0) { 
       /* array is being filled by random. Jun 2004:  added RRand */
      if (*rows == 0) 
        error(142, &token);
      double_1 = ustrcmp(token.name, "RRand") == 0;  
      scanner(inf, &token, flag);
			if (!want_sparse) {		  /* Sep 2011. old code. use global want_sparse. */	
				forEnd_32 = arr_facts->arrsize.head->value - 1;
				for (arr_fact_Env.j = 0; arr_fact_Env.j <= forEnd_32; ++arr_fact_Env.j) {
					(*arr)[arr_fact_Env.j] = NULL;
					randomize(double_1, &(*arr)[arr_fact_Env.j]);
				}
			}
			else   /* Sep 2011. new code for sparse arrays. */
        sparse_random(double_1, &arr_fact_Env);			
      arr_facts->rows = *rows;      /* Jun 2004 remove scanner */  /* bug, July 1998 */
      *arr_free = true;
    }
        
    else if (want_sparse && ustrcmp(token.name, "]") == 0)   /* empty array*/
      sparse_init(spar, *rows);
    
    else 
      error(40, &token);
    
    if (ustrcmp(token.name, "]") != 0) {
      if (*arr_free) 
        if (*spar == NULL) 
          free_arr(arr, arr_facts);
        else 
          free_sparse(spar, *rows, true);
      error(24, &token);
    }
    scanner(inf, &token, flag);
    
  }    /* if token.name = '[' */
  
  else if (ustrcmp(token.name, "Adjoint") == 0) {
    oldtok = token;
    scanner(inf, &token, flag);
    new_worknode(&arr_fact_Env.i, &oldtok);
    arr2 = workhead[arr_fact_Env.i - 1];
    arr_fact(inf, n, arr2, arr_facts, &arr2_free, rows, flag, spar);
    if (arr_facts->arrsize.head->value == 0) 
      error(72, &oldtok);
    if (!is_product_of(&arr_facts->arrsize, *rows, *rows))   /* Oct 2000 */
      error(241, &token);
    if (*spar != NULL) 
      error(242, &oldtok);
    adjoint(arr2, arr, arr2_free, *rows, spar);
    free_work();
    *arr_free = true;
  }
  
  else if (ustrcmp(token.name, "Altmult") == 0) {
    oldtok = token;
    scanner(inf, &token, flag);
    if (ustrcmp(token.name, "(") != 0) 
      error(177, &token);
    scanner(inf, &token, flag);
    new_worknode(&arr_fact_Env.i, &oldtok);
    arr2 = workhead[arr_fact_Env.i - 1];
    arr_expre(inf, n, arr2, arr_facts, &even, rows, flag, spar, true);
    if (arr_facts->arrsize.head->value == 0)      /* Oct 2000 */
      error(72, &token);
    arr_fact_Env.firstcol = quotient_of(&arr_facts->arrsize, *rows);  /* Oct 2000 */
    if (*spar != NULL) 
      error(242, &oldtok);
    if (ustrcmp(token.name, ",") != 0) 
      error(202, &token);
    scanner(inf, &token, flag);
    new_worknode(&arr_fact_Env.i, &oldtok);
    arr3 = workhead[arr_fact_Env.i - 1];
    arr_fact_Env.firstrow = arr_fact_Env.firstcol;  /* in case following call finds a diagonal */
    arr_expre(inf, n, arr3, arr_facts, &double_1, &arr_fact_Env.firstrow, 
              flag, spar, true);
    /* 'firstrow' is misnomer. it's really the second matrix's row. */
    if (arr_facts->arrsize.head->value == 0) 
      error(72, &token);
    if (*spar != NULL) 
      error(242, &token);
    if (ustrcmp(token.name, ")") != 0) 
      error(1, &token);
    arr_fact_Env.cols = quotient_of(&arr_facts->arrsize, arr_fact_Env.firstrow);  /* Oct 2000 */
    if (arr_fact_Env.firstcol != arr_fact_Env.firstrow) 
      error(39, &oldtok);
    if (oversize(*rows, arr_fact_Env.cols)) 
      error(43, &token);
    fast_mat_mult(arr2, arr3, arr, *rows, arr_fact_Env.firstcol, arr_fact_Env.cols);
    scanner(inf, &token, flag);
    special_set_2(*rows, arr_fact_Env.firstcol, &arr_facts->arrsize);  /* Oct 2000 */
    if (even) 
      free_arr(arr2, arr_facts);
    special_set_2(arr_fact_Env.firstrow, arr_fact_Env.cols, &arr_facts->arrsize);  /* Oct 2000 */
    if (double_1) 
      free_arr(arr3, arr_facts);
    free_work();
    free_work();
    special_set_2(*rows, arr_fact_Env.cols, &arr_facts->arrsize);  /* Oct 2000 */
    arr_facts->rows = *rows;
    *arr_free = true;
  }
  
  else if (ustrcmp(token.name, "Altpower") == 0 || ustrcmp(token.name, "MPowermod") == 0) {
    /* Mar 1999 */
    oldtok = token;
    scanner(inf, &token, flag);
    if (ustrcmp(token.name, "(") != 0) 
      error(177, &token);
    scanner(inf, &token, flag);
    arr_expre(inf, n, arr, arr_facts, arr_free, rows, flag, spar, 
              true);
    if (arr_facts->arrsize.head->value == 0) 
      error(72, &token);
    arr_fact_Env.cols = quotient_of(&arr_facts->arrsize, *rows);  /* Oct 2000 */
    if (*spar != NULL) 
      error(242, &oldtok);
    if (*rows != arr_fact_Env.cols) 
      error(172, &oldtok);
    if (ustrcmp(token.name, ",") != 0) 
      error(202, &token);
    m2.size = 0;
    get_exponent(inf, flag, &m2, ustrcmp(token.name, "Altpower") == 0);
    /* for MPowermod, m2 is now always in rational format. */
    if (ustrcmp(token.name, "Altpower") == 0) {
      expont = check_and_convert(&m2);
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      alt_mat_power(arr, arr_facts, arr_free, expont);
    } else {                                      /* Mar 1999 */
      arr_fact_Env.n3 = NULL;
      if (ustrcmp(token.name, ",") == 0) {
        scanner(inf, &token, flag);
        old_expre(inf, &arr_fact_Env.n3, flag);
        if (!arr_fact_Env.n3->numb) 
          if (arr_fact_Env.n3->variant.vc_2.denom != NULL) 
            error(288, &token);
        if (lintmode) 
          if (arr_fact_Env.n3->numb) 
            error(188, &token);
          else                                    /* nothing */
            ;
        else if (arr_fact_Env.n3->numb && arr_fact_Env.n3->variant.vc_1.ncoef->head->value <= 0) 
          error(288, &token);
      }
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
      matpowermod(arr, arr_facts, arr_free, &m2, &arr_fact_Env.n3, 
                  verbose && windy);
      free_quoly(&arr_fact_Env.n3);
    }
    free_num(&m2);
    scanner(inf, &token, flag);
  }
  
  else if (ustrcmp(token.name, "\'") == 0) {
    arr_fact_Env.j = 0;
    do {
      if (arr_fact_Env.j > arr_limit - 1) {
        special_set(arr_limit, &arr_facts->arrsize);  /* Oct 2000 */
        free_arr(arr, arr_facts);
        error(71, &token);
      }
      dumbscanner(inf, &token, flag, &double_1);
      if (ustrcmp(token.name, "\'") != 0) {
        (*arr)[arr_fact_Env.j] = NULL;
        quoly_set(token.name[0], &(*arr)[arr_fact_Env.j]);
        arr_fact_Env.j++;
      }
    } while (ustrcmp(token.name, "\'") != 0);
    scanner(inf, &token, flag);
    if (arr_fact_Env.j == 0) 
      error(110, &token);
    special_set(arr_fact_Env.j, &arr_facts->arrsize);  /* Oct 2000 */
    arr_facts->rows = 1;
    *arr_free = true;
    *rows = 1;
    
  } else {         /* Just call fact. Might get signal from fact to eval matrix */
    matrix_eval++;
    arr_fact_Env.m = matrix_eval;

    old_fact(inf, n, flag);

    if (matrix_eval != arr_fact_Env.m)            /* fact changed it - want to eval n at matrix */
      quoly_at_matrix(inf, *n, arr, arr_facts, arr_free, rows, flag, 
                      spar);
    else {
      matrix_eval--;
      special_set(0, &arr_facts->arrsize);        /* Oct 2000 */
    }
  }

  if (ustrcmp(token.name, "^") == 0) {
    if (arr_facts->arrsize.head->value == 0)      /* Oct 2000 */
      arr_facts->rows = 0;
    if (!is_product_of(&arr_facts->arrsize, arr_facts->rows, arr_facts->rows)) {
      if (*spar == NULL) {
        if (*arr_free) 
          free_arr(arr, arr_facts);
      } else 
        free_sparse(spar, arr_facts->rows, *arr_free);
      error(172, &expsign);
    }
    m2.size = 0;
    get_exponent(inf, flag, &m2, true);
    if (arr_facts->arrsize.head->value == 0) 
      raise_to_power(n, &m2);
    else {
      expont = check_and_convert(&m2);
      matrix_power(arr, arr_facts, arr_free, expont, spar);
    }
    free_num(&m2);
    
  } 
  
  else if (ustrcmp(token.name, "#") == 0) 
    if (arr_facts->arrsize.head->value > 0) {     /* Oct 2000 */
      scanner(inf, &token, flag);
      free_quoly(n);
      if (*spar != NULL) {
        sparse_evalquoly(n, spar, arr_facts->rows, arr_free, inf, 
                         flag);
        return;
      }
      forEnd_33 = arr_facts->arrsize.head->value - 1;
      for (arr_fact_Env.j = 0; arr_fact_Env.j <= forEnd_33; ++arr_fact_Env.j) 
         get_evalquoly(inf, &(*arr)[arr_fact_Env.j], n, &arr_fact_Env.locat, 
                       flag, false, !(*arr_free)); /* Mar 2005. big simpflication */
    
      *arr_free = true;
      if ((*n)->next != NULL)     /* total_eval was called by get_evalquoly */
        while (*n != NULL) {
          arr_fact_Env.n3 = (*n)->next;
          free_quoly(n);
          *n = arr_fact_Env.n3;
        }
      quoly_set(0, n);
    } 
    else {
      scanner(inf, &token, flag);                 /* bug of July 1996 */
      if (ustrcmp(token.name, "[") == 0) {
        *spar = NULL;                             /* bug of July 1996 */
        quoly_at_matrix(inf, *n, arr, arr_facts, arr_free, rows, flag, spar);
        quoly_set(0, n);
      } else {
        arr_fact_Env.n3 = NULL;                   /* flag to get_evalquoly */
        get_evalquoly(inf, n, &arr_fact_Env.n3, &arr_fact_Env.locat, flag, true, false);
        free_quoly(&arr_fact_Env.n3);
      }
    }
}

/***************************************************************************/

void half_arr_fact(textptr inf, quolyptr n, workptr arr, arr_descr *arr_facts, Boolean *arr_free, LongIntPtr rows, nameptr *flag, sparseptr *spar)
{
  /* Nov 1997 */
  
  quoly n3;
  number m2;
  long expont;
  long j;
  long forEnd_34;

  if (ustrcmp(token.name, "^") == 0) {
    if (arr_facts->arrsize.head->value == 0) 
      arr_facts->rows = 0;
    if (!is_product_of(&arr_facts->arrsize, arr_facts->rows, arr_facts->rows)) {
      if (*spar == NULL) {
        if (*arr_free) 
          free_arr(arr, arr_facts);
      } else 
        free_sparse(spar, arr_facts->rows, *arr_free);
      error(172, &expsign);
    }
    m2.size = 0;
    get_exponent(inf, flag, &m2, true);
    if (arr_facts->arrsize.head->value == 0) 
      raise_to_power(n, &m2);
    else {
      expont = check_and_convert(&m2);
      matrix_power(arr, arr_facts, arr_free, expont, spar);
    }
    free_num(&m2);
  } else if (ustrcmp(token.name, "#") == 0) 
    if (arr_facts->arrsize.head->value > 0) {
      scanner(inf, &token, flag);
      free_quoly(n);
      if (*spar != NULL) {
        sparse_evalquoly(n, spar, arr_facts->rows, arr_free, inf, 
                         flag);
        return;
      }
      forEnd_34 = arr_facts->arrsize.head->value - 1;
      for (j = 0; j <= forEnd_34; ++j)  /* Mar 2005. big simplification */
        get_evalquoly(inf, &(*arr)[j], n, &expont, flag, false, !(*arr_free)); 
                      
      *arr_free = true;
      if ((*n)->next != NULL)                     /* total_eval was called by get_evalquoly */
        while (*n != NULL) {
          n3 = (*n)->next;
          free_quoly(n);
          *n = n3;
        }
      quoly_set(0, n);
    } else {
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, "[") == 0) {
        *spar = NULL;
        quoly_at_matrix(inf, *n, arr, arr_facts, arr_free, rows, flag, 
                        spar);
        quoly_set(0, n);
      } else {
        n3 = NULL;                                /* flag to get_evalquoly */
        get_evalquoly(inf, n, &n3, &expont, flag, true, false);
        free_quoly(&n3);
      }
    }
}

/********************************************************************************/

/* n is not a number. count field elements as distinct terms. Jul 2003 */
long fieldterms(quoly n)
{
  
  return f_poly_numterms(n->variant.vc_2.numer) + f_poly_numterms(n->variant.vc_2.denom);
}

/*****************************************************************************/

struct set_mod_out_EnvRec {
  polypt q;
  nameptr *flag;
  Boolean got_auxes;
  Boolean cancelling;
  /*    can't be in modularmode, or even lintmode.  The first auxiliary list 
     is computed here or is supplied by the user.  It is a list of primes
     w.r.t. the mod-out poly is invertible.  The second auxiliary list is computed 
     here.  It is a list of pairs (y, p), where y is an integer and p is a prime, 
     such that mod p, the mod-out-poly evaluated at y is 0. */
  
  quoly num;
  long expon;
  Boolean *imperative;
  Boolean old_tt;
  shortstring old_left;
  poly r;
  poly alter;
  poly muldata;
  short n;
  jmp_buf set_mod_out_exit;
};
typedef struct set_mod_out_EnvRec set_mod_out_EnvRec;

/********************************************************************/

static void compute_aux_primes(polyptrr p, short level, set_mod_out_EnvRec *set_mod_out_Env)
{
  
  /* p is the modder.  Use global polypt q. start and end in rational mode.
     field_depth = level at start.  aux_prime1_number is a global, defined
     by fer120
       Feb 2005: allow to be invoked in modularmode!  */

  short i;
  short j;
  short k;
  short old_field_depth;
  short limit;
  short fail;
  Boolean oldlaurent;
  Boolean oldm1;
  Boolean success;
  Boolean failed;
  quoly test;
  quoly copy;
  poly t;

  if (aux1_hit_0) {                               /* May 1998 */
    fprintf(stdout, "  First auxiliary list is already empty.\n");
    fflush(stdout);
    return;
  }

  oldlaurent = laurent;
  laurent = false;
  set_mod_out_Env->q->field = false;              /* redundant, failsafe */
  if (!lintmode) { /* Feb 2005 */
    mod_is_prime = true;
    if (*set_mod_out_Env->flag == NULL) {
      fprintf(stdout, "  Computing and counting first auxiliary list.\n");
      fflush(stdout);
    }
  }

  /* restore field_depth; it was just changed by the caller. */
  old_field_depth = field_depth;
  if (field_depth == number_polys)
    field_depth = 0;
  else
    field_depth++;

  for (j = 2; j <= level; ++j) {
    newpoly(&t);
    t->next = NULL;
    t->numb = false;
    t->exp = 0;
    t->variant.pcoef = *p;
    *p = t;
  }
  copy = NULL;
  newquoly(&test);
  test->numb = false;
  test->variant.vc_2.rat = false;
  test->variant.vc_2.numer = *p;
  test->variant.vc_2.denom = NULL;
  *p = NULL;

  if (lintmode) /* Feb 2005 */
    limit = 0;
  else if (aux_prime1_number == 0) {
    auxptr = (primeptr)malloc(sizeof(auxprimes));  /* a global, defined by fer120 */
    limit = maxauxnum;
    if (limit > aux_num_1factor)
      limit = aux_num_1factor;
  } else
    limit = aux_prime1_number;

  k = 0;
  failed = false;
  for (i = 1; i <= limit; ++i) {
    /* go into modular mode */
    if (aux_prime1_number == 0) 
      if (i <= med_prime_size) 
        modulus = (*med_prime)[i - 1];
      else if (i <= primesize - 5 + med_prime_size)   /* Mar 2009 */
        modulus = prime[(i + 5 - med_prime_size) - 1]->lint;
	  else   /* Mar 2009 */
	    modulus = nextprime(modulus);
    else 
      modulus = (*auxptr)[i - 1]->head->value;
    half_modulus = modulus / 2;
    smallmodulus = true;                          /* Aug 2001 */
    two28_mod = block % modulus;
    poly_change_to_mod(&test->variant.vc_2.numer, false);
    change_poly_modout_data();
    oldm1 = command_int;
    command_int = false;
    modularmode = true;
    lintmode = true;

    /* perform test. copy is always in modular format. */
    quoly_assign(test, &copy);
    irreducible_poly(&copy, -1);
    success = copy->variant.vc_1.ncoef->lint == 1;
    free_quoly(&copy);

    modularmode = false;
    lintmode = false;
    if (masterfix != NULL)
      restore_from_mod(&masterfix);
    command_int = oldm1;

    if (success) {
      k++;
      if (aux_prime1_number == 0) {
        newimag(&(*auxptr)[k - 1]);
        (*auxptr)[k - 1]->size = 0;
        setvalue(1, (*auxptr)[k - 1]);
        (*auxptr)[k - 1]->head->value = modulus;
      }
      if (*set_mod_out_Env->flag == NULL)
        if (k % 10 == 0) {
          fprintf(stdout, "%5d", k);
          if (k % 100 == 0)
            fprintf(stdout, "\n");
          fflush(stdout);
        }
    } else if (aux_prime1_number > 0) {
      /* must reconcile later; mark now as 0. */
      failed = true;
      (*auxptr)[i - 1]->head->value = 0;
    }
  }

  if (!lintmode) { /* Feb 2005 */
    if (*set_mod_out_Env->flag == NULL && k % 100 != 0)
      fprintf(stdout, "\n");
    if (*set_mod_out_Env->flag == NULL && k < 50) {
      fprintf(stdout, " *** Warning. Few auxiliary primes found.\n");
      fprintf(stdout, "     Expect slow g.c.d. performance.  It would be better\n");
      fprintf(stdout, "     to restart Fermat and use &X to increase the\n");
      fprintf(stdout, "     first auxiliary search factor.  Current factor is ");
      fprintf(stdout, "%1d\n", aux_num_1factor);
      fflush(stdout);
    }
  }

  fail = 0;          /* counts number of failed moduli seen in following loop */
  if (aux_prime1_number > 0 && failed)
    for (i = 1; i <= aux_prime1_number; ++i)
      if ((*auxptr)[i - 1]->head->value == 0)
        fail++;
      else if (fail > 0)
        (*auxptr)[(i - fail) - 1]->head->value = (*auxptr)[i - 1]->head->value;

  aux_prime1_number = k; /* Feb 2005, 0 in lintmode */
  if (aux_prime1_number == 0)
    aux1_hit_0 = true;                      /* May 1998 */
  free_quoly(&test);
  set_mod_out_Env->got_auxes = true;        /* Sep 2001, clarify:  yes, true, even if k = 0 */
  field_depth = old_field_depth;
  laurent = oldlaurent;
}

/***********************************************************************/

static void get_aux_primes(textptr inf, nameptr *flag, Boolean *haveaux2, set_mod_out_EnvRec *set_mod_out_Env)
{
  /* changes got_auxes and system globals aux_prime1_number, auxptr.
     Does not reuse space for auxptr^.  Probably not worth bothering about.
     uses q, as of May 1998. */
  short i;
  quoly n2;
  long val1;                                      /* May 1998 */
  imptr im;
  imptrptr ii;                                    /* May 1998 */

  i = 0;
  n2 = NULL;
  auxptr = (primeptr)malloc(sizeof(auxprimes));   /* a global, defined by fer120 */
  
  do {
    scanner(inf, &token, flag);
    if (i == 0 && ustrcmp(token.name, ":") == 0)   /* no auxes of type 1!  Sep 2001 */
      break;
    old_expre(inf, &n2, flag);
    if (!n2->numb) 
      error(201, &token);
    im = n2->variant.vc_1.ncoef;
    if (im->size != 1 || im->head->value > lastbigprime || im->head->value < 2) {   /* June 1998. Mar 2009, lastbigprime */
      aux_prime1_number = 0;
      fprintf(stdout, " *** You\'ve messed up the first auxiliary prime list.\n");
      error(201, &token);
    }
    i++;
    if (i > maxauxnum) 
      error(268, &token);
    newimag(&(*auxptr)[i - 1]);
    (*auxptr)[i - 1]->size = 0;
    setvalue(1, (*auxptr)[i - 1]);
    (*auxptr)[i - 1]->head->value = im->head->value;
  } while (ustrcmp(token.name, ",") == 0);
  
  aux_prime1_number = i;                          /* a global, defined by fer120 */
  set_mod_out_Env->got_auxes = true;              /* Sep 2001.  yes, even if i=0 */
  
  if (ustrcmp(token.name, ":") != 0) {   /* the rest added May 1998; get type two auxes also */
    free_quoly(&n2);
    return;
  }
  
  ii = &set_mod_out_Env->q->gcd_data;
  *ii = NULL;
  i = 0;
  do {
    scanner(inf, &token, flag);
    old_expre(inf, &n2, flag);
    if (!n2->numb) 
      error(201, &token);
    im = n2->variant.vc_1.ncoef;
    val1 = im->head->value;
    if (im->size != 1 || val1 > lastbigprime || val1 < 2) {  /* June 1998. Mar 2009, lastbigprime */
      fprintf(stdout, " *** You\'ve messed up the second auxiliary prime list.\n");
      fprintf(stdout, " *** Quit Fermat immediately.\n");
      error(201, &token);
    }
    if (ustrcmp(token.name, ",") != 0) {
      fprintf(stdout, " *** Comma expected. You\'ve messed up the second auxiliary prime list.\n");
      fprintf(stdout, " *** Quit Fermat immediately.\n");
      error(201, &token);
    }
    scanner(inf, &token, flag);
    old_expre(inf, &n2, flag);
    if (!n2->numb) 
      error(201, &token);
    im = n2->variant.vc_1.ncoef;
    if (im->size != 1 || im->head->value < 0 || val1 <= im->head->value) {
      fprintf(stdout, " *** You\'ve messed up the second auxiliary prime list.\n");
      fprintf(stdout, " *** Quit Fermat immediately.\n");
      error(201, &token);
    }
    insert_new_prime(val1, im->head->value, ii);
    ii = &(*ii)->imag;
    i++;
  } while (ustrcmp(token.name, ",") == 0);
  *haveaux2 = true;                               /* June 1998 */
  set_mod_out_Env->q->aux_num = i;
  free_quoly(&n2);
}

/*************************************************/

static void get_data(textptr inf, nameptr *flag, intptr n, Boolean *field, Boolean *haveaux2,
        set_mod_out_EnvRec *set_mod_out_Env)   /* Feb 2004 */
{
  /* compute n = depth, expon, field, and num. Read from either input or
     given inf, flag.
        Refers to globals num, imperative, q, cancelling, and got_auxes.
        Changes field_depth, q, and got_auxes.
        haveaux2 added May 1998. */
  
  short i;
  quoly n2;
  poly p;
  poly s;
  poly t;
  poly p2;

  *haveaux2 = false;                              /* May 1998 */
  scanner(inf, &token, flag);
  set_mod_out_Env->cancelling = ustrcmp(token.name, "-") == 0;
  if (set_mod_out_Env->cancelling)
    scanner(inf, &token, flag);
  set_mod_out_Env->num = NULL;
  old_expre(inf, &set_mod_out_Env->num, flag);

  /* num must be a monic poly of positive degree. if cancelling, must be
     the single poly var name alone. */
  check_for_monic_poly(195, set_mod_out_Env->num, n, &set_mod_out_Env->expon,
                       &p, &t);                   /* sets p, t, n */
  /* p, t point to (part of) num^.numer */
  
  if (set_mod_out_Env->expon < 2 && !set_mod_out_Env->cancelling)
    error(171, &token);

  if (ustrcmp(token.name, ",") == 0) {
    if (set_mod_out_Env->cancelling)
      error(269, &token);
    scanner(inf, &token, flag);
    n2 = NULL;
    old_expre(inf, &n2, flag);
    *field = quoly_eq_1(n2);
    free_quoly(&n2);
  } else 
    *field = false;
  
  if (set_mod_out_Env->cancelling)
    if (set_mod_out_Env->expon != 1 || p->next != NULL) 
      error(200, &token);
  
  /* See that this var (at level n) is suitable for modding. */
  set_mod_out_Env->q = polynames;
  for (i = 2; i <= *n; ++i)
    set_mod_out_Env->q = set_mod_out_Env->q->next;
  if (set_mod_out_Env->cancelling) {
    if (set_mod_out_Env->q->p == NULL) 
      fprintf(stdout, " *** Warning. Wasn\'t modding out on %s.\n", set_mod_out_Env->q->let.name);
    else {
      free_poly(&set_mod_out_Env->q->p);
      free_poly(&set_mod_out_Env->q->alt);
      free_poly(&set_mod_out_Env->q->roots);
      free_poly(&set_mod_out_Env->q->multdata);
      set_mod_out_Env->q->field = false;
      free_gcd_data(set_mod_out_Env->q);
      if (verbose || *flag == NULL) /* Feb 2005 */
        fprintf(stdout, " No longer modding out polynomial variable %s.\n", set_mod_out_Env->q->let.name);
    }
    reset_pseudo_poly();                          /* sets field_depth, others too */
    if (field_depth == 0)
      fprintf(stdout, " There are no fields.\n");
    quoly_set(0, &prevnum);
    free_quoly(&set_mod_out_Env->num);
    if (*set_mod_out_Env->imperative) {
      if (ustrcmp(token.name, ")") != 0) 
        error(1, &token);
    } else {
      if (ustrcmp(token.name, ";") != 0)
        error(129, &token);
      tt_flag = set_mod_out_Env->old_tt;
      ustrcpy(leftover, set_mod_out_Env->old_left);
    }                 /* have to reset tt_flag = old_tt, etc?  May 24, 1996*/
    longjmp(set_mod_out_Env->set_mod_out_exit, -1);
    /*exit(::set_mod_out) ~ up-level function exit*/
  } else if (set_mod_out_Env->q->p != NULL) 

    if (*set_mod_out_Env->imperative) {
      fprintf(stdout, " *** Warning. Was already modding out on %s.\n", set_mod_out_Env->q->let.name);
      fprintf(stdout, "     Will discard former modding polynomial.\n");
      set_mod_out_Env->q->field = false;
      free_poly(&set_mod_out_Env->q->alt);
      free_poly(&set_mod_out_Env->q->roots);
      free_poly(&set_mod_out_Env->q->multdata);
      free_poly(&set_mod_out_Env->q->p);          /* will just replace old with new,
                                                     but see below */
    } else 
      error(199, &set_mod_out_Env->q->let);
  
  /* Get formats right.  Recall that p and t point into num. t "trails" p.
     p has no independent storage at this point. 
     Assign right value to num, but we need p (p2) for compute_aux_primes. */
  s = p->next;
  p2 = NULL;
  if (*field)
    poly_assign(p, &p2);
  if (s == NULL)                                  /* modding out by just t^n; can't be field */
    quoly_set(0, &set_mod_out_Env->num);          /* BEWARE: t and p now meaningless. */
  else if (s->numb && s->next == NULL) {          /* modding out by t^n + number */
    poly_assign(s, &set_mod_out_Env->num->variant.vc_2.numer);
    polynum_to_quoly(&set_mod_out_Env->num);
  } else {
    if (laurent && anynegs(s)) 
      error(168, &token);
    if (t != NULL) {                              /* need to store the modder as a top level poly */
      t->variant.pcoef = NULL;
      free_poly(&set_mod_out_Env->num->variant.vc_2.numer);
      set_mod_out_Env->num->variant.vc_2.numer = p;
    }
  }

  if (*field) {
    if (set_mod_out_Env->q->next != NULL)         /* check for suitability */
      if (!set_mod_out_Env->q->next->field)
        error(266, &token);
    if (field_depth > 0)
      if (field_depth >= *n)                      /* so it's n or n+1 */
        field_depth = *n;
      else
        error(98, &set_mod_out_Env->q->let);
    else
      field_depth = *n;
  } else if (laurent)
    error(271, &token);

  set_mod_out_Env->got_auxes = false;
  if (ustrcmp(token.name, ":") == 0)
    if (*field)
      get_aux_primes(inf, flag, haveaux2, set_mod_out_Env);  /* changes got_auxes */
    else
      error(270, &token);        /* Mar 2001: Hmm... user can't suppress output. */
  else if (*field) 
    compute_aux_primes(&p2, *n, set_mod_out_Env);  /* changes got_auxes */
  if (*field) 
    free_poly(&p2);
}

/***********************************************************************/

static void sparse_update(arrptr ap, set_mod_out_EnvRec *set_mod_out_Env)
{
  long i;
  long j;
  colm_ptrptr u;
  sparseptr sp;
  long forEnd_35;
  long forEnd_36;

  sp = ap->spar;
  forEnd_36 = (ap->rows - 1) / sparsesize;
  for (i = 0; i <= forEnd_36; ++i) {
    forEnd_35 = (i + 1) * sparsesize;
    for (j = 1 + i * sparsesize; j <= forEnd_35; ++j) 
      if (j > ap->rows) 
        break;
      else {
        u = &sp->indx[(j - i * sparsesize) - 1];
        while (*u != NULL) {
          mod_out_quoly(&(*u)->val, &set_mod_out_Env->r, &set_mod_out_Env->alter, 
                        &set_mod_out_Env->muldata, set_mod_out_Env->n, 
                        set_mod_out_Env->expon, set_mod_out_Env->q);
          if (quoly_iszero((*u)->val)) 
            free_colm(u);
          else 
            u = &(*u)->next;
        }
      }
    sp = sp->next;
  }
}

/*******************************************************************/

void set_mod_out(textptr inf, nameptr *flag, Boolean imperative, Boolean highest)
{  /*    can't be in modularmode, or even lintmode.  The first auxiliary list 
     is computed here or is supplied by the user.  It is a list of primes
     w.r.t. the mod-out poly is invertible.  The second auxiliary list is computed 
     here.  It is a list of pairs (y, p), where y is an integer and p is a prime, 
     such that mod p, the mod-out-poly evaluated at y is 0. 
       Feb 2005: allow modularmode! 
       Apr 2005: added highest, saying that the var being modded must be the highest,
     which was just attached a microsecond ago. */
 
  short i;
  long j;
  varptr p;
  Boolean field;
  Boolean haveaux2;
  arrptr ap;
  imptr im;
  set_mod_out_EnvRec set_mod_out_Env;

  if (setjmp(set_mod_out_Env.set_mod_out_exit)) 
    return;
  set_mod_out_Env.imperative = &imperative;
  set_mod_out_Env.flag = flag;
  if (imperative) 
    get_data(inf, flag, &set_mod_out_Env.n, &field, &haveaux2, &set_mod_out_Env);  /* changes num */
  else {
    fprintf(stdout, "Changing polynomial mod out.\n");
    fprintf(stdout, " Enter polynomial:\n");
    ustrcpy(set_mod_out_Env.old_left, leftover);
    do_prompts();
    set_mod_out_Env.old_tt = tt_flag;
    tt_flag = true;
    get_data(&Input, &zilch, &set_mod_out_Env.n, &field, &haveaux2, 
             &set_mod_out_Env);                   /* changes num */
    tt_flag = set_mod_out_Env.old_tt;
    ustrcpy(leftover, set_mod_out_Env.old_left);
  }

  if (highest && set_mod_out_Env.n != 1) /* Apr 2005 */
    error(357, &token);
  
  /* Warning: get_data must do ALL reading from terminal.  
      ???  What the heck is this message?  It's obviously false!! May 1995*/
  
  if (verbose || *flag == NULL) { /* Feb 2005 */
    fprintf(stdout, " Now modding out polynomial variable %s, using \n", set_mod_out_Env.q->let.name);
    fprintf(stdout, "     ");
  }

  if (set_mod_out_Env.num->numb) {
    j = 1;                       /* Mar 2001. use below to suppress large display. */
    if (verbose || *flag == NULL) { /* Feb 2005 */
      fprintf(stdout, "%s^%1d", set_mod_out_Env.q->let.name, set_mod_out_Env.expon);
      if (lintmode) {
				if (set_mod_out_Env.num->variant.vc_1.ncoef->lint != 0)   /* Oct2 2010, old BUG! It CAN be lintmode. */
          if (!alt_form_display || set_mod_out_Env.num->variant.vc_1.ncoef->lint <= modulus/2)
						fprintf(stdout, " + ");
			}
			else
				if (set_mod_out_Env.num->variant.vc_1.ncoef->head->value > 0) 
          fprintf(stdout, " + ");
    }
  } else 
    j = fieldterms(set_mod_out_Env.num);          /* Mar 2001, Jul 2003 */
    
  if (verbose || *flag == NULL) { /* Feb 2005 */
    dummy = 0;
    /* note the q in this call to quoly_display */
    if (!quoly_iszero(set_mod_out_Env.num)) 
      if (j < 200)                                  /* Mar 2001 */
        quoly_display(&Output, true, false, true, set_mod_out_Env.num, 
                      &dummy, &semicolon, set_mod_out_Env.q, false, true, false);
      else 
        fprintf(stdout, " a poly of %0d terms.\n", j);  /* Jul 2003 */
    fprintf(stdout, "\n");
    if (field) {
      fprintf(stdout, "     This creates a field.\n");
      if (set_mod_out_Env.got_auxes) {
        fprintf(stdout, "     auxiliary primes (%1d):\n", aux_prime1_number);
        if (aux_prime1_number == 0)                 /* Sep 2001 */
          fprintf(stdout, " *** no auxiliary primes.  OK, but polygcd might run slowly.");
        else 
          fprintf(stdout, " ");
        for (i = 1; i <= aux_prime1_number; ++i) {
          fprintf(stdout, " %0d", (*auxptr)[i - 1]->head->value);

          if (i % 10 == 0) {
            fprintf(stdout, "\n");
            fprintf(stdout, " ");
          }
        }
        fprintf(stdout, "\n");
      }
    }                                               /* Mar 2001 */
    else 
      fprintf(stdout, " *** Not a field. Be careful dividing! Some things will not work right.\n");
  }

  pseudo_polynames = polynames;
  
  /* Convert format */
  if (set_mod_out_Env.num->numb) {
    quoly_inplace(set_mod_out_Env.num);           /* convert to older t^n = -num format */
    quoly_to_poly(set_mod_out_Env.num, &set_mod_out_Env.r);
    free_quoly(&set_mod_out_Env.num);
  } else {
    set_mod_out_Env.r = set_mod_out_Env.num->variant.vc_2.numer;
    set_mod_out_Env.num->variant.vc_2.numer = NULL;
    set_mod_out_Env.num->next = quolygarb;
    quolygarb = set_mod_out_Env.num;
  }
  set_mod_out_Env.alter = NULL;
  if (set_mod_out_Env.r->numb) {                  /* need ordinary style also */
    base_poly(&set_mod_out_Env.alter, 1);
    set_mod_out_Env.alter->exp = set_mod_out_Env.expon;
    if (!node_iszero(set_mod_out_Env.r))          /*  bug of 23 May 1996 */
      poly_makeneg(set_mod_out_Env.r, &set_mod_out_Env.alter->next);
  }
  
  /*  Set some globals and compute multiplying data.  */
  set_mod_out_Env.q->field = field;      /* must be done now; tricky. field_depth already set. */
  set_mod_out_Env.q->expon = set_mod_out_Env.expon;  /* changed placement, June 1995 */
  /* Now compute the q^.multdata for fast multiplying. */
  make_muldata(&set_mod_out_Env.muldata, &set_mod_out_Env.r, set_mod_out_Env.expon, 
               set_mod_out_Env.q);
  
  /* Compute second auxiliary list to speed up gcd. Placement of this segment
     changed in June 1995. */
  set_mod_out_Env.q->p = set_mod_out_Env.r;       /* Note: might be 0 */
  set_mod_out_Env.q->multdata = set_mod_out_Env.muldata;
  if (set_mod_out_Env.r->numb) 
    set_mod_out_Env.q->alt = set_mod_out_Env.alter;

  if (lintmode) { /* Feb 2005. turn off stuff below*/
    haveaux2 = true;
    set_mod_out_Env.q->aux_num = 0;
  }

  if (!haveaux2)                                  /* May 1998 */
    free_gcd_data(set_mod_out_Env.q);
  if (field) {

    if (!haveaux2) {                              /* May 1998 */
      if (verbose || *flag == NULL)  /* Feb 2005 */
        fprintf(stdout, " Computing secondary auxiliary primes for poly mod out...\n");    
      make_and_reconcile_gcd_lists(set_mod_out_Env.q);
    }
    if (!lintmode) /* Feb 2005 */
      if (verbose || *flag == NULL)  /* Feb 2005 */
        fprintf(stdout, " Number of secondary auxiliary primes for gcd: %d\n", set_mod_out_Env.q->aux_num);
    second_aux_num = set_mod_out_Env.q->aux_num;   /* Mar 2009 */
    if (set_mod_out_Env.q->aux_num < 5) {
      no_aux_primes2 = true;
      if (!lintmode) /* Feb 2005 */
        if (verbose || *flag == NULL) {
          fprintf(stdout, " *** Warning:  This is a small number.  Try restarting Fermat,\n");
          fprintf(stdout, "         then use &A to increase the search factor.  Current\n");
          fprintf(stdout, "         search factor is %1d.\n", aux_num_2factor);
        }
    } else 
      no_aux_primes2 = false;
  }
  
  /* Change all the storage. Note that q^.p, q^.alt, and q^.multdata must be nil
     (yet the aux2 data must be correct and in place, for Armand modular). 
     mod_out_quoly may change them, but must restore them. */
  set_mod_out_Env.q->p = NULL;
  set_mod_out_Env.q->multdata = NULL;
  set_mod_out_Env.q->alt = NULL;
  if (verbose || *flag == NULL) { /* Feb 2005 */
    fprintf(stdout, " Converting variables...\n");
    fflush(stdout);
  }
  
  quoly_set(0, &prevnum);

  if (!highest) { /* Apr 2005 */
   for (i = 0; i <= 150; ++i) {
    p = sca_store[i];
    while (p != NULL) {
      mod_out_quoly(&p->val, &set_mod_out_Env.r, &set_mod_out_Env.alter, 
                    &set_mod_out_Env.muldata, set_mod_out_Env.n, set_mod_out_Env.expon, 
                    set_mod_out_Env.q);           /* r is the modder */
      p = p->next;
    }
   }
  
   for (j = 0; j <= endarr; ++j) 
     if ((*arp[BSR(j, 10)])[BAnd(j, tenmask)] != NULL) 
      mod_out_quoly(&(*arp[BSR(j, 10)])[BAnd(j, tenmask)], &set_mod_out_Env.r, 
                    &set_mod_out_Env.alter, &set_mod_out_Env.muldata, 
                    set_mod_out_Env.n, set_mod_out_Env.expon, set_mod_out_Env.q);
  
   if (syst->spar == NULL) 
     for (j = 0; j <= syst->stop; ++j) 
      mod_out_quoly(&(*stash)[j], &set_mod_out_Env.r, &set_mod_out_Env.alter, 
                    &set_mod_out_Env.muldata, set_mod_out_Env.n, set_mod_out_Env.expon, 
                    set_mod_out_Env.q);
  
   for (i = 0; i <= 150; ++i) {
    ap = arr_store[i];
    while (ap != NULL) {
      if (ap->spar != NULL) 
        sparse_update(ap, &set_mod_out_Env);
      ap = ap->next;
    }
   }
  
   if (syst->spar != NULL) 
     sparse_update(syst, &set_mod_out_Env);
  }
  
  /* Actually effect the change. */
  set_mod_out_Env.q->p = set_mod_out_Env.r;
  if (node_iszero(set_mod_out_Env.r)) 
    set_mod_out_Env.q->polycut = nilpotcut;       /*May 1996*/
  set_mod_out_Env.q->multdata = set_mod_out_Env.muldata;
  if (set_mod_out_Env.r->numb) 
    set_mod_out_Env.q->alt = set_mod_out_Env.alter;
  pseudo_polynames = polynames;     /* a fail safe */

  reset_pseudo_poly();   /* Jul 2004. It's needed! */

  if (verbose || *flag == NULL)   /* Mar 2009 */
    if (field_depth > 0 && number_polys - field_depth > 3)     /* Apr2 2011, remove extra argument */
	    fprintf(stdout, " *** Warning. Many poly vars are in the field. Performance may slow, especially over Z.\n");  
}

/****************************************************************************/

void concaten(quolyptr n, workptr arr2, arr_descr *arr_facts, Boolean arr2_free, Boolean arr_free,
     workptr arr, Boolean first, LongIntPtr rows)
{
  long i;

  if (arr_facts->arrsize.head->value + 1 > arr_limit) {
    if (arr2_free) 
      free_arr(arr2, arr_facts);
    error(111, &concatsign);
  }
  arr_facts->arrsize.head->value++;
  if (arr_facts->rows > 1)
    arr_facts->rows = arr_facts->arrsize.head->value;  /* convert to column vector */
  *rows = arr_facts->rows;
  
  if (first) {                                    /* put n in front */
    for (i = arr_facts->arrsize.head->value - 1; i >= 1; --i)
      (*arr)[i] = (*arr2)[i - 1];
    if (!arr_free)
      (*arr)[0] = NULL;
    quoly_assign(*n, &(*arr)[0]);
  } else {                                        /* put n in back */
    i = arr_facts->arrsize.head->value - 1;
    (*arr)[i] = NULL;
    quoly_assign(*n, &(*arr)[i]);
  }
}

/***************************************************************************/

void concatenate(workptr arr, workptr arr2, arr_descr *arr_facts, arr_descr *arr2_facts, Boolean arr_free,
     Boolean arr2_free, LongIntPtr col, LongIntPtr rows, Boolean *oktofree)
{
  /* wasteful overuse of assign -- should just assign pointers */
  
  long col2;
  long i;
  long increm;
  workptr prod;
  Boolean goof;
  quoly n;
  long forEnd_37;
  long forEnd_38;
  long forEnd_39;
  long forEnd_40;
  long forEnd_41;
  long forEnd_42;
  long forEnd_43;

  if (arr_facts->arrsize.head->value + arr2_facts->arrsize.head->value > arr_limit) {  /*Oct 2000*/
    if (arr_free) 
      free_arr(arr, arr_facts);
    if (arr2_free) 
      free_arr(arr2, arr2_facts);
    error(111, &concatsign);
  }
  
  col2 = quotient_of(&arr2_facts->arrsize, arr2_facts->rows);  /* Oct 2000, below */
  
  if (arr_facts->arrsize.head->value == 1) {
    if (!arr2_free) {
      forEnd_37 = arr2_facts->arrsize.head->value - 1;
      for (i = 0; i <= forEnd_37; ++i) {          /* Oct 2000 */
        n = NULL;
        quoly_assign((*arr2)[i], &n);             /*loop !!*/
        (*arr2)[i] = n;
      }
    }
    n = (*arr)[0];                                /* looks weird, I know */
    concaten(&n, arr2, arr2_facts, true,          /*!!*/
             arr_free, arr, true, rows);
    /*   if arr_free then free_quoly(n);   remove!!*/
    spec_num_assign(&arr2_facts->arrsize, &arr_facts->arrsize);  /* Oct 2000 */
    arr_facts->rows = arr2_facts->rows;
    *oktofree = false;
    return;
  } else if (arr2_facts->arrsize.head->value == 1) {  /* Oct 2000 */
    if (!arr_free) {
      forEnd_38 = arr_facts->arrsize.head->value - 1;
      for (i = 0; i <= forEnd_38; ++i) {
        n = NULL;
        quoly_assign((*arr)[i], &n);              /*loop !!*/
        (*arr)[i] = n;
      }
    }
    concaten(&(*arr2)[0], arr, arr_facts, true,   /*!!*/
             true, arr, false, rows);
    return;
  }
  
  increm = -arr2_facts->rows;
  goof = false;
  new_worknode(&i, &token);
  prod = workhead[i - 1];
  
  if (*col == col2) {
    forEnd_39 = arr_facts->arrsize.head->value - 1;
    for (i = 0; i <= forEnd_39; ++i) {
      if (i % arr_facts->rows == 0) 
        increm += arr2_facts->rows;
      (*prod)[i + increm] = NULL;
      quoly_assign((*arr)[i], &(*prod)[i + increm]);
    }
    increm = 0;
    forEnd_40 = arr2_facts->arrsize.head->value - 1;
    for (i = 0; i <= forEnd_40; ++i) {            /* Oct 2000 */
      if (i % arr2_facts->rows == 0) 
        increm += arr_facts->rows;
      (*prod)[i + increm] = NULL;
      quoly_assign((*arr2)[i], &(*prod)[i + increm]);
    }
    *rows = arr_facts->rows + arr2_facts->rows;
  } else if (arr_facts->rows == arr2_facts->rows) {  /* rows are equal */
    forEnd_41 = arr_facts->arrsize.head->value - 1;
    for (i = 0; i <= forEnd_41; ++i) {
      (*prod)[i] = NULL;
      quoly_assign((*arr)[i], &(*prod)[i]);
    }
    forEnd_42 = arr_facts->arrsize.head->value + arr2_facts->arrsize.head->value - 1;
    for (i = arr_facts->arrsize.head->value; i <= forEnd_42; ++i) {  /* Oct 2000 */
      (*prod)[i] = NULL;
      quoly_assign((*arr2)[i - arr_facts->arrsize.head->value], &(*prod)[i]);
    }
    *rows = arr_facts->rows;
    col2 = *col + col2;
  } else 
    goof = true;
  
  if (arr_free) 
    free_arr(arr, arr_facts);
  if (goof && arr2_free) {
    free_arr(arr2, arr2_facts);
    error(112, &concatsign);
  }
  
  special_set_2(*rows, col2, &arr_facts->arrsize);  /* Oct 2000 */
  arr_facts->rows = *rows;
  forEnd_43 = arr_facts->arrsize.head->value - 1;
  for (i = 0; i <= forEnd_43; ++i)                /* Oct 2000 */
    (*arr)[i] = (*prod)[i];
  
  
  free_work();
}

/******************************************************************************/

struct arr_term_EnvRec {
  sparseptr *spar;
  arr_descr *arr_facts;
  Boolean *arr_free;
  workarray *arr;
  sparseptr spar2;
  arr_descr arr2_facts;                           /* Mar 2004 */
  Boolean arr2_free;
  workptr arr2;
  tokentipe oldtoken;
  Boolean implicit;
  char key;
};
typedef struct arr_term_EnvRec arr_term_EnvRec;

/*****************************************************************/

static void sparse_error(long x, arr_term_EnvRec *arr_term_Env)
{
  if (*arr_term_Env->spar != NULL) 
    free_sparse(arr_term_Env->spar, arr_term_Env->arr_facts->rows, 
                *arr_term_Env->arr_free);
  else if (*arr_term_Env->arr_free) 
    free_arr(arr_term_Env->arr, arr_term_Env->arr_facts);
  if (arr_term_Env->spar2 != NULL) 
    free_sparse(&arr_term_Env->spar2, arr_term_Env->arr2_facts.rows, 
                arr_term_Env->arr2_free);
  else if (arr_term_Env->arr2_free) 
    free_arr(arr_term_Env->arr2, &arr_term_Env->arr2_facts);
  error(x, &arr_term_Env->oldtoken);
}

/***************************************************************************/

static void one_error(sparseptr *sp, workptr ar, Boolean free, arr_descr *facts, long x, arr_term_EnvRec *arr_term_Env)
{
  if (*sp != NULL) 
    free_sparse(sp, facts->rows, free);
  else if (free) 
    free_arr(ar, facts);
  error(x, &arr_term_Env->oldtoken);
}

/**************************************************************************/

static Boolean check_implicit(arr_term_EnvRec *arr_term_Env)  /*@@@*/
{
  arr_term_Env->implicit = arr_term_Env->key >= 'a' && arr_term_Env->key <= 'z' || arr_term_Env->key >= 'A' && arr_term_Env->key <= 'Z';
  return arr_term_Env->implicit;
}

/**************************************************************************/

void arr_term(textptr inf, quolyptr n, workptr arr, arr_descr *arr_facts, Boolean 
             *arr_free, LongIntPtr rows, nameptr *flag, sparseptr *spar, Boolean callfact)
{
  /* Evaluate array term.  Possible space losing problem.  If error occurs during
     second call to arr_fact, the storage of arr will be lost. (maybe fixed, Nov 92,
     with sparse_error and one_error).
        arr_facts is output parameter. Only exception is arr_facts[1] is needed by 
     arr_fact if it finds [1] or [Rand]. 
         Nov 1997:  callfact added. */
  
  quoly n2;
  quoly n3;
  arr_descr first_facts;  /* Mar 2004 */
  long i;
  long col;
  long copy;
  Boolean oktofree;
  Boolean times;
  long forEnd_44;
  long forEnd_45;
  long forEnd_46;
  long forEnd_47;
  long forEnd_48;
  long forEnd_49;
  long forEnd_50;
  long forEnd_51;
  long forEnd_52;
  long forEnd_53;
  long forEnd_54;
  arr_term_EnvRec arr_term_Env;

  arr_term_Env.arr = arr;
  arr_term_Env.arr_free = arr_free;
  arr_term_Env.arr_facts = arr_facts;
  arr_term_Env.spar = spar;
  n2 = NULL;
  arr_term_Env.arr2_facts.arrsize.size = 0;       /* moved Mar 2004 */
  first_facts.arrsize.size = 0;                   /* Mar 2004 */
  spec_num_assign(&arr_facts->arrsize, &arr_term_Env.arr2_facts.arrsize);  
     /* Moved Mar 2004. only needed below by [Rand]. */
  spec_num_assign(&arr_facts->arrsize, &first_facts.arrsize);  /* save a copy. Mar 2004 */
  
  if (callfact) 
    arr_fact(inf, n, arr, arr_facts, arr_free, rows, flag, spar);

  /* special_set(0, arr2_facts.arrsize); comment out, Mar 2004 */
  
  init_gcd_stash();                               /* Dec 2003 */
                                                  /* push onto the stack ~~~~*/
  
  copy = *rows;
  arr_term_Env.key = token.name[0];
  
  while ((PSet_Test(arr_term_ops, sizeof(arr_term_ops)/2, arr_term_Env.key)) || 
          check_implicit(&arr_term_Env)) {  /* Note || in C is always shortcut!  So we must 
                                             recompute implicit below to be sure. Jul 2003 */
    arr_term_Env.implicit = arr_term_Env.key >= 'a' && arr_term_Env.key <= 'z' || 
                     arr_term_Env.key >= 'A' && arr_term_Env.key <= 'Z';
    new_worknode(&i, &token);
    arr_term_Env.arr2 = workhead[i - 1];
    arr_term_Env.oldtoken = token;
    /* implicit set above in while condition @@@*/
    times = arr_term_Env.implicit || arr_term_Env.key == '*';
    if (!arr_term_Env.implicit)                   /*@@@*/
      scanner(inf, &token, flag);
    arr_term_Env.spar2 = NULL;
    
    spec_num_assign(&first_facts.arrsize, &arr_term_Env.arr2_facts.arrsize);
      /* Moved Mar 2004. might be [Rand] or [1] */
    
    arr_fact(inf, &n2, arr_term_Env.arr2, &arr_term_Env.arr2_facts, 
             &arr_term_Env.arr2_free, &copy, flag, &arr_term_Env.spar2);
    
    if (arr_term_Env.arr2_facts.arrsize.head->value == 0 && arr_facts->arrsize.head->value == 0)
      /* @@@ both scalars */
    {
      if (times) 
        fast_quoly_mult(n, &n2);                  /* Dec 2001 */
      else if (ustrcmp(arr_term_Env.oldtoken.name, "/") == 0) 
        fast_quoly_quot(n, &n2, false);           /* Dec 2001 */
      else if (ustrcmp(arr_term_Env.oldtoken.name, "_") == 0) { /* was Ä */
        free_quoly(&n2);
        free_quoly(n);
        error(113, &arr_term_Env.oldtoken);
      } else
        quoly_mod_or_div(*n, n2, n, arr_term_Env.oldtoken.name[0]);
    } else if (arr_facts->arrsize.head->value == 0) {  
    /* first item is a scalar */
      *rows = copy;            /* this is the correct value to pass back (usually) */
      if (times) 
        if (arr_term_Env.spar2 == NULL) {
          forEnd_44 = arr_term_Env.arr2_facts.arrsize.head->value - 1;
          for (i = 0; i <= forEnd_44; ++i) {      /* Oct 2000 */
            (*arr)[i] = NULL;
            quoly_mult((*arr_term_Env.arr2)[i], *n, &(*arr)[i]);
          }
        } else {
          mult_cons_sparse(&arr_term_Env.spar2, *n, arr_term_Env.arr2_free, 
                           *rows);
          *spar = arr_term_Env.spar2;
        }
      else if (ustrcmp(arr_term_Env.oldtoken.name, "/") == 0) 
        if (is_product_of(&arr_term_Env.arr2_facts.arrsize, arr_term_Env.arr2_facts.rows, 
                          arr_term_Env.arr2_facts.rows))   /* matrix inversion */
          if (first_available <= worksize) {
            mat_invert(arr_term_Env.arr2, arr, arr_term_Env.arr2_free, false, arr_term_Env.arr2_facts.rows, n,
                       true, false, &arr_term_Env.spar2, NULL, -1,-1, -1, false, 0);   /* Jan 2008 */
            if (quoly_eq_1(*n))
              *spar = arr_term_Env.spar2;
            else if (arr_term_Env.spar2 == NULL) {
              forEnd_45 = arr_term_Env.arr2_facts.arrsize.head->value - 1;
              for (i = 0; i <= forEnd_45; ++i) 
                fast_quoly_mult(&(*arr)[i], n);   /* Dec 2001 */
            } else {
              mult_cons_sparse(&arr_term_Env.spar2, *n, arr_term_Env.arr2_free, 
                               *rows);
              *spar = arr_term_Env.spar2;
            }
          } else 
            one_error(&arr_term_Env.spar2, arr_term_Env.arr2, arr_term_Env.arr2_free, 
                      &arr_term_Env.arr2_facts, 89, &arr_term_Env);
        else if (arr_term_Env.spar2 == NULL) {
          forEnd_46 = arr_term_Env.arr2_facts.arrsize.head->value - 1;
          for (i = 0; i <= forEnd_46; ++i) {      /* Oct 2000 */
            (*arr)[i] = NULL;
            quoly_quot(*n, (*arr_term_Env.arr2)[i], &(*arr)[i], false);
          }
        } else 
          one_error(&arr_term_Env.spar2, arr_term_Env.arr2, arr_term_Env.arr2_free, 
                    &arr_term_Env.arr2_facts, 242, &arr_term_Env);
      
      else if (ustrcmp(arr_term_Env.oldtoken.name, "_") == 0)  /* Jul 2003 */
        if (arr_term_Env.spar2 == NULL) 
          if (arr_term_Env.arr2_free) 
            concaten(n, arr_term_Env.arr2, &arr_term_Env.arr2_facts, 
                     arr_term_Env.arr2_free, false, arr, true, rows);
          else {
            forEnd_47 = arr_term_Env.arr2_facts.arrsize.head->value - 1;
            for (i = 0; i <= forEnd_47; ++i) {
              (*arr)[i] = NULL;
              quoly_assign((*arr_term_Env.arr2)[i], &(*arr)[i]);
            }
            concaten(n, arr, &arr_term_Env.arr2_facts, true, false, 
                     arr, true, rows);
          }
        else 
          one_error(&arr_term_Env.spar2, arr_term_Env.arr2, arr_term_Env.arr2_free, 
                    &arr_term_Env.arr2_facts, 242, &arr_term_Env);
      
      else if (arr_term_Env.spar2 == NULL) {
        forEnd_48 = arr_term_Env.arr2_facts.arrsize.head->value - 1;
        for (i = 0; i <= forEnd_48; ++i) {
          (*arr)[i] = NULL;
          quoly_mod_or_div(*n, (*arr_term_Env.arr2)[i], &(*arr)[i], 
                           arr_term_Env.oldtoken.name[0]);
        }
      } else 
        one_error(&arr_term_Env.spar2, arr_term_Env.arr2, arr_term_Env.arr2_free, 
                  &arr_term_Env.arr2_facts, 242, &arr_term_Env);
      
      spec_num_assign(&arr_term_Env.arr2_facts.arrsize, &arr_facts->arrsize);  /* Oct 2000 */
      arr_facts->rows = arr_term_Env.arr2_facts.rows;  /* BUG of Jun 2001 */
      if (arr_term_Env.arr2_free && ustrcmp(arr_term_Env.oldtoken.name, "_") != 0 &&
         arr_term_Env.spar2 == NULL)
        free_arr(arr_term_Env.arr2, &arr_term_Env.arr2_facts);
    }
    
    /* first item is a scalar */
    
    else if (arr_term_Env.arr2_facts.arrsize.head->value == 0)   
    /* second is scalar */
      if (*arr_free) 
        if (times) 
          if (*spar == NULL) {
            forEnd_49 = arr_facts->arrsize.head->value - 1;
            for (i = 0; i <= forEnd_49; ++i) 
              fast_quoly_mult(&(*arr)[i], &n2);   /* Dec 2001 */
          } else 
            mult_cons_sparse(spar, n2, true, *rows);
        else if (ustrcmp(arr_term_Env.oldtoken.name, "/") == 0) 
          if (*spar == NULL) {
            forEnd_50 = arr_facts->arrsize.head->value - 1;
            for (i = 0; i <= forEnd_50; ++i) 
              fast_quoly_quot(&(*arr)[i], &n2, false);  /* Dec 2001 */
          } else {
            quoly_reciprocal(&n2);
            mult_cons_sparse(spar, n2, true, *rows);
          }
        else if (ustrcmp(arr_term_Env.oldtoken.name, "_") == 0) 
          if (*spar == NULL) 
            concaten(&n2, arr, arr_facts, true, true, arr, false, rows);
          else 
            one_error(spar, arr, *arr_free, arr_facts, 242, &arr_term_Env);
        else if (*spar == NULL) {
          forEnd_51 = arr_facts->arrsize.head->value - 1;
          for (i = 0; i <= forEnd_51; ++i) 
            quoly_mod_or_div((*arr)[i], n2, &(*arr)[i], arr_term_Env.oldtoken.name[0]);
        } else 
          sparse_mod_or_div(spar, n2, *rows, true, arr_term_Env.oldtoken.name[0]);
      else if (ustrcmp(arr_term_Env.oldtoken.name, "_") == 0) 
        if (*spar == NULL) {
          forEnd_52 = arr_facts->arrsize.head->value - 1;
          /* must duplicate stuff in arr */
          for (i = 0; i <= forEnd_52; ++i) {
            n3 = NULL;
            quoly_assign((*arr)[i], &n3);
            (*arr)[i] = n3;
          }
          concaten(&n2, arr, arr_facts, true,     /*!!*/
                   false, arr, false, rows);
        } else 
          one_error(spar, arr, *arr_free, arr_facts, 242, &arr_term_Env);
      else if (*spar == NULL) {
        forEnd_53 = arr_facts->arrsize.head->value - 1;
        for (i = 0; i <= forEnd_53; ++i) {
          n3 = NULL;
          if (times) 
            quoly_mult((*arr)[i], n2, &n3);
          else if (ustrcmp(arr_term_Env.oldtoken.name, "/") == 0) 
            quoly_quot((*arr)[i], n2, &n3, false);
          else 
            quoly_mod_or_div((*arr)[i], n2, &n3, arr_term_Env.oldtoken.name[0]);
          (*arr)[i] = n3;
        }
      } else if (times) 
        mult_cons_sparse(spar, n2, false, *rows);
      else if (ustrcmp(arr_term_Env.oldtoken.name, "/") == 0) {
        quoly_reciprocal(&n2);
        mult_cons_sparse(spar, n2, false, *rows);
      } else if (ustrcmp(arr_term_Env.oldtoken.name, "_") == 0) 
        one_error(spar, arr, *arr_free, arr_facts, 242, &arr_term_Env);
      else 
        sparse_mod_or_div(spar, n2, *rows, false, arr_term_Env.oldtoken.name[0]);
    
    else {  
    /* both arrays */
      oktofree = true;
      col = quotient_of(&arr_facts->arrsize, arr_facts->rows);  /* Oct 2000 */
      
      if (ustrcmp(arr_term_Env.oldtoken.name, "_") == 0)   /* was Ä */
        if (*spar == NULL && arr_term_Env.spar2 == NULL) 
          concatenate(arr, arr_term_Env.arr2, arr_facts, &arr_term_Env.arr2_facts, 
                      *arr_free, arr_term_Env.arr2_free, &col, rows, &oktofree);
        else 
          sparse_error(242, &arr_term_Env);
          
      else if (times && col == arr_term_Env.arr2_facts.rows) 
        matrix_mult(arr, arr_term_Env.arr2, arr_facts, &arr_term_Env.arr2_facts, 
                    *arr_free, spar, &arr_term_Env.spar2);
                    
      else if (col == arr_term_Env.arr2_facts.rows && 
               is_product_of(&arr_term_Env.arr2_facts.arrsize, col, col) && 
               ustrcmp(arr_term_Env.oldtoken.name, "/") == 0) {
        quoly_set(1, n);
        if (first_available <= worksize) {
          mat_invert(arr_term_Env.arr2, arr_term_Env.arr2, arr_term_Env.arr2_free, arr_term_Env.arr2_free, col, 
		             n, true, true, &arr_term_Env.spar2, NULL, -1,-1, -1, false, 0);   /* Jan 2008 */
          arr_term_Env.arr2_free = true;
        } else 
          error(89, &quotsign);
        matrix_mult(arr, arr_term_Env.arr2, arr_facts, &arr_term_Env.arr2_facts, 
                    *arr_free, spar, &arr_term_Env.spar2);
      } else if (!(spec_equal(&arr_facts->arrsize, &arr_term_Env.arr2_facts.arrsize) &&
                 arr_facts->rows == arr_term_Env.arr2_facts.rows))
        sparse_error(39, &arr_term_Env);
      else if (*spar == NULL && arr_term_Env.spar2 == NULL) {
        forEnd_54 = arr_facts->arrsize.head->value - 1;
        for (i = 0; i <= forEnd_54; ++i) {
          n3 = NULL;
          if (times) 
            quoly_mult((*arr)[i], (*arr_term_Env.arr2)[i], &n3);
          else if (ustrcmp(arr_term_Env.oldtoken.name, "/") == 0) 
            quoly_quot((*arr)[i], (*arr_term_Env.arr2)[i], &n3, false);
          else 
            quoly_mod_or_div((*arr)[i], (*arr_term_Env.arr2)[i], &n3, 
                             arr_term_Env.oldtoken.name[0]);
          if (*arr_free) 
            free_quoly(&(*arr)[i]);
          (*arr)[i] = n3;
        }
      } else 
        sparse_error(191, &arr_term_Env);         /*@@@*/
      
      if (oktofree && arr_term_Env.arr2_free) 
        if (arr_term_Env.spar2 == NULL) 
          free_arr(arr_term_Env.arr2, &arr_term_Env.arr2_facts);
        else 
          free_sparse(&arr_term_Env.spar2, arr_term_Env.arr2_facts.rows, 
                      true);
    }
    
    free_work();
    arr_term_Env.key = token.name[0];
    *arr_free = true;
  }

  special_free(&arr_term_Env.arr2_facts.arrsize);  /* Oct 2000 */
  special_free(&first_facts.arrsize);    /* Memory Leak! Fixed Sep 2010 */
  pop_gcd_stash();
  free_quoly(&n2);
}

/***************************************************************************/

struct arr_expre_EnvRec {
  arr_descr *arr_facts;
  arr_descr arr2_facts;                           /* Mar 2004 */
  sparseptr *spar;
  sparseptr spar2;
};
typedef struct arr_expre_EnvRec arr_expre_EnvRec;

/****************************************************************************/

static Boolean nomatch(arr_expre_EnvRec *arr_expre_Env)
{
  Boolean first;
  Boolean value_nomatch;

  first = !spec_equal(&arr_expre_Env->arr_facts->arrsize, &arr_expre_Env->arr2_facts.arrsize);  /* Oct 2000 */
  if (*arr_expre_Env->spar != NULL || arr_expre_Env->spar2 != NULL) 
    value_nomatch = first || arr_expre_Env->arr_facts->rows != arr_expre_Env->arr2_facts.rows;
  else 
    value_nomatch = first;
  return value_nomatch;
}

/*******************************************************************************/

void arr_expre(textptr inf, quolyptr n, workptr arr, arr_descr *arr_facts, Boolean *arr_free, LongIntPtr
               rows, nameptr *flag, sparseptr *spar, Boolean callterm)
{
  /* evaluate array expression.  Possible space losing problem.  If error occurs
     during second call to arr_term, the storage of arr will be lost. 
        Concerning spar and spar2: if you create it, you nil it.
        arr_facts is output parameter. Only exception is arr_facts[1] is needed by 
     arr_fact if it finds [1] or [Rand]. 
     
       Nov 1997: callterm says if we need to get all of the first term here. */
  
  quoly n2;
  quoly n3;
  workptr arr2;
  arr_descr first_facts;  /* Mar 2004 */
  Boolean arr2_free;
  Boolean plus;
  tokentipe oldtoken;
  long i;
  long forEnd_55;
  long forEnd_56;
  long forEnd_57;
  long forEnd_58;
  long forEnd_59;
  long forEnd_60;
  long forEnd_61;
  long forEnd_62;
  long forEnd_63;
  long forEnd_64;
  long forEnd_65;
  long forEnd_66;
  long forEnd_67;
  long forEnd_68;
  long forEnd_69;
  long forEnd_70;
  long forEnd_71;
  long forEnd_72;
  arr_expre_EnvRec arr_expre_Env;

  arr_expre_Env.spar = spar;
  arr_expre_Env.arr_facts = arr_facts;
  cancelflag = true;
  
  if (!callterm)                          /* Nov 1997. part of (arr, spar) already set. */
    switch (token.name[0]) { 
      case '^':
      case '#':
        half_arr_fact(inf, n, arr, arr_facts, arr_free, rows, flag, spar);
        break;
      default:
        /* nothing */
        break;
    }
  
  arr_expre_Env.arr2_facts.arrsize.size = 0;      /* Oct 2000 */
  first_facts.arrsize.size = 0;                   /* Mar 2004. in case of later [Rand] or [1] */
  spec_num_assign(&arr_facts->arrsize, &first_facts.arrsize);  /* save a copy. Mar 2004 */
  spec_num_assign(&arr_facts->arrsize, &arr_expre_Env.arr2_facts.arrsize);  /* moved Mar 2004 */
  /* call to arr_term below needs this if second argument is [Rand]. */
  
  arr_term(inf, n, arr, arr_facts, arr_free, rows, flag, spar, callterm);
  /* arr_facts may now have changed. */
  
  n2 = NULL;
  arr2 = NULL;
  
  while (ustrcmp(token.name, "+") == 0 || ustrcmp(token.name, "-") == 0) {
    oldtoken = token;
    plus = ustrcmp(oldtoken.name, "+") == 0;
    scanner(inf, &token, flag);
    if (arr2 == NULL) {
      new_worknode(&i, &token);
      arr2 = workhead[i - 1];
    }
    arr_expre_Env.spar2 = NULL;
    
    spec_num_assign(&first_facts.arrsize, &arr_expre_Env.arr2_facts.arrsize);  
      /* Mar 2004. might get [Rand] or [1] */
    
    arr_term(inf, &n2, arr2, &arr_expre_Env.arr2_facts, &arr2_free, 
             rows, flag, &arr_expre_Env.spar2, true);
    
    if (arr_expre_Env.arr2_facts.arrsize.head->value == 0 && arr_facts->arrsize.head->value == 0)
      /* both scalars */
    {
      if (plus) 
        best_quoly_add(n, n2);
      else 
        best_quoly_sub(n, n2);
      n2 = NULL;
    } else if (arr_facts->arrsize.head->value == 0)   /* first is scalar */
      if (arr_expre_Env.spar2 == NULL) {
        if (plus) {
          forEnd_55 = arr_expre_Env.arr2_facts.arrsize.head->value - 1;
          for (i = 0; i <= forEnd_55; ++i) {
            (*arr)[i] = NULL;
            if (arr2_free) 
              better_quoly_add((*arr2)[i], *n, &(*arr)[i]);
            else 
              quoly_add((*arr2)[i], *n, &(*arr)[i]);
          }
        } else {
          forEnd_56 = arr_expre_Env.arr2_facts.arrsize.head->value - 1;
          for (i = 0; i <= forEnd_56; ++i) {
            (*arr)[i] = NULL;
            quoly_sub(*n, (*arr2)[i], &(*arr)[i]);
            if (arr2_free) 
              free_quoly(&(*arr2)[i]);
          }
        }
        spec_num_assign(&arr_expre_Env.arr2_facts.arrsize, &arr_facts->arrsize);  /* Oct 2000 */
        arr_facts->rows = arr_expre_Env.arr2_facts.rows;
        free_quoly(&n2);
        special_set(0, &arr_expre_Env.arr2_facts.arrsize);
      } else {
        if (arr_expre_Env.arr2_facts.arrsize.head->value > arr_limit)   /* BUG, Oct 2000 */
          error(250, &token);
        forEnd_57 = arr_expre_Env.arr2_facts.arrsize.head->value - 1;
        for (i = 0; i <= forEnd_57; ++i) {
          (*arr)[i] = NULL;
          quoly_assign(*n, &(*arr)[i]);
        }
        spec_num_assign(&arr_expre_Env.arr2_facts.arrsize, &arr_facts->arrsize);  /* Oct 2000 */
        arr_facts->rows = arr_expre_Env.arr2_facts.rows;
        free_quoly(&n2);
        special_set(0, &arr_expre_Env.arr2_facts.arrsize);
        add_one_sparse(arr, arr_facts, arr2_free, arr_expre_Env.spar2, 
                       plus);
      }
    else if (arr_expre_Env.arr2_facts.arrsize.head->value == 0)   /* second is scalar */
      if (*spar == NULL) {
        if (*arr_free) 
          if (plus) {
            forEnd_58 = arr_facts->arrsize.head->value - 1;
            for (i = 0; i <= forEnd_58; ++i) 
              better_quoly_add((*arr)[i], n2, &(*arr)[i]);
          } else {
            forEnd_59 = arr_facts->arrsize.head->value - 1;
            for (i = 0; i <= forEnd_59; ++i) 
              better_quoly_sub((*arr)[i], n2, &(*arr)[i]);
          }
        else {
          forEnd_60 = arr_facts->arrsize.head->value - 1;
          for (i = 0; i <= forEnd_60; ++i) {
            n3 = NULL;
            if (plus) 
              quoly_add((*arr)[i], n2, &n3);
            else 
              quoly_sub((*arr)[i], n2, &n3);
            (*arr)[i] = n3;
          }
        }
        free_quoly(&n2);
      } else {
        if (arr_facts->arrsize.size > 1)          /* Oct 2000, and below */
          error(250, &token);
        if (arr_facts->arrsize.head->value > arr_limit) 
          error(250, &token);
        if (!plus) 
          quoly_inplace(n2);
        forEnd_61 = arr_facts->arrsize.head->value - 1;
        for (i = 0; i <= forEnd_61; ++i) {
          (*arr)[i] = NULL;
          quoly_assign(n2, &(*arr)[i]);
        }
        free_quoly(&n2);
        add_one_sparse(arr, arr_facts, *arr_free, *spar, true);
        *spar = NULL;
      }
    
    else {                                        /* both arrays */
           
      if (nomatch(&arr_expre_Env)) {
        if (*arr_free) 
          if (*spar == NULL) 
            free_arr(arr, arr_facts);
          else 
            free_sparse(spar, arr_facts->rows, true);
        if (arr2_free) 
          if (arr_expre_Env.spar2 == NULL) 
            free_arr(arr2, &arr_expre_Env.arr2_facts);
          else 
            free_sparse(&arr_expre_Env.spar2, arr_expre_Env.arr2_facts.rows, 
                        true);
        free_quoly(&n2);
        error(39, &oldtoken);
      }
      
      if (*spar != NULL && arr_expre_Env.spar2 != NULL) 
        add_sparses(spar, &arr_expre_Env.spar2, *arr_free, arr2_free, 
                    arr_facts->rows, plus);
      else if (*spar != NULL) {                   /* harder than it first seems! */
        if (plus) {
          if (arr2_free) {
            forEnd_62 = arr_facts->arrsize.head->value - 1;
            for (i = 0; i <= forEnd_62; ++i) 
              (*arr)[i] = (*arr2)[i];
          } else {
            forEnd_63 = arr_facts->arrsize.head->value - 1;
            for (i = 0; i <= forEnd_63; ++i) {
              (*arr)[i] = NULL;
              quoly_assign((*arr2)[i], &(*arr)[i]);
            }
          }
          add_one_sparse(arr, arr_facts, *arr_free, *spar, true);
        } else if (arr2_free) {
          forEnd_64 = arr_facts->arrsize.head->value - 1;
          for (i = 0; i <= forEnd_64; ++i) 
            quoly_inplace((*arr2)[i]);
          add_one_sparse(arr2, arr_facts, *arr_free, *spar, true);
          forEnd_65 = arr_facts->arrsize.head->value - 1;
          for (i = 0; i <= forEnd_65; ++i) 
            (*arr)[i] = (*arr2)[i];
        } else {
          forEnd_66 = arr_facts->arrsize.head->value - 1;
          for (i = 0; i <= forEnd_66; ++i) {
            (*arr)[i] = NULL;
            quoly_makeneg((*arr2)[i], &(*arr)[i]);
          }
          add_one_sparse(arr, arr_facts, *arr_free, *spar, true);
        }
        *spar = NULL;
      } else if (arr_expre_Env.spar2 != NULL)     /* also subtle! */
        if (*arr_free) 
          add_one_sparse(arr, arr_facts, arr2_free, arr_expre_Env.spar2, 
                         plus);
        else {
          n2 = NULL;
          forEnd_67 = arr_facts->arrsize.head->value - 1;

          for (i = 0; i <= forEnd_67; ++i) {
            quoly_assign((*arr)[i], &n2);
            (*arr)[i] = n2;
            n2 = NULL;
          }
          add_one_sparse(arr, arr_facts, arr2_free, arr_expre_Env.spar2, 
                         plus);
        }
      else if (*arr_free && arr2_free) 
        if (plus) {
          forEnd_68 = arr_facts->arrsize.head->value - 1;
          for (i = 0; i <= forEnd_68; ++i) 
            best_quoly_add(&(*arr)[i], (*arr2)[i]);
        } else {
          forEnd_69 = arr_facts->arrsize.head->value - 1;
          for (i = 0; i <= forEnd_69; ++i) 
            best_quoly_sub(&(*arr)[i], (*arr2)[i]);
        }
      else if (*arr_free) 
        if (plus) {
          forEnd_70 = arr_facts->arrsize.head->value - 1;
          for (i = 0; i <= forEnd_70; ++i) 
            better_quoly_add((*arr)[i], (*arr2)[i], &(*arr)[i]);
        } else {
          forEnd_71 = arr_facts->arrsize.head->value - 1;
          for (i = 0; i <= forEnd_71; ++i) 
            better_quoly_sub((*arr)[i], (*arr2)[i], &(*arr)[i]);
        }
      else {
        forEnd_72 = arr_facts->arrsize.head->value - 1;
        for (i = 0; i <= forEnd_72; ++i) {
          n3 = NULL;
          if (plus) 
            quoly_add((*arr)[i], (*arr2)[i], &n3);
          else 
            quoly_sub((*arr)[i], (*arr2)[i], &n3);
          (*arr)[i] = n3;
          if (arr2_free) 
            free_quoly(&(*arr2)[i]);
        }
      }
      
      special_set(0, &arr_expre_Env.arr2_facts.arrsize); /* Oct 2000. Mar 2004: probably pointless */
      free_quoly(&n2);
    }
    
    *arr_free = true;
  }

  special_free(&arr_expre_Env.arr2_facts.arrsize);  /* Oct 2000 */
  special_free(&first_facts.arrsize);  /* Memory Leak! Fixed Sep 2010 */
  cancelflag = false;
  if (arr2 != NULL) 
    
    free_work();
}

/***********************************************************************

  procedure statement(var inf: text; var n: quoly; var flag: nameptr);

    Nov 1997.  obsolete.

  ******************************************************************************/

void create_array(textptr inf, quolyptr n, nameptr *flag)
{
  /* Nov 1997 */
  
  tokentipe oldtoken;
  Boolean colflag;
  long rows;
  long cols;

  do {                                            /* Sep 2000 */
    scanner(inf, &token, flag);
    if (token.name[0] < 'a' || token.name[0] > 'z') 
      error(40, &token);
    if (its_a_polyname(&token.name))               /* Apr 1998 */
      error(125, &token);
    oldtoken = token;
    scanner(inf, &token, flag);
    if (ustrcmp(token.name, "[") != 0) 
      error(178, &token);
    scanner(inf, &token, flag);
    if (integerflag) 
      ievalcoords(&rows, &cols, flag, &colflag);
    else 
      evalcoords(inf, &rows, &cols, flag, ']', ',', &colflag, true);
    scanner(inf, &token, flag);
    if (!colflag)                                 /* a linear array  */
      cols = 1;                                   /* may have been addresser = 0 */
    if (ustrcmp(token.name, "Sparse") == 0) {
      scanner(inf, &token, flag);
      sparse_create(&oldtoken, rows, cols, !colflag, true);
    } else 
      insertarr(&oldtoken, rows, cols, !colflag);
    new_array = true;                             /* Jul 2002 */
  } while (token.name[0] == ',');
  
  quoly_set(0, n);
}

/****************************************************************************/

Boolean evalcond(textptr inf, nameptr *p)
{
  quoly n1;
  quoly n2;
  tokentipe sign;
  long num1;
  long num2;
  Boolean first_ok;
  Boolean sec_ok;
  imptr im1;
  imptr im2;
  Boolean value_evalcond;

  n1 = NULL;
  if (integerflag) 
    old_iexpre(&num1, p);                         /* Nov 1997 */
  else 
    old_expre(inf, &n1, p);
  
  /* sign = token;  Jul 2003, see below */
  memcpy(sign.name, token.name, sizeof(nametype));  
  
  if (!(PSet_Test(cond_set, sizeof(cond_set)/2, sign.name[0])))  /* Oct 1999; two char symbols */
    if (ustrcmp(sign.name, "]") == 0 || ustrcmp(sign.name, "or") == 0 || 
        ustrcmp(sign.name, "¥") == 0 || ustrcmp(sign.name, "and") == 0) 
    {  
      if (integerflag) 
        value_evalcond = num1 == 1;
      else 
      {
        if (n1->numb) 
          if (lintmode) 
            value_evalcond = n1->variant.vc_1.ncoef->lint == 1;  /* was 1.0 (!) Jul 2003 */
          else 
            value_evalcond = n1->variant.vc_1.ncoef->head->value == 1 &&
	        n1->variant.vc_1.ncoef->size == 1;
        else 
          value_evalcond = false;
        free_quoly(&n1);
      }
      return value_evalcond;
    } else 
      error(13, &sign);
  
  n2 = NULL;
  scanner(inf, &token, p);
  if (sign.name[0] == '<')                        /* Oct 1999; double length signs */
    if (token.name[0] == '=') 
    {
      ustrcpy(sign.name, " ");  
      sign.name[0] = 178;
      scanner(inf, &token, p);
    } else if (token.name[0] == '>') 
    {
      ustrcpy(sign.name, " ");  
      sign.name[0] = 173;
      scanner(inf, &token, p);
    } else                                        /* nothing */
      ;
  else if (sign.name[0] == '>') 
    if (ustrcmp(token.name, "=") == 0) 
    {
      ustrcpy(sign.name, " ");  
      sign.name[0] = 179;
      scanner(inf, &token, p);
    }
    
  if (integerflag) 
    old_iexpre(&num2, p);                         /* Nov 1997 */
  else 
    old_expre(inf, &n2, p);
    
  if (!integerflag) 
  {
    if (n1->numb) 
      first_ok = true;
    else if (lintmode) 
      first_ok = false;
    else 
      first_ok = n1->variant.vc_2.rat;
    if (n2->numb) 
      sec_ok = true;
    else if (lintmode) 
      sec_ok = false;
    else 
      sec_ok = n2->variant.vc_2.rat;
    if (!(sign.name[0] == '=' || sign.name[0] == 173) && !(first_ok && sec_ok)) 
      error(123, &sign);
  }
  
  if (integerflag) 
    switch (sign.name[0]) 
    { 
      case '=':
        value_evalcond = num1 == num2;
        break;
      case 173:
        value_evalcond = num1 != num2;
        break;
      case '>':
        value_evalcond = num1 > num2;
        break;
      case '<':
        value_evalcond = num1 < num2;
        break;
      case 179:
        value_evalcond = num1 >= num2;
        break;
      case 178:
        value_evalcond = num1 <= num2;
        break;
    }
  else 
  
 { if (sign.name[0] == '=')
          value_evalcond = quoly_equal(n1, n2);
          
  else if (sign.name[0] == 173)
           value_evalcond = !quoly_equal(n1, n2);
 
  else 
  {   if (n1->numb && n2->numb) 
      {
        im1 = n1->variant.vc_1.ncoef;
        im2 = n2->variant.vc_1.ncoef;
        first_ok = false;
        sec_ok = false;
      }                                           /* For rest of cases, must be in rat mode */
      else 
      {                                      /* else wouldn't be here. */
        newimag(&im1);
        im1->size = 0;
        if (n1->numb) 
        {
          fast_mult(n1->variant.vc_1.ncoef, n2->variant.vc_2.denom->variant.ncoef, 
                    im1);
          im2 = n2->variant.vc_2.numer->variant.ncoef;
          first_ok = true;
          sec_ok = false;
        } else if (n2->numb) 
        {
          fast_mult(n2->variant.vc_1.ncoef, n1->variant.vc_2.denom->variant.ncoef, 
                    im1);
          im2 = im1;
          im1 = n1->variant.vc_2.numer->variant.ncoef;
          first_ok = false;
          sec_ok = true;
        } else 
        {
          newimag(&im2);
          im2->size = 0;
          first_ok = true;
          sec_ok = true;
          fast_mult(n1->variant.vc_2.numer->variant.ncoef, n2->variant.vc_2.denom->variant.ncoef, 
                    im1);
          fast_mult(n1->variant.vc_2.denom->variant.ncoef, n2->variant.vc_2.numer->variant.ncoef, 
                    im2);
        }
      }
      
      switch (sign.name[0]) 
      { 
        case '>':
          value_evalcond = bigger(im1, im2);
          break;
        case '<':
          value_evalcond = bigger(im2, im1);
          break;
        case 179:
          value_evalcond = bigger(im1, im2) || equal(im1, im2);
          break;
        case 178:
          value_evalcond = bigger(im2, im1) || equal(im1, im2);
          break;
      }
      
      if (first_ok) 
        free_imag(&im1);
      if (sec_ok) 
        free_imag(&im2);
        
   }
 
    free_quoly(&n1);
    free_quoly(&n2);
 }
  
  return value_evalcond;
}

/****************************************************************************/

/* Set qp to point to the right quoly.  If array is sparse and the spot r, c
   is zero, set qp to nil. */

/*spar. many changes here; almost all new procedure */

void lookup(tokentipe *x, long r, long c, arrptr *q, quolyptr *qp, Boolean colflag)
{
  array_seek(x, q);
  array_quoly_ptr(*q, r, c, colflag, qp, x, false);
}

/****************************************************************************/

void spec_lookup(tokentipe *x, long spot, arrptr *q, quolyptr *qp)
{
  /* Set qp to point to the right quoly.  Use spot to linearly access.  If array is
     sparse and the spot is zero, set qp to nil. Used for compiled references. */
  
  long r;
  long c;
  long i;
  colm_ptr t;
  sparseptr sp;
  long forEnd_73;

  if (spot < addresser) 
    error(27, x);
  array_seek(x, q);
  if ((*q)->spar == NULL) {
    spot = (*q)->start - addresser + spot;
    if (spot < (*q)->start || spot > (*q)->stop) 
      error(27, x);
    *qp = &(*arp[BSR(spot, 10)])[BAnd(spot, tenmask)];
  } else {
    /* convert to row, col indexing */
    c = 1 + (spot - addresser) / ((*q)->rows);
    r = 1 + (spot - addresser) % (*q)->rows;
    if ((*q)->sizearr.size > 1)
      /* no problem! Oct 2000. manual will say spot < 2^28. */
      ;
    else if (spot > (*q)->sizearr.head->value - 1 + addresser) 
      error(27, &token);
    sp = (*q)->spar;
    forEnd_73 = (r - 1) / sparsesize;
    for (i = 1; i <= forEnd_73; ++i) 
      sp = sp->next;
    t = sp->indx[1 + (r - 1) % sparsesize - 1];
    while (t != NULL) 
      if (t->coord == c) 
        break;
      else 
        t = t->next;
    if (t == NULL) 
      sparse_set(r + addresser - 1, c + addresser - 1, *q, qp, false);
    /* the above will now be an error, caught in compile. Dec 1997 */
    else 
      *qp = &t->val;
  }
}

/****************************************************************************/

struct do_this_level_EnvRec {
  long order;
  workptr beta;
};
typedef struct do_this_level_EnvRec do_this_level_EnvRec;

/************************************************************************/

static long subfield(polypt qt)
{
  /* qt <> nil */
  long subb;

  subb = 1;
  qt = qt->next;
  while (qt != NULL) {
    subb *= qt->expon;
    qt = qt->next;
  }
  return subb;
}

/************************************************************************/

static void basis(polyptrr q, long i, polypt qt)
{
  /* Compute the i^th basis in the list 0..m-1 of basis elements, where m
     is the order of the field from this level (qt) on down.  i = 0 means
     the first one, etc.
       qt <> nil. q is nil on entry.
       For example, if this (qt^) poly var is u and t is the only lower var,
     the list would be 1,t,t^2,...t^(n-1), u, ut, ut^2,... . */
  
  long n;
  long m;
  poly s;

  s = NULL;
  n = subfield(qt);
  if (qt->next == NULL) 
    poly_set(1, &s);
  else 
    basis(&s, i % n, qt->next);
  m = i / n;
  if (m == 0 && s->numb) 
    *q = s;
  else {
    newpoly(q);  /*AAR???*/
    (*q)->exp = m;
    (*q)->next = NULL;
    (*q)->numb = false;
    (*q)->variant.pcoef = s;
  }
}

/*********************************************************************/

static void dump_coeffs(poly q, long col, long startrow, polypt qt, do_this_level_EnvRec *do_this_level_Env)
{
  /* Extract the numerical coefficients of q and put them in column col
     (unnormalized) of beta, starting at row startrow (normalized to 0).  
     qt <> nil. */
  
  long i;
  long nextsize;
  long n;
  long startpos;
  Boolean nextnil;
  polypt nqt;
  long forEnd_74;

  nqt = qt->next;
  nextnil = nqt == NULL;
  if (!nextnil) 
    nextsize = subfield(qt);
  startpos = (col - 1) * do_this_level_Env->order + startrow;
  for (i = qt->expon - 1; i >= 0; --i) 
    if (q->exp == i) {
      if (nextnil) {
        (*do_this_level_Env->beta)[startpos + i] = NULL;
        if (q->numb) 
          n = q->variant.ncoef->lint;
        else 
          n = q->variant.pcoef->variant.ncoef->lint;
        quoly_set(n, &(*do_this_level_Env->beta)[startpos + i]);
      } else if (q->numb) 
        dump_coeffs(q, col, startrow + i * nextsize, nqt, do_this_level_Env);
      else 
        dump_coeffs(q->variant.pcoef, col, startrow + i * nextsize, 
                    nqt, do_this_level_Env);
      q = q->next;
    } else if (nextnil) {
      (*do_this_level_Env->beta)[startpos + i] = NULL;
      quoly_set(0, &(*do_this_level_Env->beta)[startpos + i]);
    } else {
      forEnd_74 = startpos + (i + 1) * nextsize - 1;
      for (n = startpos + i * nextsize; n <= forEnd_74; ++n) {
        (*do_this_level_Env->beta)[n] = NULL;
        quoly_set(0, &(*do_this_level_Env->beta)[n]);
      }
    }
}

/*********************************************************************/

static void mult_out(polyptrr s, long col, long startrow, polypt qt, do_this_level_EnvRec *do_this_level_Env)
{
  
  /* the inverse of dump_coeffs. s nil or irrelevant on entry. s = 0 is 
     signalled on output by s = nil.  qt <> nil. */
  
  long i;
  long incr;
  long n;
  long startpos;
  Boolean nextnil;
  polypt nqt;
  polyptrr ps;
  poly t;

  nqt = qt->next;
  nextnil = nqt == NULL;
  if (nextnil) 
    startpos = (col - 1) * do_this_level_Env->order + startrow;
  else 
    incr = subfield(qt);
  ps = s;
  for (i = qt->expon - 1; i >= 0; --i) 
    if (nextnil) 
      if (!quoly_iszero((*do_this_level_Env->beta)[startpos + i])) {
        n = (*do_this_level_Env->beta)[startpos + i]->variant.vc_1.ncoef->lint;
        newpoly(ps);
        (*ps)->exp = i;
        (*ps)->numb = i == 0;
        if (i == 0) {
          init_poly_node(*ps);
          (*ps)->variant.ncoef->lint = n;
        } else {
          (*ps)->variant.pcoef = NULL;
          poly_set(n, &(*ps)->variant.pcoef);
        }
        ps = &(*ps)->next;
      } else                                      /* nothing */
        ;
    else {
      mult_out(&t, col, startrow + i * incr, nqt, do_this_level_Env);
      if (t != NULL) {
        if (i == 0 && t->numb) 
          *ps = t;
        else {
          newpoly(ps);
          (*ps)->exp = i;
          (*ps)->numb = false;
          (*ps)->variant.pcoef = t;
        }
        t = NULL;                                 /* probably not necessary */
        ps = &(*ps)->next;
      }
    }
  
  *ps = NULL;
}

/**********************************************************************/

static void do_this_level(polypt qt)
{
  /* if qt^.next <> nil, the roots already exist there. */
  
  long i;
  long j;
  long suborder;
  polypt tt;
  poly q;
  poly s;
  quoly dumq;
  sparseptr dumsp;
  arr_descr arr_facts;
  long forEnd_75;
  do_this_level_EnvRec do_this_level_Env;

  new_worknode(&i, &token);
  do_this_level_Env.beta = workhead[i - 1];
  
  free_poly(&qt->roots);
  
  /* Compute the order of the field from here down, and of the field below. */
  suborder = subfield(qt);
  do_this_level_Env.order = (qt->expon) * suborder;
  
  /* Create the matrix for the homomorphism x -> x^Modulus by raising
     each basis element (q) to the modulus power, then dumping the
     coefficients into beta column by column. */
  q = NULL;
  for (i = 1; i <= do_this_level_Env.order; ++i) {
    basis(&q, i - 1, qt);
    compute_power(&q, modulus, qt);
    dump_coeffs(q, i, 0, qt, &do_this_level_Env);
    free_poly(&q);
  }
  
  /* Invert the matrix, to form the homomorphism modulus-root. */
  dumsp = NULL;
  dumq = NULL;
  mat_invert(do_this_level_Env.beta, do_this_level_Env.beta, true, true, do_this_level_Env.order, 
             &dumq, true, true, &dumsp, NULL, -1,-1, -1, false, 0);   /* Jan 2008 */
  
  arr_facts.arrsize.size = 0;                     /* Oct 2000 */
  special_set_2(do_this_level_Env.order, do_this_level_Env.order, 
                &arr_facts.arrsize);
  arr_facts.rows = do_this_level_Env.order;
  
  /* Transfer the desired pth roots to qt^.roots. */
  s = NULL;
  base_poly(&s, 1);
  s->exp = 0;                                     /* the desired format for this list */
  j = 1;
  forEnd_75 = qt->expon - 1;
  for (i = 1; i <= forEnd_75; ++i) {
    q = s;
    newpoly(&s);
    s->exp = i;
    s->next = q;
    s->numb = false;
    s->variant.pcoef = NULL;
    j += suborder;
    mult_out(&s->variant.pcoef, j, 0, qt, &do_this_level_Env);
  }
  qt->roots = s;
  qt->modls = modulus;
  free_arr(do_this_level_Env.beta, &arr_facts);
  special_free(&arr_facts.arrsize);               /* Oct 2000 */
  
  free_work();
}

/******************************************************************************/

void arretrieve(textptr inf, tokentipe *x, nameptr *flag, quolyptr *qp)  

{
  /* Nov 1997: no longer return n, only qp. qp nil means sparse array with
     no entry; i.e. interpret as 0.  */
  
  long r;
  long c;
  arrptr q;                                       /* arrptr for array named x */
  Boolean colflag;                                /* is a second coordinate present? */

  scanner(inf, &token, flag);
  if (integerflag) 
    ievalcoords(&r, &c, flag, &colflag);
  else 
    evalcoords(inf, &r, &c, flag, ']', ',', &colflag, false);
  scanner(inf, &token, flag);
  lookup(x, r, c, &q, qp, colflag);               /*spar*/
  if (*qp != NULL) 
    if (**qp == NULL) {
      uninit++;                              /* Jul 2002 */
      if (uninit < 21) 
        fprintf(stdout, "Warning. Uninitialized array element in [%s] has been set to 0.\n",
	        x->name);
      else if (uninit == 21) 
        fprintf(stdout, " ....etc...\n");
      quoly_set(0, *qp);
      (*(*qp))->variant.vc_1.arr_arg = false;     /* May 2001. failsafe */
    }
}

/****************************************************************************/

struct compile_EnvRec {
  nameptr *flag;
};
typedef struct compile_EnvRec compile_EnvRec;

/************************************************************************/

struct read_and_link_EnvRec {
  short numpars;
  nametype names[100];
  nameptr nmeptr[100];
  nameptr tail;
  nameptr externals;
  long pos;
  arrptr qa;
  numptr np;
};
typedef struct read_and_link_EnvRec read_and_link_EnvRec;

/************************************************************************/

static Boolean its_in_the_list(nametype x, intptr s, read_and_link_EnvRec *read_and_link_Env)
{    /* Feb 2004 */
  short i;
  Boolean value_its_in_the_list = false;

  for (i = 1; i <= read_and_link_Env->numpars; ++i) 
    if (ustrcmp(x, read_and_link_Env->names[i - 1]) == 0) {
      *s = i;
      return true;
    } else if (ustrcmp(x, read_and_link_Env->names[i - 1]) < 0) {
      *s = i;
      return value_its_in_the_list;
    }
  *s = read_and_link_Env->numpars + 1;
  return value_its_in_the_list;
}

/********************************************************************/

struct do_tok_list_EnvRec {
  /* Search an expression, looking up all likely tokens in the symbol tables
     created earlier.  Mark suitable tokens as compiled, and of what 'tipe'. */
  
  nameptr lastq;
};
typedef struct do_tok_list_EnvRec do_tok_list_EnvRec;

/*...............................................................*/

static Boolean search_and_set(nametype this, classtype typ, do_tok_list_EnvRec *do_tok_list_Env, read_and_link_EnvRec *read_and_link_Env)
{
  short i;
  Boolean value_search_and_set;

  if (its_in_the_list(this, &i, read_and_link_Env)) {
    do_tok_list_Env->lastq->qp = read_and_link_Env->nmeptr[i - 1]->qp;
    read_and_link_Env->nmeptr[i - 1]->nother = do_tok_list_Env->lastq;
    read_and_link_Env->nmeptr[i - 1] = do_tok_list_Env->lastq;
    do_tok_list_Env->lastq->compiled = true;
    do_tok_list_Env->lastq->tipe = typ;
    value_search_and_set = true;
  } else 
    value_search_and_set = false;
  return value_search_and_set;
}

/********************************************************************/

static Boolean found_digit(nameptr q)
{
  return q->let.name[0] >= '0' && q->let.name[0] <= '9';
}

/*********************************************************************/

static void do_tok_list(nameptr q, read_and_link_EnvRec *read_and_link_Env)
{
  
  nameptr saveq;
  nametype arryname;
  short leng;
  Boolean found;
  Boolean constant;
  do_tok_list_EnvRec do_tok_list_Env;
  int len;

  while (q != NULL) {
    do_tok_list_Env.lastq = q;
    q = q->next;
    if (q == NULL) 
      break;
    if (ustrcmp(q->let.name, "[") == 0 && do_tok_list_Env.lastq->let.name[0] >= 'a' && do_tok_list_Env.lastq->let.name[0] <= 'z') {
      q = q->next;
      if (q == NULL) 
        break;
      leng = ustrlen(do_tok_list_Env.lastq->let.name);
      if (leng + 1 <= 10){  
        ustrcpy(arryname,do_tok_list_Env.lastq->let.name);
        arryname[leng+1] = '[';
	    arryname[leng+2] = 0;
      }
      else 
        continue;
      leng = leng + 1 + ustrlen(q->let.name);
      if (leng <= 10) 
	    ustrcat(arryname, q->let.name);
      else 
        continue;
      saveq = q;
      constant = found_digit(q);
      q = q->next;
      if (q == NULL) 
        break;
      if (constant) 
        while (found_digit(q)) {
          leng++;
          if (leng <= 10) 
	        ustrcat(arryname,q->let.name);
          else 
            break;
          q = q->next;
          if (q == NULL) 
            return;
        }
      if (ustrcmp(q->let.name, "]") == 0) {
        leng++;
        if (leng <= 10) 
     	  ustrcat(arryname,"]");
        else {
          q = saveq;
          continue;
        }
        found = search_and_set(arryname, two, &do_tok_list_Env, read_and_link_Env);
        if (found) 
          q = q->next;
        else {
          q = saveq;
          ustrcpy(arryname, do_tok_list_Env.lastq->let.name);
          arryname[0] = (char)(arryname[0] - 32);  /* capitalize */
          found = search_and_set(arryname, three, &do_tok_list_Env, 
                                 read_and_link_Env);
        }
      } else {
        /* at least try it as a tipe three */
        q = saveq;
        ustrcpy(arryname, do_tok_list_Env.lastq->let.name);
        arryname[0] = (char)(arryname[0] - 32);   /* capitalize */
        found = search_and_set(arryname, three, &do_tok_list_Env, 
                               read_and_link_Env);
      }
    } else 
      found = search_and_set(do_tok_list_Env.lastq->let.name, one, 
                             &do_tok_list_Env, read_and_link_Env);
  }
}

/********************************************************************/

static void do_form(formptr q, read_and_link_EnvRec *read_and_link_Env);

/********************************************************************/

static void do_right(condexptr d, read_and_link_EnvRec *read_and_link_Env)
{
  if (d->cond == NULL) 
    do_tok_list(d->expr, read_and_link_Env);
  else {
    do_tok_list(d->cond, read_and_link_Env);
    do_form(d->form1, read_and_link_Env);
    if (d->form2 != NULL) 
      do_form(d->form2,read_and_link_Env);
  }
}

/********************************************************************/

static void do_form(formptr q, read_and_link_EnvRec *read_and_link_Env)
{
  while (q != NULL) {
    do_right(q->cptr, read_and_link_Env);
    q = q->next;
  }
}

/*****************************************************************/

static void insert_and_update(nametype thisone, intptr i, tokentipe *name1, tokentipe *name2, read_and_link_EnvRec *read_and_link_Env)    /* Feb 2004 */
{
  short k;
  short forEnd_77;

  if (its_in_the_list(thisone, i, read_and_link_Env))   /* sets i even if not in list */
    error(233, name1);
  if (read_and_link_Env->numpars == 100) 
    error(230, name2);
  read_and_link_Env->numpars++;
  forEnd_77 = *i + 1;
  for (k = read_and_link_Env->numpars; k >= forEnd_77; --k) {
    ustrcpy(read_and_link_Env->names[k - 1], read_and_link_Env->names[(k - 1) - 1]);
    read_and_link_Env->nmeptr[k - 1] = read_and_link_Env->nmeptr[(k - 1) - 1];
  }
  ustrcpy(read_and_link_Env->names[*i - 1], thisone);
  if (read_and_link_Env->tail == NULL) {
    newname(&read_and_link_Env->externals);
    read_and_link_Env->tail = read_and_link_Env->externals;
  } else {
    newname(&read_and_link_Env->tail->next);
    read_and_link_Env->tail = read_and_link_Env->tail->next;
  }
}

/********************************************************************/

struct get_one_name_EnvRec {
  varptr q;
  short i;
};
typedef struct get_one_name_EnvRec get_one_name_EnvRec;

/*******************************************************************/

static void get_q(nameptr p, get_one_name_EnvRec *get_one_name_Env)
{
  get_one_name_Env->q = sca_store[get_one_name_Env->i];
  while (get_one_name_Env->q != NULL) 
    if (ustrcmp(get_one_name_Env->q->let.name, p->let.name) == 0) 
      break;
    else 
      get_one_name_Env->q = get_one_name_Env->q->next;
  if (get_one_name_Env->q == NULL) 
    error(19, &p->let);
}

/*******************************************************************/

static void get_one_name(compile_EnvRec *compile_Env, read_and_link_EnvRec *read_and_link_Env)
{ /* get_one_name */
  
  /* Scan the list of names after 'Compile'. Extract the next one, place in
     symbol tables. */
  
  nametype thisone;
  short k;
  quolyptr qp;
  nameptr oldflag;
  char x;
  get_one_name_EnvRec get_one_name_Env;

  ustrcpy(thisone, (*compile_Env->flag)->let.name);
  get_one_name_Env.i = (*compile_Env->flag)->let.address;
  if (thisone[0] >= 'a' && thisone[0] <= 'z') {
    oldflag = *compile_Env->flag;
    *compile_Env->flag = (*compile_Env->flag)->next;
    currentchar = (*compile_Env->flag)->next;
    if (ustrcmp((*compile_Env->flag)->let.name, "[") == 0) {
      /* a reference like var[dim]; 'tipe' two */
      *compile_Env->flag = (*compile_Env->flag)->next;  /*spar; whole block */
      currentchar = (*compile_Env->flag)->next;
      ustrcat(thisone,"[");
      get_one_name_Env.i = (*compile_Env->flag)->let.address;
      x = (*compile_Env->flag)->let.name[0];
      read_and_link_Env->pos = 0;
      if (x >= '0' && x <= '9') 
        while (x >= '0' && x <= '9') {
          read_and_link_Env->pos = 10 * read_and_link_Env->pos + x - 48;
		  ustrcat(thisone,(*compile_Env->flag)->let.name);
          *compile_Env->flag = (*compile_Env->flag)->next;
          currentchar = (*compile_Env->flag)->next;
          x = (*compile_Env->flag)->let.name[0];
        }
      else {
        get_q(*compile_Env->flag, &get_one_name_Env);
        if (!get_one_name_Env.q->val->numb) 
          error(246, &(*compile_Env->flag)->let);
	    ustrcat(thisone,(*compile_Env->flag)->let.name);
        *compile_Env->flag = (*compile_Env->flag)->next;
        currentchar = (*compile_Env->flag)->next;
        if (lintmode) 
          read_and_link_Env->pos = get_one_name_Env.q->val->variant.vc_1.ncoef->lint;
        else 
          read_and_link_Env->pos = get_one_name_Env.q->val->variant.vc_1.ncoef->head->value;
      }
      spec_lookup(&oldflag->let, read_and_link_Env->pos, &read_and_link_Env->qa, 
                  &qp);
      if (*qp == NULL) 
        error(29, &oldflag->let);
      if (ustrcmp((*compile_Env->flag)->let.name, "]") != 0) 
        error(267, &(*compile_Env->flag)->let);
      ustrcat(thisone,"]");
      *compile_Env->flag = (*compile_Env->flag)->next;
      currentchar = (*compile_Env->flag)->next;
    } else {
      qp = NULL;
      get_q(oldflag, &get_one_name_Env);
    }
    insert_and_update(thisone, &get_one_name_Env.i, &(*compile_Env->flag)->let, 
                      &oldflag->let, read_and_link_Env);
    if (qp == NULL) 
      read_and_link_Env->tail->qp = &get_one_name_Env.q->val;
    else 
      read_and_link_Env->tail->qp = qp;
    read_and_link_Env->nmeptr[get_one_name_Env.i - 1] = read_and_link_Env->tail;
  } else if (thisone[0] == '[') {                 /* a reference like [y]; 'tipe' three */
    *compile_Env->flag = (*compile_Env->flag)->next;
    currentchar = (*compile_Env->flag)->next;
    oldflag = *compile_Env->flag;
    ustrcpy(thisone, (*compile_Env->flag)->let.name);
    read_and_link_Env->pos = fastestlookup(&(*compile_Env->flag)->let, 
                                           &read_and_link_Env->qa);
    if (read_and_link_Env->pos == -1) 
      error(28, &(*compile_Env->flag)->let);
    if (read_and_link_Env->qa->spar != NULL) 
      error(242, &token);
    *compile_Env->flag = (*compile_Env->flag)->next;
    currentchar = (*compile_Env->flag)->next;
    if (ustrcmp((*compile_Env->flag)->let.name, "]") != 0) 
      error(24, &(*compile_Env->flag)->let);
    *compile_Env->flag = (*compile_Env->flag)->next;
    currentchar = (*compile_Env->flag)->next;
    thisone[0] = (char)(thisone[0] - 32);         /* Capitalize */
    insert_and_update(thisone, &get_one_name_Env.i, &(*compile_Env->flag)->let, 
                      &oldflag->let, read_and_link_Env);
    newnum(read_and_link_Env->np);
    read_and_link_Env->np->value = read_and_link_Env->qa->start;
    newnum(read_and_link_Env->np->next);
    read_and_link_Env->np->next->value = read_and_link_Env->qa->rows;
    read_and_link_Env->tail->qp = (quolyptr)read_and_link_Env->np;
    read_and_link_Env->nmeptr[get_one_name_Env.i - 1] = read_and_link_Env->tail;
  } else 
    error(232, &(*compile_Env->flag)->let);
}

/***********************************************************************/

static void read_and_link(funcptr f, condexptr p, compile_EnvRec *compile_Env)
{ /* of read_and_link */
  
  /* Begin to collect symbol table of names to be compiled. 
     Start with the parameters/local vars. Already attached by setargs. */
  formptr q;
  paramptr r;
  nametype copy;
  nameptr dup;
  short i;
  short j;
  short k;
  short forEnd_78;
  short forEnd_79;
  read_and_link_EnvRec read_and_link_Env;

  *compile_Env->flag = (*compile_Env->flag)->next;
  currentchar = (*compile_Env->flag)->next;
  if (ustrcmp((*compile_Env->flag)->let.name, "*") == 0) {
    /* ignore the parameters; move up flag. */
    *compile_Env->flag = (*compile_Env->flag)->next;
    currentchar = (*compile_Env->flag)->next;
    f->do_params = false;
    r = NULL;
  } else {
    r = f->pars;
    f->do_params = true;
  }
  
  read_and_link_Env.numpars = 0;
  read_and_link_Env.tail = NULL;
  while (r != NULL) {
    if (r->arry) {                                /* array param, set by setargs. Treat
                                                     as external; i.e., as a 'tipe' three. */
      ustrcpy(copy, r->let.name);
      if (r->sparse) 
        error(247, &r->let);
      copy[0] = (char)(copy[0] - 32);             /* Capitalize */
      if (read_and_link_Env.numpars == 100) 
        error(230, &r->let);
      read_and_link_Env.numpars++;
      ustrcpy(read_and_link_Env.names[read_and_link_Env.numpars - 1], copy);
      read_and_link_Env.nmeptr[read_and_link_Env.numpars - 1] = (nameptr)r;
    } else {         /* standard parameter.  Dump unsorted into names. */
      read_and_link_Env.numpars++;
      if (read_and_link_Env.numpars > 100) 
        error(230, &r->let);
      ustrcpy(read_and_link_Env.names[read_and_link_Env.numpars - 1], r->let.name);
      read_and_link_Env.nmeptr[read_and_link_Env.numpars - 1] = (nameptr)r;
    }
    r = r->next;
  }
  
  /* Insertion sort names, moving nmeptr accordingly */
  for (i = 2; i <= read_and_link_Env.numpars; ++i) {
    forEnd_79 = i - 1;
    for (j = 1; j <= forEnd_79; ++j) 
      if (ustrcmp(read_and_link_Env.names[i - 1], read_and_link_Env.names[j - 1]) < 0) {
        ustrcpy(copy, read_and_link_Env.names[i - 1]);
        dup = read_and_link_Env.nmeptr[i - 1];
        forEnd_78 = j + 1;
        for (k = i; k >= forEnd_78; --k) {
          ustrcpy(read_and_link_Env.names[k - 1], read_and_link_Env.names[(k - 1) - 1]);
          read_and_link_Env.nmeptr[k - 1] = read_and_link_Env.nmeptr[(k - 1) - 1];
        }
        ustrcpy(read_and_link_Env.names[j - 1], copy);
        read_and_link_Env.nmeptr[j - 1] = dup;
        break;
      }
  }
  
  /* Look for rest of compile statement. Add more names if present. */
  if (ustrcmp((*compile_Env->flag)->let.name, "(") == 0) {
    do {
      *compile_Env->flag = (*compile_Env->flag)->next;
      currentchar = (*compile_Env->flag)->next;
      get_one_name(compile_Env, &read_and_link_Env);
    } while (ustrcmp((*compile_Env->flag)->let.name, ",") == 0);
    if (ustrcmp((*compile_Env->flag)->let.name, ")") != 0) 
      error(231, &(*compile_Env->flag)->let);
  }
  
  /* Move past the compile statement. */
  q = f->rht;
  while (q->cptr != p) {
    q = q->next;
    if (q == NULL) 
      error(229, &token);
  }
  q = q->next;
  
  /* Resolve references, and link up. Need to leave linked lists for reassign 
     to find later.  The nodes pointed to by the external list wouldn't have 
     to be linked up, but it's harmless. */
  f->comp = q;
  do_form(q, &read_and_link_Env);
  
  /* Finish off the lists. */
  for (i = 1; i <= read_and_link_Env.numpars; ++i) 
    read_and_link_Env.nmeptr[i - 1]->nother = NULL;
  if (read_and_link_Env.tail != NULL) {
    read_and_link_Env.tail->next = name_garb;
    name_garb = read_and_link_Env.externals;
  }
}

/*********************************************************************/

static void reassign(funcptr f)
{
  paramptr r;
  nameptr q;

  r = f->pars;
  while (r != NULL) {
    if (r->arry && r->sparse) 
      error(247, &r->let);
    q = r->nother;
    while (q != NULL) {
      q->qp = r->qp;
      q = q->nother;
    }
    r = r->next;
  }
}

/*************************************************************************/

void compile(quolyptr n, condexptr p, nameptr *flag)
{ /* of compile */
  
  funcptr f;
  compile_EnvRec compile_Env;

  compile_Env.flag = flag;
  if (statcount == 0) 
    error(234, &token);
  f = lastf->f;
  if (f->comp == NULL)                            /* hasn't been compiled yet */
    read_and_link(f, p, &compile_Env);
  else if (f->do_params) 
    reassign(f);
  
  eval_form(&Input, f->comp, n);
  if (*n == NULL) 
    quoly_set(0, n);
  exit_flag = true;
}

/*****************************************************************************/

Boolean bool_expre(textptr inf, nameptr *p);

/*****************************************************************************/

Boolean bool_fact(textptr inf, nameptr *p)
{
  Boolean value_bool_fact;

  if (ustrcmp(token.name, "[") == 0) {         /* Oct 1999; new grammar */
    scanner(inf, &token, p);
    value_bool_fact = bool_expre(inf, p);
    if (ustrcmp(token.name, "]") != 0) 
      error(153, &token);
    else 
      scanner(inf, &token, p);
  } else if (ustrcmp(token.name, "not") == 0) {  /* Oct 1999; new grammar */
    scanner(inf, &token, p);
    value_bool_fact = !bool_fact(inf, p);
  } else 
    value_bool_fact = evalcond(inf, p);
  return value_bool_fact;
}

/*********************************************************************/

Boolean bool_term(textptr inf, nameptr *p)
{
  Boolean value;

  value = bool_fact(inf, p);
  while (ustrcmp(token.name, "and") == 0) {    /* Oct 1999 */
    scanner(inf, &token, p);
    value = bool_fact(inf, p) && value;  /* beware shortcut &&, Jul 2003 */
  }
  
  return value;
}

/*****************************************************************************/

Boolean bool_expre(textptr inf, nameptr *p)
{
  Boolean value;
  Boolean value_bool_expre;

  value = bool_term(inf, p);
  while (ustrcmp(token.name, "or") == 0) {     /* Oct 1999; new 'or' */
    scanner(inf, &token, p);
    value = bool_term(inf, p) || value;  /* beware shortcut || !  Jul 2003 */
  }
  
  value_bool_expre = value;
  if (ustrcmp(token.name, "]") != 0 && ustrcmp(token.name, "¥") != 0)
    /* & (token.name <> ';')  Mar 1998 */
    error(104, &token);
  return value_bool_expre;
}

/*******************************************************************************/

void spec_retrieve(tokentipe *x, quolyptr n, quolyptr *qp)
{
  varptr q;
  short i;

  if (x->address == -1) 
    i = hash(&x->name, 151);
  else 
    i = x->address;
  
  q = sca_store[i];
  while (q != NULL) 
    if (ustrcmp(q->let.name, x->name) == 0) 
      break;
    else 
      q = q->next;
  
  if (q == NULL) {
    error(19, x);
    quoly_set(0, n);
    return;
  } else {
    *qp = &q->val;
    quoly_assign(q->val, n);
  }
  
  if ((*n)->numb)                                 /* check for array - scalar param error */
    if (q->val->variant.vc_1.arr_arg) {
      quoly_set(0, n);
      fprintf(stdout, "Warning. %s is an array parameter.\n", x->name);
      fprintf(stdout, "  Value 0 used for %s.\n", x->name);
      fflush(stdout);
    }
}

/***************************************************************************/

void left_side(textptr inf, arrptr *q, LongIntPtr rows, LongIntPtr cols, LongIntPtr start, LongIntPtr total_rows, LongIntPtr firstrow, LongIntPtr firstcol, LongIntPtr target_rows, tokentipe *oldtok, nameptr *flag, Boolean systok)
{

  /* token = '[' on entry */
  /* This is used by arr_asstat, where it was originally, get_from_array, and 
     built_in_func.  
        Have to juggle some of the vars differently in the non-subarray case. 
     Must leave start = -1 and target_rows = 0 if not subarray. However, rows, 
     total_rows, and cols are correct in all cases.
        Nov 92:  No, cols seems to be undefined if q is nil; rows = 0 = total_rows
     = target_rows then too. <<<
        July 1995:  Subtlety with # discovered. If # is found here, must pass that
     back to the caller, since some callers create new array of name oldtok if size
     found here does not match a size created in some array computation.  The nature
     of # as an alias contradicts that idea.  
     
        Nov 1997: much rearranging below.  Added systok, so[<] now ok, as long as
     it's not an assignment -- caller must check that. */
  
  long m;
  quoly n;

  *start = -1;
  *target_rows = 0;                          /* Nov 1997; flags to see if subarray was called */
  scanner(inf, &token, flag);
  *oldtok = token;                           /* Nov 1997 */
  if (ustrcmp(token.name, "<") == 0)          /* Jul 2003 */
    if (systok) {
      if (syst->stop == -1) 
        error(175, &token);
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, "[") == 0) 
        error(83, &token);
      if (ustrcmp(token.name, "]") != 0) 
        error(24, &token);
      scanner(inf, &token, flag);
      *rows = syst->rows;
      *total_rows = *rows;
      *cols = (syst->stop + 1) / (*rows);
      *q = syst;
      return;
    } else 
      error(176, &token);
  
  if (ustrcmp(token.name, "%") == 0) {
    n = NULL;
    get_arr_arr(inf, &n, flag, &m);
    *q = (*arrstash)[m];
    free_quoly(&n);
    ustrcpy(token.name, "%");
    if (*q == NULL) 
      error(220, &token);
      
  } else {
    if (token.name[0] < 'a' || token.name[0] > 'z')   /*@@@*/
      error(42, &token);
    if (polynames != NULL && its_a_polyname(&token.name)) 
      error(125, &token);
    if (token.address == -1) 
      token.address = hash(&token.name, 151);
    *q = arr_store[token.address];
    while (*q != NULL) 
      if (ustrcmp((*q)->name.name, token.name) == 0) 
        break;
      else 
        *q = (*q)->next;
  }
  
  if (*q == NULL) 
    *rows = 0;
  else 
    *rows = (*q)->rows;
  
  scanner(inf, &token, flag);
  if (ustrcmp(token.name, "[") == 0) 
    if (*q == NULL) 
      error(55, oldtok);
    else 
      subarray(inf, *q, start, target_rows, cols, firstrow, firstcol, 
               total_rows, flag);
  else {
    *total_rows = *rows;
    if (*rows != 0) 
      *cols = quotient_of(&(*q)->sizearr, *rows);  /* Oct 2000 */
    else *cols = 0;
  }
  if (ustrcmp(token.name, "]") != 0) 
    error(24, &token);
  scanner(inf, &token, flag);
}

/******************************************************************************/

void getval(textptr inf, condexptr p, quolyptr n)
{
  /* startexpr must be correct (the last thing executed) upon entry.  
     prev_expr is immediately set to this.
     Upon conclusion, startexpr is the last thing successfully executed.
     At any time, if an error occurs, both are correct. 
        n is nil upon entry. */
  
  nameptr q;                                      /* local copies */
  nameptr t;
  varptr r;
  long i;
  long stop;
  long increm;
  long negflag;
  numptr spcol;                                   /* Dec 2000 */
  numptrptr np;                                   /* Dec 2000 */
  char x;   /* new Jun 2003 */

  q = p->expr;
  t = p->cond;
  prev_expr = startexpr;
  startexpr = t;
  if (t == NULL) {
    startexpr = q;
    token = q->let;                               /* \nameptr   many! */
    currentchar = q->next;
    c_cntcount = 0;                               /* Mar 2001 */
    c_cntdepth = 0;                               /* Dec 2003 */
    a_cntcount = 0;                               /* Dec 2001 */
    d_cntcount = 0;                               /* Dec 2001 */
    g_cntcount = 0;                               /* Nov 2002 */
    g_cutoff = default_gc;
    alg_c_count = 0;            /* Mar 2008 */
    original_depth = 1;   /* Feb 2011 */
    x = token.name[0];  /* Jun 2003 */
    if (ustrcmp(token.name, "Diag") == 0)
       x = '~';
    if (ustrcmp(token.name, "Trans") == 0)
       x = '"';
       
    switch (x) {  /* was token.name[0] Jun 2003 */
      case '!':
        parse(inf, n, &q);                        /* can't put '&' in this list! */
        break;
      case 'I':
        if (ustrcmp(token.name, "Integer") == 0) {
          integerflag = true;                     /* n is never touched */
          scanner(inf, &token, &q);
        } else 
          old_expre(inf, n, &q);
        break;
      case 'C':
        if (ustrcmp(token.name, "Compile") == 0) 
          compile(n, p, &q);
        else if (integerflag) {
          old_iexpre(&increm, &q);                /* Nov 1997 */
          quoly_set(increm, n);
        } else 
          old_expre(inf, n, &q);
        break;
      case '~':  /*  Diag */
      case '[':
      case '"':  /* Transpose */
        arr_parse(x, inf, n, &q);  /* Jun 2003 */
        break;
      case 'A':
        if (ustrcmp(token.name, "Adjoint") == 0 || ustrcmp(token.name, "Altmult") == 0 || 
            ustrcmp(token.name, "Altpower") == 0) 
          arr_parse('A', inf, n, &q);
        else if (integerflag) {
          old_iexpre(&increm, &q);                /* Nov 1997 */
          quoly_set(increm, n);
        } else 
          old_expre(inf, n, &q);
        break;
      case 'M':
        if (ustrcmp(token.name, "MPowermod") == 0)   /* Mar 1999 */
          arr_parse('M', inf, n, &q);
        else if (integerflag) {
          old_iexpre(&increm, &q);                /* Nov 1997 */
          quoly_set(increm, n);
        } else 
          old_expre(inf, n, &q);
        break;
      default:
        if (integerflag) {
          iexpre(&increm, &q);                    /* Nov 1997 */
          quoly_set(increm, n);
        } else 
          parse(inf, n, &q);                      /* Nov 1997 */
        break;
    }
    if (ustrcmp(token.name, "¥") != 0 && ustrcmp(token.name, ";") != 0) /* the old omega Jun 2003 */
      error(31, &token);
  } else if (p->aloop) 
    if (ustrcmp(t->let.name, ":") == 0) {      /* a for-loop */
      /*  Nov 1997 token := t^.let;  */
      t = t->next;  /* Jul 2003 */
      token = t->let;
      currentchar = t->next;
      set_up_for_loop(inf, &t, &r, &i, &stop, &increm, &spcol, &np);  /* Dec 2000 */
      if (ustrcmp(token.name, "¥") != 0)   /* the old omega */
        error(190, &token);
      if (increm < 0) {
        i = -i;
        stop = -stop;
        increm = -increm;
        negflag = -1;
      } else 
        negflag = 1;
      while (i <= stop) {
        eval_form(inf, p->form1, n);
        if (exit_flag)                 /* global set by some expression */
          break;    /* changed Aug 2003, fix memory leak */
        if (leave_flag) {              /* global set by some expression */
          leave_flag = false;
          break;
        }
        if (cycle_flag) 
          cycle_flag = false;
        if (spcol == NULL)                        /* Dec 2000 */
          i += increm;
        else if (*np == NULL) 
          i = stop + 1;
        else {
          i = (*np)->value;
          np = &(*np)->next;
        }
        adjust(r, negflag * i);
      }
      if (spcol != NULL) {             /* Dec 2000 */
        while (*np != NULL) {   /* fixed memory leak when abnormal end, Aug 2003 */
           np = &(*np)->next;
        }
        *np = numhead;
        numhead = spcol;  /*AAR can't use freenum here*/
      }
      if (exit_flag)                   /* moved here Aug 2003 */
        return;
      if (p->form2 != NULL) 
        eval_form(inf, p->form2, n);
    } else {
      token = t->let;
      currentchar = t->next;
      while (bool_expre(inf, &t)) {
        eval_form(inf, p->form1, n);
        if (exit_flag)                            /* global set by some expression */
          return;
        if (leave_flag) {                         /* global set by some expression */
          leave_flag = false;
          break;
        }
        if (cycle_flag) 
          cycle_flag = false;
        t = p->cond;
        prev_expr = startexpr;
        startexpr = t;
        token = t->let;
        currentchar = t->next;
      }
      if (p->form2 != NULL) 
        eval_form(inf, p->form2, n);
    }
  else {                                          /* it's an if statement */
    token = t->let;
    currentchar = t->next;
    if (bool_expre(inf, &t)) 
      eval_form(inf, p->form1, n);
    else if (p->form2 != NULL) 
      eval_form(inf, p->form2, n);
  }
}

/***************************************************************************/

/* may end with n nil. ~ several */
void eval_form(textptr inf, formptr q, quolyptr n)
{
  while (q != NULL) {
    free_quoly(n);
    getval(inf, q->cptr, n);
    if (exit_flag || leave_flag || cycle_flag) 
      return;
    q = q->next;
  }
}

/***************************************************************************/

struct evaluate_EnvRec {
  FILEPtr *inf;
  quoly *n;
};
typedef struct evaluate_EnvRec evaluate_EnvRec;

/*****************************************************************/

struct setargs_EnvRec {
  Boolean its_array_arg;
  paramptr *p;
  nameptr *flag;
  quolyptr qp;
  long colpos;                                    /* Nov 1997 */
};
typedef struct setargs_EnvRec setargs_EnvRec;

/*************************************************************************/

static void arrayarg(tokentipe *x, quolyptr n, arrptr *newar, nameptr *flag, evaluate_EnvRec *evaluate_Env, setargs_EnvRec *setargs_Env)
{
  arrptr p;
  arrptr q;

  newarray(&p);                                   /* Oct 2000 */
  p->name = *x;
  scanner(evaluate_Env->inf, &token, flag);
  if (ustrcmp(token.name, "<") == 0)
    error(176, &token);
  p->start = fasterlookup(&token, &q, evaluate_Env->inf, flag);
  if (p->start == -1) 
    error(28, &token);
  p->stop = q->stop;
  p->rows = q->rows;
  p->linear = q->linear;
  spec_num_assign(&q->sizearr, &p->sizearr);      /* Oct 2000 */
  p->spar = q->spar;       /* This opens up a can of worms. Sparse array passing
                              is no longer by reference, but sort-of by value-result. */
  p->father = q;             /* for sake of sparse and sparse/normal conflicts */
  p->time = -abs(q->time);
  p->next = *newar;
  *newar = p;
  scanner(evaluate_Env->inf, &token, flag);
  if (ustrcmp(token.name, "]") != 0) 
    error(24, &token);
  scanner(evaluate_Env->inf, &token, flag);
  quoly_set(0, n);
  setargs_Env->its_array_arg = true;
}

/***********************************************************************/

static void get_qp_n(setargs_EnvRec *setargs_Env, evaluate_EnvRec *evaluate_Env)
{
  tokentipe oldtok;
  colm_ptrptr aux;                                /* Nov 1997 */

  if (ustrcmp(token.name, ")") == 0) 
    error(206, &(*setargs_Env->p)->let);
  else {
    scanner(evaluate_Env->inf, &token, setargs_Env->flag);
    if (token.name[0] >= 'a' && token.name[0] <= 'z') 
      if (its_a_polyname(&token.name)) 
        error(207, &token);
      else {
        oldtok = token;
        scanner(evaluate_Env->inf, &token, setargs_Env->flag);
        if (ustrcmp(token.name, "[") == 0) {
          new_arretrieve(evaluate_Env->inf, &oldtok, setargs_Env->flag, 
                         &setargs_Env->qp, evaluate_Env->n, &aux, 
                         &setargs_Env->colpos);  /* Nov 1997 */
          /* OLD BUG fix, Oct 2005 */
          if (aux != NULL || setargs_Env->qp == NULL) 
            error(318, &token);
          quoly_assign(*setargs_Env->qp, evaluate_Env->n);
        } else 
          spec_retrieve(&oldtok, evaluate_Env->n, &setargs_Env->qp);
      }
    else 
      error(207, &token);
  }
}

/********************************************************************/

static void setargs(paramptr p, nameptr *flag, tokentipe *mytoken, evaluate_EnvRec *evaluate_Env)
{
  /* This procedure allows for local variables: once ')' is seen in
     the argument list, all remaining formal parameters are set to 0 -
     i.e., they become local variables .  Same thing if there is no
            argument list. */
  
  varptr q;
  varptr temp;
  arrptr newarr;
  arrptr t;
  short i;
  numptr np;
  setargs_EnvRec setargs_Env;

  setargs_Env.flag = flag;
  setargs_Env.p = &p;
  ustrcpy(mytoken->name, " ");
  if (p != NULL) {
    newarr = NULL;
    temp = NULL;
    scanner(evaluate_Env->inf, &token, flag);
    if (ustrcmp(token.name, "(") != 0) {       /* programmer has passed no arguments. Thats ok-
                                                    all params are local vars.*/
      *mytoken = token;                           /* someone will want it */
      ustrcpy(token.name, ")");
      token.address = -1;
    }
    
    /* Create linked list of arguments, pointed to by temp.  
       WHEN ALL FINISHED attach these to the store array. */
    while (p != NULL) {
      if (its_a_polyname(&p->let.name)) 
        error(125, &p->let);
      setargs_Env.its_array_arg = false;          /* could be changed by arrayarg */
      if (p->result) 
        get_qp_n(&setargs_Env, evaluate_Env);     /* sets n and p^.gp */
      else if (ustrcmp(token.name, ")") != 0) {
        scanner(evaluate_Env->inf, &token, flag);
        if (ustrcmp(token.name, "[") == 0) 
          arrayarg(&p->let, evaluate_Env->n, &newarr, flag, evaluate_Env, 
                   &setargs_Env);                 /* n now 0 */
        else 
          old_expre(evaluate_Env->inf, evaluate_Env->n, flag);
      } else 
        quoly_set(0, evaluate_Env->n);
      if (var_garb == NULL) 
        q = (varptr)malloc(sizeof(varnode));
      else {
        q = var_garb;
        var_garb = var_garb->next;
      }
      q->let = p->let;
      if (p->result) 
        q->qp = setargs_Env.qp;
      if (setargs_Env.its_array_arg) 
        (*evaluate_Env->n)->variant.vc_1.arr_arg = true;  /* universal flag */
      else if ((*evaluate_Env->n)->numb) 
        (*evaluate_Env->n)->variant.vc_1.arr_arg = false;
      q->val = *evaluate_Env->n;
      /* assign p^.qp for eventual compilation. Need to be careful
         about array args. */
      if (setargs_Env.its_array_arg) 
        p->sparse = newarr->spar != NULL;
      if (setargs_Env.its_array_arg)              /*\nameptr; whole block of code */
        if (p->arry) {                            /* was array arg last time too */
          np = (numptr)p->qp;
          np->value = newarr->start;
          /* Changed addresser, Sept 1996 */
          np->next->value = newarr->rows;
        } else {
          newnum(np);
          np->value = newarr->start;
          newnum(np->next);
          np->next->value = newarr->rows;
          p->arry = true;
          p->qp = (quolyptr)np;
        }
      else if (p->arry) {
        np = (numptr)p->qp;
	freenum(np,np->next);
/* AAR
        np->next->next = numhead;
        numhead = np;
*/
        p->arry = false;
        p->qp = &q->val;
      } else 
        p->qp = &q->val;
      q->next = temp;
      temp = q;
      p = p->next;
      *evaluate_Env->n = NULL;
      if (ustrcmp(token.name, ",") != 0 && ustrcmp(token.name, ")") != 0 && p != NULL) 
        error(14, &token);
    }
    
    if (ustrcmp(token.name, ")") != 0) 
      error(15, &token);
    
    /* attach to symbol table. */
    while (q != NULL) {
      i = q->let.address;
      temp = q->next;
      q->next = sca_store[i];
      sca_store[i] = q;
      q = temp;
    }
    
    while (newarr != NULL) {
      i = newarr->name.address;
      t = newarr->next;
      newarr->next = arr_store[i];
      arr_store[i] = newarr;
      newarr = t;
    }
  }
  
  if (ustrcmp(mytoken->name, " ") == 0) 
    scanner(evaluate_Env->inf, mytoken, flag);
  
}

/***********************************************************/

static funcptr func_retrieve(tokentipe *name)
{
  funcptr q;
  funcptr value_func_retrieve = NULL;

  if (name->address == -1) 
    name->address = hash(&name->name, 71);
  q = func_store[name->address];
  while (q != NULL) {
    if (ustrcmp(q->name.name, name->name) == 0) 
      break;
    q = q->next;
  }
  
  if (q == NULL) 
    error(16, name);
  else 
    value_func_retrieve = q;
  return value_func_retrieve;
}

/******************************************************************/

/* procedure removeargs is before evaluate.*/

void evaluate(textptr inf, tokentipe *name, quolyptr n, nameptr *flag)
{
  funcptr p;
  tokentipe mytoken;
  nameptr old_startexpr;
  nameptr old_prev_expr;
  Boolean old_int_flag;
  evaluate_EnvRec evaluate_Env;

  evaluate_Env.n = n;
  evaluate_Env.inf = inf;
  p = func_retrieve(name);
  setargs(p->pars, flag, &mytoken, &evaluate_Env);
  
  /* Update status count and pointers.*/
  lastf = lastf->next;
  lastf->f = p;
  statcount++;
  old_startexpr = startexpr;
  old_prev_expr = prev_expr;
  old_int_flag = integerflag;
  integerflag = false;
  uninit = 0;                                     /* Jul 2002 */
  
  /* Now actually evaluate. */
  quoly_set(0, n);
  prev_expr = NULL;
  startexpr = NULL;
  eval_form(inf, p->rht, n);
  if (*n == NULL) 
    quoly_set(0, n);                              /* needs to be after every call of eval_form,
                                                     except in getval, of course. */
  exit_flag = false;
  
  if (ustrcmp(token.name, "¥") != 0)   /* the old omega */
    error(31, &token);
  
  remove_args(p, false);
  
  token = mytoken;
  
  /* Now reset the status information.*/
  statcount--;
  syst_dump = false;
  lastf = lastf->prev;
  prev_expr = old_prev_expr;
  startexpr = old_startexpr;
  integerflag = old_int_flag;
}

/***************************************************************************/

void get_from_array(textptr inf, nameptr *flag, bigstring newname)
{
  /* used by set_switch, attach_poly, load, and save to name a file. */
  /* p2c note: in the Pascal, this is var newname, so newname is supposed to be 
     changed!  It will be (the translation above is correct), even though this is very
     confusing.  Jul 2003 */
     
  long i;
  long start;
  short j;
  tokentipe other;                                /*<<<< whole proc. */
  arrptr p;
  quoly q;
  int len;

  ustrcpy(newname, "");
  left_side(inf, &p, &i, &i, &start, &i, &i, &i, &i, &other, flag, false);
  if (p == NULL) 
    error(28, &token);
  if (start != -1) 
    error(258, &token);
  if (p->spar != NULL) 
    error(259, &token);
  j = 1;
  for (i = p->start; i <= p->stop; ++i) {
    q = (*arp[BSR(i, 10)])[BAnd(i, tenmask)];
    if (q != NULL) 
      if (q->numb) {
        if (lintmode) 
          start = q->variant.vc_1.ncoef->lint;
        else 
          start = q->variant.vc_1.ncoef->head->value;
        if ((char)start != ' ') {
	      len = ustrlen(newname);
	      newname[len++] = (char)start;
	      newname[len] = (char)0;
          j++;
        }
      } else 
        error(260, &token);
    if (j >= 256) 
      break;
  }
  if (j == 1) 
    fprintf(stdout, "*** Warning. array [%s] is empty.\n", p->name.name);
}

/***************************************************************************/

void get_cut_from_array(textptr inf, nameptr *flag)
{
  /* Jan 2010.  similar to get_from_array */
     
  long i;
  long val;
  short j;
  tokentipe other;          
  arrptr p;
  quoly q;
  polypt pt;
  Boolean empty;
 
  left_side(inf, &p, &i, &i, &val, &i, &i, &i, &i, &other, flag, false);
  if (p == NULL) 
    error(28, &token);
  if (val != -1) 
    error(258, &token);
  if (p->spar != NULL) 
    error(259, &token);
  j = 0;  
  pt = polynames;
  empty = true;
  for (i = p->start; i <= p->stop; ++i) {
    q = (*arp[BSR(i, 10)])[BAnd(i, tenmask)];
    j++;
	if (q != NULL) 
      if (q->numb) {
        if (lintmode) 
          val = q->variant.vc_1.ncoef->lint;
        else 
          val = q->variant.vc_1.ncoef->head->value;
		empty = false;
		if (pt == NULL)
		  break;
		if (val >= 6) {
		  pt->polycut = val;
 /*fprintf(stdout, " did it %d, %d, %d\n", j, pt->depth, val);   REMOVE EVENTUALLY  Jan 2010 */
		}
		if (j == 1) {
		  if (val >= 6) 
		    poly_cutoff = val;
		  else 
		    poly_cutoff = 40;   /* Aug 2010 */
 /* fprintf(stdout, " poly cut now %d, %d, %d\n", j, pt->depth, poly_cutoff);  REMOVE EVENTUALLY  Feb 2010 */
		}
		pt = pt->next;
		if (pt == NULL)
		  break;
      } else 
        error(260, &token);
    if (j >= number_polys) 
      break;
  }
  
  if (empty) 
    fprintf(stdout, "*** Warning. array [%s] is empty.\n", p->name.name);
}

/******************************************************************************/

struct do_total_degree_EnvRec {
  long last;
  /* n is not a number and n^.denom = nil. May 1997.
     Compute the subpolynomial of n consisting of all terms with total degree k involving
     the variables named by q^. laurent ok. k could be negative. */
  
  Boolean searchlist[max_number_polys];
};
typedef struct do_total_degree_EnvRec do_total_degree_EnvRec;

/*******************************************************************/

struct total_degree_EnvRec {
  /* Consume p and compute the answer. Note: the argument to p becomes undefined. 
     0 is returned as nil. If not laurent, deg >= 0. */
  
  polyptrr tp;
};
typedef struct total_degree_EnvRec total_degree_EnvRec;

/***************************************************************************/

static void take(polyptrr p, total_degree_EnvRec *total_degree_Env)
{
  /* p is not a number */
  poly t;

  t = *p;
  *p = (*p)->next;
  if (t->exp == 0) 
    if (t->variant.pcoef->numb && t->variant.pcoef->next == NULL) {
      freepoly(t,t);/*AAR*/
/*AAR
      t->next = polygarb;
      polygarb = t;
*/
      t = t->variant.pcoef;
    }
  *total_degree_Env->tp = t;
  total_degree_Env->tp = &t->next;
}

/******************************************************************************/

static void delete_1(polyptrr p)
{
  poly t;

  t = (*p)->next;
  (*p)->next = NULL;
  free_poly(p);
  *p = t;
}

/******************************************************************************/

static poly total_degree(poly p, long level, long deg, do_total_degree_EnvRec *do_total_degree_Env)
{
  
  poly ans;
  Boolean level_of_a_var;
  long newdeg;
  poly value_total_degree;
  total_degree_EnvRec total_degree_Env;

  if (level > do_total_degree_Env->last) {
    if (deg != 0) 
      free_poly(&p);
    return p;
  }
  total_degree_Env.tp = &ans;
  level_of_a_var = do_total_degree_Env->searchlist[level - 1];
  while (p != NULL) 
    if (p->numb) 
      if (deg == 0) {                             /* take it */
        *total_degree_Env.tp = p;
        total_degree_Env.tp = &p->next;
        p = p->next;
      } else 
        delete_1(&p);
    else if (level_of_a_var) {
      newdeg = deg - p->exp;
      if (laurent || newdeg >= 0) {
        p->variant.pcoef = total_degree(p->variant.pcoef, level + 1, 
                                        newdeg, do_total_degree_Env);
        if (p->variant.pcoef == NULL) 
          delete_1(&p);
        else 
          take(&p, &total_degree_Env);
      } else 
        delete_1(&p);
    } else {
      p->variant.pcoef = total_degree(p->variant.pcoef, level + 1, 
                                      deg, do_total_degree_Env);
      if (p->variant.pcoef == NULL) 
        delete_1(&p);
      else 
        take(&p, &total_degree_Env);
    }
  
  *total_degree_Env.tp = NULL;
  return ans;
}

/*****************************************************************/

void do_total_degree(quolyptr n, arrptr q, long k)
{
  long i;
  long j;
  quoly m;
  do_total_degree_EnvRec do_total_degree_Env;

  if (!laurent && k < 0) {
    quoly_set(0, n);
    return;
  }
  
  if (q->spar != NULL) 
    error(242, &token);
  
  /* Fill in the array searchlist to mark the vars present in q^. */
  for (i = 1; i <= max_number_polys; ++i) 
    do_total_degree_Env.searchlist[i - 1] = false;
  do_total_degree_Env.last = -1;
  for (i = q->start; i <= q->stop; ++i) {
    m = (*arp[BSR(i, 10)])[BAnd(i, tenmask)];
    if (m == NULL) 
      error(29, &token);
    if (m->numb || m->variant.vc_2.denom != NULL) 
      error(311, &token);
    j = poly_level(m->variant.vc_2.numer);        /* j must be reasonable */
    do_total_degree_Env.searchlist[j - 1] = true;
    if (j > do_total_degree_Env.last) 
      do_total_degree_Env.last = j;
  }
  
  (*n)->variant.vc_2.numer = total_degree((*n)->variant.vc_2.numer, 
                                          1, k, &do_total_degree_Env);
  
  if ((*n)->variant.vc_2.numer == NULL) 
    quoly_set(0, n);
  else if ((*n)->variant.vc_2.numer->numb && (*n)->variant.vc_2.numer->next == NULL) 
    polynum_to_quoly(n);
}


/********************************************************************/

/*****************************************************************************/

void make_sparse(textptr inf, quolyptr n, nameptr *flag)
{
  /* Create new copies of all nonzero stuff in the array, to be looked up here.
     Delete all the standard format values. */
  
  short i;
  arrptr q;
  Boolean paren;

  scanner(inf, &token, flag);
  paren = ustrcmp(token.name, "(") == 0;
  if (paren) 
    scanner(inf, &token, flag);
  if (ustrcmp(token.name, "[") != 0) 
    error(178, &token);
  scanner(inf, &token, flag);
  if (ustrcmp(token.name, "<") == 0)
    error(176, &token);
  if (token.address == -1) 
    i = hash(&token.name, 151);
  else 
    i = token.address;
  
  q = arr_store[i];
  while (q != NULL) 
    if (ustrcmp(q->name.name, token.name) == 0) 
      break;
    else 
      q = q->next;
  if (q == NULL) 
    error(28, &token);
  if (q->time < 0 && q->spar == NULL)             /* Aug 2002 */
    error(138, &token);
  
  scanner(inf, &token, flag);
  if (ustrcmp(token.name, "]") != 0) 
    error(24, &token);
  if (paren) {
    scanner(inf, &token, flag);
    if (ustrcmp(token.name, ")") != 0) 
      error(1, &token);
  }
  scanner(inf, &token, flag);
  quoly_set(0, n);
  if (q->spar != NULL)                            /* rearrange, Aug 2002 */
    return;
  
  newsparse(&q->spar);
  fill_sparse(q);
}

/**************************************************************************/

void quoly_set_coef(quolyptr n, textptr inf, nameptr *flag)
{
  /* complications because of handling numbers as both poly and quoly.
     n is nilled out or is a number or there is no n^.denom. */
  
  poly n2;
  imptr q;

  if (*n == NULL) {
    n2 = NULL;
    set_coef(&n2, inf, flag, 0);
    if (n2->numb && n2->next == NULL) 
      poly_consume(&n2, n);
    else {
      newquoly(n);
      (*n)->numb = false;
      (*n)->variant.vc_2.rat = false;
      (*n)->variant.vc_2.denom = NULL;
      (*n)->variant.vc_2.numer = n2;
    }
  } else if ((*n)->numb) {
    quoly_to_poly(*n, &n2);                       /* n is unchanged */
    set_coef(&n2, inf, flag, 0);
    if (n2->numb && n2->next == NULL) {
      q = n2->variant.ncoef;
      n2->variant.ncoef = (*n)->variant.vc_1.ncoef;
      (*n)->variant.vc_1.ncoef = q;
      free_poly(&n2);
    } else {
      free_imag(&(*n)->variant.vc_1.ncoef);
      (*n)->numb = false;
      (*n)->variant.vc_2.rat = false;
      (*n)->variant.vc_2.denom = NULL;
      (*n)->variant.vc_2.numer = n2;
    }
  } else {
    set_coef(&(*n)->variant.vc_2.numer, inf, flag, 0);
    if ((*n)->variant.vc_2.numer->numb && (*n)->variant.vc_2.numer->next == NULL) 
      polynum_to_quoly(n);
  }
}

/**************************************************************************/

void change_coef(textptr inf, quolyptr n, nameptr *flag)
{
  /* Locate the quolynomial to be changed. Complicated by use of Numer and Denom. */
  
  tokentipe oldtok;
  varptr q;                                       /* spar. whole thing */
  poly p;
  quoly qy;
  quoly dq;
  arrptr qa;
  quolyptr qp;
  quolyptr oldqp;
  long r;
  long c;
  long location;
  Boolean colflag;
  Boolean itscalar;
  Boolean num_den;
  Boolean numer;
  Boolean sparse;

  scanner(inf, &token, flag);
  if (ustrcmp(token.name, "(") != 0) 
    error(154, &token);
  scanner(inf, &oldtok, flag);
  if (ustrcmp(oldtok.name, "Numer") == 0 || ustrcmp(oldtok.name, "Denom") == 0) {
    num_den = true;
    numer = ustrcmp(oldtok.name, "Numer") == 0;
    scanner(inf, &token, flag);
    if (ustrcmp(token.name, "(") != 0) 
      error(177, &token);
    scanner(inf, &oldtok, flag);
  } else 
    num_den = false;
  
  if (oldtok.name[0] > 'z' || oldtok.name[0] < 'a') 
    error(157, &oldtok);
  scanner(inf, &token, flag);
  qy = NULL;
  sparse = false;                                 /* Nov 1997 */
  if (ustrcmp(token.name, "[") == 0) {
    scanner(inf, &token, flag);
    evalcoords(inf, &r, &c, flag, ']', ',', &colflag, false);
    scanner(inf, &token, flag);
    lookup(&oldtok, r, c, &qa, &qp, colflag);
    sparse = qa->spar != NULL;                    /* Nov 1997 */
    if (qp == NULL) 
      sparse_set(r, c, qa, &qp, colflag);         /*need r, c, colflag later */
    itscalar = false;
  } else {
    itscalar = true;
    /* Lookup oldtok in symbol table. */
    if (oldtok.address == -1) 
      r = hash(&oldtok.name, 151);
    else 
      r = oldtok.address;
    
    q = sca_store[r];
    while (q != NULL) 
      if (ustrcmp(q->let.name, oldtok.name) == 0) 
        break;
      else 
        q = q->next;
    
    if (q == NULL) 
      qp = &qy;
    else 
      qp = &q->val;
  }
  
  if (num_den) {
    if (ustrcmp(token.name, ")") != 0) 
      error(1, &token);
    scanner(inf, &token, flag);
    if (*qp == NULL) 
      error(167, &oldtok);
    if ((*qp)->numb) 
      error(67, &oldtok);
    newquoly(&dq);
    dq->numb = false;
    dq->variant.vc_2.rat = false;
    dq->variant.vc_2.denom = NULL;
    if (numer) 
      dq->variant.vc_2.numer = (*qp)->variant.vc_2.numer;
    else 
      dq->variant.vc_2.numer = (*qp)->variant.vc_2.denom;
    oldqp = qp;
    qp = &dq;  /* so qp^ is not a number. comment added Aug 2003 */
  }
  
  if (*qp != NULL) 
    if (!(*qp)->numb && (*qp)->variant.vc_2.denom != NULL) 
      error(185, &oldtok);
    else {
      quoly_set_coef(qp, inf, flag);
      if (num_den) {  /* qp^ is not a number. comment added Aug 2003 */
        if (dq->numb) 
          quoly_consume(&dq, &p);
        else {
          p = dq->variant.vc_2.numer;
          dq->next = quolygarb;
          quolygarb = dq;
        }
        qp = oldqp;
        if (numer) 
          (*qp)->variant.vc_2.numer = p;
        else {
          (*qp)->variant.vc_2.denom = p;
          if (poly_iszero(p)) {
            fprintf(stdout, " Warning. A quoly denominator has become 0 due to :.\n");
            if (itscalar) 
              fprintf(stdout, "   A variable named %s", oldtok.name);
            else 
              fprintf(stdout, "   An array named %s", oldtok.name);
            fprintf(stdout, " was involved, and set to 0.\n");
            quoly_set(0, qp);
          }
        }
        if ((*qp)->variant.vc_2.denom != NULL) 
          check_quoly(qp, laurent && !numer);
        else if ((*qp)->variant.vc_2.numer->numb && (*qp)->variant.vc_2.numer->next == NULL) 
          polynum_to_quoly(qp);
      }
    }
  else {
    quoly_set_coef(qp, inf, flag);
    if (itscalar) {
      q = sca_store[r];
      if (var_garb == NULL) 
        new(sca_store[r]);
      else {
        sca_store[r] = var_garb;
        var_garb = var_garb->next;
      }
      sca_store[r]->next = q;
      q = sca_store[r];
      q->let = oldtok;
      q->val = *qp;
    }
  }
  
  if (*flag == NULL) 
    quoly_assign(*qp, n);
  else 
    quoly_set(0, n);
  
  if (sparse) 
    if (quoly_iszero(*qp)) 
      sparse_delete(r, c, qa, colflag);           /* Nov 1997 */
}

/******************************************************************************/

struct quoly_at_matrix_EnvRec {
  poly t;
  quoly qq;         /* a dummy head node quoly used to convert various polys. */
  sparseptr spar2;
  long *rows;
  workptr arr2;
  Boolean *arr_free;
  sparseptr *spar;
  workarray *arr;
  arr_descr *arr_facts;
  arr_descr arr2_facts;
  arr_descr arr3_facts;
  jmp_buf quoly_at_matrix_exit;
};
typedef struct quoly_at_matrix_EnvRec quoly_at_matrix_EnvRec;

/*********************************************************/

static void pad_1(poly p, quoly_at_matrix_EnvRec *quoly_at_matrix_Env)
{
  newpoly(&quoly_at_matrix_Env->t);
  quoly_at_matrix_Env->t->exp = 0;
  quoly_at_matrix_Env->t->numb = false;
  quoly_at_matrix_Env->t->next = NULL;
  quoly_at_matrix_Env->t->variant.pcoef = p;
}

/*********************************************************/

static void add_scalar(poly p, quoly_at_matrix_EnvRec *quoly_at_matrix_Env)
{
  /* add scalar p (i.e. exp = 0) to main diagonal of arr2, spar2. p is read only. 
     qq is reused each time. */
  
  long i;
  long forEnd_83;

  if (p->numb) {
    quoly_at_matrix_Env->qq->numb = true;
    quoly_at_matrix_Env->qq->variant.vc_1.ncoef = p->variant.ncoef;
  } else {
    quoly_at_matrix_Env->qq->numb = false;
    quoly_at_matrix_Env->qq->variant.vc_2.denom = NULL;
    quoly_at_matrix_Env->qq->variant.vc_2.rat = false;
    quoly_at_matrix_Env->qq->variant.vc_2.numer = p;
  }
  if (quoly_at_matrix_Env->spar2 == NULL) {
    forEnd_83 = *quoly_at_matrix_Env->rows - 1;
    for (i = 0; i <= forEnd_83; ++i) 
      better_quoly_add((*quoly_at_matrix_Env->arr2)[i * (*quoly_at_matrix_Env->rows + 1)], 
                       quoly_at_matrix_Env->qq, &(*quoly_at_matrix_Env->arr2)[i * (*quoly_at_matrix_Env->rows + 1)]);
  } else 
    add_to_diag(quoly_at_matrix_Env->qq, quoly_at_matrix_Env->spar2, 
                *quoly_at_matrix_Env->rows);
}

/*****************************************************/

static void finish_3(quoly_at_matrix_EnvRec *quoly_at_matrix_Env)
{
  long i;
  long forEnd_84;

  if (*quoly_at_matrix_Env->arr_free) 
    if (*quoly_at_matrix_Env->spar == NULL)       /* all rearranged*/
      free_arr(quoly_at_matrix_Env->arr, quoly_at_matrix_Env->arr_facts);
    else 
      free_sparse(quoly_at_matrix_Env->spar, *quoly_at_matrix_Env->rows, 
                  *quoly_at_matrix_Env->arr_free);
  if (quoly_at_matrix_Env->spar2 == NULL) {       /* note spar2. not same as spar = nil!!
                                                         move free_work below */
    forEnd_84 = quoly_at_matrix_Env->arr2_facts.arrsize.head->value - 1;
    for (i = 0; i <= forEnd_84; ++i) 
      (*quoly_at_matrix_Env->arr)[i] = (*quoly_at_matrix_Env->arr2)[i];
    *quoly_at_matrix_Env->spar = NULL;
  } else 
    *quoly_at_matrix_Env->spar = quoly_at_matrix_Env->spar2;
  free_work();
  spec_num_assign(&quoly_at_matrix_Env->arr2_facts.arrsize, &quoly_at_matrix_Env->arr_facts->arrsize);  /* Oct 2000 */
  quoly_at_matrix_Env->arr_facts->rows = quoly_at_matrix_Env->arr2_facts.rows;
  *quoly_at_matrix_Env->arr_free = true;
  if (quoly_at_matrix_Env->t != NULL) {
    freepoly(quoly_at_matrix_Env->t,quoly_at_matrix_Env->t); /*AAR*/
/*AAR
    quoly_at_matrix_Env->t->next = polygarb;
    polygarb = quoly_at_matrix_Env->t;
*/
  }
  quoly_at_matrix_Env->qq->next = quolygarb;
  quolygarb = quoly_at_matrix_Env->qq;
  special_free(&quoly_at_matrix_Env->arr2_facts.arrsize);  /* Oct 2000 */
  special_free(&quoly_at_matrix_Env->arr3_facts.arrsize);  /* Oct 2000 */
  longjmp(quoly_at_matrix_Env->quoly_at_matrix_exit, -1);
  /*exit(::quoly_at_matrix) ~ up-level function exit*/
}

/*******************************************************/

void quoly_at_matrix(textptr inf, quoly nq, workptr arr, arr_descr *arr_facts, Boolean *arr_free, LongIntPtr rows, nameptr *flag, sparseptr *spar)
{
  /* Token is '[' upon entry. nq is already determined. Evaluate nq at matrix arr, spar
     to be computed here.  This procedure inefficiently recomputes lots of 
     matrix powers if there are big gaps in the poly nq.
         arr, spar is plugged into the highest level poly var.
         If spar <> nil then all matrix arithmetic is of sparse matrices.
     This may not be optimal!  I'm ignoring that for now, Nov 1992.
         Nov 1994:  Previous sentence now changed. Switch of storage format spar2 -> arr2 
     and spar3 -> arr3 can occur. Very delicate.  Depends on the way that mat_invert
     and matrix multiply work.  
         Nov 1997: nq is now read-only. */
  
  Boolean arr2_free;
  Boolean arr3_free;
  workptr arr3;
  long i;
  long j;
  long k;
  long num;
  long nextexp;
  poly n;
  poly q;
  sparseptr spar3;
  long forEnd_85;
  long forEnd_86;
  long forEnd_87;
  long forEnd_88;
  long forEnd_89;
  long forEnd_90;
  long forEnd_91;
  long forEnd_92;
  quoly_at_matrix_EnvRec quoly_at_matrix_Env;

  if (setjmp(quoly_at_matrix_Env.quoly_at_matrix_exit)) 
    return;
  quoly_at_matrix_Env.arr_facts = arr_facts;
  quoly_at_matrix_Env.arr = arr;
  quoly_at_matrix_Env.spar = spar;
  quoly_at_matrix_Env.arr_free = arr_free;
  quoly_at_matrix_Env.rows = rows;
  if (!nq->numb && (lintmode || !nq->variant.vc_2.rat)) 
    if (nq->variant.vc_2.denom != NULL) {
      free_quoly(&nq);
      error(186, &bulletsign);
    }
  
  quoly_at_matrix_Env.qq = NULL;                  /* Nov 1997; remove nq from this call */
  arr_fact(inf, &quoly_at_matrix_Env.qq, arr, arr_facts, arr_free, 
           rows, flag, spar);
  free_quoly(&quoly_at_matrix_Env.qq);            /* qq should not have been touched */
  
  if (arr_facts->arrsize.head->value != 0 && !is_product_of(&arr_facts->arrsize, 
                                                            *rows, *rows)) {  /*spar @@@*/
    free_quoly(&nq);
    if (*arr_free) 
      if (*spar == NULL) 
        free_arr(arr, arr_facts);
      else 
        free_sparse(spar, *rows, true);
    error(174, &bulletsign);
  }
  
  n = nq->variant.vc_2.numer;                     /* a bit tricky since nq may be a number. */
  if (!nq->numb) 
    num = poly_length(n);
  
  if (nq->numb || !lintmode && nq->variant.vc_2.rat || n->exp == 0 && num == 1) {
    if (*spar == NULL) 
      for (i = 1; i <= *rows; ++i) 
        for (j = 1; j <= *rows; ++j) {
          k = i + (*rows) * (j - 1) - 1;
          if (!*arr_free) 
            (*arr)[k] = NULL;
          if (i == j) 
            quoly_assign(nq, &(*arr)[k]);
          else 
            quoly_set(0, &(*arr)[k]);
        }
    else {
      spar_identi(spar, *rows, *arr_free);
      mult_cons_sparse(spar, nq, true, *rows);
    }
    *arr_free = true;
    return;
  }
  
  quoly_at_matrix_Env.t = NULL;
  newquoly(&quoly_at_matrix_Env.qq);
  
  /* first step is special case - deal with leading coef, which is not a matrix. */
  if (n->numb) {                                  /* possible only in laurent */
    quoly_at_matrix_Env.qq->numb = true;
    quoly_at_matrix_Env.qq->variant.vc_1.ncoef = n->variant.ncoef;
  } else {
    q = n->variant.pcoef;
    if (q->numb && q->next == NULL) {
      quoly_at_matrix_Env.qq->numb = true;
      quoly_at_matrix_Env.qq->variant.vc_1.ncoef = q->variant.ncoef;
    } else {
      pad_1(q, &quoly_at_matrix_Env);             /* must pad with dummy node for depth. sets t. */
      quoly_at_matrix_Env.qq->numb = false;
      quoly_at_matrix_Env.qq->variant.vc_2.denom = NULL;
      quoly_at_matrix_Env.qq->variant.vc_2.rat = false;
      quoly_at_matrix_Env.qq->variant.vc_2.numer = quoly_at_matrix_Env.t;
    }
  }
  
  /* answer is built up in arr2, spar2 */
  quoly_at_matrix_Env.spar2 = NULL;
  new_worknode(&i, &bulletsign);                  /* necessary even if spar <> nil */
  quoly_at_matrix_Env.arr2 = workhead[i - 1];
  if (*spar == NULL) {
    forEnd_85 = arr_facts->arrsize.head->value - 1;
    for (i = 0; i <= forEnd_85; ++i) 
      (*quoly_at_matrix_Env.arr2)[i] = NULL;
  }
  
  arr2_free = true;
  quoly_at_matrix_Env.arr2_facts.arrsize.size = 0;
  spec_num_assign(&arr_facts->arrsize, &quoly_at_matrix_Env.arr2_facts.arrsize);  /* Oct 2000 */
  quoly_at_matrix_Env.arr2_facts.rows = arr_facts->rows;
  if (num == 1) 
    nextexp = n->exp;
  else 
    nextexp = n->exp - n->next->exp;
  if (nextexp > 1 || nextexp < 0) {               /* nextexp can't be 0 here. */
    /* nextexp < 0 only if num = 1 */
    if (*spar == NULL) {
      forEnd_86 = arr_facts->arrsize.head->value - 1;
      for (i = 0; i <= forEnd_86; ++i) 
        quoly_assign((*arr)[i], &(*quoly_at_matrix_Env.arr2)[i]);
    } else 
      copy_sparse(spar, &quoly_at_matrix_Env.spar2, *rows, false);
    matrix_power(quoly_at_matrix_Env.arr2, &quoly_at_matrix_Env.arr2_facts, 
                 &arr2_free, nextexp, &quoly_at_matrix_Env.spar2);
    if (quoly_at_matrix_Env.spar2 == NULL) {
      forEnd_87 = arr_facts->arrsize.head->value - 1;
      for (i = 0; i <= forEnd_87; ++i) 
        fast_quoly_mult(&(*quoly_at_matrix_Env.arr2)[i], &quoly_at_matrix_Env.qq);  /* Dec 2001 */
    } else 
      mult_cons_sparse(&quoly_at_matrix_Env.spar2, quoly_at_matrix_Env.qq, 
                       arr2_free, *rows);
  } else if (*spar == NULL) {
    forEnd_88 = arr_facts->arrsize.head->value - 1;
    for (i = 0; i <= forEnd_88; ++i) 
      quoly_mult(quoly_at_matrix_Env.qq, (*arr)[i], &(*quoly_at_matrix_Env.arr2)[i]);
  } else {
    copy_sparse(spar, &quoly_at_matrix_Env.spar2, *rows, false);
    mult_cons_sparse(&quoly_at_matrix_Env.spar2, quoly_at_matrix_Env.qq, 
                     true, *rows);
  }
  
  if (num > 1)
    n = n->next;
  else 
    finish_3(&quoly_at_matrix_Env);               /* exit */
  
  /* If get here, no switch of storage format spar2 -> arr2 has occurred. */
  if (n->numb) 
    add_scalar(n, &quoly_at_matrix_Env);
  else if (n->variant.pcoef->numb && n->variant.pcoef->next == NULL) 
    add_scalar(n->variant.pcoef, &quoly_at_matrix_Env);
  else {                                          /* must pad with dummy node for depth */
    if (quoly_at_matrix_Env.t == NULL)            /* one time only */
      pad_1(n->variant.pcoef, &quoly_at_matrix_Env);  /* sets t */
    else 
      quoly_at_matrix_Env.t->variant.pcoef = n->variant.pcoef;  /* reuse pad created first time. */
    add_scalar(quoly_at_matrix_Env.t, &quoly_at_matrix_Env);
  }
  
  /* handle other coeffs with loop. */
  /* arr3, spar3 used for powers of matrix, including negative powers.
     arr3 may in fact never be used. */
  arr3 = NULL;
  arr3_free = false;
  quoly_at_matrix_Env.arr3_facts.arrsize.size = 0;  /* Oct 2000 */
  if (num > 2 || n->exp > 1 || n->exp < 0) {      /* will probably need space for 
                                                     matrix power.  definitely will 
                                                     if num = 2 and n^.exp > 1, < 0 */
    new_worknode(&i, &bulletsign);
    arr3 = workhead[i - 1];                       /* note move */
    if (*spar == NULL) {
      forEnd_89 = arr_facts->arrsize.head->value - 1;
      for (i = 0; i <= forEnd_89; ++i) 
        (*arr3)[i] = NULL;
    }
    /* it is not necessary to nil out the quolies in arr3^ if 
       spar <> nil, even if storage shift occurs later. */
    spec_num_assign(&arr_facts->arrsize, &quoly_at_matrix_Env.arr3_facts.arrsize);  /* Oct 2000 */
    quoly_at_matrix_Env.arr3_facts.rows = arr_facts->rows;
  }
  
  spar3 = NULL;
  forEnd_91 = num - 2;
  for (i = 1; i <= forEnd_91; ++i) {              /* Horner's method */
    nextexp = n->exp - n->next->exp;
    /* no switch of storage format spar3 -> arr3 can occur in this loop.
       Recall also that no switch of format spar2 -> arr2 has occurred. */
    if (nextexp > 1) {                            /* raise arr to power and put in arr3 */
      if (*spar == NULL) {
        forEnd_90 = arr_facts->arrsize.head->value - 1;
        for (j = 0; j <= forEnd_90; ++j) 
          quoly_assign((*arr)[j], &(*arr3)[j]);
      } else {
        if (spar3 != NULL) 
          free_sparse(&spar3, arr_facts->rows, true);
        copy_sparse(spar, &spar3, arr_facts->rows, false);
      }
      arr3_free = true;
      matrix_power(arr3, &quoly_at_matrix_Env.arr3_facts, &arr3_free, nextexp, &spar3);
      matrix_mult(quoly_at_matrix_Env.arr2, arr3, &quoly_at_matrix_Env.arr2_facts, 
                  &quoly_at_matrix_Env.arr3_facts, arr2_free, &quoly_at_matrix_Env.spar2, 
                  &spar3);
    } else 
      matrix_mult(quoly_at_matrix_Env.arr2, arr, &quoly_at_matrix_Env.arr2_facts, 
                  arr_facts, arr2_free, &quoly_at_matrix_Env.spar2, spar);
    
    n = n->next;
    if (n->numb) 
      add_scalar(n, &quoly_at_matrix_Env);
    else if (n->variant.pcoef->numb && n->variant.pcoef->next == NULL) 
      add_scalar(n->variant.pcoef, &quoly_at_matrix_Env);
    else {                                        /* must pad with dummy node for depth */
      if (quoly_at_matrix_Env.t == NULL)          /* will be first time */
        pad_1(n->variant.pcoef, &quoly_at_matrix_Env);  /* sets t */
      else 
        quoly_at_matrix_Env.t->variant.pcoef = n->variant.pcoef;  /* reuse pad created first time.*/
      add_scalar(quoly_at_matrix_Env.t, &quoly_at_matrix_Env);
    }
  }
  
  if (n->exp > 1 || n->exp < 0) {
    if (*spar == NULL) {
      forEnd_92 = arr_facts->arrsize.head->value - 1;
      for (i = 0; i <= forEnd_92; ++i) 
        quoly_assign((*arr)[i], &(*arr3)[i]);
    } else {
      if (spar3 != NULL) 
        free_sparse(&spar3, arr_facts->rows, true);
      copy_sparse(spar, &spar3, arr_facts->rows, false);
    }
    arr3_free = true;
    /* spar3 might flip format to arr3 here, only if n^.exp < 0. */
    matrix_power(arr3, &quoly_at_matrix_Env.arr3_facts, &arr3_free, n->exp, &spar3);
    /* spar2 might flip format to arr2 here. matrix_mult will do the
       right thing. */
    matrix_mult(quoly_at_matrix_Env.arr2, arr3, &quoly_at_matrix_Env.arr2_facts, 
                &quoly_at_matrix_Env.arr3_facts, arr2_free, &quoly_at_matrix_Env.spar2, 
                &spar3);
  } else if (n->exp == 1) 
    matrix_mult(quoly_at_matrix_Env.arr2, arr, &quoly_at_matrix_Env.arr2_facts, 
                arr_facts, arr2_free, &quoly_at_matrix_Env.spar2, spar);
  /* else if n^.exp = 0 do nothing */
  
  if (arr3_free)                                  /* iff arr3 was used */
    if (spar3 == NULL) 
      free_arr(arr3, &quoly_at_matrix_Env.arr3_facts);
    else 
      free_sparse(&spar3, *rows, true);
  if (arr3 != NULL) 
    free_work();                                  /* moved from just above */
  
  finish_3(&quoly_at_matrix_Env);
}

/***************************************************************************/

struct single_rubout_EnvRec {
  tokentipe oldtok;
  arrptr r;
  nameptr *flag;
  arrptr u2;
  short i;  /* Dec 2007. leave it for now, as sme routines use short */
  funcptr p;
  funcptr s;
  jmp_buf single_rubout_exit;
};
typedef struct single_rubout_EnvRec single_rubout_EnvRec;

/************************************************************************/

static void removearray(Boolean fast, single_rubout_EnvRec *single_rubout_Env)
{
  /* Remove the array called oldtok. Leave r pointing to node removed.
     This is a very delicate procedure.*/
  
  long locat;
  long length;
  long i;
  arrptr u;
  arrptr bad;
  short j;
  Boolean array_param;
  long forEnd_93;
  long forEnd_94;

  locat = fastestlookup(&single_rubout_Env->oldtok, &single_rubout_Env->r);  /*spar*/
  if (fast && single_rubout_Env->r == NULL) 
    return;                                       /* moved */
  if (locat == -1) 
    error(28, &token);
  array_param = single_rubout_Env->r->time < 0;
  if (array_param) 
    if (levelcount == 1 && *single_rubout_Env->flag == NULL) 
      fprintf(stdout, " Warning.  About to delete an array parameter.\n");
    else {
      if (single_rubout_Env->u2 != NULL) 
        ustrcpy(single_rubout_Env->u2->name.name, single_rubout_Env->oldtok.name);
      error(138, &single_rubout_Env->oldtok);
      fprintf(stdout, " Cancel aborted.\n");
      longjmp(single_rubout_Env->single_rubout_exit, -1);
       /*exit(::single_rubout) ~ up-level function exit*/
    }
  
  length = single_rubout_Env->r->stop - single_rubout_Env->r->start + 1;
  /* yes! don't use r^.size! spar.  should be 0 for sparse Aug 2002 */

  /* First, fix up the list in arr_store containing oldtok. Remove the
     node containing oldtok. */
  if (single_rubout_Env->oldtok.address == -1) 
    j = hash(&single_rubout_Env->oldtok.name, 151);
  else 
    j = single_rubout_Env->oldtok.address;
  
  single_rubout_Env->r = arr_store[j];
  u = NULL;
  while (ustrcmp(single_rubout_Env->r->name.name, single_rubout_Env->oldtok.name) != 0) {
    u = single_rubout_Env->r;
    single_rubout_Env->r = single_rubout_Env->r->next;
  }
  if (u == NULL) 
    arr_store[j] = arr_store[j]->next;
  else 
    u->next = single_rubout_Env->r->next;
  single_rubout_Env->r->next = arr_garb;
  arr_garb = single_rubout_Env->r;                /* r still points to the node. */
  if (array_param) 
    return;                                       /* don't touch the storage */
  
  /* now free the storage */
  if (single_rubout_Env->r->spar != NULL) 
    free_sparse(&single_rubout_Env->r->spar, single_rubout_Env->r->rows, true);
  
  if (length == 0)                                /*spar     sparse test!  Aug 2002 */
    return;
  forEnd_93 = locat + length - 1;
  for (i = locat; i <= forEnd_93; ++i) 
    free_quoly(&(*arp[BSR(i, 10)])[BAnd(i, tenmask)]);
  forEnd_94 = endarr - length;
  
  for (i = locat; i <= forEnd_94; ++i) 
    (*arp[BSR(i, 10)])[BAnd(i, tenmask)] = (*arp[BSR(i + length, 10)])[BAnd(i + length, tenmask)];
  
  for (i = endarr - length + 1; i <= endarr; ++i) 
    (*arp[BSR(i, 10)])[BAnd(i, tenmask)] = NULL;
  
  endarr -= length;
  
  /* don't change numblocks -- it's the number of so far allocated blocks,
    empty or not. */
  
  /* Now patch up all the other nodes in arr_store, using the time field
     stored in locat. */
  bad = NULL;
  locat = single_rubout_Env->r->time;             /* r^.time must be positive here */
  for (i = 0; i <= 150; ++i) {
    u = arr_store[i];
    while (u != NULL) {
      if (abs(u->time) > locat && u->spar == NULL) {  /* OLD BUG Aug 2002 */
        u->start = u->start - length;
        u->stop = u->stop - length;
      } else if (u->time == -locat)               /* just cancelled an array with alias u^.name */
        if (levelcount == 1 && *single_rubout_Env->flag == NULL) {
          fprintf(stdout, " Warning. Encountered array parameter named %s,\n", u->name.name);
          fprintf(stdout, " which is an alias of %s.  Delete it immediately.\n",
	          single_rubout_Env->oldtok.name);
        } else 
          bad = u;                                /* call error later */
      u = u->next;
    }
  }
  if (bad != NULL) {
    if (single_rubout_Env->u2 != NULL) 
      ustrcpy(single_rubout_Env->u2->name.name, single_rubout_Env->oldtok.name);
    error(139, &bad->name);
    fprintf(stdout, " Cancel aborted.\n");
  }
}

/************************************************************************/

static void find_pointer(single_rubout_EnvRec *single_rubout_Env)
{
  if (token.address == -1) 
    single_rubout_Env->i = hash(&token.name, 71);
  else 
    single_rubout_Env->i = token.address;
  single_rubout_Env->p = func_store[single_rubout_Env->i];
  if (single_rubout_Env->p == NULL) 
    error(20, &token);
  while (ustrcmp(token.name, single_rubout_Env->p->name.name) != 0) {
    single_rubout_Env->s = single_rubout_Env->p;
    single_rubout_Env->p = single_rubout_Env->p->next;
    if (single_rubout_Env->p == NULL) 
      error(20, &token);
  }
}

/************************************************************************/

void single_rubout(textptr inf, nameptr *flag)
{
  varptr q;
  varptr t;
  long ii;  /* Dec 2007. BUG fix */
  tokentipe secondtok;
  single_rubout_EnvRec single_rubout_Env;

  if (setjmp(single_rubout_Env.single_rubout_exit)) 
    return;
  single_rubout_Env.flag = flag;
  single_rubout_Env.u2 = NULL;
  if (token.name[0] >= 'a' && token.name[0] <= 'z') {
    if (token.address == -1) 
      single_rubout_Env.i = hash(&token.name, 151);
    else 
      single_rubout_Env.i = token.address;
    q = sca_store[single_rubout_Env.i];
    if (q == NULL) {
      error(19, &token);
      return;
    }
    while (ustrcmp(token.name, q->let.name) != 0) {
      t = q;
      q = q->next;
      if (q == NULL) {
        error(19, &token);
        return;
      }
    }
    if (q == sca_store[single_rubout_Env.i]) 
      sca_store[single_rubout_Env.i] = sca_store[single_rubout_Env.i]->next;
    else 
      t->next = q->next;
    q->next = var_garb;
    var_garb = q;
    free_quoly(&q->val);
  } else if (ustrcmp(token.name, "[") == 0) {
    scanner(inf, &single_rubout_Env.oldtok, flag);
    if (ustrcmp(single_rubout_Env.oldtok.name, "<") == 0)
      error(176, &single_rubout_Env.oldtok);
    scanner(inf, &token, flag);
    if (ustrcmp(single_rubout_Env.oldtok.name, "*") == 0) {
      secondtok = token;
      scanner(inf, &token, flag);
    }
    if (ustrcmp(token.name, "]") != 0) 
      error(24, &token);
    if (ustrcmp(single_rubout_Env.oldtok.name, "*") == 0) 
      if (ustrcmp(secondtok.name, "*") == 0) 
        for (single_rubout_Env.i = 0; single_rubout_Env.i <= 150; ++single_rubout_Env.i) 
          while (arr_store[single_rubout_Env.i] != NULL) {
            single_rubout_Env.oldtok = arr_store[single_rubout_Env.i]->name;
            removearray(false, &single_rubout_Env);
          }
      else if (secondtok.name[0] < 'a' || secondtok.name[0] > 'z') 
        error(28, &secondtok);
      else {
        single_rubout_Env.oldtok = secondtok;
        removearray(true, &single_rubout_Env);
        if (single_rubout_Env.r == NULL) 
          error(28, &single_rubout_Env.oldtok);
        else 
          do 
            removearray(true, &single_rubout_Env);
          while (single_rubout_Env.r != NULL);
      }
    else 
      removearray(false, &single_rubout_Env);
  } else if (token.name[0] >= 'A' && token.name[0] <= 'Z') {
    find_pointer(&single_rubout_Env);             /*p*/
    if (single_rubout_Env.p == func_store[single_rubout_Env.i]) 
      func_store[single_rubout_Env.i] = func_store[single_rubout_Env.i]->next;
    else 
      single_rubout_Env.s->next = single_rubout_Env.p->next;
  }
  
  else if (ustrcmp(token.name, "<") == 0) {    /* purge array or function */
    scanner(inf, &token, flag);
    if (token.name[0] >= 'A' && token.name[0] <= 'Z') {
      scanner(inf, &single_rubout_Env.oldtok, flag);
      if (ustrcmp(single_rubout_Env.oldtok.name, ">") != 0) 
        error(128, &token);
      find_pointer(&single_rubout_Env);           /*p*/
      single_rubout_Env.s = single_rubout_Env.p;
      single_rubout_Env.p = single_rubout_Env.p->next;
      while (single_rubout_Env.p != NULL) {
        if (ustrcmp(token.name, single_rubout_Env.p->name.name) == 0) 
          single_rubout_Env.s->next = single_rubout_Env.p->next;
        else 
          single_rubout_Env.s = single_rubout_Env.p;
        single_rubout_Env.p = single_rubout_Env.p->next;
      }
    } else if (ustrcmp(token.name, "[") == 0) {
      scanner(inf, &single_rubout_Env.oldtok, flag);
      ii = fastestlookup(&single_rubout_Env.oldtok, &single_rubout_Env.r);   /* Dec 2007 */
      if (ii == -1)    /* Dec 2007 */
        error(28, &single_rubout_Env.oldtok);
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, "]") != 0) 
        error(24, &token);
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, ">") != 0) 
        error(128, &token);
      ustrcpy(single_rubout_Env.r->name.name, " temp*");  /* impossible name. changed Dec 2007 from hell */
      single_rubout_Env.u2 = single_rubout_Env.r;
      do 
        removearray(true, &single_rubout_Env);
      while (single_rubout_Env.r != NULL);
      ustrcpy(single_rubout_Env.u2->name.name, single_rubout_Env.oldtok.name);  /* put it back */
    } else 
      error(208, &token);
  }
  
  
  else 
    error(21, &token);
}

/***************************************************************************/

struct load_EnvRec {
  short i;
  /* Jul 2002, now reverse arrays just like functions. */
  
  /*func_st_type oldfunc_store; AAR*/ funcptr *oldfunc_store;
  /*arr_st_type oldarr_store; AAR */ arrptr *oldarr_store; /* Jul 2002 */
};
typedef struct load_EnvRec load_EnvRec;

/******************************************************************/

static void reverse(load_EnvRec *load_Env)
{
  funcptr p;
  funcptr q;

  q = func_store[load_Env->i];
  func_store[load_Env->i] = load_Env->oldfunc_store[load_Env->i];
  while (q->next != load_Env->oldfunc_store[load_Env->i]) {
    p = q->next;
    q->next = func_store[load_Env->i];
    func_store[load_Env->i] = q;
    q = p;
  }
  q->next = func_store[load_Env->i];
  func_store[load_Env->i] = q;
}

/******************************************************************/

static void arr_reverse(load_EnvRec *load_Env)    /* Jul 2002 */
{
  /* reverse the function list down to what was there before the load */
  
  arrptr p;
  arrptr q;

  q = arr_store[load_Env->i];
  arr_store[load_Env->i] = load_Env->oldarr_store[load_Env->i];
  while (q->next != load_Env->oldarr_store[load_Env->i]) {
    p = q->next;
    q->next = arr_store[load_Env->i];
    arr_store[load_Env->i] = q;
    q = p;
  }
  q->next = arr_store[load_Env->i];
  arr_store[load_Env->i] = q;
}

/******************************************************************/

void load(textptr inf, quolyptr n, nameptr *flag, bigstring newtok, Boolean *quit)

   { /* p2c note: see start of save.  Jul 2003 */
  
  Boolean old_tt;
  Boolean old_int;
  tokentipe oldtok;
  tokentipe other;
  shortstring oldleft;
  nameptr myzilch;              /*@@@ use instead of system global zilch */
  load_EnvRec load_Env;
  char xx;  /* Jun 2003 */

  load_Env.oldfunc_store = func_store;
  load_Env.oldarr_store = arr_store;              /* Jul 2002 */
  old_int = integerflag;
  integerflag = false;
  minus_warning = true;                           /* August 1996 */
  *quit = false;
  myzilch = NULL;                                 /*@@@ all myzilch here*/
 
	if (*n == NULL)   /* Feb 2011. failsafe. probably not necessay. bug fix, Feb 17. */
		quoly_set(0, n);
		 
	if (ustrcmp(input_file_name, "") == 0 || ustrcmp(token.name, "R") == 0) {
    if (ustrcmp(newtok, " ") != 0)             /* nothing */
      ;
    else {
      scanner(inf, &oldtok, flag);             /* must do this now */
      *quit = true;
      fprintf(stdout, "Enter name of input file: \n");
      do_prompts();
      scanner(&Input, &other, &myzilch);
      if (other.name[0] == '@') {
        fprintf(stdout, "*** Read cancelled\n");
        ustrcpy(token.name, ";");
        ustrcpy(leftover, "");
        return;
      } else if (other.name[0] == '\'') {
        ustrcpy(newtok, "");
        load_Env.i = 0;
        do {
          dumbscanner(&Input, &other, &myzilch, &old_tt);  /* old_tt is dummy here */
          if (ustrcmp(token.name, "¥") == 0)   /* the old omega */
            error(33, &token);
          load_Env.i += ustrlen(other.name);
          if (load_Env.i <= 255) {
            if (ustrcmp(other.name, "\'") != 0) 
	      ustrcat(newtok,other.name);
          } else {
            fprintf(stdout, "*** Warning. Name is too long.\n");
            break;
          }
        } while (ustrcmp(other.name, "\'") != 0);
      } else if (other.name[0] == '[') 
        get_from_array(&Input, flag, newtok);     
      else {
        ustrcpy(newtok, other.name);
        fprintf(stdout, "\n");
      }
      ustrcpy(leftover, "");
    }
    if (ustrcmp(newtok, "") == 0) 
      error(248, &token);
    if (ustrcmp(newtok, output_file_name) == 0) 
      error(149, &token);
    if (ustrcmp(newtok, "@") == 0) {           /* Jul 2002, was bullet */
      fclose(inpuf);
      if (ustrcmp(input_file_name, "") == 0) 
        if (*flag == NULL) 
          fprintf(stdout, " *** Warning. No input file had been open.\n");
        else                                      /* nothing */
          ;
      else {
        if (*flag == NULL) 
          fprintf(stdout, " Now closing %s.\n", input_file_name);
        ustrcpy(input_file_name, "");
      }
      return;
    }
    ustrcpy(input_file_name, newtok);
    if (ustrcmp(token.name, "R") == 0 && inpuf != NULL)  /* fix crashing bug, Jul 2003 */
       fclose(inpuf);
    inpuf = fopen((char *)input_file_name, "r");
    
    if (inpuf == NULL) {    /*  fix crashing bug, Jul 2003 */
			fprintf(stdout, " *** Warning. %s: no such file. Read cancelled.\n", input_file_name);
			ustrcpy(input_file_name, "");
			ustrcpy(token.name, ";");
			ustrcpy(leftover, "");
			error(374, &token);   /* Feb 2011. bug fix, Feb 17. */			
			return;
    }
    done_load = false;                    /* global var "done_load" */
  }
  
  if (!done_load) 
    rewind(inpuf);
    
  done_load = false;
  old_tt = tt_flag;
  tt_flag = false;
  ustrcpy(oldleft, leftover);
  ustrcpy(leftover, "");
  new_funcs = false;                       /* Jul 2002, new name */
  new_array = false;                       /* Jul 2002 */
  if (feof(inpuf)) 
    fprintf(stdout, "*** Warning.  End of file %s encountered.\n", input_file_name);
  
  while (!feof(inpuf) && !done_load) {
    scanner(&inpuf, &token, &myzilch);
    if (feof(inpuf)) {
      ustrcpy(leftover, "");
      break;
    }
    free_quoly(n);                                /* a failsafe; leave it */
    c_cntcount = 0;                               /* Mar 2001 */
    c_cntdepth = 0;                               /* Dec 2003 */
    a_cntcount = 0;                               /* Dec 2001 */
    d_cntcount = 0;                               /* Dec 2001 */
    g_cntcount = 0;                               /* Nov 2002 */
    g_cutoff = default_gc;                                 /* Nov 2002 */
    uninit = 0;                                   /* Jul 2002 */
    alg_c_count = 0;  /* Mar 2008 */
    original_depth = 1;   /* Feb 2011 */
		
    xx = token.name[0]; 
    if (ustrcmp(token.name, "Diag") == 0)
       xx = '~';
    if (ustrcmp(token.name, "Trans") == 0)
       xx = '"';

    switch (xx) {     /* Jun 2003 */
      
      case '!':
      case ';':
        parse(&inpuf, n, &myzilch);
        break;
      case '~':
      case '[':
      case '"':
        arr_parse(xx, &inpuf, n, &myzilch);
        break;
      case 'A':
        if (ustrcmp(token.name, "Adjoint") == 0 || ustrcmp(token.name, "Altmult") == 0 ||
	    ustrcmp(token.name, "Altpower") == 0)
          arr_parse('A', &inpuf, n, &myzilch);
        else 
          old_expre(&inpuf, n, &myzilch);
        break;
      case 'M':
        if (ustrcmp(token.name, "MPowermod") == 0)   /* Mar 1999 */
          arr_parse('M', &inpuf, n, &myzilch);
        else 
          old_expre(&inpuf, n, &myzilch);
        break;
      default:
        parse(&inpuf, n, &myzilch);               /* Nov 1997 expre(inpuf, n, myzilch)*/
        break;
    }
    if (ustrcmp(token.name, ";") != 0 && ustrcmp(token.name, "¥") != 0 && 
        ustrcmp(token.name, "@") != 0 && ustrcmp(token.name, ":") != 0) 
      error(129, &token);                         /* May 2002 */
    /*  if noisy
          then plflush(output);  BUG  Dec 1996 */
    /* if parse sees &x, done_load becomes true */
    fscanf(inpuf,"%*[^\n]");
    getc(inpuf);
  }
  if (*n == NULL) 
    quoly_set(0, n);
  
  if (new_funcs)                                  /* was tripped by funcdef. Jul 2002 */
    for (load_Env.i = 0; load_Env.i <= 70; ++load_Env.i) 
      if (func_store[load_Env.i] != load_Env.oldfunc_store[load_Env.i]) 
        reverse(&load_Env);                       /* i */
  
  if (new_array)                                  /* was tripped by Array builtin.  Jul 2002  */
    for (load_Env.i = 0; load_Env.i <= 150; ++load_Env.i) 
      if (arr_store[load_Env.i] != load_Env.oldarr_store[load_Env.i]) 
        arr_reverse(&load_Env);                   /* i */
  
  tt_flag = old_tt;
  integerflag = old_int;
  minus_warning = false;                          /* August 1996 */
  if (*quit) 
    token = oldtok;
  else if (*flag == NULL) 
    ustrcpy(leftover, oldleft);
}

/******************************************************************************/

void iarretrieve(tokentipe *x, quolyptr *qp, nameptr *flag, Boolean *sparse)
{
  /* big changes, Nov 1997 */
  
  long r;
  long c;
  arrptr q;                                       /* arrptr for array named x */
  Boolean colflag;                                /* is a second coordinate present? */

  *flag = (*flag)->next;
  token = (*flag)->let;
  ievalcoords(&r, &c, flag, &colflag);
  *flag = (*flag)->next;
  token = (*flag)->let;
  lookup(x, r, c, &q, qp, colflag);
  /* q can't be nil */
  *sparse = q->spar != NULL;
  if (*qp == NULL)                                /* sparse array, no entry */
    return;
  if (**qp == NULL) 
    quoly_set(0, *qp);                            /* Jan 1998; new grammar */
  else if (!(*(*qp))->numb) 
    error(227, x);                                /* used to be 253 !?!? */
}

/**************************************************************************/

void special_set_quol(quolyptr p)
{
  newquoly(p);
  (*p)->numb = true;
  init_quoly_node(*p);
  setvalue(0, (*p)->variant.vc_1.ncoef);
}

/****************************************************************************/

struct change_prec_EnvRec {
  Boolean wasmodular;
  FILEPtr *inf;
};
typedef struct change_prec_EnvRec change_prec_EnvRec;

/*************************************************************************/

struct quoly_change_num_EnvRec {
  jmp_buf quoly_change_num_exit;
};
typedef struct quoly_change_num_EnvRec quoly_change_num_EnvRec;

/* the old standard way of going to modularmode.  Free nodes if coeffs become 0. */

/*************************************************************************/

static void check_0_quoly(quolyptr q, quoly_change_num_EnvRec *quoly_change_num_Env)
{
  if ((*q)->variant.vc_2.denom == NULL || poly_iszero((*q)->variant.vc_2.denom)) {
    free_quoly(q);
    fprintf(stdout, "Warning. A zero quoly denominator was found. That quoly was set to 0.\n");
    fflush(stdout);
    longjmp(quoly_change_num_Env->quoly_change_num_exit, -1);
    /*exit(::quoly_change_num) ~ up-level function exit*/
  }
}

/******************************************************************************/

static void quoly_change_num(quolyptr q)
{
  quoly_change_num_EnvRec quoly_change_num_Env;

  if (setjmp(quoly_change_num_Env.quoly_change_num_exit)) 
    return;
  if ((*q)->numb) 
    change_num((*q)->variant.vc_1.ncoef, true, true);
  else {
    (*q)->variant.vc_2.rat = false;
    poly_change_num(&(*q)->variant.vc_2.numer);
    if ((*q)->variant.vc_2.numer == NULL) { /* only in changing to modular mode and getting 0's */
      free_quoly(q);
      return;
    }
    if ((*q)->variant.vc_2.denom != NULL) {
      poly_change_num(&(*q)->variant.vc_2.denom);
      check_0_quoly(q, &quoly_change_num_Env);
      check_quoly(q, laurent);                    /* was false.  5/94 */
    } else if ((*q)->variant.vc_2.numer->numb && (*q)->variant.vc_2.numer->next == NULL) 
      polynum_to_quoly(q);
  }
}

/*********************************************************************/

static void change_vars(Boolean wasmodular)  /* Jun 2006 */
{
  /* if going to mod mode, modularmode is true,  Don't have to change the 
     global < because it's going to be 0. **!!  I don't believe this anymore!
     July 1995. I have inserted various changes of prevnum. */
  
  varptr p;
  short i;

  for (i = 0; i <= 150; ++i) {
    p = sca_store[i];
    while (p != NULL) {
      if (wasmodular) 
        quoly_change_from_mod(p->val);
      else 
        quoly_change_num(&p->val);
      if (p->val == NULL) 
        special_set_quol(&p->val);
      p = p->next;
    }
  }
}

/**********************************************************************/

static void change_arrays(Boolean wasmodular)  /* Jun 2006 */
{
  /* if going to mod mode, modularmode is true */
  
  long i;
  quolyptr qp;

  for (i = 0; i <= endarr; ++i) {
    qp = &(*arp[BSR(i, 10)])[BAnd(i, tenmask)];
    if (*qp != NULL) {
      if (wasmodular) 
        quoly_change_from_mod(*qp);
      else 
        quoly_change_num(qp);
      if (*qp == NULL) 
        special_set_quol(qp);
    }
  }
  
  if (syst->spar == NULL) 
    for (i = 0; i <= syst->stop; ++i) 
      if (wasmodular) 
        quoly_change_from_mod((*stash)[i]);
      else 
        quoly_change_num(&(*stash)[i]);
}

/************************************************************************/

static void sparse_change_from_mod(arrptr ap)
{
  long i;
  long j;
  colm_ptrptr u;
  sparseptr sp;
  long forEnd_95;
  long forEnd_96;

  sp = ap->spar;
  forEnd_96 = (ap->rows - 1) / sparsesize;
  for (i = 0; i <= forEnd_96; ++i) {
    forEnd_95 = (i + 1) * sparsesize;
    for (j = 1 + i * sparsesize; j <= forEnd_95; ++j) 
      if (j > ap->rows) 
        break;
      else {
        u = &sp->indx[(j - i * sparsesize) - 1];
        while (*u != NULL) {
          quoly_change_from_mod((*u)->val);
          u = &(*u)->next;
        }
      }
    sp = sp->next;
  }
}

/************************************************************************/

static void sparse_change(arrptr ap)
{
  long i;
  long j;
  colm_ptrptr u;
  sparseptr sp;
  long forEnd_97;
  long forEnd_98;

  sp = ap->spar;
  forEnd_98 = (ap->rows - 1) / sparsesize;
  for (i = 0; i <= forEnd_98; ++i) {
    forEnd_97 = (i + 1) * sparsesize;
    for (j = 1 + i * sparsesize; j <= forEnd_97; ++j) 
      if (j > ap->rows) 
        break;
      else {
        u = &sp->indx[(j - i * sparsesize) - 1];
        while (*u != NULL) {
          quoly_change_num(&(*u)->val);
          if ((*u)->val == NULL || quoly_iszero((*u)->val)) 
            free_colm(u);
          else 
            u = &(*u)->next;
        }
      }
    sp = sp->next;
  }
}

/************************************************************************/

static void change_sparses(Boolean wasmodular)  /* Jun 2006 */
{
  /* if going to mod mode, modularmode is true; else it's false. */
  
  short i;
  arrptr ap;

  for (i = 0; i <= 150; ++i) {
    ap = arr_store[i];
    while (ap != NULL) {
      if (ap->spar != NULL) {
        if (ap->spar->modmode != modularmode) 
          if (wasmodular) 
            sparse_change_from_mod(ap);
          else 
            sparse_change(ap);
        ap->spar->modmode = modularmode;
      }
      ap = ap->next;
    }
  }
  
  if (syst->spar != NULL) {
    if (syst->spar->modmode != modularmode) 
      if (wasmodular) 
        sparse_change_from_mod(syst);
      else 
        sparse_change(syst);
    syst->spar->modmode = modularmode;
  }
}

/*************************************************************************/

static void fast_change_vars(Boolean wasmodular)  /* Jun 2006 */
{
  varptr p;
  short i;

  if (wasmodular) {
    if (masterfix != NULL) 
      restore_from_mod(&masterfix);
    return;
  }
  for (i = 0; i <= 150; ++i) {
    p = sca_store[i];
    while (p != NULL) {
      quoly_change_to_mod(&p->val);
      p = p->next;
    }
  }
}

/**************************************************************************/

static void fast_change_arrays(Boolean wasmodular)  /* Jun 2006 */
{
  /* if going to mod mode, modularmode is true. 
        Subtlety with system array.  Must do it the long way, since 
     the user may unthinkingly change it later.  Warn user that it's best not 
     to have any system array if doing fast change. */
  
  long i;
  quolyptr qp;

  if (wasmodular) 
    if (masterfix == NULL)                        /* nothing */
      ;
    else 
      restore_from_mod(&masterfix);
  else 
    for (i = 0; i <= endarr; ++i) {
      qp = &(*arp[BSR(i, 10)])[BAnd(i, tenmask)];
      if (*qp != NULL) 
        quoly_change_to_mod(qp);
    }
  
  if (syst->spar == NULL) 
    for (i = 0; i <= syst->stop; ++i) 
      if (wasmodular) 
        quoly_change_from_mod((*stash)[i]);
      else 
        quoly_change_num(&(*stash)[i]);
}

/**************************************************************************/

static void fast_change_spar(arrptr q, Boolean fastway, Boolean wasmodular)  
  /* Jun 2006.  if not wasmodular, need to know that caller has turned on lintmode!  beware!  */
{
  long i;
  long j;
  colm_ptrptr u;
  sparseptr sp;
  sparse_fixer us;                                /* Feb 2004 */
  colm_ptr cp;                                    /* Feb 2004 */
  long forEnd_99;
  long forEnd_100;

  if (fastway && wasmodular) {  /* BUG fix and speed up. Jun 2006 */
    restore_from_mod(&masterfix);
	restore_sparsefix();
	return;
  }
  
  sp = q->spar;
  forEnd_100 = (q->rows - 1) / sparsesize;
  for (i = 0; i <= forEnd_100; ++i) {
    forEnd_99 = (i + 1) * sparsesize;
    for (j = 1 + i * sparsesize; j <= forEnd_99; ++j) 
      if (j > q->rows) 
        break;
      else {
        u = &sp->indx[(j - i * sparsesize) - 1];
        while (*u != NULL) {
          if (fastway)  /* Jun 2006. can't be wasmodular; see above fix. */
            quoly_change_to_mod(&(*u)->val);
          else if (wasmodular)
            quoly_change_from_mod((*u)->val);
          else 
            quoly_change_num(&(*u)->val);
 
          /* Feb 2004.  for following statement, 
             old comment here: "may introduce 0 to the sparse matrix; no choice".
             This was bad, of course.  big change below.  Jun 2006: quoly_iszero works here because lintmode is on when !wasmodular. */
          if ((*u)->val == NULL || quoly_iszero((*u)->val) ) 
            /* remove this node from the matrix! */
            if (fastway) {
              /* put this node on the sparsefix list */
              us = sparse_fix;
              sparse_fix = (sparse_fixer)malloc(sizeof(sparse_fixdata));
              sparse_fix->next = us;
              sparse_fix->prev = u;
              sparse_fix->node = *u;
              *u = (*u)->next;
            } else {
              /* put this node in the garbage */
              cp = (*u)->next;
              (*u)->next = colm_garb;
              colm_garb = *u;
              *u = cp;
            }
          else 
            u = &(*u)->next;
        }
      }
    sp = sp->next;
  }
}

/**************************************************************************/

static void fast_change_sparses(Boolean wasmodular)  /* Jun 2006 */
{
  /* do_one_name's 'fastway' is true on entry; it is in essence passed on
     to fast_change_spar. 
        See comment under fast_change_arrays above. 
        Feb 2004:  fastway means selective change, i.e. local.*/
  
  short i;
  arrptr ap;

  for (i = 0; i <= 150; ++i) {
    if (wasmodular) 
      if (masterfix == NULL) 
        break;
    ap = arr_store[i];
    while (ap != NULL) {
      if (ap->spar != NULL) {
        if (ap->spar->modmode != modularmode) 
          fast_change_spar(ap, true, wasmodular);
        ap->spar->modmode = modularmode;
        if (wasmodular) 
          if (masterfix == NULL) 
            break;
      }
      ap = ap->next;
    }
  }
  
  if (syst->spar != NULL) {
    /* Must change system array the slow way! */
    if (syst->spar->modmode != modularmode) 
      fast_change_spar(syst, false, wasmodular);
    syst->spar->modmode = modularmode;
  }
}

/***************************************************************************/

struct change_local_EnvRec {
  nameptr *flag;
  Boolean firstcall;
  tokentipe oldtok;
  jmp_buf change_local_exit;
};
typedef struct change_local_EnvRec change_local_EnvRec;

/*****************************************************************************/

static void prec_error(long num, tokentipe *tok, change_local_EnvRec *change_local_Env)
{
  fprintf(stdout, " *** Inappropriate symbol: %s\n", tok->name);
  out_err_mess(num);      /* Feb 2004: message below */
  fprintf(stdout, " Change of ground ring will continue. Some data may not be changed.\n");
  fflush(stdout);
  longjmp(change_local_Env->change_local_exit, -1);  /*exit(::change_local) ~ up-level function exit*/
}

/****************************************************************************/

static void do_one_name(change_prec_EnvRec *change_prec_Env, change_local_EnvRec *change_local_Env)
{
  
  arrptr q;
  varptr p;
  quolyptr qp;
  quoly n;
  long i;
  long m;
  long locat;
  Boolean fastway;

  fastway = false;
  if (ustrcmp(token.name, "*") == 0) {
    fastway = true;
    scanner(change_prec_Env->inf, &token, change_local_Env->flag);
    if (ustrcmp(token.name, "*") == 0) 
      if (change_local_Env->firstcall) {
        fast_change_vars(change_prec_Env->wasmodular);  /* Jun 2006 */
        fast_change_arrays(change_prec_Env->wasmodular);
        fast_change_sparses(change_prec_Env->wasmodular);
        scanner(change_prec_Env->inf, &token, change_local_Env->flag);
        longjmp(change_local_Env->change_local_exit, -1);
	/*exit(::change_local) ~ up-level function exit*/
      } else 
        prec_error(236, &token, change_local_Env);
  }
  if (ustrcmp(token.name, "[") == 0) {
    scanner(change_prec_Env->inf, &change_local_Env->oldtok, change_local_Env->flag);
    if (ustrcmp(change_local_Env->oldtok.name, "%") == 0) {
      n = NULL;
      get_arr_arr(change_prec_Env->inf, &n, change_local_Env->flag, &m);
      free_quoly(&n);
      q = (*arrstash)[m];
      if (q == NULL) 
        prec_error(220, &token, change_local_Env);
    } else {
      locat = fastestlookup(&change_local_Env->oldtok, &q);  /* don't want locat */
      if (q == NULL) 
        prec_error(28, &change_local_Env->oldtok, change_local_Env);
    }
    
    scanner(change_prec_Env->inf, &token, change_local_Env->flag);
    if (ustrcmp(token.name, "]") != 0) 
      prec_error(24, &token, change_local_Env);
    if (q->spar == NULL) 
      for (i = q->start; i <= q->stop; ++i) {
        qp = &(*arp[BSR(i, 10)])[BAnd(i, tenmask)];
        if (*qp != NULL) {
          if (fastway) 
            if (change_prec_Env->wasmodular) 
              if (masterfix != NULL) 
                restore_from_mod(&masterfix);
              else                                /* nothing */
                ;
            else 
              quoly_change_to_mod(qp);
          else if (change_prec_Env->wasmodular) 
            quoly_change_from_mod(*qp);
          else 
            quoly_change_num(qp);
          if (*qp == NULL) 
            special_set_quol(qp);
        }
      }
    else {
      if (q->spar->modmode != modularmode) 
        fast_change_spar(q, fastway, change_prec_Env->wasmodular);  /* Jun 2006 */
      q->spar->modmode = modularmode;
    }
  } else {
    if (token.address == -1) 
      i = hash(&token.name, 151);
    else 
      i = token.address;
    p = sca_store[i];
    while (p != NULL) 
      if (ustrcmp(p->let.name, token.name) == 0) 
        break;
      else 
        p = p->next;
    if (p == NULL) 
      prec_error(19, &token, change_local_Env);
    if (fastway) 
      if (change_prec_Env->wasmodular) 
        if (masterfix != NULL) 
          restore_from_mod(&masterfix);
        else                                      /* nothing */
          ;
      else 
        quoly_change_to_mod(&p->val);
    else if (change_prec_Env->wasmodular) 
      quoly_change_from_mod(p->val);
    else 
      quoly_change_num(&p->val);
    if (p->val == NULL) 
      special_set_quol(&p->val);
  }
  scanner(change_prec_Env->inf, &token, change_local_Env->flag);
}

/**************************************************************************/

static void change_local(nameptr flag, change_prec_EnvRec *change_prec_Env)
{ /* of change_local */
  
  long i;
  change_local_EnvRec change_local_Env;

  if (setjmp(change_local_Env.change_local_exit)) 
    return;
  change_local_Env.flag = &flag;
  token = flag->let;
  currentchar = flag->next;
  change_local_Env.firstcall = true;
  if (ustrcmp(token.name, ")") == 0)           /* nothing */
    ;
  else {
    do_one_name(change_prec_Env, &change_local_Env);
    change_local_Env.firstcall = false;
    while (ustrcmp(token.name, ")") != 0) {
      if (ustrcmp(token.name, ",") != 0)
        prec_error(358, &token, &change_local_Env);  /* was 122, Jun 2005  */
      scanner(change_prec_Env->inf, &token, &flag);
      do_one_name(change_prec_Env, &change_local_Env);
    }
  }

  if (syst->spar == NULL) 
    for (i = 0; i <= syst->stop; ++i) 
      if (change_prec_Env->wasmodular) 
        quoly_change_from_mod((*stash)[i]);
      else 
        quoly_change_num(&(*stash)[i]);
}

/***************************************************************************/

static void change_polydata(change_prec_EnvRec *change_prec_Env)
{
  /* if going to mod mode, modularmode is true. */
  
  polypt q;
  poly t;
  short i;
  short j;
  long limit;
  short forEnd_101;

  q = polynames;
  if (!change_prec_Env->wasmodular) 
    while (q != NULL) {
      if (q->p != NULL) 
        poly_change_to_mod(&q->p, false);  /* Aug 2004. these are the important falses */
      if (q->alt != NULL) {
        poly_change_to_mod(&q->alt, false);
        if (q->p == NULL)          /* possible! Nov 1996 */
          poly_set(0, &q->p);
      }
      if (q->multdata != NULL) {
        t = q->multdata;
        while (t != NULL) {
          poly_change_to_mod(&t->variant.pcoef, false);
          t = t->next;
        }
      }
      q = q->next;
    }
  
  if (!need_to_set_char_poly) 
    if (change_prec_Env->wasmodular) 
      if (masterfix != NULL) 
        restore_from_mod(&masterfix);
      else        /* nothing */
        ;
    else if (mod_is_prime && !chpoly_block) 
      for (i = 1; i <= full_charpol; ++i) 
        quoly_change_to_mod(&denom[i - 1]);
  
  if (limit_char_arrays < in_house_charpol)
    limit = limit_char_arrays;
  else 
    limit = in_house_charpol;
  
  if (!need_to_set_char_poly) 
    if (!change_prec_Env->wasmodular && mod_is_prime && !chpoly_block) 
      for (i = 1; i <= limit; ++i) {
        forEnd_101 = limit - 1;
        for (j = i - 1; j <= forEnd_101; ++j) 
          quoly_change_to_mod(&(*pol)[j][i - 1]);
      }
}

/****************************************************************************/

void change_prec(textptr inf, quolyptr num, nameptr *flag, long val2, nameptr np, Boolean
                 printstuff)
{
  /* Do not exit this procedure early. Certain delicate things must be done. */
  
  long n;
  Boolean local;
  change_prec_EnvRec change_prec_Env;

  change_prec_Env.inf = inf;
  change_prec_Env.wasmodular = false;
  local = np != NULL;
  
  if (modularmode) {
    if (printstuff) {
      fprintf(stdout, " Changing to rational arithmetic.\n");
      fflush(stdout);
    }

    if (changed_in_modmode) {  /* Feb 2005 */
      error(353, &token);
      return;
    }

    free_quoly(&prevnum);
    free_quoly(&sysnum);                          /* above too*/
    free_quoly(num);                              /* might be redundant, no problem */
    if (lookupgcd > 0) 
      free_gcd_stash();
    modularmode = false;
    lintmode = false;
    f256 = false;  /* Jun 2004 */
    f2t16 = false;
    finf = false;  /* Jul 2004 */
		reset_cutoffs(40);  /* Jan 2010. Aug 2010 8 -> 20 */
    poly_cutoff = 40;   /* was 8, Jun 2005. then 6. return to 8, Jan 2010. now 20, Aug 2010 */
    div_poly_cutoff = 6;
    quoly_set(0, &prevnum);
    quoly_set(0, num);
    quoly_set(0, &sysnum);                        /* failsafes. do it. */
    change_prec_Env.wasmodular = true;
    if (local) 
      change_local(np, &change_prec_Env);
    else {
      change_vars(change_prec_Env.wasmodular);  /* Jun 2006 */
      change_arrays(change_prec_Env.wasmodular);
      change_sparses(change_prec_Env.wasmodular);
    }
    change_polydata(&change_prec_Env);    /* will take care of masterfix, if nothing else has */
    modulus = -1;
    limit_char_arrays = full_charpol;
    was_in_rat = true;                      /* Sept 1996 */
    calc_disp(false, 4);
  } else if (lintmode) 
    error(62, &token);
  else {
    if (printstuff) {
      fprintf(stdout, " Changing to modular arithmetic.\n");  /* Jul 2002 */
      fflush(stdout);
    }
    if (val2 == -1)                               /* get n from terminal or file */
      if (tt_flag) 
        do {
          fprintf(stdout, " Enter modulus:\n");
          do_prompts();
          scanner(&Input, &token, flag);
          old_expre(&Input, num, &zilch);
          if (!(*num)->numb) 
            error(148, &token);
          n = quoly_convert_to_int(*num);
	  if (n == neg_two_to_31)   /* num.size > 1. Apr 2004 */
            if ((*num)->variant.vc_1.ncoef->size == 2)
	      if ((*num)->variant.vc_1.ncoef->head->value < 8)
                n = block * (*num)->variant.vc_1.ncoef->head->value +
                    (*num)->variant.vc_1.ncoef->tail->value;
          if (n < 2 || n >= modlimit)             /* June 1998; Aug 2001 */
                                                  /* Apr 2004 */
            fprintf(stdout, " *** Improper modulus %2d. upper limit is 2147483646. Reenter.\n", n);
        } while (!(n > 1 && n < modlimit));       /* Nov 1997,June 1998,Aug 2001 */
      else {
        old_expre(inf, num, flag);                /* Nov 1997 */
        n = quoly_convert_to_int(*num);
      }
    else
      n = val2;
    if (n < 2 || n >= modlimit) {                 /* Nov 1997,  June 1998 */
      error(84, &token);
      n = 2;
    }

    if (n == 256)  /* Jul 2004 */
      /* Leave n = 256. There is no homomorphism from Z -> F256, hence "by rights" go thru Z/2, so
         n=2. But this turns out to be no good.  must use 256. See manual. */
      f256 = true;
    else f256 = false;  /* shouldn't be necessary */

    if (n == 65536)  /* Jul 2004 */
      /* Leave n = 65536. There is no homomorphism from Z -> F256, hence "by rights" go thru Z/2, so
         n=2. But this turns out to be no good.  must use 256. See manual. */
      f2t16 = true;
    else f2t16 = false; /* shouldn't be necessary */
    
    finf = f256 || f2t16;  /* Jul 2004 */

    modulus = n;                                  /* Nov 1997. removed a lot below */
    smallmodulus = n < halfmask;     /* Sep 2004.  Note: FALSE for ft216, but see below */
    rmodulus = modulus;                           /* Aug 2001; needed only if >= halfmask */
    
    free_quoly(num);
    free_quoly(&sysnum);
    free_quoly(&prevnum);
    if (lookupgcd > 0) 
      free_gcd_stash();
    modularmode = true;
    lintmode = true;
    half_modulus = modulus / 2;
    
    quoly_set(0, &prevnum);
    quoly_set(0, num);
    quoly_set(0, &sysnum);                        /* failsafes. do it. */

    calc_disp(false, 16);                         /* Don't move this! */
    reset_cutoffs(40);  /* Jan 2010. Aug 2010, 8 -> 20 */
    poly_cutoff = 40;   /* was 12. Jun 2005. then 6. back to 8, Jan 2010. Aug 2010, 8 -> 20 */
    div_poly_cutoff = 25;
    two28_mod = block % modulus;
    mod_is_prime = is_prime(modulus);    /* will be false for finf?  no, turned on below.  */
    if (modulus < limit_char_arrays) 
      limit_char_arrays = modulus;
    change_polydata(&change_prec_Env);            /* moved June 1995 */
    if (local) 
      change_local(np, &change_prec_Env);
    else {
      change_vars(change_prec_Env.wasmodular);  /* Jun 2006 */
      change_arrays(change_prec_Env.wasmodular);
      change_sparses(change_prec_Env.wasmodular);
    }
    /* change_polydata;  <- was here before June 1995 */
    was_in_rat = false;                           /* Sept 1996 */

    if (finf){
      modulus = 2;  /* just for print below */
      mod_is_prime = true;
    }

    if (printstuff) {
      fprintf(stdout, " Now in modular mode. Modulus is %1d,", modulus);
      if (mod_is_prime) 
        fprintf(stdout, " a prime");
      else 
        fprintf(stdout, " not a prime");  /* Sep 2004, Nov 2004 */
      if (f256)
        fprintf(stdout, "; working over the prime field of 2^8 = 256 elements.\n");
      else 
        if (f2t16)
          fprintf(stdout, "; working over the prime field of 2^16 = 65536 elements.\n");
      else
        fprintf(stdout, ".\n");
      fflush(stdout);
    }

    if (finf){ /* Jul 2004 */
      if (f256)
         modulus = 256;
      else 
         modulus = 65536;
      alt_form_display = false;
      /* Sep 2004  remove this silly stmt: setvalue(modulus - 1, &rand_denom_n);  */
      mod_is_prime = true; /* it already was */
      smallmodulus = true; /* it wasn't! */
    }
  }
  
  setvalue(1, &rand_denom_n);    /* don't need an earlier freeing statement */
  quoly_set(0, &prevnum);
  quoly_set(0, num);
  rand_denom_n.lint = 1;
}

/***************************************************************************/

/* laurent will be changed to newval. */

/**************************************************************************/

static void change_quol(quolyptr q)
{
  
  poly exps;
  poly tail;

  if (laurent) 
    if (!((*q)->numb || (*q)->variant.vc_2.denom == NULL || (*q)->variant.vc_2.rat)) 
      if (lintmode) 
        lint_normal_form(*q, true);
      else 
        normal_form(*q, true);
    else                                          /* nothing */
      ;
  else if (!((*q)->numb || (*q)->variant.vc_2.rat)) {
    clear_bads(&(*q)->variant.vc_2.numer, &exps, &tail, 0, halfblock);
    if (exps != NULL) {
      if ((*q)->variant.vc_2.denom == NULL) 
        poly_set(1, &(*q)->variant.vc_2.denom);
      eliminate_bads(&(*q)->variant.vc_2.denom, &exps, -1);
      freepoly(exps,tail); /*AAR*/
/*AAR
      tail->next = polygarb;
      polygarb = exps;
*/
    }
  }
}

/*************************************************************************/

static void change_vars_1(void)
{
  varptr p;
  short i;

  for (i = 0; i <= 150; ++i) {
    p = sca_store[i];
    while (p != NULL) {
      change_quol(&p->val);
      p = p->next;
    }
  }
}

/*************************************************************************/

static void change_arrays_1(void)
{
  long i;

  for (i = 0; i <= endarr; ++i) 
    if ((*arp[BSR(i, 10)])[BAnd(i, tenmask)] != NULL) 
      change_quol(&(*arp[BSR(i, 10)])[BAnd(i, tenmask)]);
  
  if (syst->spar == NULL) 
    for (i = 0; i <= syst->stop; ++i) 
      change_quol(&(*stash)[i]);
}

/************************************************************************/

static void sparse_change_1(arrptr ap)
{
  long i;
  long j;
  colm_ptr u;
  sparseptr sp;
  long forEnd_102;
  long forEnd_103;

  sp = ap->spar;
  forEnd_103 = (ap->rows - 1) / sparsesize;
  for (i = 0; i <= forEnd_103; ++i) {
    forEnd_102 = (i + 1) * sparsesize;
    for (j = 1 + i * sparsesize; j <= forEnd_102; ++j) 
      if (j > ap->rows) 
        break;
      else {
        u = sp->indx[(j - i * sparsesize) - 1];
        while (u != NULL) {
          change_quol(&u->val);
          u = u->next;
        }
      }
    sp = sp->next;
  }
}

/************************************************************************/

static void change_sparses_1(void)
{
  short i;
  arrptr ap;

  for (i = 0; i <= 150; ++i) {
    ap = arr_store[i];
    while (ap != NULL) {
      if (ap->spar != NULL) 
        sparse_change_1(ap);
      ap = ap->next;
    }
  }
  if (syst->spar != NULL) 
    sparse_change_1(syst);
}

/***************************************************************************/

void change_laurent(Boolean newval)
{
  
  if (lintmode) 
    error(235, &token);
  laurent = newval;
  change_quol(&prevnum);
  if (sysnum != NULL) 
    change_quol(&sysnum);
  change_vars_1();
  change_arrays_1();
  
  change_sparses_1();
}

/****************************************************************************/

struct attach_poly_EnvRec {
  FILEPtr *inf;
  quoly one;
  long depth;
  nameptr *flag;
  Boolean cancel;
  Boolean *doscanner;
  tokentipe savetoken;  /* Jun 2005 */
};
typedef struct attach_poly_EnvRec attach_poly_EnvRec;

/**************************************************************/

static void update_num(polyptrr p)
{
  poly q;

  if (!(*p)->numb || (*p)->next != NULL) {
    q = *p;
    newpoly(p);
    (*p)->numb = false;
    (*p)->exp = 0;
    (*p)->variant.pcoef = q;
    (*p)->next = NULL;
  }
}

/**************************************************************/

static void update_quoly(quolyptr p)
{
  if (!(*p)->numb) {
    update_num(&(*p)->variant.vc_2.numer);
    if ((*p)->variant.vc_2.denom != NULL) 
      update_num(&(*p)->variant.vc_2.denom);
  }
}

/**************************************************************/

static void update_vars(void)
{
  varptr p;
  short i;

  for (i = 0; i <= 150; ++i) {
    p = sca_store[i];
    while (p != NULL) {
      update_quoly(&p->val);
      p = p->next;
    }
  }
}

/**************************************************************/

static void update_arrays(void)
{
  long i;

  for (i = 0; i <= endarr; ++i) 
    if ((*arp[BSR(i, 10)])[BAnd(i, tenmask)] != NULL) 
      update_quoly(&(*arp[BSR(i, 10)])[BAnd(i, tenmask)]);
  
  if (syst->spar == NULL) 
    for (i = 0; i <= syst->stop; ++i) 
      update_quoly(&(*stash)[i]);
}

/**************************************************************/

static void downdate_vars(attach_poly_EnvRec *attach_poly_Env)
{
  varptr p;
  short i;
	poly den_denom;   /* Apr2 2011, and below.  big changes. */
  poly n3;
  poly d3;
  
	den_denom = NULL;    /* Apr2 2011 */
	n3 = NULL;
	d3 = NULL;
	poly_set(1, &n3);
	for (i = 0; i <= 150; ++i) {
    p = sca_store[i];
    while (p != NULL) {
			if (!p->val->numb && p->val->variant.vc_2.denom != NULL) {  /* Apr2 2011. check for denom becoming 0 */				
				actual_eval_poly(&p->val->variant.vc_2.denom, &den_denom, &n3, &d3, attach_poly_Env->depth, halfblock, polynames);
				if (poly_iszero(p->val->variant.vc_2.denom)) {
					badcnt ++;
					if (badcnt < 41)
					  fprintf(stdout, "Warning. A quoly denominator has become 0.  That variable has been set to 1.\n");
					quoly_set(1, &p->val);
				}
				else get_evalquoly(attach_poly_Env->inf, &p->val, &attach_poly_Env->one, 
													 &attach_poly_Env->depth, attach_poly_Env->flag, false, false);
			}
      else
				get_evalquoly(attach_poly_Env->inf, &p->val, &attach_poly_Env->one, 
											&attach_poly_Env->depth, attach_poly_Env->flag, false, false);
      remove_poly_var(&p->val, attach_poly_Env->depth);
      p = p->next;
    }
  }
	free_poly(&n3);
}

/**************************************************************/

static void downdate_arrays(attach_poly_EnvRec *attach_poly_Env)
{
  long i;
  quolyptr qp;
	poly den_denom;   /* Apr2 2011, and below.  big changes. */
  poly n3;
  poly d3;
	
	den_denom = NULL;    /* Apr2 2011 */
	n3 = NULL;
	d3 = NULL;
	poly_set(1, &n3);
	for (i = 0; i <= endarr; ++i) {
    qp = &(*arp[BSR(i, 10)])[BAnd(i, tenmask)];
    if (*qp != NULL) {   
			if (!(*qp)->numb && (*qp)->variant.vc_2.denom != NULL) {  /* Apr2 2011. check for denom becoming 0 */				
				actual_eval_poly(&(*qp)->variant.vc_2.denom, &den_denom, &n3, &d3, attach_poly_Env->depth, halfblock, polynames);
				if (poly_iszero((*qp)->variant.vc_2.denom)) {
					badcnt ++;
					if (badcnt < 41)
					  fprintf(stdout, "Warning. A quoly denominator has become 0.  That array entry has been set to 1.\n");
					quoly_set(1, qp);
				}
				else get_evalquoly(attach_poly_Env->inf, qp, &attach_poly_Env->one, 
													 &attach_poly_Env->depth, attach_poly_Env->flag, false, false);
			}
      else			
        get_evalquoly(attach_poly_Env->inf, qp, &attach_poly_Env->one, 
											&attach_poly_Env->depth, attach_poly_Env->flag, false, false);
      remove_poly_var(qp, attach_poly_Env->depth);
    }
  }
  
  if (syst->spar == NULL) 
    for (i = 0; i <= syst->stop; ++i) {
      if (!(*stash)[i]->numb && (*stash)[i]->variant.vc_2.denom != NULL) {  /* Apr2 2011. check for denom becoming 0 */				
				actual_eval_poly(&(*stash)[i]->variant.vc_2.denom, &den_denom, &n3, &d3, attach_poly_Env->depth, halfblock, polynames);
				if (poly_iszero((*stash)[i]->variant.vc_2.denom)) {
					badcnt ++;
					if (badcnt < 41)
					  fprintf(stdout, "Warning. A quoly denominator in the system array has become 0.  That entry has been set to 1.\n");
					quoly_set(1, &(*stash)[i]);
				}
				else get_evalquoly(attach_poly_Env->inf, &(*stash)[i], &attach_poly_Env->one, 
													 &attach_poly_Env->depth, attach_poly_Env->flag, false, false);
			}
      else
				get_evalquoly(attach_poly_Env->inf, &(*stash)[i], &attach_poly_Env->one, 
											&attach_poly_Env->depth, attach_poly_Env->flag, false, false);
      remove_poly_var(&(*stash)[i], attach_poly_Env->depth);
    }
	
	free_poly(&n3);
}

/********************************************************/

static void sparse_update_1(arrptr ap)
{
  long i;
  long j;
  colm_ptr u;
  sparseptr sp;
  long forEnd_104;
  long forEnd_105;

  sp = ap->spar;
  forEnd_105 = (ap->rows - 1) / sparsesize;
  for (i = 0; i <= forEnd_105; ++i) {
    forEnd_104 = (i + 1) * sparsesize;
    for (j = 1 + i * sparsesize; j <= forEnd_104; ++j) 
      if (j > ap->rows) 
        break;
      else {
        u = sp->indx[(j - i * sparsesize) - 1];
        while (u != NULL) {
          update_quoly(&u->val);
          u = u->next;
        }
      }
    sp = sp->next;
  }
}

/********************************************************/

static void sparse_down(arrptr ap, attach_poly_EnvRec *attach_poly_Env)
{
  long i;
  long j;
  colm_ptrptr u;
  sparseptr sp;
  long forEnd_106;
  long forEnd_107;
	poly den_denom;   /* Apr2 2011, and below.  big changes. */
  poly n3;
  poly d3;
	
	den_denom = NULL;    /* Apr2 2011 */
	n3 = NULL;
	d3 = NULL;
	poly_set(1, &n3);
	
  sp = ap->spar;
  forEnd_107 = (ap->rows - 1) / sparsesize;
  for (i = 0; i <= forEnd_107; ++i) {
    forEnd_106 = (i + 1) * sparsesize;
    for (j = 1 + i * sparsesize; j <= forEnd_106; ++j) 
      if (j > ap->rows) 
        break;
      else {
        u = &sp->indx[(j - i * sparsesize) - 1];
        while (*u != NULL) {
          if (!(*u)->val->numb && (*u)->val->variant.vc_2.denom != NULL) {  /* Apr2 2011. check for denom becoming 0 */				
						actual_eval_poly(&(*u)->val->variant.vc_2.denom, &den_denom, &n3, &d3, attach_poly_Env->depth, halfblock, polynames);
						if (poly_iszero((*u)->val->variant.vc_2.denom)) {
							badcnt ++;
							if (badcnt < 41)
								fprintf(stdout, "Warning. A quoly denominator in a sparse array entry has become 0.  That entry has been set to 1.\n");
							quoly_set(1, &(*u)->val);
						}
						else get_evalquoly(attach_poly_Env->inf, &(*u)->val, &attach_poly_Env->one, 
															 &attach_poly_Env->depth, attach_poly_Env->flag, false, false);
					}
					else
						get_evalquoly(attach_poly_Env->inf, &(*u)->val, &attach_poly_Env->one, 
													&attach_poly_Env->depth, attach_poly_Env->flag, false, false);
          remove_poly_var(&(*u)->val, attach_poly_Env->depth);
          if ((*u)->val == NULL || quoly_iszero((*u)->val)) 
            free_colm(u);
          else 
            u = &(*u)->next;
        }
      }
    sp = sp->next;
  }
	free_poly(&n3);
}

/*********************************************************/

static void redo_sparses(attach_poly_EnvRec *attach_poly_Env)
{
  /* Take care not to do a given sparse matrix twice */
  short i;
  arrptr ap;

  for (i = 0; i <= 150; ++i) {
    ap = arr_store[i];
    while (ap != NULL) {
      if (ap->spar != NULL) 
        ap->spar->notdone = true;
      ap = ap->next;
    }
  }
  for (i = 0; i <= 150; ++i) {
    ap = arr_store[i];
    while (ap != NULL) {
      if (ap->spar != NULL) 
        if (ap->spar->notdone) {
          if (attach_poly_Env->cancel) 
            sparse_down(ap, attach_poly_Env);
          else 
            sparse_update_1(ap);
          ap->spar->notdone = false;
        }
      ap = ap->next;
    }
  }
  if (syst->spar != NULL) 
    if (attach_poly_Env->cancel) 
      sparse_down(syst, attach_poly_Env);
    else 
      sparse_update_1(syst);
}

/**************************************************************/

static void reset_depths(void)
{
  polypt p;
  short h;

  p = polynames;
  h = 1;
  while (p != NULL) {
    p->depth = h;
    h++;
    p = p->next;
  }
}

/*******************************************************/

static void check_validity(attach_poly_EnvRec *attach_poly_Env)  /* Jul 2002 */
{
  /* User has (probably) named a poly var by Var(i).  Compute i, check validity, return
     the name, set doscanner. */
  long i;
  polypt q;

  scanner(attach_poly_Env->inf, &token, attach_poly_Env->flag);
  old_fact(attach_poly_Env->inf, &attach_poly_Env->one, attach_poly_Env->flag);
  i = quoly_convert_to_int(attach_poly_Env->one);
  free_quoly(&attach_poly_Env->one);
  if (i > number_polys || i < 1) 
    error(124, &token);
  q = polynames;
  while (i > 1) {
    q = q->next;
    i--;
  }
  attach_poly_Env->savetoken = token;  /* Jun 2005 */
  token = q->let;
  *attach_poly_Env->doscanner = false;
}

/*******************************************************/

void attach_poly(textptr inf, nameptr *flag, Boolean not_imper, Boolean *doscanner)
{ 
  /* added the doscanner business, Oct 1995.  This assumes that only set_switch
     calls this proc when doscanner is set to false here.  doscanner is irrelevant on
     input.  
        check_validity added Jul 2002, to implement cancelling of numbered vars. 
        Apr 2005: callP allows for combined call &(J=..., P=...).  This saves a lot of time
     if there are a lot of arrays and variables already. */
  
  polypt q;
  Boolean oldm1;
  Boolean callP;  /* Apr 2005 */
  Boolean gotfromarray; /* Apr 2005 */
  Boolean bottom;  /* Jul 2008 */
  short i;
  short j;
  bigstring bigname;
  short forEnd_108;
  short forEnd_109;
  short forEnd_110;
  short forEnd_111;
  
  attach_poly_EnvRec attach_poly_Env;

  bottom = ustrcmp(token.name, ">") == 0;  /* Jul 2008 */
  if (bottom && field_depth > 0)
    error(360, &token);
 
  attach_poly_Env.doscanner = doscanner;
  attach_poly_Env.flag = flag;
  attach_poly_Env.inf = inf;
  if (windy || not_imper || *flag == NULL)        /* Sep 2000 */
    fprintf(stdout, " Change of polynomial variable");

  if (lintmode)  /* Feb 2005, now allowed! */
    changed_in_modmode = true;   /* error(235, &polysign);*/

  attach_poly_Env.cancel = false;
  callP = false;  /* Apr 2005 */
  gotfromarray = false;  /* Apr 2005 */
  *doscanner = true;
  attach_poly_Env.one = NULL;                     /* moved, Jul 2002 */
  if (not_imper) {                                /* get from terminal */
    fprintf(stdout, ".\n");
    fflush(stdout);
    fprintf(stdout, " Enter variable name:\n");
    do_prompts();
    scanner(&Input, &token, &zilch);
    if (ustrcmp(token.name, ">") == 0)   /* Jul 2008 */
	  error(362, &token);
	if (ustrcmp(token.name, "-") == 0) {
      attach_poly_Env.cancel = true;
      scanner(&Input, &token, &zilch);
    }
    if (token.name[0] == '[') {
      get_from_array(&Input, &zilch, bigname);    /* apparent bug. Sep 2000, 
                                                     was 'flag'*/
      if (ustrcmp(bigname, "") == 0) 
        error(124, &token);
      ustrcpy(token.name, bigname);
    }
    if (token.name[0] < 'a' || token.name[0] > 'z')
      if (attach_poly_Env.cancel && ustrcmp(token.name, "Var") == 0) /* Jun 2005 */
	  check_validity(&attach_poly_Env);     /* changes token to name of poly var */
      else
	  error(124, &token);
    /* else it's fine  Jul 2002 */
    forEnd_108 = ustrlen(token.name);
    for (i = 1; i < forEnd_108; ++i)             /* Sep 2000 */
      if (token.name[i] < 'a' || token.name[i] > 'z') 
        if (token.name[i] < 'A' || token.name[i] > 'Z')
          if (token.name[i] < '0' || token.name[i] > '9') 
            if (token.name[i] != '_') 
              error(124, &token);
  } else { /* it is imper */
    scanner(inf, &token, flag);
    if (ustrcmp(token.name, "-") == 0) {
      attach_poly_Env.cancel = true;
      scanner(inf, &token, flag);
    }
    if (token.name[0] == '[') {
      get_from_array(inf, flag, bigname);
      gotfromarray = true;    /* Apr 2005 */
      if (ustrcmp(bigname, "") == 0) 
        error(124, &token);
      if (ustrcmp(token.name, ",") == 0) {  /* Apr 2005 */
        if (attach_poly_Env.cancel)
           error(356, &token);
        if (bottom)   /* Jul 2008 */
	      error(361, &token);
	    scanner(inf, &token, flag);
        if (ustrcmp(token.name, "P") != 0) 
           error(355, &token);
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "=") != 0) 
           error(4, &token);
        callP = true;
      } else
          if (ustrcmp(token.name, ")") != 0) 
            error(135, &token);
      ustrcpy(token.name, bigname);
      *doscanner = false;         /* set_switch will end with this token, but it doesn't
                                     matter. */
    }
    if (token.name[0] < 'a' || token.name[0] > 'z')  /* Jun 2004 */
       if (attach_poly_Env.cancel && ustrcmp(token.name, "Var") == 0) /* Jun 2005 */
	   check_validity(&attach_poly_Env);     /* changes token to name of poly var */
       else
	   error(124, &token);
    /* else it's fine  Jul 2002 */
    forEnd_109 = ustrlen(token.name);
    for (i = 1; i < forEnd_109; ++i)             /* Sep 2000 */
      if (token.name[i] < 'a' || token.name[i] > 'z')
        if (token.name[i] < 'A' || token.name[i] > 'Z') 
          if (token.name[i] < '0' || token.name[i] > '9') 
            if (token.name[i] != '_') 
              error(124, &token);
    if (windy || *flag == NULL) {                 /* Sep 2000 */
      fprintf(stdout, ": ");
      if (attach_poly_Env.cancel) 
        fprintf(stdout, "cancel ");  
      fprintf(stdout, "%s.\n", token.name);
      fflush(stdout);
    }
    if (!gotfromarray) {
      ustrcpy(bigname, token.name);  /* save name of new var */
      if (*doscanner)
	scanner(inf, &token, flag);
      else
	token = attach_poly_Env.savetoken;  /* Jun 2005 */
      if (ustrcmp(token.name, ",") == 0) {  /* Apr 2005 */
        if (attach_poly_Env.cancel)
           error(356, &token);
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "P") != 0) 
           error(355, &token);
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "=") != 0) 
           error(4, &token);
        callP = true;
      } else
          if (ustrcmp(token.name, ")") != 0) 
            error(135, &token);
      ustrcpy(token.name, bigname);
      *doscanner = false;         /* set_switch will end with this token, but it doesn't
                                     matter. */
    }
  }
  
  if (attach_poly_Env.cancel) {
    if (!is_poly_name(&token.name, &attach_poly_Env.depth)) {  /* need depth */
      error(169, &token);
      return;
    }
	if (bottom)   /* Jul 2008 */
	  fprintf(stdout, "Warning.  '>' ignored.\n");
  } else if (is_poly_name(&token.name, &attach_poly_Env.depth)) {
    error(126, &token);
    return;
  }
  
  quoly_set(0, &prevnum);
  
  if (attach_poly_Env.cancel) {
    quoly_set(1, &attach_poly_Env.one);           /* Jul 2002 */
    attach_poly_Env.one->next = NULL;             /* flag for calls to get_evalquoly */
    badcnt = 0;   /* Apr2 2011 */
		downdate_vars(&attach_poly_Env);
    downdate_arrays(&attach_poly_Env);
    redo_sparses(&attach_poly_Env);
    if (badcnt > 40)  /* Apr2 2011 */
			fprintf(stdout, "... There were %d more such cases.\n", badcnt - 40);
    delete_poly_name(attach_poly_Env.depth);  

    /* delete from sorted array polyvar.  */
    i = 1; 
    while (ustrcmp(polyvar[i - 1], token.name) != 0) 
      i++; 
    forEnd_110 = number_polys - 1;
    for (j = i; j <= forEnd_110; ++j) 
      ustrcpy(polyvar[j - 1], polyvar[j + 1 - 1]);
    
    number_polys--;
    free_quoly(&attach_poly_Env.one);
    reset_pseudo_poly();
    reset_depths();
    if (windy || not_imper || *flag == NULL)      /* Sep 2000 */
      fprintf(stdout, "%s now cancelled.\n", token.name);
  } else {
    if (number_polys == max_number_polys) 
      error(228, &token);
    if (bottom)   /* Jul 2008 */
      if (polynames == NULL) {   /* Jan 2009. bug fix */
         newpt(&q);
         q->next = NULL;
         polynames = q;
         if (pseudo_polynames != NULL)
           pseudo_polynames = polynames;
      }
      else {
	  q = polynames;
	  for (i = 2; i <= number_polys; ++i) 
	    q = q->next;
	  newpt(&q->next);
	  q = q->next;
	  q->next = NULL;  /* note use of this about 24 lines down */
      }

    else {
       newpt(&q);
      q->next = polynames;
      polynames = q;
	  if (pseudo_polynames != NULL) 
        pseudo_polynames = polynames;
	  }
    q->let = token;
    reset_depths();
    
    /* insert into sorted array polyvar */
    i = 1;
    while (i <= number_polys) {
      if (ustrcmp(token.name, polyvar[i - 1]) < 0) 
        break;
      i++;
    }
    for (j = number_polys; j >= i; --j) 
      ustrcpy(polyvar[j], polyvar[j - 1]);  /* Jul 2008, killed 1 - 1 */
    ustrcpy(polyvar[i - 1], token.name);
    number_polys++;
    if (field_depth > 0) 
      field_depth++;
    
    if (q->next != NULL) {              /* This is at least the second variable. Need to */
                                        /* update all polys that already exist. */
      update_vars();
      update_arrays();
      redo_sparses(&attach_poly_Env);
    }
    
    if (need_to_set_char_poly) {
      need_to_set_char_poly = false;
      for (i = first_step + 1; i <= in_house_charpol - 1; ++i) {
        forEnd_111 = i + 1;
        for (j = 1; j <= forEnd_111; ++j)  {
          get_char_poly(i, j, &(*pol)[i][j - 1]); 
          size_data_strucs += sizequoly((*pol)[i][j - 1]);   /* Jul 2003 */
        }
      }
      /* obsolete Sep 2003: fclose(char_poly_data); */
    }

    if (callP) {  /* implies imperative.  Apr 2005. big time saving this way. */
      set_mod_out(inf, flag, true, true);
      if (ustrcmp(token.name, ")") != 0) 
        error(135, &token);   
    }
  }
}

/*****************************************************************************/

struct basic_form_EnvRec {
  comptr *comm;
  FILEPtr *inf;
  nameptr *flag;
  Boolean forloop;
  /* Nov 1997.  endflag can now be 'elfi*' to accomodate new function syntax. */
  
  comptr lastcom;
  tokentipe *realtok;
  Boolean *once_more;
};
typedef struct basic_form_EnvRec basic_form_EnvRec;

/******************************************************/

static void comment(comptr *lastcom, basic_form_EnvRec *basic_form_Env)
{
  
  nameptr lastq;
  Boolean eolnseen;

  lastq = NULL;
  if (*lastcom == NULL) {
    *basic_form_Env->comm = (comptr)malloc(sizeof(comnode));
    /* com is parameter to basic_form. */
    *lastcom = *basic_form_Env->comm;
  } else {
    (*lastcom)->next = (comptr)malloc(sizeof(comnode));
    /* botched by p2c, noticed Jul 2003 */
    *lastcom = (*lastcom)->next;
  }

  dumbscanner(basic_form_Env->inf, &token, basic_form_Env->flag, &eolnseen);

  while (ustrcmp(token.name, "}") != 0) {
    if (lastq == NULL) {
      newname(&(*lastcom)->q);   /* botched by p2c, noticed Jul 2003 */
      lastq = (*lastcom)->q;
    } else {
      newname(&lastq->next);  /* botched by p2c, noticed Jul 2003 */
      lastq = lastq->next;
    }   
    
    lastq->let = token; 
    
   /*  ustrcpy(lastq->let.name, token.name); */
    
    /* memcpy(lastq->let.name, token.name, sizeof(nametype)); */

    if (eolnseen) 
      fprintf(stdout, " Warning. End of line encountered inside a comment.\n");
      
    dumbscanner(basic_form_Env->inf, &token, basic_form_Env->flag, 
                &eolnseen);

  }
  
  if (lastq != NULL) 
    lastq->next = NULL;
  else 
    (*lastcom)->q = NULL;
  scanner(basic_form_Env->inf, &token, basic_form_Env->flag);
}

/********************************************************/

struct attach_EnvRec {
  Boolean maybe_more;
  Boolean literal;
  Boolean in_comment;
  /*nametype *endflag; AAR*/ unsigned char **endflag; 
  long count;
  nameptr last;
};
typedef struct attach_EnvRec attach_EnvRec;

/******************************************************/

static void insertval(nameptr *front, nameptr *tail, nameptr *flag, attach_EnvRec *attach_Env, basic_form_EnvRec *basic_form_Env)
{ /* Nov 1997. simplified at last */
  
  Boolean endline;

  if (!attach_Env->maybe_more) 
    newname(front);
  attach_Env->literal = !(attach_Env->literal == (ustrcmp(token.name, "\'") == 0));
  /* check_cmd_keys(); */                              /* Nov 2001 */
  if (!attach_Env->maybe_more) {
    *tail = *front;
    if (basic_form_Env->forloop) 
      if (ustrcmp(token.name, "to") == 0) 
        ustrcpy(token.name, " to");
      else if (ustrcmp(token.name, "by") == 0) 
        ustrcpy(token.name, " by");            /* Dec 1997, delete 'from' */
    if (token.name[0] >= 'a' && token.name[0] <= 'z') 
      token.address = hash(&token.name, 151);
    else if (token.name[0] >= 'A' && token.name[0] <= 'Z') 
      token.address = hash(&token.name, 71);
    (*tail)->let = token;
    
  }
  if (attach_Env->literal || attach_Env->in_comment) {
    /* check_cmd_keys(); */                            /* Nov 2001 */
    dumbscanner(basic_form_Env->inf, &token, flag, &endline);
    if (endline) 
      fprintf(stdout, " Warning. End of line encountered inside a literal.\n");
  } else {
    if (ustrcmp(leftover, " ") == 0) 
      (*tail)->space = true;                      /* Dec 1997 */
    scanner(basic_form_Env->inf, &token, flag);
  }
}

/*******************************************************/

static Boolean funcstart(void)                    /* Nov 1997 */
{
  return ustrcmp(token.name, "Function") == 0 || ustrcmp(token.name, "Func") == 0;
}

/*******************************************************/

/* flag could be 'elfi*', Nov 1997 */
static Boolean mate(tokentipe *x, nametype flag)
{
  Boolean value_mate;

  if (ustrcmp(flag, ".") == 0) 
    value_mate = ustrcmp(x->name, "Function") == 0 || ustrcmp(x->name, "Func") == 0;
    /* Nov 1997 */
  else if (ustrcmp(flag, ")") == 0) 
    value_mate = ustrcmp(x->name, "(") == 0;
  else if (ustrcmp(flag, "]") == 0)            /* deleted '{',  Oct 1999 */
    value_mate = ustrcmp(x->name, "[") == 0;
  else if (ustrcmp(flag, "od") == 0) 
    value_mate = ustrcmp(x->name, "do") == 0;
  else if (ustrcmp(flag, "elfi*") == 0 || ustrcmp(flag, "fi") == 0) 
    value_mate = ustrcmp(x->name, "if") == 0;
  else 
    value_mate = false;
  return value_mate;
}

/**************************************************************/

static Boolean found_endflag(attach_EnvRec *attach_Env)  /* Nov 1997 */
{
  Boolean value_found_endflag;

  if (ustrcmp(token.name, *attach_Env->endflag) == 0) 
    value_found_endflag = true;
  else if (ustrcmp(*attach_Env->endflag, "elfi*") == 0) 
    value_found_endflag = ustrcmp(token.name, "fi") == 0 || ustrcmp(token.name, "else")
               == 0 && attach_Env->count == 1;
  else 
    value_found_endflag = false;
  return value_found_endflag;
}

/**************************************************************/

static void store_char(char x, attach_EnvRec *attach_Env)
{
  newname(&attach_Env->last->next);
  attach_Env->last = attach_Env->last->next;
  ustrcpy(attach_Env->last->let.name, " ");  /* Jun 2003 p2c apparently screwed this up */
  attach_Env->last->let.name[0] = x;
  attach_Env->last->let.address = -1;
}

/***************************************************************/

static void attach(nameptr *q, nametype endflag, basic_form_EnvRec *basic_form_Env)
{
  /* The first unmated endflag marks the end.  So does the
     first semicolon not in an enclosed function def. */
  /* Modified so that decimal constants can be in function
     definitions. use maybe_more and digit_seen */
  long func_count;
  Boolean in_func;
  Boolean maybe_in_func;
  Boolean ok;
  Boolean last_one;
  Boolean digit_seen;
  attach_EnvRec attach_Env;
  nameptr temp;

  attach_Env.endflag = &endflag;
  attach_Env.count = 1;               /* count the matings */
  newname(q);
  attach_Env.last = *q;
  attach_Env.last->next = NULL;
  func_count = 0;                /* count levels of internal function nestings */
  ok = true;
  attach_Env.literal = false;                     /* used by insertval */
  attach_Env.maybe_more = false;
  attach_Env.in_comment = false;    /* needed in case a function defines a function
                                        which has a comment */
  maybe_in_func = false;
  if (mate(&token, endflag)) 
    attach_Env.count++;
  last_one = ustrcmp(endflag, ".") == 0 && funcstart();  /* Nov 1997 */
  
  if (basic_form_Env->forloop)
  /* Nov 1997. new way to mark for-loops, at start of condition only */
    store_char(':', &attach_Env);
  
  /* 'Count' counts the number of endflags seen, adjusted for pairings with
     'mate'.  'func_count' counts the number of function definitions 
     seen and 'in'. */
  digit_seen = token.name[0] >= '0' && token.name[0] <= '9';
  maybe_in_func = funcstart();                    /* Nov 1997 */
  while (attach_Env.count > 0 && ok) {
    insertval(&attach_Env.last->next, &attach_Env.last, basic_form_Env->flag, 
              &attach_Env, basic_form_Env);
    /* insertval calls scanner, changes last, allocates new nodes. */
    if (ustrcmp(token.name, "{") == 0 && !attach_Env.literal) 
      attach_Env.in_comment = true;
    if (ustrcmp(token.name, "}") == 0 && attach_Env.in_comment) 
      attach_Env.in_comment = false;
    if (!attach_Env.literal && !attach_Env.in_comment) {
      if (attach_Env.maybe_more) 
        if (token.name[0] < '0' || token.name[0] > '9') {
          /* Do what you should have before
             for the period. */
          func_count--;
          attach_Env.count--;
          if (func_count < 0) 
            break;
          store_char('.', &attach_Env);
        } else 
          store_char('.', &attach_Env);
      attach_Env.maybe_more = false;
      if (found_endflag(&attach_Env)) 
        if (digit_seen && ustrcmp(endflag, ".") == 0) 
          attach_Env.maybe_more = true;
        else 
          attach_Env.count--;
      else if (mate(&token, endflag)) 
        attach_Env.count++;
      digit_seen = token.name[0] >= '0' && token.name[0] <= '9';
      if (last_one && (token.name[0] < 'A' || token.name[0] > 'Z')) 
        attach_Env.count--;
      last_one = ustrcmp(endflag, ".") == 0 && funcstart();  /* Nov 1997 */
      in_func = maybe_in_func && token.name[0] >= 'A' && token.name[0] <= 'Z';
      maybe_in_func = funcstart();                /* Nov 1997 */
      if (in_func) 
        func_count++;
      if (ustrcmp(token.name, ".") == 0 && !attach_Env.maybe_more && ustrcmp(endflag, ".") == 0) 
        func_count--;
      if (ustrcmp(token.name, ";") == 0 && func_count < 1) 
        ok = false;
    } else 
      digit_seen = false;
    if (feof(*basic_form_Env->inf) && func_count > 0) 
      ok = false;
  }
  
  if (basic_form_Env->lastcom != NULL) 
    basic_form_Env->lastcom->next = NULL;
  if (attach_Env.maybe_more) {
    *basic_form_Env->realtok = token;
    ustrcpy(token.name, ".");
    *basic_form_Env->once_more = false;
  }
  newname(&attach_Env.last->next);
  attach_Env.last = attach_Env.last->next;
  
  ustrcpy(attach_Env.last->let.name, "¥");  /* the old omega Jul 2003 */
  attach_Env.last->next = NULL;
  temp = *q;
  *q = (*q)->next;
  free(temp);
  if (*q == NULL) 
    error(8, &token);
  else 
    last_attached = *q;
}

/**********************************************************************/

static Boolean reserved(nametype name, nametype first_mate, Boolean *its_a_loop, basic_form_EnvRec *basic_form_Env)
{
  Boolean value_reserved = false;

  basic_form_Env->forloop = ustrcmp(name, "for") == 0;  /* Nov 1997 */
  *its_a_loop = true;
  switch (name[0]) {                              /* Dec 1998 */
    case 'i':
    case 'w':
      /* nothing; must check below */
      break;
    case 'f':
      if (ustrcmp(name, "fi") == 0) 
        error(319, &token);
      break;
    case 'e':
      if (ustrcmp(name, "else") == 0) 
        error(319, &token);

      break;
    case 'o':
      if (ustrcmp(name, "od") == 0) 
        error(319, &token);
      break;
    default:
      return value_reserved;
      break;
  }
  
  value_reserved = true;
  if (ustrcmp(name, "if") == 0) {
    ustrcpy(first_mate, "then");
    *its_a_loop = false;
  } else if (ustrcmp(name, "while") == 0) 
    ustrcpy(first_mate, "do");
  else if (ustrcmp(name, "for") == 0) 
    ustrcpy(first_mate, "do");
  else 
    value_reserved = false;
  return value_reserved;
}

/***************************************************************************/

void basic_form(condexptr *q, comptr *comm, nametype endflag, textptr inf, nameptr *flag, Boolean *once_more, tokentipe *realtok)
{
  /* A basic form is a loop, if-statement, or expression. A loop or if-statement
     is a condition with one or two right_sides enclosed in brackets.
     Attach is called to actually attach the sequence of characters.   */
  
  nametype first_mate;
  nametype second_mate;
  Boolean its_a_loop;
  basic_form_EnvRec basic_form_Env;

  basic_form_Env.once_more = once_more;
  basic_form_Env.realtok = realtok;
  basic_form_Env.flag = flag;
  basic_form_Env.inf = inf;
  basic_form_Env.comm = comm;
 
  basic_form_Env.lastcom = NULL;
  
/* fprintf(stdout, "start of basic, token: %s, endflag: %s\n", token.name, endflag);   Apr 2007 */

  if (in_sys_func && ustrcmp(token.name, ";") == 0) {  /* Apr 2007. Something executable has to be entered into the sysfunc data structure. */
    ustrcpy(token.name, "0");                          /* It will be 0;  */
  }

  newcond(q);  /* Apr 2007. moved slightly */
   
  while (ustrcmp(token.name, "{") == 0) 
    comment(&basic_form_Env.lastcom, &basic_form_Env);
  
  if (reserved(token.name, first_mate, &its_a_loop, &basic_form_Env)) {
  /* sets forloop too */
    if (doing_sys_func) {
      token = sys_func_token;
      doing_sys_func = false;
    } else 
      scanner(inf, &token, flag);
      
    attach(&(*q)->cond, first_mate, &basic_form_Env);  /* Nov 1997. ')' */
    
    (*q)->aloop = its_a_loop;
    scanner(inf, &token, flag);
    if (ustrcmp(first_mate, "do") == 0) 
      ustrcpy(second_mate, "od");
    else 
      ustrcpy(second_mate, "elfi*");
    right_side(&(*q)->form1, second_mate, inf, flag, once_more, realtok);
    if (ustrcmp(token.name, "else") == 0) {
      if (ustrcmp(first_mate, "then") == 0) 
        scanner(inf, &token, flag);
      else 
        error(214, &token);
      ustrcpy(second_mate, "fi");
      right_side(&(*q)->form2, second_mate, inf, flag, once_more, 
                 realtok);
    } else 
      (*q)->form2 = NULL;
    scanner(inf, &token, flag);
    (*q)->expr = NULL;
  } else {
    (*q)->aloop = false;
    (*q)->cond = NULL;
    (*q)->form1 = NULL;
    (*q)->form2 = NULL;
    attach(&(*q)->expr, endflag, &basic_form_Env);
  }
}

/******************************************************************************/

void arrinsert(nametype x, quolyptr qp, long r, long c, arrptr q, quolyptr n, Boolean colflag)
{ /* added colflag, Dec 1997 */
  long cols;                                      /*spar*/
  long i;
  Boolean oldtt;     /* added Jan 1998; had been in other versions */

  cols = quotient_of(&q->sizearr, q->rows);       
                                                  /* Oct 2000 */
  if (levelcount > 1 && prompt[0] != (char)13) 
    fprintf(stdout, "%1d", levelcount);
  if (promptsize > 0) 
    fprintf(stdout, "%s", prompt);
  if (cols > 1 && colflag) 
    fprintf(stdout, "%s[%2d,%2d] := ", x, r, c);  /* Nov 1997 */
  else 
    fprintf(stdout, "%s[%2d] := ", x, r);   /* Nov 1997 */
  oldtt = tt_flag;                                
  tt_flag = true;
  ustrcpy(leftover, "");
  getc(Input);
  scanner(&Input, &token, &zilch);
  if (ustrcmp(token.name, "@") == 0) 
    return;
  old_expre(&Input, n, &zilch);
  quoly_assign(*n, qp);
  tt_flag = oldtt;
}

/****************************************************************************/

struct whole_arrinsert_EnvRec {
  FILEPtr *inf;
  nameptr *flag;
  tokentipe *stash;
  /*shortstring *saveleft; AAR*/ unsigned char **saveleft;
  tokentipe *x;
  quoly *n;
  long rows;
  long cols;
  long spot;
  long locat;
  jmp_buf whole_arrinsert_exit;
};
typedef struct whole_arrinsert_EnvRec whole_arrinsert_EnvRec;

/****************************************************************************/

static void load_char_string(whole_arrinsert_EnvRec *whole_arrinsert_Env)
/* new, Dec 2000 */
{
  sparseptr spar;
  arr_descr arr_facts;
  workptr arr;
  Boolean oldtt;
  Boolean arr_free;
  arrptr q;
  long i;
  long forEnd_112;

  scanner(whole_arrinsert_Env->inf, &token, whole_arrinsert_Env->flag);
  *whole_arrinsert_Env->stash = token;
  ustrcpy(*whole_arrinsert_Env->saveleft, leftover);
  new_worknode(&i, &token);
  arr = workhead[i - 1];
  if (levelcount > 1) 
    fprintf(stdout, "%1d", levelcount);
  if (promptsize > 0 || prompt[0] == (char)13) 
    fprintf(stdout, "%s", prompt);
  fprintf(stdout, "[%s] := \'", whole_arrinsert_Env->x->name);
  oldtt = tt_flag;
  tt_flag = true;
  ustrcpy(leftover, "");
  getc(Input);  /*AAR*/
  ustrcpy(token.name, "\'");
  spar = NULL;
  arr_facts.arrsize.size = 0;
  arr_fact(&Input, whole_arrinsert_Env->n, arr, &arr_facts, &arr_free, 
           &whole_arrinsert_Env->rows, &zilch, &spar);
  /* rows = 1 and arr_free is true. */
  whole_arrinsert_Env->cols = quotient_of(&arr_facts.arrsize, whole_arrinsert_Env->rows);
  insertarr(whole_arrinsert_Env->x, whole_arrinsert_Env->rows, whole_arrinsert_Env->cols, 
            whole_arrinsert_Env->cols == 1);
  whole_arrinsert_Env->x->address = hash(&whole_arrinsert_Env->x->name, 151);
  q = arr_store[whole_arrinsert_Env->x->address];
  whole_arrinsert_Env->spot = q->start;
  forEnd_112 = whole_arrinsert_Env->cols - 1;
  for (i = 0; i <= forEnd_112; ++i) {
    whole_arrinsert_Env->locat = whole_arrinsert_Env->spot + i;
    free_quoly(&(*arp[BSR(whole_arrinsert_Env->locat,10)])[BAnd(whole_arrinsert_Env->
    locat,  tenmask)]);
    (*arp[BSR(whole_arrinsert_Env->locat, 10)])[BAnd(whole_arrinsert_Env->locat,
                                                     tenmask)] = (*arr)[i];
  }
  free_work();
  special_free(&arr_facts.arrsize);
  tt_flag = oldtt;
  quoly_set(0, whole_arrinsert_Env->n);
  longjmp(whole_arrinsert_Env->whole_arrinsert_exit, -1);
   /*exit(::whole_arrinsert) up-level function exit*/
}

/****************************************************************************/

void whole_arrinsert(textptr inf, tokentipe *x, nameptr *flag, quolyptr n, tokentipe
                        *stash,  shortstring saveleft)
{  /* p2c note: saveleft is a var param in Pascal, so above is OK */
  
  arrptr q;
  quolyptr qp;
  nametype arrname;  /* added Jun 2003 to fix apparent compiler bug involving x */
  long i;
  long j;
  long firstrow;
  long firstcol;
  long total_rows;
  long forEnd_113;
  long forEnd_114;
  whole_arrinsert_EnvRec whole_arrinsert_Env;

  if (setjmp(whole_arrinsert_Env.whole_arrinsert_exit)) 
    return;
  whole_arrinsert_Env.n = n;
  whole_arrinsert_Env.x = x;
  whole_arrinsert_Env.saveleft = &saveleft;
  whole_arrinsert_Env.stash = stash;
  whole_arrinsert_Env.flag = flag;
  whole_arrinsert_Env.inf = inf;
  if (ustrcmp(x->name, "<") == 0)
    error(176, x);
  ustrcpy(arrname, x->name);
  whole_arrinsert_Env.locat = fasterlookup(x, &q, inf, flag);  /*spar; whole procedure */
  
  scanner(inf, &token, flag);
  if (ustrcmp(token.name, "[") == 0) {
    if (whole_arrinsert_Env.locat == -1)          /* Dec 2000 */
      error(28, &token);
    if (q->spar != NULL) 
      error(242, &token);
    subarray(inf, q, &i, &whole_arrinsert_Env.rows, &whole_arrinsert_Env.cols, 
             &firstrow, &firstcol, &total_rows, flag);
  } else {
    if (ustrcmp(token.name, "]") != 0) 
      error(24, &token);
    if (whole_arrinsert_Env.locat != -1) {        /* Dec 2000 */
      whole_arrinsert_Env.cols = quotient_of(&q->sizearr, q->rows);  /* Oct 2000 */
      whole_arrinsert_Env.rows = q->rows;
      total_rows = whole_arrinsert_Env.rows;
      firstrow = addresser;
      firstcol = addresser;
    }
  }
  if (ustrcmp(token.name, "]") != 0 && ustrcmp(token.name, "¥") != 0 &&
      ustrcmp(token.name, ";") != 0)
    error(107, &token);
  if (ustrcmp(token.name, "]") == 0) 
    scanner(inf, &token, flag);
  if (ustrcmp(token.name, ":") == 0) {         /* Dec 2000 */
    scanner(inf, &token, flag);
    if (ustrcmp(token.name, "char") == 0) 
      load_char_string(&whole_arrinsert_Env);     /* exits */
    else 
      error(334, &token);
  }
  if (whole_arrinsert_Env.locat == -1)            /* moved here Dec 2000 */
    error(28, &token);
  if (q->spar != NULL) 
      error(242, &token); 
  *stash = token;
  ustrcpy(saveleft, leftover);
  whole_arrinsert_Env.locat = (whole_arrinsert_Env.locat - addresser) - total_rows * addresser;
  forEnd_114 = whole_arrinsert_Env.rows + firstrow - 1;
  for (i = firstrow; i <= forEnd_114; ++i) {
    forEnd_113 = whole_arrinsert_Env.cols + firstcol - 1;
    for (j = firstcol; j <= forEnd_113; ++j) {
      whole_arrinsert_Env.spot = whole_arrinsert_Env.locat + i + total_rows * j;
      qp = &(*arp[BSR(whole_arrinsert_Env.spot, 10)])[BAnd(whole_arrinsert_Env.spot, 
                                                           tenmask)];
      arrinsert(arrname, qp, i, j, q, n, true);
      if (ustrcmp(token.name, "@") == 0) 
        return;
    }
  }
}

/******************************************************************************/

void fill_syst_array(workptr arr, arr_descr *arr_facts, Boolean arr_free, sparseptr spar,
                    long r)
{
  /* Nov 1997. if spar <> nil, arr is never mentioned.  Oct 2000: changed arr_facts
     above to var */
  
  long i;
  long forEnd_115;
  long forEnd_116;

  if (syst->spar != NULL) 
    free_sparse(&syst->spar, syst->rows, true);
  else 
    for (i = 0; i <= syst->stop; ++i) 
      free_quoly(&(*stash)[i]);
  syst->rows = r;
  if (spar != NULL) 
    if (arr_free) 
      syst->spar = spar;
    else 
      copy_sparse(&spar, &syst->spar, r, false);
  else if (arr_free) {
    forEnd_115 = arr_facts->arrsize.head->value - 1;
    for (i = 0; i <= forEnd_115; ++i) 
      (*stash)[i] = (*arr)[i];
  } else {
    forEnd_116 = arr_facts->arrsize.head->value - 1;
    for (i = 0; i <= forEnd_116; ++i) 
      quoly_assign((*arr)[i], &(*stash)[i]);
  }
  syst->stop = arr_facts->arrsize.head->value - 1;
  spec_num_assign(&arr_facts->arrsize, &syst->sizearr);  /* Oct 2000 */
  syst_dump = true;
}

/******************************************************************************/

void fillit(long rows, long cols, long start, long total_rows, workptr arr)  /* Nov 1997 */
{
  /* does not create new storage; rather, pointers in arr point to
     existing storage. */
  long i;             /* BUG fixed June 1998 */
  long j;
  long k;
  long forEnd_117;
  long forEnd_118;

  j = 0;
  forEnd_118 = cols - 1;
  for (i = 0; i <= forEnd_118; ++i) {
    forEnd_117 = rows - 1;
    for (k = 0; k <= forEnd_117; ++k) {
      check_and_assign(start + k + i * total_rows, &(*arr)[j]);
      j++;
    }
  }
}

/******************************************************************************/

struct arr_asstat_EnvRec {
  arr_descr *arr_facts;
  long cols;
  long target_rows;
  /* The source is determinded by a call to arr_expre, which fills the parameter
     arr (unless the source is a scalar).   If arr_free, this stuff is then transfered
     directly to the permanaent storage area.  If not, duplicate the storage via
     poly_assign. Therefore, do not free arr in either case.  arr_free is not reset at
     the end because nobody cares.

       Nov 1997: changed for new grammar; will revert to arr_expre if it in fact is
     not an assignment statement. */
  
  long rows;
  long j;
  long locat;
  long start;
  Boolean *arr_free;
  workarray *arr;
  arrptr q;
  long total_rows;
  quoly *n;
  tokentipe oldtok;
};
typedef struct arr_asstat_EnvRec arr_asstat_EnvRec;

/***************************************************************************/

static Boolean nomatch_1(arr_asstat_EnvRec *arr_asstat_Env)
{
  /* allow linear target and source (a big pain) except for sparses. 
     might change rows.  SIDE EFFECT!!  Jul 2003  */
  Boolean linear1;
  Boolean linear2;
  Boolean value_nomatch;

  if (!is_product_of(&arr_asstat_Env->arr_facts->arrsize, arr_asstat_Env->cols, 
                     arr_asstat_Env->target_rows))   /* = 0 if q is nil */
    value_nomatch = true;
  else if (arr_asstat_Env->target_rows == arr_asstat_Env->arr_facts->rows) 
    value_nomatch = false;
  else {
    linear1 = arr_asstat_Env->arr_facts->arrsize.head->value == arr_asstat_Env->arr_facts->rows ||
          arr_asstat_Env->arr_facts->rows == 1;
    linear2 = arr_asstat_Env->cols == 1 || arr_asstat_Env->target_rows == 1;
    if (linear1 && linear2) 
      arr_asstat_Env->rows = arr_asstat_Env->target_rows;
    value_nomatch = !(linear1 && linear2);
  }
  return value_nomatch;
}

/********************************************************/

static void fillnewone(arr_asstat_EnvRec *arr_asstat_Env)
{
  long i;
  long k;
  quolyptr qp;
  long forEnd_119;
  long forEnd_120;

  arr_asstat_Env->j = 0;
  forEnd_120 = arr_asstat_Env->rows - 1;
  for (i = 0; i <= forEnd_120; ++i) {
    forEnd_119 = arr_asstat_Env->rows - 1;
    for (k = 0; k <= forEnd_119; ++k) {
      arr_asstat_Env->locat = arr_asstat_Env->start + k + i * arr_asstat_Env->rows;
      qp = &(*arp[BSR(arr_asstat_Env->locat, 10)])[BAnd(arr_asstat_Env->locat, 
                                                        tenmask)];
      if (i != k) 
        quoly_set(0, qp);
      else {
        if (*arr_asstat_Env->arr_free) 
          *qp = (*arr_asstat_Env->arr)[arr_asstat_Env->j];
        else 
          quoly_assign((*arr_asstat_Env->arr)[arr_asstat_Env->j], 
                       qp);
        arr_asstat_Env->j++;
      }
    }
  }
}

/*******************************************************/

static void finishdiag(arr_asstat_EnvRec *arr_asstat_Env)
{
  Boolean newone;
  long i;
  long forEnd_121;
  long forEnd_122;

  if (arr_asstat_Env->q != NULL) 
    if (arr_asstat_Env->q->spar != NULL) 
      error(242, &diag_sign);                     /* Sept 1996 */
  if (arr_asstat_Env->q != NULL) 
    if (arr_asstat_Env->arr_facts->arrsize.head->value == 0) {
      /* it's a scalar; put into each spot in target array */
      forEnd_121 = arr_asstat_Env->rows - 1;
      for (i = 0; i <= forEnd_121; ++i) {
        arr_asstat_Env->locat = arr_asstat_Env->start + i + i*arr_asstat_Env->total_rows;
        quoly_assign(*arr_asstat_Env->n, &(*arp[BSR(arr_asstat_Env->locat,
                      10)])[BAnd(arr_asstat_Env->locat, tenmask)]);
      }
    } else {                                      /* source is not a scalar */
      if (arr_asstat_Env->rows != arr_asstat_Env->q->rows
      /* create new array of name oldtok; */
          && arr_asstat_Env->target_rows == 0) {  /* couldn't have been subarray. */
        insertarr(&arr_asstat_Env->oldtok, arr_asstat_Env->rows, arr_asstat_Env->rows, 
                  arr_asstat_Env->rows == 1);
        if (arr_asstat_Env->oldtok.address == -1) 
          i = hash(&arr_asstat_Env->oldtok.name, 151);
        else 
          i = arr_asstat_Env->oldtok.address;
        arr_asstat_Env->q = arr_store[i];
        arr_asstat_Env->start = arr_asstat_Env->q->start;
        newone = true;
      } else 
        newone = false;
      if (arr_asstat_Env->start == -1)            /* still!  This is the usual case. */
        arr_asstat_Env->start = arr_asstat_Env->q->start;
      if (newone) 
        fillnewone(arr_asstat_Env);
      else {
        forEnd_122 = arr_asstat_Env->rows - 1;
        for (i = 0; i <= forEnd_122; ++i) {       /* fill old one */
          arr_asstat_Env->locat = arr_asstat_Env->start + i + i * arr_asstat_Env->total_rows;
          if (*arr_asstat_Env->arr_free) {
            free_quoly(&(*arp[BSR(arr_asstat_Env->locat,10)])[BAnd(arr_asstat_Env->
	             locat, tenmask)]);
            (*arp[BSR(arr_asstat_Env->locat, 10)])[BAnd(arr_asstat_Env->locat, 
                                                   tenmask)] = (*arr_asstat_Env->arr)[i];
          } else 
            quoly_assign((*arr_asstat_Env->arr)[i], &(*arp[BSR(arr_asstat_Env->locat, 
                          10)])[arr_asstat_Env->locat % arr_block_size]);
        }
      }
    }
  else if (arr_asstat_Env->arr_facts->arrsize.head->value == 0) {
    /* scalar has been computed; create 1 by 1 */
    insertarr(&arr_asstat_Env->oldtok, 1, 1, true);
    if (arr_asstat_Env->oldtok.address == -1) 
      i = hash(&arr_asstat_Env->oldtok.name, 151);
    else 
      i = arr_asstat_Env->oldtok.address;
    arr_asstat_Env->q = arr_store[i];
    i = arr_asstat_Env->q->start;
    quoly_assign(*arr_asstat_Env->n, &(*arp[BSR(i, 10)])[BAnd(i, tenmask)]);
  } else {        /* q is nil, array has been computed; cannot be subarray.
                     make new oldtok */
    insertarr(&arr_asstat_Env->oldtok, arr_asstat_Env->rows, arr_asstat_Env->rows, 
              arr_asstat_Env->rows == 1);
    if (arr_asstat_Env->oldtok.address == -1) 
      i = hash(&arr_asstat_Env->oldtok.name, 151);
    else 
      i = arr_asstat_Env->oldtok.address;
    arr_asstat_Env->q = arr_store[i];
    arr_asstat_Env->start = arr_asstat_Env->q->start;
    fillnewone(arr_asstat_Env);
  }
}

/*-*********************************************************************/

void arr_asstat(textptr inf, quolyptr n, workptr arr, arr_descr *arr_facts, Boolean *arr_free, 
          nameptr *flag, sparseptr *spar)
{
  /* rows and cols are numbers, not coordinates 
	   Sep 2011: This proc called only from arr_prase.  *spar is NULL on input.  */
  
  long firstrow;
  long firstcol;
  long i;
  long k;
  Boolean diagonal;
  long forEnd_123;
  long forEnd_124;
  long forEnd_125;
  long forEnd_126;
  arr_asstat_EnvRec arr_asstat_Env;

  arr_asstat_Env.n = n;
  arr_asstat_Env.arr = arr;
  arr_asstat_Env.arr_free = arr_free;
  arr_asstat_Env.arr_facts = arr_facts;
  if (ustrcmp(token.name, "Diag") == 0) {
    scanner(inf, &token, flag);
    if (ustrcmp(token.name, "[") != 0) 
      error(92, &token);
    diagonal = true;
  } else 
    diagonal = false;
  
  left_side(inf, &arr_asstat_Env.q, &arr_asstat_Env.rows, &arr_asstat_Env.cols, 
            &arr_asstat_Env.start, &arr_asstat_Env.total_rows, &firstrow, 
            &firstcol, &arr_asstat_Env.target_rows, &arr_asstat_Env.oldtok, 
            flag, true);                          /* Nov 1997 */

  if (arr_asstat_Env.start == -1) {
    if (arr_asstat_Env.q != NULL) 
      spec_num_assign(&arr_asstat_Env.q->sizearr, &arr_facts->arrsize);  /* Oct 2000 */
    /* sparse_read and random need this. */
  } else {
    special_set_2(arr_asstat_Env.cols, arr_asstat_Env.target_rows, 
                  &arr_facts->arrsize);           /* Oct 2000 */
    arr_asstat_Env.rows = arr_asstat_Env.target_rows;
       /* For calls to arr_expre. Later, only [1] and [Rand] need this. */
  }
  
  if (ustrcmp(token.name, ":") != 0) {         /* Nov 1997.  This isn't an assignment. */
    if (arr_asstat_Env.q == NULL) 
      error(28, &token);
    *spar = arr_asstat_Env.q->spar;
    if (arr_asstat_Env.start == -1)               /* not a subarray. June 1998 */
      arr_asstat_Env.start = arr_asstat_Env.q->start;
    else if (*spar != NULL) 
      error(244, &token);                         /* June 1998 */
    if (arr_asstat_Env.q == syst) 
      *arr_free = true;                           /* Nov 1997 */
    else 
      *arr_free = false;                          /* <- Note! */
    arr_facts->rows = arr_asstat_Env.rows;
    if (*arr_free)                                /* Nov 1997 */
      copy_syst(arr, arr_asstat_Env.rows, spar);
    else if (*spar == NULL) 
      fillit(arr_asstat_Env.rows, arr_asstat_Env.cols, arr_asstat_Env.start, 
             arr_asstat_Env.total_rows, arr);     /* June 1998 */
    if (diagonal) 
      extract_diagonal(arr, arr, arr_facts, false, &arr_asstat_Env.rows, 
                       spar);
    /* will reset rows & arr_facts and set spar = nil */
    /* finish by calling arr_expre with last argument false */
    arr_expre(inf, n, arr, arr_facts, arr_free, &arr_asstat_Env.rows, 
              flag, spar, false);
    fill_syst_array(arr, arr_facts, *arr_free, *spar, arr_asstat_Env.rows);
    quoly_set(0, n);
    return;
  } else if (arr_asstat_Env.q == syst) 
    error(176, &token);                           /* Nov 1997 */
  
  scanner(inf, &token, flag);
  if (ustrcmp(token.name, "=") != 0) 
    error(4, &token);
  scanner(inf, &token, flag);
  
  if (arr_asstat_Env.q != NULL) 
    if (arr_asstat_Env.q->spar != NULL) 
      want_sparse = true;   /* Sep 2011, note global var want_sparse */

  arr_expre(inf, n, arr, arr_facts, arr_free, &arr_asstat_Env.rows, 
            flag, spar, true);
  
  want_sparse = false;

  if (diagonal && *spar != NULL) 
    error(242, &diag_sign);
  if (*spar != NULL && arr_asstat_Env.start != -1) 
    error(244, &token);
  
  if (diagonal) 
    arr_asstat_Env.rows = arr_facts->arrsize.head->value;
  
  /* If subarray, then target and source dimensions must match, unless source is just a
     scalar. */
  
  if (!diagonal) {    /* do nomatch_1 first below! Jul 2003  */
    if (nomatch_1(&arr_asstat_Env) && arr_asstat_Env.start != -1 &&
        arr_facts->arrsize.head->value != 0)
      error(60, &arr_asstat_Env.oldtok);
  } else if (arr_asstat_Env.start != -1 && arr_facts->arrsize.head->value != 0 &&
             !is_longint(&arr_facts->arrsize, arr_asstat_Env.target_rows))
    error(93, &arr_asstat_Env.oldtok);
  
  /* Figure out where the source stuff goes in the target.  This depends on three things:
     subarray or not; q = nil or not; source is scalar or not. */
  if (arr_asstat_Env.start == -1)                 /* not subarray */
    if (arr_facts->arrsize.head->value != 0)      /* it is not a scalar */
                                                  /* Oct 2000 */
      arr_asstat_Env.cols = quotient_of(&arr_facts->arrsize, arr_asstat_Env.rows);
      /* rows is correct; probably can't compute start yet */
    else if (arr_asstat_Env.q == NULL) 
      /* will later create 1 by 1 to hold scalar; nothing to do now */
      
      ;
    else {      /* scalar being assigned to existing array */
      arr_asstat_Env.rows = arr_asstat_Env.q->rows;  /* use q's data */
      arr_asstat_Env.start = arr_asstat_Env.q->start;  /* might be 0 if q sparse */
      arr_asstat_Env.total_rows = arr_asstat_Env.rows;
      arr_asstat_Env.cols = quotient_of(&arr_asstat_Env.q->sizearr, 
                                        arr_asstat_Env.rows);  /* Oct 2000 */
    }
  if (arr_asstat_Env.start == -1)
  /* not a subarray; if haven't set total_rows yet, set it here. */
    arr_asstat_Env.total_rows = arr_asstat_Env.rows;
  
  arr_asstat_Env.j = 0;            /* index for arr, below*/
  
  if (diagonal) 
    finishdiag(&arr_asstat_Env);
  else if (arr_asstat_Env.q != NULL) 
    if (arr_facts->arrsize.head->value == 0)
      /* it's a scalar; put into each spot in target array */
      if (arr_asstat_Env.q->spar == NULL) {
        forEnd_124 = arr_asstat_Env.cols - 1;
        for (i = 0; i <= forEnd_124; ++i) {
          forEnd_123 = arr_asstat_Env.rows - 1;
          for (k = 0; k <= forEnd_123; ++k) {
            arr_asstat_Env.locat = arr_asstat_Env.start + k + i*arr_asstat_Env.total_rows;
            quoly_assign(*n, &(*arp[BSR(arr_asstat_Env.locat,10)])
                        [BAnd(arr_asstat_Env.locat,  tenmask)]);
          }
        }
      } else 
        sparse_set_scalar(arr_asstat_Env.q, arr_asstat_Env.cols, *n);
    else {              /* not a scalar */
      if (*spar != NULL) {		/* can't be subarray */
        diagonal = *spar != arr_asstat_Env.q->spar;  /* May 2006. not mnemonic */
        if (!(spec_equal(&arr_facts->arrsize, &arr_asstat_Env.q->sizearr) &&
	        arr_asstat_Env.rows == arr_asstat_Env.q->rows)) {   /* Oct 2000 above */
          if (ustrcmp(arr_asstat_Env.oldtok.name, "%") == 0) 
            error(297, &arr_asstat_Env.oldtok);
          sparse_create(&arr_asstat_Env.oldtok, arr_asstat_Env.rows, 
                        arr_asstat_Env.cols, false, false); /* no main storage assigned */
          if (arr_asstat_Env.oldtok.address == -1) 
            arr_asstat_Env.oldtok.address = hash(&arr_asstat_Env.oldtok.name, 151);
          arr_asstat_Env.q = arr_store[arr_asstat_Env.oldtok.address];
        } else if (arr_asstat_Env.q->spar == NULL)   /* zapp the main storage */
          for (k = arr_asstat_Env.q->start; k <= arr_asstat_Env.q->stop; ++k) 
            free_quoly(&(*arp[BSR(k, 10)])[BAnd(k, tenmask)]);
        else 
          if (diagonal)  /* May 2006. fix bug of [q] := [q]. */
		    free_sparse(&arr_asstat_Env.q->spar, arr_asstat_Env.rows, true);
  
        if (*arr_free) 
          arr_asstat_Env.q->spar = *spar;
        else 
          if (diagonal) /* May 2006. fix bug of [q] := [q]. */
		    copy_sparse(spar, &arr_asstat_Env.q->spar, arr_asstat_Env.rows, false);
			
        quoly_set(0, n);
        return;
      }
      
      if (!spec_equal(&arr_facts->arrsize, &arr_asstat_Env.q->sizearr)
       /* create new array of name oldtok; */
          && arr_asstat_Env.target_rows == 0) {
	  /* couldn't have been subarray. Oct 2000 above */
        if (ustrcmp(arr_asstat_Env.oldtok.name, "%") == 0) 
          error(297, &arr_asstat_Env.oldtok);
        insertarr(&arr_asstat_Env.oldtok, arr_asstat_Env.rows, arr_asstat_Env.cols, 
                  false);
        if (arr_asstat_Env.oldtok.address == -1) 
          arr_asstat_Env.oldtok.address = hash(&arr_asstat_Env.oldtok.name, 
                                               151);
        arr_asstat_Env.q = arr_store[arr_asstat_Env.oldtok.address];
        arr_asstat_Env.start = arr_asstat_Env.q->start;
      }
      if (arr_asstat_Env.start == -1)    /* still!  This is the usual case. */
        arr_asstat_Env.start = arr_asstat_Env.q->start;
      if (arr_asstat_Env.q->spar == NULL) {
        forEnd_126 = arr_asstat_Env.cols - 1;
        for (i = 0; i <= forEnd_126; ++i) {
          forEnd_125 = arr_asstat_Env.rows - 1;
          for (k = 0; k <= forEnd_125; ++k) {
            arr_asstat_Env.locat = arr_asstat_Env.start + k + i*arr_asstat_Env.total_rows;
            if (*arr_free) {
              free_quoly(&(*arp[BSR(arr_asstat_Env.locat,10)])[BAnd(arr_asstat_Env.locat,
                                                                     tenmask)]);
              (*arp[BSR(arr_asstat_Env.locat, 10)])[BAnd(arr_asstat_Env.locat, 
                                              tenmask)] =(*arr)[arr_asstat_Env.j];
            } else 
              quoly_assign((*arr)[arr_asstat_Env.j], &(*arp[BSR(arr_asstat_Env.locat,
                             10)])[BAnd(arr_asstat_Env.locat, tenmask)]);
            arr_asstat_Env.j++;

          }
        }
      } else if (arr_asstat_Env.q->rows == arr_facts->rows) 
        standard_to_sparse(arr_asstat_Env.q, arr, arr_asstat_Env.cols, *arr_free);
      else
        error(249, &arr_asstat_Env.oldtok);       /* changed Sept 1996 */
    }
  else if (arr_facts->arrsize.head->value == 0) {
    /* scalar has been computed; create 1 by 1 */
    /* if q = nil, oldtok.name <> '%'*/
    insertarr(&arr_asstat_Env.oldtok, 1, 1, true);
    if (arr_asstat_Env.oldtok.address == -1) 
      arr_asstat_Env.oldtok.address = hash(&arr_asstat_Env.oldtok.name, 
                                           151);
    arr_asstat_Env.q = arr_store[arr_asstat_Env.oldtok.address];
    i = arr_asstat_Env.q->start;
    quoly_assign(*n, &(*arp[BSR(i, 10)])[BAnd(i, tenmask)]);
  } else {  /* q is nil, array has been computed; cannot be subarray. make new oldtok */
    /* if q = nil, oldtok.name <> '%'*/
    if (*spar == NULL) 
      insertarr(&arr_asstat_Env.oldtok, arr_asstat_Env.rows, arr_asstat_Env.cols, 
                false);
    else 
      sparse_create(&arr_asstat_Env.oldtok, arr_asstat_Env.rows, arr_asstat_Env.cols, 
                    false, false);
    if (arr_asstat_Env.oldtok.address == -1) 
      arr_asstat_Env.oldtok.address = hash(&arr_asstat_Env.oldtok.name, 151);
    arr_asstat_Env.q = arr_store[arr_asstat_Env.oldtok.address];
    
    if (*spar == NULL) 
      for (i = arr_asstat_Env.q->start; i <= arr_asstat_Env.q->stop; ++i) {
        if (*arr_free) 
          (*arp[BSR(i, 10)])[BAnd(i, tenmask)] = (*arr)[arr_asstat_Env.j];
        else 
          quoly_assign((*arr)[arr_asstat_Env.j], &(*arp[BSR(i, 10)])[BAnd(i, tenmask)]);
        arr_asstat_Env.j++;
      }
    else if (*arr_free) 
      arr_asstat_Env.q->spar = *spar;
    else 
      copy_sparse(spar, &arr_asstat_Env.q->spar, arr_asstat_Env.rows, false);
  }
  
  quoly_set(0, n);
}

/*****************************************************************************/

struct minors_EnvRec {
  colm_ptrptr u;
  long k;
  /* q is an existing sparse array. qrows and qcols are existing ordinary arrays.
     Create new sparse array of name 'let' by extracting the minor specified by
     qrows and qcols. Warning to user (Manual Note): if in mod mode, user must make 
     sure the coords in qrows and qcols are correct!  Also, even in rational mode,
     user must make sure of the reasonableness of the entries.  Not all errors will 
     be caught!  However, the data in qrows and qcols does not have to be sorted by 
     the user.
         q, qrows, qcols are read only.  The data in qrows and qcols is sorted here
     via a bin sort (that's bin, not binary) with rowdat and coldat.
         Nov 2000 */
  
  workptr rowdat;
  long mblock;
  sparseptr spold;
  long colnum;
  workptr coldat;
};
typedef struct minors_EnvRec minors_EnvRec;

/**************************************************************************/

struct do_the_row_EnvRec {
  jmp_buf do_the_row_exit;
};
typedef struct do_the_row_EnvRec do_the_row_EnvRec;

static void exitt(minors_EnvRec *minors_Env, do_the_row_EnvRec *do_the_row_Env)
{
  *minors_Env->u = NULL;
  longjmp(do_the_row_Env->do_the_row_exit, -1);
  /*exit(::do_the_row) ~ up-level function exit*/
}

/***************************************************************************/

static void do_the_row(minors_EnvRec *minors_Env, Boolean seestar) /* Jun 2009 */
{
  /* uses and changes spold, u, and block.  uses k and colnum. colnum
     has been set to newcols - 1.  Initially u^ is nil and u^ is some 
     sp^.indx[]. rowdat^[k] is valid. coldat has been sorted. 
	    seestar = cannibalize storage. */

  long source;
  long c;
  colm_ptr t;
  do_the_row_EnvRec do_the_row_Env;

  if (setjmp(do_the_row_Env.do_the_row_exit)) 
    return;
  source = (long)(*minors_Env->rowdat)[minors_Env->k] + 1 - addresser;
  /* Find that row in the old matrix. */
  while (source > minors_Env->mblock * sparsesize) {
    minors_Env->mblock++;
    minors_Env->spold = minors_Env->spold->next;
  }
  /* Use t to run down the col nodes for row source. */
  t = minors_Env->spold->indx[1 + (source - 1) % sparsesize - 1];
  c = -1;
  /* Use c to index coldat. Recall that all col entries in sparse arrays are 
     always 1-based, no matter what addresser is. */
  source = -1;                                    /* source is now a col source. */
  while (t != NULL) {
    /* Source is the addresser-corrected 1-based col coord shown by coldat.
       At start of this loop, we know that source < t^.coord. */
    while (source < t->coord) {
      c++;
      if (c > minors_Env->colnum)            /* we just went off the end of coldat */
        exitt(minors_Env, &do_the_row_Env);
      source = (long)(*minors_Env->coldat)[c] + 1 - addresser;
    }
    /* Now source >= t^.coord */
    while (source > t->coord) {
      t = t->next;
      if (t == NULL) 
        exitt(minors_Env, &do_the_row_Env);
    }
    /* Now source <= t^.coord */
    if (source == t->coord) {
      newcolm(minors_Env->u);
      if (seestar) {   /* Jun 2009 */
	(*minors_Env->u)->val = t->val;
	t->val = NULL;
	quoly_set(1, &t->val);
      }
      else {   /* Jun 2009 */
	    (*minors_Env->u)->val = NULL;  
	    quoly_assign(t->val, &(*minors_Env->u)->val);
	  }
      (*minors_Env->u)->coord = c + 1;            /* tricky; not source */
      minors_Env->u = &(*minors_Env->u)->next;
      t = t->next;
    }
  }
  *minors_Env->u = NULL;
}

/*****************************************************/

void minors(quolyptr n, arrptr q, arrptr qrows, arrptr qcols, tokentipe *let, Boolean seestar)  /* Jun 2009 */
{
  tokentipe errorname;
  long i;
  long j;
  long rownum;
  long newrows;
  long newcols;
  quoly qp;
  sparseptr sp;
  sparseptr spar;
  long forEnd_127;
  long forEnd_128;
  long forEnd_129;
  long forEnd_130;
  minors_EnvRec minors_Env;

  if (qrows == NULL) 
    error(329, &token);
  if (qcols == NULL) 
    error(329, &token);
  if (qrows->spar != NULL)      /* maybe change these two someday? */
    error(328, &token);
  if (qcols->spar != NULL) 
    error(328, &token);
  if (qrows->sizearr.head->value == 0) 
    error(329, &token);
  if (qcols->sizearr.head->value == 0) 
    error(329, &token);
  if (q->spar == NULL) 
    error(330, &token);
  
  /* set rownum and colnum for original sparse matrix whose elements are 
     being extracted. */
  rownum = q->rows;
  minors_Env.colnum = quotient_of(&q->sizearr, rownum);
  ustrcpy(errorname.name, "Minors");
  new_worknode(&j, &errorname);
  minors_Env.rowdat = workhead[j - 1];
  new_worknode(&j, &errorname);
  minors_Env.coldat = workhead[j - 1];
  
  /* initialize rowdat and coldat to impossible value, -1.  Note that the sparse
     array q might have more than arr_limit rows or cols, but the numbers of rows
     and cols in the new matrix must be <= arr_limit, simply because the minor data
     is stored in ordinary arrays, qrows and qcols.  However, if an entry in qrows
     or qcols is more than arr_limit, an error will result (checked below).  */
  if (rownum > arr_limit) {
    fprintf(stdout, " Warning. more than %0d rows.\n", arr_limit);
    fprintf(stdout, "    This may cause problems later.\n");
    rownum = arr_limit;
  }
  if (minors_Env.colnum > arr_limit) {
    fprintf(stdout, " Warning. more than %0d cols.\n", arr_limit);
    fprintf(stdout, "    This may cause problems later.\n");
    minors_Env.colnum = arr_limit;
  }
  forEnd_127 = rownum - 1;
  for (j = 0; j <= forEnd_127; ++j) 
    (*minors_Env.rowdat)[j] = (quoly)(-1);
  forEnd_128 = minors_Env.colnum - 1;
  for (j = 0; j <= forEnd_128; ++j) 
    (*minors_Env.coldat)[j] = (quoly)(-1);
  
  /* Sort array qrows with a bin sort. Move data to rowdat. Also, count exactly
     how many we insert, just to guard against the unlikely event that there are
     duplicate coords in qrows (sneaky!).  So at end, newrows is number of rows
     in new sparse matrix of minors, same for newcols.  Note that some of these 
     rows in the new matrix might turn out to be all 0, so that sp^.indx[] will be  
     nil. That's OK. */
  newrows = 0;
  for (i = qrows->start; i <= qrows->stop; ++i) {
    qp = (*arp[BSR(i, 10)])[BAnd(i, tenmask)];
    if (qp->numb) 
      if (lintmode) 
        j = qp->variant.vc_1.ncoef->lint;
      else 
        j = qp->variant.vc_1.ncoef->head->value;  /* Note: don't check size */
    else 
      error(331, &token);
    if (j + 1 - addresser > rownum || j + 1 - addresser < 1) 
      error(332, &token);
    if ((long)(*minors_Env.rowdat)[j - addresser] == -1) 
      newrows++;
    (*minors_Env.rowdat)[j - addresser] = (quoly)j;
  }
  
  /*sort array qcols. move data to coldat. */
  newcols = 0;
  for (i = qcols->start; i <= qcols->stop; ++i) {
    qp = (*arp[BSR(i, 10)])[BAnd(i, tenmask)];
    if (qp->numb) 
      if (lintmode) 
        j = qp->variant.vc_1.ncoef->lint;
      else 
        j = qp->variant.vc_1.ncoef->head->value;
    else 
      error(331, &token);
    if (j + 1 - addresser > minors_Env.colnum || j + 1 - addresser < 1) 
      error(332, &token);
    if ((long)(*minors_Env.coldat)[j - addresser] == -1) 
      newcols++;
    (*minors_Env.coldat)[j - addresser] = (quoly)j;
  }
  
  /* Squeeze the -1s out of coldat. It is much more efficient and easier for 
     later steps to do this now.  It's not important, though, to squeeeze them
     out of rowdat. */
  j = 0;
  forEnd_129 = minors_Env.colnum - 1;
  for (i = 0; i <= forEnd_129; ++i) 
    if ((long)(*minors_Env.coldat)[i] != -1) {
      (*minors_Env.coldat)[j] = (*minors_Env.coldat)[i];
      j++;
    }
  if (j != newcols) 
    fermat_error("j <> newcols in minors.", true);
  
  /* Create the new matrix. */
  minors_Env.colnum = newcols - 1;         /* used by procedure do_the_row */
  rownum = newrows;                        /* used at the end */
  sparse_init(&spar, newrows);
  sp = spar;
  minors_Env.spold = q->spar;
  minors_Env.mblock = 1;     /* gives current block of q^.spar, i.e., which rowarray */
  minors_Env.k = 0;
  forEnd_130 = (newrows - 1) / sparsesize;
  for (j = 0; j <= forEnd_130; ++j) {
    /* fill in the stuff for the rows of new matrix, taken in order.
       sp goes down new matrix.  spold goes down old matrix, q, the "source." 
       k indexes the array rowdat, now sorted but with some -1 entries. */
    for (i = 1; i <= sparsesize; ++i)
      if (i > newrows) 
        break;
      else {
        /* We know there are more rows to do, since i <= newrows. Thus,
           the k loop here can't overflow the end of rowdat^. */
        while ((long)(*minors_Env.rowdat)[minors_Env.k] == -1) 
          minors_Env.k++;
        minors_Env.u = &sp->indx[i - 1];
        do_the_row(&minors_Env, seestar);  /* Jun 2009 */
        minors_Env.k++;
      }
    newrows -= sparsesize;
    sp = sp->next;
  }
  
  free_work();
  free_work();
  
  quick_sparse_create(spar, let, rownum, newcols, newcols == 1);
  quoly_set(rownum, n);
}

/*****************************************************************************/

void set_quotient(quoly m, textptr inf, nameptr *flag, long errno, char end_char)
{
  /* m is used or freed. 
     errno, end_char Oct 2003 */
  
  tokentipe oldtok;
  quolyptr qp;
  quolyptr qp2;
  varptr q;
  arrptr q2;
  numptr np;
  Boolean colflag;
  Boolean ordinary;
  long rows;
  long cols;
  long location;

  oldtok = token;
  if (*flag != NULL && (*flag)->compiled) {
    qp = (*flag)->qp;
    if ((*flag)->tipe == two) {
      *flag = (*flag)->next->next;
      do 
        *flag = (*flag)->next;
      while (ustrcmp((*flag)->let.name, "]") != 0);
    }
    *flag = (*flag)->next;
    token = (*flag)->let;
  } else {
    qp = NULL;
    scanner(inf, &token, flag);
  }
  if (polynames != NULL && its_a_polyname(&oldtok.name)) 
    error(125, &oldtok);
  if (oldtok.name[0] < 'a' || oldtok.name[0] > 'z') 
    error(232, &oldtok);
  
  if (token.name[0] == end_char)        /* Oct 2003 */
    if (qp == NULL) {
      insert_var(&oldtok, m, &q);
      m = NULL;
    } else {
      if (m->numb) 
        m->variant.vc_1.arr_arg = false;
      free_quoly(qp);
      *qp = m;
      m = NULL;
    }
  else if (ustrcmp(token.name, "[") == 0) {
    if (ustrcmp(oldtok.name, "<") == 0)      /* system array Jul 2003  */
      error(176, &oldtok);
    scanner(inf, &token, flag);
    if (integerflag) 
      ievalcoords(&rows, &cols, flag, &colflag);
    else 
      evalcoords(inf, &rows, &cols, flag, ']', ',', &colflag, false);
    scanner(inf, &token, flag);                   /* should be ')' */
    if (qp == NULL) {
      lookup(&oldtok, rows, cols, &q2, &qp2, colflag);
      ordinary = q2->spar == NULL;
    } else {                                      /* tipe three compiled reference */
      ordinary = true;
      np = (numptr)qp;
      location = np->value + rows - addresser;
      if (colflag) 
        location += (cols - addresser) * (np->next->value);
      qp2 = &(*arp[BSR(location, 10)])[BAnd(location, tenmask)];
    }
    if (qp2 == NULL) 
      sparse_insert(rows, cols, q2, colflag, &m);
    else if (ordinary || !quoly_iszero(m)) {
      free_quoly(qp2);
      *qp2 = m;
      m = NULL;
    } else 
      sparse_delete(rows, cols, q2, colflag);     /*@@@*/
  }
  
  if (m != NULL) 
    free_quoly(&m);
  if (token.name[0] != end_char) /* Nov 2004 BUG fix; had not completed the
                                        Oct 2003 revision */
    error(errno, &token);
}

/******************************************************************************/

struct sparse_adjoin_EnvRec {
  /* n is used up and nilled out. no checking here for index out of bounds. */
  
  colm_ptrptr t;
  long *c;
  quoly *n;
};
typedef struct sparse_adjoin_EnvRec sparse_adjoin_EnvRec;

/*****************************************************************************/

static void attach_1(sparse_adjoin_EnvRec *sparse_adjoin_Env)
{
  colm_ptr s;

  s = *sparse_adjoin_Env->t;
  newcolm(sparse_adjoin_Env->t);
  (*sparse_adjoin_Env->t)->next = s;
  (*sparse_adjoin_Env->t)->coord = *sparse_adjoin_Env->c;
  (*sparse_adjoin_Env->t)->val = *sparse_adjoin_Env->n;
}

/*****************************************************************************/

void sparse_adjoin(sparseptr spar, long r, long c, quolyptr n)
{
  long i;
  sparseptr sp;
  long forEnd_131;
  sparse_adjoin_EnvRec sparse_adjoin_Env;

  sparse_adjoin_Env.n = n;
  sparse_adjoin_Env.c = &c;
  if (quoly_iszero(*n)) {
    free_quoly(n);
    return;
  }
  r = r - addresser + 1;
  c = c - addresser + 1;
  sp = spar;
  forEnd_131 = (r - 1) / sparsesize;
  for (i = 1; i <= forEnd_131; ++i) 
    sp = sp->next;
  sparse_adjoin_Env.t = &sp->indx[1 + (r - 1) % sparsesize - 1];
  while (*sparse_adjoin_Env.t != NULL) 
    if ((*sparse_adjoin_Env.t)->coord < c) 
      sparse_adjoin_Env.t = &(*sparse_adjoin_Env.t)->next;
    else 
      break;
  if (*sparse_adjoin_Env.t == NULL) 
    attach_1(&sparse_adjoin_Env);
  else if (c == (*sparse_adjoin_Env.t)->coord) {
    best_quoly_add(&(*sparse_adjoin_Env.t)->val, *n);
    if (quoly_iszero((*sparse_adjoin_Env.t)->val)) 
      free_colm(sparse_adjoin_Env.t);
  } else 
    attach_1(&sparse_adjoin_Env);
  *n = NULL;
}

/******************************************************************************/

struct funcdef_EnvRec {
  FILEPtr *inf;
  nameptr *flag;
};
typedef struct funcdef_EnvRec funcdef_EnvRec;

/****************************************************************************/

struct make_par_list_EnvRec {
  /* Formal parameters are linked up.  A semicolon separator
     means the following parameters are really local vars, but
     this procedure treats them exactly like parameters. */
  
  paramptr last;
};
typedef struct make_par_list_EnvRec make_par_list_EnvRec;

/**************************************************************************/

static void compare(paramptr p, make_par_list_EnvRec *make_par_list_Env)
{
  while (p != make_par_list_Env->last) {
    if (ustrcmp(p->let.name, make_par_list_Env->last->let.name) == 0) 
      error(237, &make_par_list_Env->last->let);
    p = p->next;
  }
}

/*************************************************************************/

static void make_par_list(paramptr *q, funcdef_EnvRec *funcdef_Env)
{
  Boolean res;
  make_par_list_EnvRec make_par_list_Env;
  paramptr temp;

  *q = (paramptr)malloc(sizeof(paramnode));
  make_par_list_Env.last = *q;
  do {
    scanner(funcdef_Env->inf, &token, funcdef_Env->flag);
    if (token.name[0] == '^') {
      res = true;
      scanner(funcdef_Env->inf, &token, funcdef_Env->flag);
    } else 
      res = false;
    if (token.name[0] >= 'a' && token.name[0] <= 'z') {
      token.address = hash(&token.name, 151);
      make_par_list_Env.last->next = (paramptr)malloc(sizeof(paramnode));
      make_par_list_Env.last = make_par_list_Env.last->next;
      make_par_list_Env.last->let = token;
      make_par_list_Env.last->result = res;
      make_par_list_Env.last->arry = false;       /* used by compiler */
      compare((*q)->next, &make_par_list_Env);
    } else 
      error(5, &token);
    scanner(funcdef_Env->inf, &token, funcdef_Env->flag);
    if (ustrcmp(token.name, ",") != 0 && ustrcmp(token.name, ";") != 0 &&
        ustrcmp(token.name, ")") != 0)
      error(6, &token);
  } while (ustrcmp(token.name, ")") != 0);
  make_par_list_Env.last->next = NULL;
  temp = *q;
  *q = (*q)->next;
  free(temp);
  scanner(funcdef_Env->inf, &token, funcdef_Env->flag);
  if (ustrcmp(token.name, "=") != 0) 
    error(7, &token);
}

/******************************************************************/

void funcdef(textptr inf, nameptr *flag)
{
  funcptr q;
  Boolean once_more;
  short i;
  tokentipe realtok;
  funcdef_EnvRec funcdef_Env;

  funcdef_Env.flag = flag;
  funcdef_Env.inf = inf;
  current_func = token;
  func_def_count++;
  once_more = true;
  last_good_one = NULL;
  last_attached = NULL;
  last_comm = NULL;
  q = (funcptr)malloc(sizeof(funcnode));
  q->comp = NULL;
  q->name = token;
  
  scanner(inf, &token, flag);
  if (ustrcmp(token.name, "(") == 0) 
    make_par_list(&q->pars, &funcdef_Env);
  else if (ustrcmp(token.name, "=") == 0) 
    q->pars = NULL;
  else 
    error(12, &token);
    
  scanner(inf, &token, flag);
  right_side(&q->rht,(unsigned char *) ".", inf, flag, &once_more, &realtok);
  if (feof(*inf) && ustrcmp(token.name, ".") != 0) 
    error(103, &token);
  
  i = hash(&q->name.name, 71);
  q->name.address = i;
  q->next = func_store[i];
  func_store[i] = q;
  new_funcs = true;                               /* Jul 2002, new name */
  
  /* once_more and realtok are set by attach, basically because a decimal constant 
     was found in the funcdef */
  if (once_more) 
    scanner(inf, &token, flag);
  else 
    token = realtok;
  func_def_count--;
  
}

/******************************************************************************/

long check_and_mod_numb(long m) /* Dec 2005 */
{
  m = m % modulus;
  if (m < 0)
    m = m + modulus;
  if (m == 0)
    error(359, &token);
  return(m);
}

/******************************************************************************/

void check_and_mod_poly(poly p) /* Dec 2005 */
{
  while (p != NULL) {
    if (p->numb)
      p->variant.ncoef->lint = check_and_mod_numb(p->variant.ncoef->lint);
    else 
      check_and_mod_poly(p->variant.pcoef);
    p = p->next;
  }
 
}

/******************************************************************************/

void check_and_mod(quoly n)
{ /* BUG fix. Dec 2005 */

  if (n->numb) 
    n->variant.vc_1.ncoef->lint = check_and_mod_numb(n->variant.vc_1.ncoef->lint);
  else {
    check_and_mod_poly(n->variant.vc_2.numer);
    if (n->variant.vc_2.denom != NULL) {
      check_and_mod_poly(n->variant.vc_2.denom);
      lint_normal_form(n, laurent);
    }
  }
}

/******************************************************************************/

void sparse_read(textptr inf, quolyptr n, nameptr *flag, arr_descr *arr_facts, Boolean *arr_free, 
                 Boolean *errcode, sparseptr *spar)
{
  /* errcode (and firstval) added Jan 1997. false means "normal", i.e., found a matrix in
     sparse-reading format.  True means leave this and drop back into "ordinary" reading. 
     In that case n is the first value found.
       The purpose of this proc is to detect full sparse read format, while also allowing for
     the ordinary array read format.
       Dec 2005: BUG fix. Add check_and_mod. */
  
  Boolean oldmodmode;
  Boolean firstval;
  long rows;
  long cols;
  long r;
  long c;
  long j;
  sparseptr sp;
  long forEnd_132;
  long forEnd_133;

  rows = arr_facts->rows;                         /* already known to be valid size */
  cols = quotient_of(&arr_facts->arrsize, rows);  /* Oct 2000 */
  *errcode = false;                               /* Jan 1997; all references */
  firstval = true;                                /* Jan 1997; all references */
  
  newsparse(spar);
  sp = *spar;
  forEnd_132 = 1 + (rows - 1) / sparsesize;
  for (c = 2; c <= forEnd_132; ++c) {
    for (j = 1; j <= sparsesize; ++j) 
      sp->indx[j - 1] = NULL;
    newsparse(&sp->next);
    sp = sp->next;
  }
  forEnd_133 = 1 + (rows - 1) % sparsesize;
  for (j = 1; j <= forEnd_133; ++j) 
    sp->indx[j - 1] = NULL;                       /* leave sp here */
  sp->next = NULL;                                /* July 1998, new convention!! */
  
  do {
    scanner(inf, &token, flag);
    check_modular(&oldmodmode);
    old_expre(inf, n, flag);
    if (ustrcmp(token.name, ",") != 0) 
      error(202, &token);
    if (!(*n)->numb) {
      if (firstval) {
        *errcode = true;
        scanner(inf, &token, flag);
        restore_modular(oldmodmode);
        if (modularmode)
          check_and_mod(*n);   /* Dec 2005 */
      }
      /* Note: Don't need to change n!  It's usually just fine. <- Hah! Dec 2005 */
      else 
        free_quoly(n);
      sp->next = spargarb;
      spargarb = *spar;
      *spar = NULL;
      if (firstval) 
        return;
      else 
        error(265, &token);
    }
    r = convert_to_int((*n)->variant.vc_1.ncoef);
    if (r < addresser || r > rows) 
      if (firstval) {
        *errcode = true;
        scanner(inf, &token, flag);
        sp->next = spargarb;
        spargarb = *spar;
        *spar = NULL;
        restore_modular(oldmodmode);
        if (modularmode)
          check_and_mod(*n);   /* Dec 2005 */
        return;
      } else 
        error(27, &token);
    restore_modular(oldmodmode);
    while (ustrcmp(token.name, ",") == 0) {
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, "[") != 0) 
        if (firstval) {
          *errcode = true;
          sp->next = spargarb;
          spargarb = *spar;
          *spar = NULL;
          if (modularmode)
            check_and_mod(*n);   /* Dec 2005 */
          return;
        } else 
          error(255, &token);
      firstval = false;
      scanner(inf, &token, flag);
      check_modular(&oldmodmode);
      old_expre(inf, n, flag);
      if (ustrcmp(token.name, ",") != 0) 
        error(202, &token);
      if (!(*n)->numb) {
        free_quoly(n);
        sp->next = spargarb;
        spargarb = *spar;
        error(265, &token);
      }
      c = convert_to_int((*n)->variant.vc_1.ncoef);
      if (c < addresser || c > cols) 
        error(27, &token);
      scanner(inf, &token, flag);
      restore_modular(oldmodmode);
      old_expre(inf, n, flag);
      if (ustrcmp(token.name, "]") != 0) 
        error(251, &token);
      scanner(inf, &token, flag);
      sparse_adjoin(*spar, r, c, n);
    }
    if (ustrcmp(token.name, "]") != 0) 
      error(251, &token);
    scanner(inf, &token, flag);
  } while (ustrcmp(token.name, "[") == 0);
  
  if (ustrcmp(token.name, "]") != 0) 
    error(251, &token);
  scanner(inf, &token, flag);
  *arr_free = true;
  quoly_set(0, n);
}

/*****************************************************************************/

void arr_parse(char x, textptr inf, quolyptr n, nameptr *flag)

{
  workptr arr;
  workptr arr2;
  arr_descr arr_facts;
  long i;
  long r;
  long spot;
  long numprimes;   /* Oct 2009. for new SDet function.  */
  tokentipe oldtok;
  Boolean arr_free;          /* pos_only -> special, Sept 1996 */
  Boolean special;
  Boolean oldmodmode;
  tokentipe detsign;
  sparseptr spar;
  poly fct;                                       /* Sept 1996 */
  long r2;   /* Jan 2008. kill one of these dumb forEnd things. */
  long forEnd_137;
  long forEnd_138;
  long forEnd_139;
  long forEnd_140;
  long forEnd_141;

  ustrcpy(oldtok.name, " ");   /* Jun 2003 bug */
  oldtok.name[0] = x;
  
  new_worknode(&r, &oldtok);
  arr = workhead[r - 1];
  ustrcpy(detsign.name, "Det");  /* was Æ  Jun 2004 */
  
  arr_facts.arrsize.size = 0;       /* Oct 2000 */
  ustrcpy(oldtok.name, " ");
  special = false;
  spar = NULL;

  switch (x) { 
    case '[':
    case '~':  /* Diag */
      arr_asstat(inf, n, arr, &arr_facts, &arr_free, flag, &spar);  /* Nov 1997 */
      
      break;/* This works because of restrictions on array statement syntax. */
    
    
    case '"':  /* Transpose */
    case 'A':
    case 'M':
      arr_expre(inf, n, arr, &arr_facts, &arr_free, &r, flag, &spar, true);
      fill_syst_array(arr, &arr_facts, arr_free, spar, r);
      quoly_set(0, n);
      break;
    
    case 'T':                                     /* trace */
      scanner(inf, &token, flag);
      r = 0;
      arr_fact(inf, n, arr, &arr_facts, &arr_free, &r, flag, &spar);
      if (is_product_of(&arr_facts.arrsize, arr_facts.rows, arr_facts.rows) &&
         (arr_facts.arrsize.size > 1 || arr_facts.arrsize.head->value >= 1))
        if (spar == NULL) {
          quoly_assign((*arr)[0], n);
          r = arr_facts.rows + 1;
          r2 = r - 2;   /* Jan 2008, and below */
          for (i = 1; i <= r2; ++i) 
            better_quoly_add(*n, (*arr)[i * r], n);
        } else 
          sparse_trace(n, spar, arr_facts.rows);
      else 
        error(194, &token);
      if (spar == NULL) {
        if (arr_free) 
          free_arr(arr, &arr_facts);
      } else 
        free_sparse(&spar, arr_facts.rows, arr_free);
      break;
    
    case 'S':                                     /* Sumup */
      scanner(inf, &token, flag);
      r = 0;
      arr_fact(inf, n, arr, &arr_facts, &arr_free, &r, flag, &spar);
      if (arr_facts.arrsize.head->value == 0) 
        error(46, &token);
      if (spar == NULL) 
        sum_arr(arr, arr_facts.arrsize.head->value, n);  /* Oct 2000 */
      else 
        sparse_sum(n, spar, arr_facts.rows);
      if (spar == NULL) {
        if (arr_free) 
          free_arr(arr, &arr_facts);
      } else 
        free_sparse(&spar, arr_facts.rows, arr_free);
      break;
    
    case '7':  /* Det */
    case '8':  /* SDet, Oct 2009 */
    case 'H':
    case 'L':   /* H added Nov 1996; L added Apr 1998 for Det_ */
              /* Æ by itself is determinat. Æ#([b]= a) counts how many elements of
                 matrix [b] equal a -- similarly for > or <.  Æ_ finds the index 
                 in a matrix of the smallest value; Æ^ does same for largest value.
                 Æ_+ restricts to positive entries. */
              
      if (x == 'L') 
        ustrcpy(token.name, "_");              /* Apr 1998 */
      else 
        scanner(inf, &token, flag);

      if (x == '8') { /* Oct 2009 */
		if (ustrcmp(token.name, "(") != 0) 
		  error(177, &token);
		if (lintmode) 
		  error(235, &token);
	  }

      switch (token.name[0]) { 
        case '_':
        case '^':
          oldtok = token;
          scanner(inf, &token, flag);
          if (ustrcmp(token.name, "+") == 0 && ustrcmp(oldtok.name, "_") == 0) {
            special = true;
            scanner(inf, &token, flag);
          }
          break;
        case '#':
          oldtok = token;
          scanner(inf, &token, flag);
          if (ustrcmp(token.name, "(") != 0) 
            error(64, &token);
          scanner(inf, &token, flag);
          break;
        case '(':
          special = true;
          scanner(inf, &token, flag);
          break;
      } /* case token.name[0] of */
      
       if (x == '8') { /* read the first value, positive integer = number of primes needed. Oct 2009 */
	    old_expre(inf, n, flag);
        if ((*n)->numb) 
		  numprimes = (*n)->variant.vc_1.ncoef->head->value;
		else 
		  error(227, &token);
		if (numprimes < 2)
		  error(364, &token);
		if (token.name[0] != ',')
		  error(202, &token);
		scanner(inf, &token, flag);
	  }
	  else
	    numprimes = 0;
	  
      r = 0;
      arr_fact(inf, n, arr, &arr_facts, &arr_free, &r, flag, &spar);
      if (x == 'H') {                             /* Nov 1996 */
        if (!is_product_of(&arr_facts.arrsize, arr_facts.rows, arr_facts.rows)) 
          error(23, &token);                      /* Dec 2000 */
        if (arr_facts.rows > 100) 
          error(23, &token);                      /* Dec 2000 */
        if (spar != NULL) 
          error(23, &token);                      /* Dec 2000 */
        set_up_hamilton(arr, &arr_facts, &arr_free, &spar);
      }

       else if (x == '8')   /* Oct 2009 */
	    if (spar == NULL)
		  error(333, &token);
	
      /* quolies in arr^ now undefined; arr_free is now false; good. */
      if (arr_facts.arrsize.head->value == 0) 
        error(46, &detsign);
      switch (oldtok.name[0]) { 
        case ' ':
          fct = NULL;
          r = -1;            /* Mar 2004 */
	  r2 = -1;        /* Jan 2008 */
          i = 0;             /* Mar 2004 */
          spot = -1;         /* Mar 2004. don't really use spot yet. Sep 2006: It's used in the loop below, passed to mat_invert. */
          if (special) {     /* Sept 1996. saw '(' */
            /* Jul 2004. allow for up to 3 arguments (after the matrix itself).
               first = factor of Det, second, third must be numbers and =
               degree of Det (including the factor if specified) and the exponent 
               of Det/fct = a perfect nth power.
               first is number if x = 'H'. massive changes. Mar 2004 */
            while (token.name[0] == ',') {     /* Mar 2004 */
              i++;                             /* Mar 2004 */
              if (i > 4)         /* Mar 2004, Jan 2008 */
                error(15, &token);
              if (x == 'H' && i > 1)              /* Mar 2004 */
                error(15, &token);
              scanner(inf, &token, flag);
              if (token.name[0] == ',') 
                continue;                         /* Mar 2004 */
              if (x == 'H' || i > 1)              /* Mar 2004 */
                check_modular(&oldmodmode);
              old_expre(inf, n, flag);
              if (x == 'H' || i > 1)              /* Mar 2004 */
                restore_modular(oldmodmode);
              if (x == 'H')
                if ((*n)->numb) 
                  quoly_to_poly(*n, &fct);
                else 
                  error(227, &token);
              else if ((*n)->numb)       /* Mar 2004. 2, 3, 4 = degree, degree2, exponent.  Jan 2008 */
                switch (i) { 
                  case 1:
                    quoly_to_poly(*n, &fct);
                    break;
                  case 2:
                    if (lintmode) 
                      r = (*n)->variant.vc_1.ncoef->lint;
                    else 
                      r = (*n)->variant.vc_1.ncoef->head->value;
                    break;
                  case 3:   /* Jan 2008 */
                    if (lintmode) 
                      r2 = (*n)->variant.vc_1.ncoef->lint;
                    else 
                      r2 = (*n)->variant.vc_1.ncoef->head->value;
                    break;
                  case 4:  /* Jul 2004, Jan 2008 */
                    if (lintmode)
                      spot = (*n)->variant.vc_1.ncoef->lint;
                    else 
                      spot = (*n)->variant.vc_1.ncoef->head->value;
                    if (abs(spot) < 2)
                      error(351, &token);
		    if (!Odd(spot) && spot > 0)   /* Sep 2006 */
		      if (power_of_two(spot)) {
			spot = spot / 2;  /* Sep 2006. do this division here! */
						if (spot == 1) {
						  if (verbose)
						    fprintf(stdout, " Warning. Setting power = 2 has no effect.\n");
						  spot = -1;
						}
					  }
		      else
			 warning(4,  (unsigned char *)" ");  /* Oct 2007 */
                    break;
                }
              else {                              /* Mar 2004 */
                if (i > 1)
                  error(227, &token);
                if ((*n)->variant.vc_2.denom != NULL)
                  warning(1, (unsigned char *)" ");
                fct = (*n)->variant.vc_2.numer;
                (*n)->variant.vc_2.numer = NULL;
                if (laurent && anynegs(fct)) 
                  error(198, &token);
              }
            }
            if (ustrcmp(token.name, ")") != 0)
              error(1, &token);
            scanner(inf, &token, flag);
          }
          quoly_set(1, n);
          if (r != -1 && r <= 0)                  /* Mar 2004 */
            warning(2, (unsigned char *)"Æ");    /*AAR ???  OK, Mar 2004*/
          if (is_product_of(&arr_facts.arrsize, arr_facts.rows, arr_facts.rows)) 
            if (spar == NULL) 
              if (first_available <= worksize)
                mat_invert(arr, arr, arr_free, arr_free, arr_facts.rows,
                           n, false, true, &spar, fct, r, r2, spot, false, 0);  /* Jul 2004, Jan 2008  */
              else 
                warning(90, (unsigned char *)"Æ");  /*AAR ???  OK, Mar 2004*/
            else {
              if (x == 'H')
                arr_facts.rows = -arr_facts.rows;  /* a kludgy flag */
              mat_invert(arr, arr, arr_free, arr_free, arr_facts.rows,
                         n, false, true, &spar, fct, r, r2, spot, false, numprimes);  /* Jul 2004, Jan 2008  */
              if (x == 'H') {
                arr_facts.rows = -arr_facts.rows;
                free_stuff(spar, arr_facts.rows);
              }
              /* leave arr_free false; spar <> nil */
              if (spar == NULL) {                 /* see invert_sparse */
                free_work();
                return;
              }
            }
          else 
            error(241, &token);
          free_poly(&fct);
          break;

        case '_':
          if (spar == NULL) {
            spot = -1;
            if (special) {
              forEnd_137 = arr_facts.arrsize.head->value - 1;
              for (i = 0; i <= forEnd_137; ++i) 
                if ((*arr)[i]->numb) {
                  if (lintmode && (*arr)[i]->variant.vc_1.ncoef->lint > 0 || !lintmode &&
		                 (*arr)[i]->variant.vc_1.ncoef->head->value > 0) {
                    spot = i;
                    break;
                  }
                } else 
                  error(119, &logsign);
            }
            
            else 
              spot = 0;
            
            if (special) {
              if (spot >= 0) {
                forEnd_138 = arr_facts.arrsize.head->value - 1;
                for (i = spot + 1; i <= forEnd_138; ++i) 
                  if ((*arr)[i]->numb) {
                    if (lintmode && (*arr)[i]->variant.vc_1.ncoef->lint > 0 || !lintmode
		       && (*arr)[i]->variant.vc_1.ncoef->head->value > 0)
                      if (quoly_larger((*arr)[spot], (*arr)[i]))
                        spot = i;
                  } else 
                    error(119, &logsign);
              }
            }
            
            else {
              forEnd_139 = arr_facts.arrsize.head->value - 1;
              for (i = spot + 1; i <= forEnd_139; ++i) 
                if ((*arr)[i]->numb) {
                  if (quoly_larger((*arr)[spot], (*arr)[i])) 
                    spot = i;
                } else 
                  error(119, &logsign);
            }
            quoly_set(spot + addresser, n);
          }
          
          else 
            sparse_max_min(spar, arr_facts.rows, quotient_of(&arr_facts.arrsize, 
                                   arr_facts.rows), false, special, n);
          break;
        case '^':
          if (spar == NULL) {
            spot = 0;
            forEnd_140 = arr_facts.arrsize.head->value - 1;
            for (i = 1; i <= forEnd_140; ++i) 
              if ((*arr)[i]->numb) {
                if (quoly_larger((*arr)[i], (*arr)[spot])) 
                  spot = i;
              } else 
                error(119, &expsign);
            quoly_set(spot + addresser, n);
          } else 
            sparse_max_min(spar, arr_facts.rows, quotient_of(&arr_facts.arrsize, 
                                                             arr_facts.rows), true, false, n);
          break;
        case '#':
          oldtok = token;
          if (spar != NULL) 
            error(242, &token);
          if (ustrcmp(oldtok.name, "=") != 0 && ustrcmp(oldtok.name, ">") != 0 &&
	     ustrcmp(oldtok.name, "<") != 0)
            error(65, &oldtok);
          scanner(inf, &token, flag);
          old_expre(inf, n, flag);
          if (ustrcmp(token.name, ")") != 0) 
            error(66, &token);
          scanner(inf, &token, flag);
          spot = 0;
          forEnd_141 = arr_facts.arrsize.head->value - 1;
          for (i = 0; i <= forEnd_141; ++i) 
            switch (oldtok.name[0]) { 
              case '=':
                if (quoly_equal((*arr)[i], *n)) 
                  spot++;
                break;
              case '>':
                if ((*n)->numb && (*arr)[i]->numb) {
                  if (quoly_larger((*arr)[i], *n)) 
                    spot++;
                } else 
                  error(120, &oldtok);
                break;
              case '<':
                if ((*n)->numb && (*arr)[i]->numb) {
                  if (quoly_larger(*n, (*arr)[i])) 
                    spot++;
                } else 
                  error(120, &oldtok);
                break;
            }
          
          quoly_set(spot, n);
          break;
      }
      
      
      /* case oldtok.name[0] of */
      
      if (spar == NULL) {
        if (arr_free) 
          free_arr(arr, &arr_facts);
      } else 
        free_sparse(&spar, arr_facts.rows, arr_free);
      break;
  }
    
  special_free(&arr_facts.arrsize);               /* Oct 2000 */
  
  free_work();
}

/*****************************************************************************/

/* implements dumb save */

void handle_andsign(textptr inf, nameptr *flag, Boolean *outflag, textptr *tp)
{
  scanner(inf, &token, flag);                     /*spar<*/
  if (ustrcmp(token.name, "o") != 0) 
    error(261, &token);
  if (ustrcmp(output_file_name, "") == 0) 
    error(263, &token);
  scanner(inf, &token, flag);
  *outflag = false;
  *tp = &outpuf;
}

/****************************************************************************/

void handle_quote(textptr inf, quolyptr n, nameptr *flag, Boolean *outflag, textptr *tp)
{
  long c;
  long lengt;
  Boolean dumm;                                   /*spar many changes here */
  Boolean oldmodmode;
  bigstring out_name;

  c = 0;
  ustrcpy(out_name, "");
  do {
    dumbscanner(inf, &token, flag, &dumm);
    c += ustrlen(token.name);
    if (c <= 255) 
      if (ustrcmp(token.name, "\'") != 0) 
	ustrcat(out_name,token.name);
  } while (ustrcmp(token.name, "\'") != 0);
  
  c--;
  scanner(inf, &token, flag);
  fprintf(**tp, "%s", out_name);
  if (ustrcmp(token.name, ":") == 0) {
    scanner(inf, &token, flag);
    check_modular(&oldmodmode);
    old_expre(inf, n, flag);
    lengt = quoly_convert_to_int(*n);
    restore_modular(oldmodmode);
    if (lengt > c) 
      doblanks(*tp, lengt-c);
  }
}

/****************************************************************************/

struct one_write_out_EnvRec {
  Boolean oldmodmode;
  FILEPtr *inf;
  nameptr *flag;
  Boolean char_flag;
  long lengt;
  quoly *n;
};
typedef struct one_write_out_EnvRec one_write_out_EnvRec;

/****************************************************************************/

static void handle_colon(quolyptr n, LongIntPtr lengt, one_write_out_EnvRec *one_write_out_Env)
{
  check_modular(&one_write_out_Env->oldmodmode);
  old_expre(one_write_out_Env->inf, n, one_write_out_Env->flag);
  *lengt = quoly_convert_to_int(*n);
  restore_modular(one_write_out_Env->oldmodmode);
}

/**************************************************************************/

static void handle_char(one_write_out_EnvRec *one_write_out_Env)
{
  one_write_out_Env->char_flag = true;
  one_write_out_Env->lengt = 0;
  scanner(one_write_out_Env->inf, &token, one_write_out_Env->flag);
  if (ustrcmp(token.name, ":") == 0) {
    scanner(one_write_out_Env->inf, &token, one_write_out_Env->flag);
    handle_colon(one_write_out_Env->n, &one_write_out_Env->lengt, 
                 one_write_out_Env);
  }
}

/*************************************************************************/

void one_write_out(textptr inf, quolyptr n, nameptr *flag, Boolean ok, Boolean outflag, Boolean do_extras, 
                   textptr outfile)
{
  
  /* ok = false means out file must be output. outflag = is output tty? */
  
  long firstrow;
  long firstcol;
  long location;
  long total_rows;
  long r;
  long c;
  long old_disp_size;
  long m;
  arrptr q;
  tokentipe oldtoken;
  Boolean its_not_syst;
  quoly n1;
  nameptr f2;
  one_write_out_EnvRec one_write_out_Env;


  one_write_out_Env.n = n;
  one_write_out_Env.flag = flag;

  one_write_out_Env.inf = inf;
  one_write_out_Env.lengt = 4;
  one_write_out_Env.char_flag = false;            /*!*/
  old_disp_size = disp_size;                      /*spar*/
  if (ustrcmp(token.name, "[") == 0) {
    firstrow = addresser;
    firstcol = addresser;
    q = NULL;                                     /* so don't have to set r, c, etc. in main case */
    scanner(inf, &oldtoken, flag);
    if (ustrcmp(oldtoken.name, "%") == 0) {
      get_arr_arr(inf, n, flag, &m);
      q = (*arrstash)[m];
      if (q == NULL) 
        error(220, &token);
      r = q->rows;
      total_rows = r;
      c = quotient_of(&q->sizearr, q->rows);      /* Oct 2000 */
      location = q->start;
    }
    scanner(inf, &token, flag);
    if (ustrcmp(token.name, "[") == 0) {       /* find subarray */
      if (ustrcmp(oldtoken.name, "%") != 0) 
        location = fastestlookup(&oldtoken, &q);  /*spar*/
      if (location == -1) 
        error(28, &token);
      /* location is set by following, independent of above */
      subarray(inf, q, &location, &r, &c, &firstrow, &firstcol, &total_rows, 
               flag);
    }
    its_not_syst = ustrcmp(oldtoken.name, "<") != 0;  /*  syst array */
    if (!its_not_syst) {
      if (syst->stop == -1) 
        error(175, &oldtoken);
      q = syst;
      location = 0;
      r = syst->rows;
      c = (syst->stop + 1) / r;
      total_rows = r;
      firstcol = addresser;
      firstrow = addresser;
    }
    if (ustrcmp(token.name, "]") == 0) {
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, ":") == 0) {     /* this block */
        scanner(inf, &token, flag);
        if (ustrcmp(token.name, "char") == 0) 
          handle_char(&one_write_out_Env);
        else 
          handle_colon(n, &one_write_out_Env.lengt, &one_write_out_Env);
      }
      arrdisplay(outfile, outflag, outflag, &oldtoken, q, location, r, c,  /* second arg must be outflag! Sep 2005 */
                 firstrow, firstcol, total_rows, one_write_out_Env.lengt,  /* May 2006:  third arg is now outflag, was true */
                 one_write_out_Env.char_flag, its_not_syst,  do_extras,   /* outflag && */
                 stash);
    } else if (ustrcmp(token.name, ";") == 0 || ustrcmp(token.name, "¥") == 0 || ok && 
              (ustrcmp(token.name, ",") == 0 || ustrcmp(token.name, ")") == 0))  /* Dec 2007. what is strange character here, ¥  ? */
      arrdisplay(outfile, outflag, false, &oldtoken, q, location, r,   /* second arg must be outflag! Sep 2005 */ 
                 c, addresser, addresser, total_rows, one_write_out_Env.lengt, 
                 one_write_out_Env.char_flag, its_not_syst, outflag && do_extras, 
                 stash);                          /*!*/
    else if (ustrcmp(token.name, ":") == 0) {
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, "char") == 0) 
        handle_char(&one_write_out_Env);
      else 
        handle_colon(n, &one_write_out_Env.lengt, &one_write_out_Env);
      arrdisplay(outfile, outflag, false, &oldtoken, q, location, r,  /* second arg must be outflag! Sep 2005 */ 
                 c, addresser, addresser, total_rows, one_write_out_Env.lengt, 
                 one_write_out_Env.char_flag, its_not_syst, outflag && do_extras, stash);
    } else 
      error(24, &token);
  } else if (ustrcmp(token.name, "\'") == 0) 
    handle_quote(inf, n, flag, &outflag, &outfile);
  else if (ustrcmp(token.name, ";") == 0 || ustrcmp(token.name, "¥") == 0) 
    if (!ok) 
      fprintf(stdout, "\n");
    else 
      error(106, &semicolon);
  else if (ok) {
    if (ustrcmp(token.name, "^") == 0) {        /* allow pointer syntax, Mar 2009 */
      scanner(inf, &token, flag);
      get_quoly(n, inf, flag);   
    }
	else old_expre(inf, n, flag);  /* Mar 2009 */
    if (ustrcmp(token.name, ":") == 0) {
      scanner(inf, &token, flag);
      n1 = NULL;
      if (ustrcmp(token.name, "char") == 0) 
        handle_char(&one_write_out_Env);
      else 
        handle_colon(&n1, &one_write_out_Env.lengt, &one_write_out_Env);
      free_quoly(&n1);
    } else {
      one_write_out_Env.lengt = -1;
	  doblanks(outfile, 1);  /* Jun 2005 */
	}
    c = 0;
    quoly_display(outfile, outflag, false, false, *n, &c, &semicolon, 
                  polynames, false, true, one_write_out_Env.char_flag);    
	if (one_write_out_Env.lengt > c) 
      doblanks(outfile, one_write_out_Env.lengt - c - 1);
  } else {
    old_fact(inf, n, flag);
    c = 0;
    quoly_display(outfile, outflag, false, false, *n, &c, &semicolon, 
                  polynames, false, true, false);  /*spar two quoly displays here*/
  }
  disp_size = old_disp_size;                      /*spar*/
}

/***************************************************************************/

void write_out(textptr inf, quolyptr n, nameptr *flag)
{
  
  Boolean lineflag;
  Boolean outflag;
  textptr tp;

  scanner(inf, &token, flag);
  lineflag = ustrcmp(token.name, "!") == 0;
  if (lineflag) 
    scanner(inf, &token, flag);
  outflag = true;                                 /* default */
  tp = (textptr)&Output;                          /* default */
  if (ustrcmp(token.name, "(") != 0) 
    one_write_out(inf, n, flag, false, outflag, true, tp);
  else {
    scanner(inf, &token, flag);                   /*spar*/
    /* first field is special if it has &o in it -- "dumb save" */
    if (ustrcmp(token.name, "\'") == 0) 
      handle_quote(inf, n, flag, &outflag, &tp);
    else if (ustrcmp(token.name, "&") == 0) 
      handle_andsign(inf, flag, &outflag, &tp);   /* will change tp */
    else 
      one_write_out(inf, n, flag, true, outflag, false, tp);
    while (ustrcmp(token.name, ")") != 0) {
      if (ustrcmp(token.name, ",") != 0) 
        error(105, &token);
      scanner(inf, &token, flag);
      one_write_out(inf, n, flag, true, outflag, false, tp);
    }
    scanner(inf, &token, flag);
  }
  
  quoly_set(0, n);
  if (lineflag) 
    fprintf(*tp, "\n");
  if (lineflag && outflag) 
    fflush(stdout);
}

/**************************************************************************/

void check_for_mod_out(void)
{
  polypt p;

  p = polynames;
  while (p != NULL) {
    if (p->p != NULL && !p->field) 
      error(271, &p->let);
    p = p->next;
  }
}

/**************************************************************************/

struct set_switch_EnvRec {
  long value2;
  FILEPtr *inf;
  quoly *n;
  nameptr *flag;
  nameptr np;
  Boolean printstuff;
  /* colflag is used to pass back info about calling scanner one more time. 
     Basically used by change_prec, it's value here is irrelevant because of
     the statements in parse. */
  
  tokentipe oldtok;
  jmp_buf set_switch_exit;
};
typedef struct set_switch_EnvRec set_switch_EnvRec;

/**************************************************************************/

static void finish_prec(set_switch_EnvRec *set_switch_Env)
{
  Boolean prstuff;  /* Feb 2005 */

  prstuff = set_switch_Env->printstuff && (verbose || *set_switch_Env->flag == NULL);
     /* Feb 2005, and use below */

  if (set_switch_Env->value2 < 2 || set_switch_Env->value2 > modlimit)
  /* Nov 1997 ,  June 1998 */
    error(84, &token);
  if (!lintmode)
    change_prec(set_switch_Env->inf, set_switch_Env->n, set_switch_Env->flag, set_switch_Env->value2,
                set_switch_Env->np, prstuff);
		/* Nov 1997 */
  else if (modularmode && modulus == set_switch_Env->value2 && prstuff)
    fprintf(stdout, " Already in that arithmetic mode\n");
  else {
    change_prec(set_switch_Env->inf, set_switch_Env->n, set_switch_Env->flag, -1, set_switch_Env->np, prstuff);
		/* go into rational mode */
    change_prec(set_switch_Env->inf, set_switch_Env->n, set_switch_Env->flag, set_switch_Env->value2,
                set_switch_Env->np, prstuff);
  }
}

/*******************************************************/

static void finish_string(set_switch_EnvRec *set_switch_Env)
{
  bigstring newname;
  short i;
  Boolean dumm;

  if (ustrcmp(token.name, "\'") == 0) {
    i = 0;
    ustrcpy(newname, "");
    do {
      dumbscanner(set_switch_Env->inf, &token, set_switch_Env->flag, 
                  &dumm);
      if (ustrcmp(token.name, "¥") == 0)  /* the old omega */
        error(33, &token);
      i += ustrlen(token.name);
      if (i <= 255) {
        if (ustrcmp(token.name, "\'") != 0) 
	  ustrcat(newname,token.name);
      } else 
        error(209, &token);
    } while (ustrcmp(token.name, "\'") != 0);
    scanner(set_switch_Env->inf, &token, set_switch_Env->flag);
  } else {
    if (token.name[0] == '[') 
      get_from_array(set_switch_Env->inf, set_switch_Env->flag, newname);
    else {
      ustrcpy(newname, token.name);
      scanner(set_switch_Env->inf, &token, set_switch_Env->flag);
    }
    i = ustrlen(newname) + 1;
  }
  
  i--;
  if (ustrcmp(token.name, ")") != 0) 
    error(135, &token);
  token = set_switch_Env->oldtok;
  if (ustrcmp(token.name, "M") != 0 && ustrcmp(newname, " ") == 0) 
    error(33, &token);
  switch (token.name[0]) { 
    case 'S':
      save(set_switch_Env->inf, set_switch_Env->flag, newname);
      break;
    case 'R':
      load(set_switch_Env->inf, set_switch_Env->n, set_switch_Env->flag, 
           newname, &dumm);
      break;
    case 'M':
      ustrcpy(prompt, newname);
      if (i > 10) 
        fprintf(stdout, "*** Warning.  prompt name truncated to 10 characters.\n");
      if (ustrcmp(prompt, " ") == 0) {
        prompt[0] = (char)13;
        promptsize = 0;
        fprintf(stdout, " Prompt now: <cr>\n");
      } else {
        promptsize = ustrlen(prompt);
        if (promptsize == 0) 
          prompt[0] = ' ';
        fprintf(stdout, " Prompt now:%s\n", prompt);
      }
      break;
    default:
      error(141, &set_switch_Env->oldtok);
      break;
  }
  /* longjmp(set_switch_Env->set_switch_exit, -1); comment out Feb 2011. probably not needed, bug fix Feb 17 */
  /*exit(::set_switch) ~ up-level function exit*/
}

/*******************************************************************************/

void set_switch(textptr inf, quolyptr n, nameptr *flag, Boolean *colflag, Boolean *callscan)  /* Feb 2011 */
{
  long value;
  Boolean switch_1;
  Boolean infin;
  Boolean oldmodmode;
  quoly n2;
  set_switch_EnvRec set_switch_Env;

  if (setjmp(set_switch_Env.set_switch_exit)) 
    return;
  set_switch_Env.flag = flag;
  set_switch_Env.n = n;
  set_switch_Env.inf = inf;

  scanner(inf, &set_switch_Env.oldtok, flag);
  if (ustrcmp(set_switch_Env.oldtok.name, "_") == 0) {  /* two letter syntax here, Jun 2004 */
     scanner(inf, &set_switch_Env.oldtok, flag);
     switch (set_switch_Env.oldtok.name[0]) {
        case 'l': 
            ustrcpy(set_switch_Env.oldtok.name, "2");  /*  monomial list, to 2 Jun 2004 */
            break;
        case 'r': 
            ustrcpy(set_switch_Env.oldtok.name, "3");  /*  random  changed to 3, Jun 2004 */
            break;
        case 'd':
            ustrcpy(set_switch_Env.oldtok.name, "4");  /*  dispcutoff  Jun 2004 */
            break;
	case 't':
            ustrcpy(set_switch_Env.oldtok.name, "5");  /*  try_rat  Jul 2005 */
            break;
        case 's':
            ustrcpy(set_switch_Env.oldtok.name, "6");  /*  do_line_sup  Oct 2005 */
            break;
        case 'L': 
            ustrcpy(set_switch_Env.oldtok.name, "7");  /*  lagrange_stash  Apr2 2009 */
            break;
     }
  }

  scanner(inf, &token, flag);
  if (ustrcmp(token.name, "=") != 0) 
    if (ustrcmp(set_switch_Env.oldtok.name, "J") != 0)  /* Jul 2008 */
	  error(4, &token);
	else
	  if (ustrcmp(token.name, ">") != 0)
	    error(4, &token);
  if (ustrcmp(set_switch_Env.oldtok.name, "P") == 0) {
    if (lintmode) 
      changed_in_modmode = true; /* now allowed, Feb 2005 error(235, &set_switch_Env.oldtok);*/
    set_mod_out(inf, flag, true, false);
    if (ustrcmp(token.name, ")") != 0) 
      error(135, &token);
    quoly_set(0, n);
    return;
  } else if (ustrcmp(set_switch_Env.oldtok.name, "J") == 0) {
    attach_poly(inf, flag, false, &infin);        /* 'infin' not mnemonic */
    if (infin) {
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, ")") != 0) 
        error(135, &token);
    }
    quoly_set(0, n);
    return;
  }
  scanner(inf, &token, flag);
  
  if (ustrcmp(set_switch_Env.oldtok.name, "#") == 0 && ustrcmp(token.name, "[") == 0) {  /* Feb 2010 */
    get_cut_from_array(inf, flag);        
	if (ustrcmp(token.name, ")") != 0) 
	  error(135, &token);
    /* scanner(inf, &token, flag); */
    quoly_set(0, n);
    *colflag = false;
    return;  
  } 

  if (ustrcmp(token.name, "_") == 0) {  /* two letter syntax, Jun 2004 */
     scanner(inf, &token, flag);
     if (token.name[0] == 'i') 
        ustrcpy(token.name, "*5");  /*  infinity. to *5, Jun 2004*/
  }
  
  infin = ustrcmp(token.name, "*5") == 0;
  if (ustrcmp(token.name, "\'") == 0 || ustrcmp(set_switch_Env.oldtok.name, "S") == 0 ||
			ustrcmp(set_switch_Env.oldtok.name, "R") == 0 || ustrcmp(set_switch_Env.oldtok.name, "M") == 0) {
    finish_string(&set_switch_Env);
		if (ustrcmp(set_switch_Env.oldtok.name, "M") == 0 || ustrcmp(set_switch_Env.oldtok.name, "S") == 0)   /* Jul 2011. bug fix with &M. Aug 2011: add &S */
			*callscan = true;
		else
			*callscan = false;	
		return;   /* Feb 2011 */
	}
  
  value = 0;
  set_switch_Env.value2 = 0;
  n2 = NULL;
  if (ustrcmp(set_switch_Env.oldtok.name, "3") != 0)   /* keep modularmode for random set */
    check_modular(&oldmodmode);
  if (infin) 
    scanner(inf, &token, flag);
  else 
    old_expre(inf, n, flag);                      /* Nov 1997 */
  
  if (!infin && ustrcmp(set_switch_Env.oldtok.name, "3") != 0 && 
      ustrcmp(set_switch_Env.oldtok.name, "4") != 0) { /* Jun 2004 */
    if (!(*n)->numb) 
      error(147, &set_switch_Env.oldtok);
    value = big_quoly_convert_to_int(*n);             /* keep n. Dec 2005 */
  }
  if (value < 0 && set_switch_Env.oldtok.name[0] != 'D') 
    error(137, &token);
  if (!infin && ustrcmp(set_switch_Env.oldtok.name, "p") == 0) {  /* Nov 1997 */
    set_switch_Env.value2 = value;
    value = 0;
  }
  if (ustrcmp(set_switch_Env.oldtok.name, "3") != 0) 
    restore_modular(oldmodmode);
  if (ustrcmp(set_switch_Env.oldtok.name, "p") == 0 && ustrcmp(token.name, ":") == 0) 
    get_stream(&set_switch_Env.np, inf, flag);    /* Jul 2002 */
  else 
    set_switch_Env.np = NULL;
  
  if (ustrcmp(token.name, ")") != 0) 
    error(135, &token);
  switch_1 = value == 1;
  if (value != 0 && value != 1)                   /*@@@ case*/
    switch (set_switch_Env.oldtok.name[0]) { 
      case 'n':
      case 'D':
      case 'A':
        /* nothing */
        break;
      case 'L':
      case 'X':
      case 'm':
      case 'u':
      case '#':
        /* nothing */
        /*L and X, May 1996*/
        /* m, Apr 2002 */
		/* u, Jan 2009 */
		/* #, Jan 2010 */
        break;
      default:
        error(133, &token);                       /* changed 133, Apr 2002 */
        break;
    }
  
  switch (set_switch_Env.oldtok.name[0]) { 
    case 'a':
      if (addresser != value) {
        addresser = value;
        if (*flag == NULL) 
          fprintf(stdout, " Array initial index now %1d\n", addresser);
      } else if (*flag == NULL) 
        fprintf(stdout, " Already had that value; no change in error pushing.\n");  /* Dec 2003 */
      break;
    case 'e':
      if (errorpush == switch_1) 
        fprintf(stdout, " Already had that value; no change.\n");
      else {
        errorpush = switch_1;
        if (errorpush) 
          fprintf(stdout, " Will push new level after errors.\n");
        else 
          fprintf(stdout, " Pushing after errors is deactivated\n");
      }
      break;
    case 'B':
      if (lintmode) 
        error(235, &set_switch_Env.oldtok);
      else if (chpoly_block == switch_1) 
        fprintf(stdout, " Already had that value; no change in Chpoly speed.\n");  /* Dec 2003 */
      else {
        chpoly_block = switch_1;
        if (chpoly_block) 
          fprintf(stdout, " Chpoly will be slowed in modularmode.\n");
        else 
          fprintf(stdout, " Will optimize Chpoly in modularmode.\n");
      }
      break;
    case 'E':
      if (extra_line == switch_1) 
        fprintf(stdout, " Already had that value; no change in extra line display.\n");  
       /* Dec 2003 */
      else {
        extra_line = switch_1;
        if (extra_line) 
          fprintf(stdout, " Will do extra line after display.\n");
        else 
          fprintf(stdout, " No extra line after display.\n");
      }
      break;
    case 'H':
      if (alt_form_display == switch_1) {
        if (*flag == NULL)  /* Nov 2010 */
					fprintf(stdout, " Already had that value; no change in modular integers display.\n");
			}
	    /* Dec 2003 */
      else {
        alt_form_display = switch_1;
        if (*flag == NULL)  /* Nov 2010 */
					if (alt_form_display) {
						fprintf(stdout, " Will display modular values using -m, -m+1, ..., 0, 1, ..., n\n");
						fprintf(stdout, "    where m = (modulus - 1) div 2 and n = modulus div 2.\n");
					} else 
						fprintf(stdout, " Will display modular values using 0, 1, ..., modulus - 1.\n");
      }
      break;
    case 'N':
      if (noisy == switch_1) 
        fprintf(stdout, " Already had that value; no change in noise.\n");  /* Dec 2003 */
      else {
        noisy = switch_1;
        if (noisy) 
          fprintf(stdout, " Will display results.\n");
        else 
          fprintf(stdout, " Displaying results is deactivated\n");
      }
      break;
    case 'V':
      if (verbose == switch_1) 
        fprintf(stdout, " Already had that value; no change in verbose.\n"); /* Apr2 2009 */
      else {
        verbose = switch_1;
        if (verbose) 
          fprintf(stdout, " Will do verbose display.\n");
        else 
          fprintf(stdout, " No verbose display.\n");
      }
      break;
    case 'W':
      if (windy == switch_1) 
        fprintf(stdout, " Already had that value; no change in extra verbose (windy).\n");  /* Apr2 2009 */
      else {
        windy = switch_1;
        if (windy) 
          fprintf(stdout, " Will do extra verbose display.\n");
        else 
          fprintf(stdout, " No extra verbose display.\n");
      }
      break;
    case '7':
      if (lagrange_stash == switch_1) 
        fprintf(stdout, " Already had that value; no change in writing LaGrange determinants to file.\n");  /* Apr2 2009 */
      else {
        lagrange_stash = switch_1;
        if (lagrange_stash) 
          fprintf(stdout, " Will write LaGrange determinants to file.\n");
        else 
          fprintf(stdout, " No writing LaGrange determinants to file.\n");
      }
      break;
    case 'n':
      if (nomodpolyreadin == switch_1)            /* May 2001 */
        fprintf(stdout, " Already had that value; no change in poly-readin of negatives.\n");  
        /* Dec 2003 */
      else {
        nomodpolyreadin = switch_1;
        if (nomodpolyreadin) 
          fprintf(stdout, " Will not mod out integers during poly-readin over modular ground ring.\n");
        else 
          fprintf(stdout, " Will mod out integers during poly-readin over modular ground ring.\n");
      }
      break;
    case 'O':
      if (chinhensel == switch_1) {               /* Aug 2000 */
        if (*flag == NULL) 
          fprintf(stdout, " Already had that value; no change in using Hensel or CRT.\n");  
        /* Dec 2003 */
      } else {
        chinhensel = switch_1;
        if (*flag == NULL) 
          if (chinhensel) 
            fprintf(stdout,
	        " Will use Hensel and CRT for multivariate GCD.  This is the default.\n");
          else 
            fprintf(stdout,
	    " Use no Hensel or CRT for GCD. This is recommended only over Z/p for small primes.\n");
      }
      break;
    case '&':
      if (diskstore == switch_1)                  /* Jul 2001 */
        fprintf(stdout, " Already had that value; no change in using disk space for virtual memory.\n");                      /* Dec 2003 */
      else {
        diskstore = switch_1;
        if (diskstore) 
          fprintf(stdout, " Will use disk space as virtual memory.\n");
        else 
          fprintf(stdout, " No disk space as virtual memory.\n");
      }
      break;
    case 'U':
      if (uglyprint == switch_1) 
        fprintf(stdout, " Already had that value; no change in uglyprint.\n");  /* Dec 2003 */
      else {
        uglyprint = switch_1;
        if (uglyprint) 
          continuation = ' ';   /* Apr2 2009. was ` */
        else 
          continuation = '`';  /* for Linux */
        if (uglyprint) {   /* Apr 2012 */
          fprintf(stdout, " Will do ugly display style.\n");
					fprintf(stdout, " WARNING. Func, for, if, and while from terminal don't work when uglyprint is on.");
				}
        else 
          fprintf(stdout, " Will resume lovely Fermat style.\n");
      }
      break;
    case '2': /*  was 'Ï'   Jun 2004, becomes 2*/
      if (monomial_list == switch_1)              /* May 1997 */
        fprintf(stdout, " Already had that value; no change in monomial display of polynomials.\n");
	     /* Dec 2003 */
      else {
        monomial_list = switch_1;
        if (monomial_list)
          fprintf(stdout, " Will display polynomials as list of monomials.\n");
        else 
          fprintf(stdout, " Will display polynomials in nested form.\n");
      }
      break;
    case '5':        /* try_rat, Jul 2005 */
      if (try_rat == switch_1) {             /* May 1997 */
        fprintf(stdout, " Already had that value; no change in fastest probabilistic test for exact poly division.\n");
	rat_yes = try_rat;
      }
      else {
        try_rat = switch_1;
	rat_yes = try_rat;
	if (try_rat)
	  fprintf(stdout, " Will try fastest probabilistic test for exact poly division.\n");
	else
	  fprintf(stdout, " No fastest probabilistic test for exact poly division.\n");
      }
      break;
    case '6':        /* do_line_sup Oct 2005 */
      if (do_line_sup == switch_1)             
        fprintf(stdout, " Already had that value; no change in suppressing output of long polys.\n");
      else {
        do_line_sup = switch_1;
	if (do_line_sup)
	  fprintf(stdout, " Will suppress output to terminal of long polys.\n");
	else
	  fprintf(stdout, " No suppression of output to terminal of long polys.\n");
      }
      break;
    case '|':
      if (pos_mod == switch_1) {                  /* manual?*/
        if (*flag == NULL) 
          fprintf(stdout, " Already had that value; no change in | returning negatives.\n");
	  /* Dec 2003 */
      } else {
        pos_mod = switch_1;
        if (*flag == NULL)
          if (pos_mod) 
            fprintf(stdout, " Modulus must return non-negatives.\n");
          else 
            fprintf(stdout, " Modulus can return negatives.\n");
      }
      break;
    case 'D':
      if (value == 1)
        value = 0;
      detcutoff = value;                          /* Nov 1996, removed upper limit */
      if (verbose || *flag == NULL) { /* Feb 2005 */
        if (detcutoff < 0) 
          fprintf(stdout, " Will set detcutoff using defaults.\n");
        else
          fprintf(stdout, " Detcutoff now %1d.\n", detcutoff);
        if (detcutoff > size_sm_work_array)
          fprintf(stdout," Note: This value for sparse arrays only. For ordinary arrays, max value is %1d.\n", size_sm_work_array);
      }
      break;
    case 'u':    /* Jun 2008 */
      if (value > 5) { /* Oct 2008, Feb 2009 */
        value = 0;
        if (verbose || *flag == NULL)   /* Jan 2009 */
          fprintf(stdout, " Value entered is too large; will use 0.\n");
      }
      pseudet_heur = value; 
      if (verbose || *flag == NULL) 
        fprintf(stdout, " Sparse pivot heuristic now %1d.\n", pseudet_heur);
      break;
    case '#':         /* Jan 2010 */
      if (value < 6) { 
        value = 6;
        if (verbose || *flag == NULL)   
          fprintf(stdout, " Value entered is too small; will use 6.\n");
      }
      reset_cutoffs(value);
      poly_cutoff = value;      
      if (verbose || *flag == NULL) 
        fprintf(stdout, " poly_cutoff now %1d.\n", poly_cutoff);
      break;
    case 't':
      if (timerflag != switch_1) {
        timerflag = switch_1;
        if (timerflag) 
          fprintf(stdout, " Timing enabled.\n");
        else 
          fprintf(stdout, " Timing disabled.\n");
      } else 
        fprintf(stdout, " Already had that value; no change in timing.\n");
      break;
    case 'l':
      if (laurent != switch_1) {
        if (switch_1)
          check_for_mod_out();
        change_laurent(switch_1);
        if (verbose || *flag == NULL) { /* Feb 2005 */
          if (laurent)
            fprintf(stdout, " Negative exponents enabled.\n");
          else
            fprintf(stdout, " Negative exponents disabled.\n");
        }
      } else if (verbose || *flag == NULL)  /* Feb 2005 */
         fprintf(stdout, " Already had that value; no change in Laurent polynomial status.\n");
      break;
    case 'm':
      if (m_interrupt != value) {
        if (*flag == NULL) 
          fprintf(stdout, " Command interrupt now ");
        switch (value) { 
          case 0:
            command_int = false;
            if (*flag == NULL) 
              fprintf(stdout, "off.\n");
            break;
          case 1:
            command_int = true;
            cmd_modder = 32;
            if (*flag == NULL) 
              fprintf(stdout, "on, level 1.\n");  /* Apr 2002 */
            break;
          case 2:                                 /* Apr 2002 */
            command_int = true;
            cmd_modder = 2;
            if (*flag == NULL) 
              fprintf(stdout, "on, level 2.\n");
            break;
          default:
            error(146, &set_switch_Env.oldtok);   /* changed 146, Apr 2002 */
            break;
        }
        m_interrupt = value;                      /* moved Apr 2002 */
      } else 
        fprintf(stdout, " Already had that value; no change in command interrupt.\n");
      break;
    case 'A':
      if (value < 10 || value > 20000)   /* Mar 2009. 10000 -> 20000 */
        error(272, &set_switch_Env.oldtok);
      aux_num_2factor = value;
      if (verbose || *flag == NULL)  /* Feb 2005 */
        fprintf(stdout, " second auxiliary prime search factor now %1d.\n", value);
      break;
    case 'X':
      if (value < 300 || value > maxauxnum)       /* maxauxnum, May 1998 */
        error(295, &set_switch_Env.oldtok);
      aux_num_1factor = value;
      if (verbose || *flag == NULL)  /* Feb 2005 */
        fprintf(stdout, " first auxiliary prime search factor now %1d.\n", value);
      break;
    case 'L':                                     /*May 1996*/
      rat_det_method_cut = value;
      mod_det_method_cut = value / 33;            /* Nov 1996 */
      if (verbose || *flag == NULL)  /* Feb 2005 */
        fprintf(stdout, " LaGrange cut off \"mass\": %1d\n", rat_det_method_cut);
      break;
    case 'K':                                     /*May 1996*/
      gauss_cutoff = value;
      if (verbose || *flag == NULL)  /* Feb 2005 */
        fprintf(stdout, " Gauss-Bareiss switch: %1d\n", gauss_cutoff);
      break;
    case 'p':
      if (lintmode && !modularmode) 
        error(62, &token);
      if (levelcount > 1) 
        error(73, &token);                        /* Oct 2001 */
      set_switch_Env.printstuff = *flag == NULL || set_switch_Env.np == NULL;
      if (infin) 
        if (modularmode)
          change_prec(inf, n, flag, -1, set_switch_Env.np, set_switch_Env.printstuff);
        else 
          fprintf(stdout, " Already in rational mode.\n");
      else
        finish_prec(&set_switch_Env);
      if (set_switch_Env.np != NULL) 
        freename(set_switch_Env.np);
      break;
    
    /* change of namelength removed.  Jun 2003 */
    
    case '3':    /* was 'À'.  Jun 2004 Random denom */
      if (!(*n)->numb) 
        error(143, &set_switch_Env.oldtok);
      num_assign((*n)->variant.vc_1.ncoef, &rand_denom_n);
      fprintf(stdout, " Denominator for random is now: \n");
      dummy = 0;
      quoly_display(&Output, true, true, true, *n, &dummy, &semicolon, 
                    polynames, false, true, false);
      break;

    case '4':    /*  Jun 2004 dispcutoff */
      if (!(*n)->numb) 
        error(147, &set_switch_Env.oldtok);
      dispcutoff = quoly_convert_to_int(*n);
      fprintf(stdout, " Columns to display is now: \n");
      dummy = 0;
      quoly_display(&Output, true, true, true, *n, &dummy, &semicolon, 
                    polynames, false, true, false);
      break;
    
    default:
      error(136, &set_switch_Env.oldtok);
      break;
    
  }
  *colflag = false;       /* not really necessary */
}

/**************************************************************************/

void set_name_length(quolyptr n)
{
  do {
    fprintf(stdout, "Enter maximum name length. \n");
    do_prompts();
    fscanf(stdin, "%ld", &namelength);
    fprintf(stdout, "\n");
    if (namelength < 1 || namelength > 10) 
      fprintf(stdout, "*** Improper name length\n");
  } while (!(namelength > 0 && namelength < 11));
  
  quoly_set(namelength, n);
}

/**************************************************************************/

void change_detcutoff(quolyptr num)
{
  Boolean oldmodmode;

  fprintf(stdout, " Enter detcutoff:\n");
  do_prompts();
  scanner(&Input, &token, &zilch);
  check_modular(&oldmodmode);
  old_expre(&Input, num, &zilch);
  if (!(*num)->numb) 
    error(189, &token);
  detcutoff = quoly_convert_to_int(*num);
  free_quoly(num);
  restore_modular(oldmodmode);
  quoly_set(detcutoff, num);
  if (detcutoff == 1) 
    detcutoff = 0;                                /* kill the 10 limit */
  if (detcutoff < 0) 
    fprintf(stdout, " Will set detcutoff using defaults.\n");
  else 
    fprintf(stdout, " Detcutoff now %1d.\n", detcutoff);
  if (detcutoff > size_sm_work_array)   /* Feb 2006 */
    fprintf(stdout, " Note: This value for sparse arrays only. For ordinary arrays, max value is %d.\n",
	  size_sm_work_array);
}

/**************************************************************************/

void change_pseudet_heur(quolyptr num)   /* Jun 2008 */
{
  Boolean oldmodmode;

  fprintf(stdout, " Enter sparse pivot heuristic:\n");
  do_prompts();
  scanner(&Input, &token, &zilch);
  check_modular(&oldmodmode);
  old_expre(&Input, num, &zilch);
  if (!(*num)->numb) 
    error(227, &token);
  pseudet_heur = quoly_convert_to_int(*num);
  free_quoly(num);
  restore_modular(oldmodmode);
  if (pseudet_heur > 5 || pseudet_heur < 0) {  /* Oct 2008, Feb 2009 */
    pseudet_heur = 0;
    fprintf(stdout, " Value entered is too big or too small; will use 0.\n"); /* Jan 2009 */
  }
  quoly_set(pseudet_heur, num);
  fprintf(stdout, " Sparse pivot heuristic now %1d.\n", pseudet_heur);

}

/*************************************************************************/

void rubout(textptr inf, nameptr *flag)
{
  if (cancelflag) {
    error(170, &token);
    return;
  }
  scanner(inf, &token, flag);
  if (ustrcmp(token.name, "(") != 0) 
    single_rubout(inf, flag);
  else 
    do {
      scanner(inf, &token, flag);
      single_rubout(inf, flag);
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, ",") != 0 && ustrcmp(token.name, ")") != 0) 
        error(95, &token);
    } while (ustrcmp(token.name, ")") != 0);
}

/************************************************************************/

void arr_arr_state(textptr inf, quolyptr n, nameptr *flag)
{
  /* Nov 1997. May or may not be an assignment statement; might be just part
     of an expression. */
  
  tokentipe oldtok;
  long r;
  long c;
  long c1;
  Boolean colflag;
  Boolean simple;
  Boolean arr_free;
  arrptr q;
  quolyptr qp;
  sparseptr spar;                                 /* Nov 1997 */
  arr_descr arr_facts;                            /* Nov 1997 */
  workptr arr2;                                   /* Nov 1997 */

  arr_facts.arrsize.size = 0;                     /* Oct 2000 */
  get_arr_arr(inf, n, flag, &c1);
  scanner(inf, &token, flag);
  if (ustrcmp(token.name, "[") == 0) {
    if ((*arrstash)[c1] == NULL) 
      error(220, &token);
    simple = true;                                /* an entry, #[..][..] */
                                                  /* Nov 1997 */
    scanner(inf, &token, flag);
    evalcoords(inf, &r, &c, flag, ']', ',', &colflag, false);
    scanner(inf, &token, flag);
    array_quoly_ptr((*arrstash)[c1], r, c, colflag, &qp, &arr_arrsign, 
                    false);                       /*spar*/
  } else 
    simple = false;                               /* just the pointer #[..] */
  
  if (ustrcmp(token.name, ":") == 0) {
      /* must be assignment; note that [x]*[y]: makes no sense, while
         without arrays, x := y*z: does make sense.  Nov 1997 */
    scanner(inf, &token, flag);
    if (ustrcmp(token.name, "=") != 0) 
      error(4, &token);
  } else if (simple) {
    if (qp == NULL)                               /* sparse array, entry (r,c) not there */
      quoly_set(0, n);
    else if (*qp == NULL) {                       /* Jan 1998 */
      uninit++;                              /* Jul 2002 */
      if (uninit < 21) 
        fprintf(stdout, "Warning. Uninitialized array element in # has been set to 0.\n");
      else if (uninit == 21) 
        fprintf(stdout, " ....etc...\n");
      quoly_set(0, qp);
      quoly_set(0, n);
    } else 
      quoly_assign(*qp, n);
    half_expre(inf, n, flag);
    return;
  } else {
    q = (*arrstash)[c1];
    if (q == NULL) 
      error(220, &token);
    spec_num_assign(&q->sizearr, &arr_facts.arrsize);  /* Oct 2000 */
    arr_facts.rows = q->rows;
    r = q->rows;
    spar = q->spar;
    arr_free = false;
    if (spar == NULL) {
      new_worknode(&c, &token);
      arr2 = workhead[c - 1];
      fillit(r, quotient_of(&q->sizearr, r), q->start, r, arr2);  /* June 1998 */
    }
    arr_expre(inf, n, arr2, &arr_facts, &arr_free, &r, flag, &spar, false);
    fill_syst_array(arr2, &arr_facts, arr_free, spar, r);
    free_work();
    quoly_set(0, n);
    return;
  }
  
  scanner(inf, &token, flag);
  if (simple) {
    old_expre(inf, n, flag);
    if (qp == NULL)                               /* sparse array, entry (r,c) not there */
      sparse_insert(r, c, (*arrstash)[c1], colflag, n);
    else if ((*arrstash)[c1]->spar == NULL) 
      quoly_assign(*n, qp);
    else if (quoly_iszero(*n)) 
      sparse_delete(r, c, (*arrstash)[c1], colflag);  /*@@@*/
    else 
      quoly_assign(*n, qp);
  } else {
    
    if (ustrcmp(token.name, "%") == 0) { /* allow pointer-to-pointer assignment. Aug 2006 */
      get_arr_arr(inf, n, flag, &r);
      scanner(inf, &token, flag);
      if (ustrcmp(token.name, ";") != 0 && ustrcmp(token.name, "¥") != 0 &&
          ustrcmp(token.name, "@") != 0 && ustrcmp(token.name, ":") != 0) 
        error(129, &token);
      (*arrstash)[c1] = (*arrstash)[r];
      return;
    } 
    else if (ustrcmp(token.name, "[") != 0) 
      error(217, &token);

    scanner(inf, &oldtok, flag);
    scanner(inf, &token, flag);
    if (ustrcmp(token.name, "]") != 0) 
      error(218, &token);
    scanner(inf, &token, flag);
    r = fastestlookup(&oldtok, &q);               /*spar*/
    if (q == NULL) 
      error(28, &oldtok);
    (*arrstash)[c1] = q;
  }
  
  special_free(&arr_facts.arrsize);               /* Oct 2000 */
}

/****************************************************************************/

void global_dump(void)
{
  Boolean minus1;
  short i;

  fprintf(stdout, "\n");
  fprintf(stdout, " Basic arithmetic ring: ");  /* Sep 2004 */
  if (modularmode)  {
    fprintf(stdout, "modular arithmetic, modulus: %0d", modulus);
		if (!finf && long_is_prime(modulus))  /* Aug 2010 */
			fprintf(stdout, ", a prime");
	}
  else if (lintmode) 
    fprintf(stdout, "modular arithmetic, modulus: %0d, temporarily off", modulus);
  else 
    fprintf(stdout, "rational arithmetic");
  if (finf)  /* Jul 2004 */
    fprintf(stdout, ". This is a finite field of characteristic 2");
  fprintf(stdout, ".\n");
  fprintf(stdout, " Display constant is %1d.\n", disp_size);
  fprintf(stdout, " Pushing after errors is ");
  if (errorpush) 
    fprintf(stdout, "on.\n");
  else 
    fprintf(stdout, "off.\n");
  if (integerflag) 
    fprintf(stdout, "Integer mode on.\n");
  fprintf(stdout, " Displaying results is ");
  if (noisy) 
    fprintf(stdout, "on.\n");
  else 
    fprintf(stdout, "off.\n");
  fprintf(stdout, " Block on Chpoly is ");
  if (chpoly_block) 
    fprintf(stdout, "on.\n");
  else 
    fprintf(stdout, "off.\n");
  fprintf(stdout, " Hensel gcd double checking is ");  /* Aug 1997 */
  if (hen_check) 
    fprintf(stdout, "on.\n");
  else 
    fprintf(stdout, "off.\n");

  if (lookupgcd == 0 )   /* May 2010 */
    fprintf(stdout, " GCD stashing level is %0d, so it's off. table mass: %d\n", lookupgcd, gcdmass);
  else
    fprintf(stdout, " GCD stashing level is %0d, so it's on. table mass: %d\n", lookupgcd, gcdmass);
	
  if (detcutoff >= 0) 
    fprintf(stdout, " Detcutoff is %1d.\n", detcutoff);
  fprintf(stdout, " Kartasuba cutoff for poly multiplication is %1d.\n", poly_cutoff);  /* Jan 2010*/
  
  if (gauss_cutoff == 1 && detcutoff == 2) /* Jun 2005 */
    fprintf(stdout, " Determinant method is Gauss-Bareiss.\n");
  else if (gauss_cutoff == 0 && detcutoff > 0)
    fprintf(stdout, " Determinant method is Gauss elimination until %d rows, then minors expansion.\n", detcutoff);
  else if (detcutoff == -1 && rat_det_method_cut == 1)
    fprintf(stdout, " Determinant method is Lagrange interpolation if polynomials and more than 4 rows.\n");

  fprintf(stdout, " Sparse pivot heuristic is %d.\n", pseudet_heur);  /* Jun 2008 */
  fprintf(stdout, " Array initial index is ");
  if (addresser == 1) 
    fprintf(stdout, "1.\n");
  else 
    fprintf(stdout, "0.\n");
  fprintf(stdout, " Command interrupt is ");
  switch (m_interrupt) { 
    case 0:
      fprintf(stdout, "off.\n");
      break;
    case 1:
      fprintf(stdout, "on, level 1.\n");          /* Apr 2002 */
      break;
    case 2:
      fprintf(stdout, "on, level 2.\n");
      break;
  }
  if (ustrcmp(prompt, ">") != 0) 
    if (prompt[0] == (char)13) 
      fprintf(stdout, " Prompt is: <cr>\n");
    else 
      fprintf(stdout, " Prompt is: %s\n", prompt);
  if (namelength != 10) 
    fprintf(stdout, " Maximum name length is %1d.\n", namelength);
  if (uglyprint) 
    fprintf(stdout, " Ugly printing is on.\n");
  if (verbose) 
    fprintf(stdout, " Verbose display is on.\n");   /* Apr2 2009 */
  if (windy) 
    fprintf(stdout, " Extra verbose display is on.\n");   /* Apr2 2009 */
  if (lagrange_stash) {
    fprintf(stdout, " Writing LaGrange determ. coefficients to file is on.\n");   /* Apr2 2009 */
	if (!verbose || !windy)
	  fprintf(stdout, "    But verbose and windy must be turned on too.\n");
  }
  if (timerflag) 
    fprintf(stdout, " Timing is enabled.\n");
  if (ustrcmp(input_file_name, "") != 0) 
    fprintf(stdout, " Reading from file %s.\n", input_file_name);
  if (ustrcmp(output_file_name, "") != 0) 
    fprintf(stdout, " Saving to file %s.\n", output_file_name);
  if (equal_to_pm1(&rand_denom_n, &minus1) && !minus1)   /* nothing */
    ;
  else {
    fprintf(stdout, " Denominator for random is:\n");
    dummy = 0;
    display(&Output, true, true, &rand_denom_n, &dummy, false);
    fprintf(stdout, "\n");
  }
  if (polynames != NULL) {
    fprintf(stdout, " These %1d polynomial variables have been created:\n", number_polys);
    polylist(&Output, false);
  } else 
    fprintf(stdout, " No polynomial variables exist.\n");
  if (field_depth > 0) {
    fprintf(stdout, " Field depth is: %1d.\n", field_depth);   
	if (number_polys - field_depth > 3)     /* Apr2 2011, remove extra argument */
	  fprintf(stdout, " *** Warning. Many poly vars are in the field. Performance may slow, especially over Z.\n");   /* Mar 2009 */
  }
  if (laurent) 
    fprintf(stdout, " Laurent polynomials allowed.\n");
  if (aux_prime1_number > 0) {
    fprintf(stdout, " There are %d first auxiliary primes: \n", aux_prime1_number);  /* Mar 2009 */
    fprintf(stdout, " ");
    fprintf(stdout, " ");
    for (i = 1; i <= aux_prime1_number; ++i) {
      fprintf(stdout, " ");
      fprintf(stdout, " ");
      fprintf(stdout, " %0d", (*auxptr)[i - 1]->head->value);
      if (i % 10 == 0) {
        fprintf(stdout, "\n");
        fprintf(stdout, " ");
        fprintf(stdout, " ");
      }
    }
    fprintf(stdout, "\n");
  }

  if (field_depth > 0)      /* Mar 2009 */
    if (!no_aux_primes2 && second_aux_num > 0)
      fprintf(stdout, " There are %d second auxiliary primes.\n", second_aux_num);
    else 
      fprintf(stdout, " There are no second auxiliary primes.\n");   /* Apr2 2011, remove useless argument. */
	 
  fprintf(stdout, "\n");
  if (danger_ok) {
    fprintf(stdout, " *** Can interrupt anytime! This is a bit dangerous.\n");  /* Feb 2004 */
    fprintf(stdout, "\n");
  }
}

/****************************************************************************/

void parse(textptr inf, quolyptr n, nameptr *flag)
{
  tokentipe oldtoken;
  tokentipe stash;
  long r;
  long c;
  bigstring message;
  arrptr q;
  short i;
  nameptr np;
  nameptr f2;
  varptr s;
  quolyptr qp;
  colm_ptrptr aux;                  /* Nov 1997 */
  long colpos;
  Boolean colflag;                  /* double use; change_prec tells if it called scanner */
  Boolean savett;
  Boolean oldmodmode;
  Boolean callscan;    /* Jul 2009 */
  char x;   /* Jun 2003 */
  unsigned long mema; /* Sep 2004. brought here May 2010 */

  x = token.name[0];    /* Jun 2003 */
  if (ustrcmp(token.name, "Diag") == 0)
     x = '~';  /* -41 Jun 2004 */
  if (ustrcmp(token.name, "Trans") == 0)
     x = '"';

  callscan = true;   /* Feb 2011 */
	
	switch (x) {   /* Jun 2003 */

    case '[':
    case '~':
    case '"':
      arr_parse(x, inf, n, flag);     /* Jun 2003 */
      break;
    
    case '%':
      arr_arr_state(inf, n, flag);
      break;/* '''': namechange(inf, flag); */
    
    
    case '&':
      scanner(inf, &token, flag);
      if (ustrlen(token.name) > 1) 
        error(114, &token);
        
      if (ustrcmp(token.name, "_") == 0) { /* new two letter syntax, Jun 2003 */
         scanner(inf, &token, flag);
         switch (token.name[0]) {
           case 'l': 
             ustrcpy(token.name, "2");  /*  monomial list. Jun 2004, make it 2 */
             /* token.name[0] = 207; */
             break;
           case 'r': 
             ustrcpy(token.name, " ");  /*  random À , ran denom */
             token.name[0] = 208;
             break;
           case 'm': 
             ustrcpy(token.name, " ");  /*  suppress modular  µ */
             token.name[0] = 209;
             break;
           case 'P': 
             ustrcpy(token.name, " ");  /*  push  ž */
             token.name[0] = 210;
             break;
           case 'p': 
             ustrcpy(token.name, " ");  /*  pop ¹*/
             token.name[0] = 211;
             break;
           case 'd':   /* Jun 2004 */
             ustrcpy(token.name, " ");  /*  pop ¹*/
             token.name[0] = 212;
             break;
           case 'k':   /* Apr 2006, karatsuba */
             ustrcpy(token.name, " ");
             token.name[0] = 213;
             break;
           case 'n':        /* poly readin */
             scanner(inf, &token, flag);
             quoly_readin(inf, n, flag, &r);
             return;
             break;
	   case 'L': 
             ustrcpy(token.name, "5");  /*  Apr 2009. stash LaGrange. */
             /* token.name[0] = 207; */
             break;
           case 'G':        /* sort the garbage. Jun 2006 */
             scanner(inf, &token, flag);
	     quoly_set(0, n);
             clean_up_quoly();
             clean_up_poly();
             if (!lintmode)
               clean_up_imp();
             return;
             break;
           case 't':        /* try_rat, Jul 2005 */
             scanner(inf, &token, flag);
	     try_rat = !try_rat;
             rat_yes = try_rat;
             if (try_rat)
               fprintf(stdout, " Will try fastest probabilistic test for exact poly division.\n");
             else
               fprintf(stdout, " No fastest probabilistic test for exact poly division.\n");
             return;
             break;
           case 's':        /* do_line_sup Oct 2005 */
             scanner(inf, &token, flag);
	     do_line_sup = !do_line_sup;
             if (do_line_sup) 
	       fprintf(stdout, " Will suppress output to terminal of long polys.\n");
	     else
	       fprintf(stdout, " No suppression of output to terminal of long polys.\n");
             return;
             break;
           default:  /* Jun 2006 */
             error(17, &token);
             break;
        }
      };
         
      oldtoken = token;

      switch (token.name[0]) {
        case 'f':
        case 'F':
          scanner(inf, &token, flag);
          listfuncs(&Output, inf, true, &token, flag);
          break;
          
        case 'v':
          scanner(inf, &token, flag);
          if (ustrcmp(token.name, ";") != 0 && ustrcmp(token.name, ":") != 0) 
            error(303, &token);
          listvars(ustrcmp(token.name, ";") == 0);  /* August 1996 */
          break;
          
        case 's':
        case 'S':
          save(inf, flag, blankone);
          ustrcpy(blankone, " ");    /* stupid kludge is needed!  Jul 2003 */      
          break;
          
        case 'r':
        case 'R':
          load(inf, n, flag, blankone, &colflag);
          ustrcpy(blankone, " ");    /* stupid kludge is needed!  Jul 2003 */ 
          if (colflag) {
            quoly_set(0, n);
            return;
          }
          break;
          
        case 'd':
          calc_disp(true, 0);
          break;
          
        case 't':
          timerflag = !timerflag;
          if (timerflag) 
            fprintf(stdout, " Timing enabled.\n");
          else 
            fprintf(stdout, " Timing disabled.\n");
          break;
          
        case 'T':
          quoly_set(TickCount, n);  /* Dec 2010 */
          break;
          
        case 'l':
          if (!laurent) 
            check_for_mod_out();
          change_laurent(!laurent);
          if (laurent) 
            fprintf(stdout, " Negative exponents enabled.\n");

          else 
            fprintf(stdout, " Negative exponents disabled.\n");
          break;
          
        case 'm':
          fprintf(stdout, " Enter command interrupt level:\n");
          do_prompts();
          scanner(&Input, &token, &zilch);
          check_modular(&oldmodmode);
          old_expre(&Input, n, &zilch);
          if (!(*n)->numb) 
            error(146, &oldtoken);
          r = quoly_convert_to_int(*n);
          restore_modular(oldmodmode);
          fprintf(stdout, " Command interrupt now ");
          switch (r) { 
            case 0:
              command_int = false;
              m_interrupt = r;
              fprintf(stdout, "off.\n");
              break;
            case 1:
              command_int = true;
              m_interrupt = r;
              fprintf(stdout, "on, level 1.\n");  /* Apr 2002 */
              break;
            case 2:
              command_int = true;                 /* Apr 2002 */
              m_interrupt = r;
              fprintf(stdout, "on, level 2.\n");
              break;
            default:
              error(146, &oldtoken);
              break;
          }
          break;
          
        case 'a':
          addresser = 1 - addresser;
          if (*flag == NULL) 
            fprintf(stdout, " Array initial index now %1d.\n", addresser);
          quoly_set(addresser, n);
          break;
          
        case '>':
          if (*flag != NULL) 
            leave_flag = true;
          else 
            fprintf(stdout, "Warning. &> ignored.\n");
          break;
          
        case '}':
          if (*flag != NULL) 
            exit_flag = true;
          else 
            fprintf(stdout, "Warning. &} ignored.\n");
          break;
          
        case ']':
          if (*flag != NULL) 
            cycle_flag = true;
          else 
            fprintf(stdout, "Warning. &] ignored.\n");
          break;
          
        case 'e':
          errorpush = !errorpush;
          if (*flag == NULL)  /* Nov 2010 */
						if (errorpush) 
							fprintf(stdout, " Will push new level after errors.\n");
						else 
							fprintf(stdout, " Pushing after errors is deactivated.\n");
          break;
          
        case 'H':
          alt_form_display = !alt_form_display;
          if (*flag == NULL)  /* Nov 2010 */
						if (alt_form_display) {
							fprintf(stdout, " Will display modular values using -m, -m+1, ..., 0, 1, ..., n.\n");
							fprintf(stdout, "    where m = (modulus - 1) div 2 and n = modulus div 2.\n");
						} else 
							fprintf(stdout, " Will display modular values using 0, 1, ..., modulus - 1.\n");
          break;
          
        case 'U':
          uglyprint = !uglyprint;
          if (uglyprint) 
            continuation = ' ';  /* Jan 2011 */
          else 
            continuation = '`';
          if (uglyprint) {  /* Apr 2012 */
            fprintf(stdout, " Will do ugly display style.\n");
						fprintf(stdout, " WARNING. Func, for, if, and while from terminal don't work when uglyprint is on.");						
					}
          else 
            fprintf(stdout, " Will resume lovely Fermat style.\n");
          break;
        
        case '2':      /* Jun 2004, 2 */               /* May 1997 */
          monomial_list = !monomial_list;
          if (*flag == NULL)                      /* Aug 2000 */
            if (monomial_list) 
              fprintf(stdout, " Will display polynomials as list of monomials.\n");
            else 
              fprintf(stdout, " Will display polynomials in nested form.\n");
          break;
        
        case '5':      /* Apr 2009 */          
          lagrange_stash = !lagrange_stash;
          if (*flag == NULL)                     
            if (lagrange_stash) 
              fprintf(stdout, " Will stash coefficents in LaGrange Det computation -- if you have specified a save file.\n");
            else 
              fprintf(stdout, " Will not stash coefficents in LaGrange Det computation.\n");
          break;
        
        case 'V':
          verbose = !verbose;
          if (verbose) 
            fprintf(stdout, " Will display informative comments.\n");
          else 
            fprintf(stdout, " Informative comments supressed.\n");
          fflush(stdout);
          break;
          
        case 'Z':
          danger_ok = !danger_ok;
          if (danger_ok) {
            fprintf(stdout, " O.K. to interrupt anytime. This might be dangerous.\n");
           /*old message Feb 2004  fprintf(stdout, "     *** Warning!  !\n");  */
          } else
            fprintf(stdout, " Can\'t interrupt at dangerous times.\n");
          fflush(stdout);
          break;

        case 'E':
          extra_line = !extra_line;
          if (extra_line)
            fprintf(stdout, " Will do extra line after display.\n");
          else
            fprintf(stdout, " No extra line after display.\n");
          break;
          
        case 'N':
          noisy = !noisy;
          if (noisy) 
            fprintf(stdout, " Will display results.\n");
          else 
            fprintf(stdout, " Displaying results is deactivated.\n");
          break;
          
        case 'D':
          change_detcutoff(n);
          break;
          
        case 'u':   /* Jun 2008 */
          change_pseudet_heur(n);
          break;
          
        case 'h':  /* Jul 2003.  large memories! */
          if (lintmode) {   /* Aug 2004.  for modularmode */
             if (*flag == NULL)  /* Jun2 2009 */
			   fprintf(stdout, "%u\n", memavail());
			 quoly_set(memavail(), n);
		  } else {
		      mema = memavail();  /* Sep 2004 */
			  r = mema % block;
			  c = mema / block;
			  quoly_set(r, n);
			  if (c > 0) {
				newnum((*n)->variant.vc_1.ncoef->head);
				(*n)->variant.vc_1.ncoef->size ++;
				(*n)->variant.vc_1.ncoef->head->next = (*n)->variant.vc_1.ncoef->tail;
				(*n)->variant.vc_1.ncoef->head->value = c;
			  }
		  }
          break;
        
        /* no more set namelength Jun 2003 */
        
        case 'o':
          error(262, &token);                     /*spar<*/
          break;
          
        case 'n':                                 /* May 2001 */
          nomodpolyreadin = !nomodpolyreadin;
          if (nomodpolyreadin) 
            fprintf(stdout, " Will not mod out integers during poly-readin over modular ground ring.\n");
          else 
            fprintf(stdout, " Will mod out integers during poly-readin over modular ground ring.\n");
          break;
          
        case 'O':
          chinhensel = !chinhensel;               /* Aug 2000 */
          if (*flag == NULL) 
            if (chinhensel) 
              fprintf(stdout,
	      " Will use Hensel and CRT for multivariate GCD.  This is the default.\n");
            else 
              fprintf(stdout,
	      " Use no Hensel or CRT for GCD. This is recommended only over Z/p for small primes.\n");
          break;
          
        case 'x':
          if (!tt_flag) 
            done_load = true;
          break;
          
        case 'p':
          if (levelcount > 1) 
            error(73, &token);                    /* Oct 2001 */
          f2 = *flag;                             /* might be nil */
          scanner(inf, &stash, flag);
          if (ustrcmp(stash.name, "(") == 0) {  /* only works from terminal! */
            if (*flag != NULL) 
              error(264, &stash);                 /*spar<<<<*/
            save_input_stream(&np);
            if (np == NULL) 
              error(1, &token);
          } else 
            np = NULL;
          change_prec(inf, n, flag, -1, np, verbose || *flag == NULL);  /* Feb 2005 */
          if (np == NULL)
            token = stash;
          else {
            token = semicolon;
            freename(np);
          }
          *flag = f2;                          /* must back up; harmless if nil */
          break;
          
        case 'J':
          attach_poly(inf, flag, true, &savett);  /* savett irrelevant here */
          break;
          
        case 'g':
          global_dump();
          break;
          
        case 'G':
          garbage('g');
          break;
          
        case '4':   /* not implemented here. See Mac version. Jun 2003 */
          if (dupptr != NULL) 
            arrdisplay(&Output, true, false, &duparr->name, duparr, 
                       0, duparr->rows, (duparr->stop + 1) / (duparr->rows), 
                       addresser, addresser, duparr->rows, 4, false, 
                       false, true, dupptr);
          break;
          
        case 'B':
          if (lintmode) 
            error(235, &token);
          else {
            chpoly_block = !chpoly_block;
            if (chpoly_block) 
              fprintf(stdout, " Chpoly will be slowed in modularmode.\n");
            else 
              fprintf(stdout, " Will optimize Chpoly in modularmode.\n");
          }
          break;
          
        case 'C':
          scanner(inf, &token, flag);
          if (ustrcmp(token.name, "+") == 0) {
            lookupgcd++;
            if (lookupgcd > 0) 
              ustrcpy(message, " stashing on.");
            else if (lookupgcd < 0) 
              ustrcpy(message, " pushed, but stashing still off.");
            else 
              ustrcpy(message, " stashing off.");
          } else if (ustrcmp(token.name, "-") == 0) {
            lookupgcd--;
            if (lookupgcd > 0) 
              ustrcpy(message, " popped, but stashing remains in effect.");
            else if (lookupgcd < 0) 
              ustrcpy(message, " stashing off.");
            else {
              ustrcpy(message, " stashing off.");
              free_gcd_stash();
            }
          } else 
            error(285, &token);
          if (*flag == NULL) 
            fprintf(stdout, "%s\n", message);
          quoly_set(lookupgcd, n);
          break;
          
        case '&':
          diskstore = !diskstore;                 /* Jul 2001. Apr2 2009: unused */
          if (diskstore) 
            fprintf(stdout, " Will use disk space for virtual memory.\n");
          else 
            fprintf(stdout, " No disk space for virtual memory.\n");
          break;
        
        case '#':                                 /* Jun 2002 */
          fprintf(stdout, " Enter poly_cutoff (usually 10-90):\n");  /* Oct 2002. Aug2 2010. Aug3 2010 */
          do_prompts();
          check_modular(&oldmodmode);
          scanner(&Input, &token, &zilch);
          old_expre(&Input, n, &zilch);
          if (!(*n)->numb) 
            error(272, &oldtoken);
          r = quoly_convert_to_int(*n);   /* Jan 2010 */
          restore_modular(oldmodmode); 
	  if (r < 6) {
	    fprintf(stdout, " *** smallest legal value is 6. will use 6.\n");
	    r = 6;
	  }
          reset_cutoffs(r);  /* Jan 2010 */
	  poly_cutoff = r;
	  fprintf(stdout, " poly_cutoff: %1d\n", poly_cutoff);
          break;
        
        case 'P':
          if (lintmode)
            changed_in_modmode = true; /* Feb 2005. now allowed. error(235, &token); */
          set_mod_out(inf, flag, false, false);
          break;
          
        case 'A':
          fprintf(stdout, " Enter second auxiliary prime search factor:\n");
          do_prompts();
          check_modular(&oldmodmode);             /* Nov 1996, and below */
          scanner(&Input, &token, &zilch);
          old_expre(&Input, n, &zilch);
          if (!(*n)->numb) 
            error(272, &oldtoken);
          aux_num_2factor = quoly_convert_to_int(*n);
          restore_modular(oldmodmode);
          if (aux_num_2factor < 10 || aux_num_2factor > 20000)  /* Mar 2009 */
            error(272, &oldtoken);
          fprintf(stdout, " second auxiliary prime search factor: %1d\n", aux_num_2factor);
          break;
          
        case 'X':
          fprintf(stdout, " Enter first auxiliary prime search factor:\n");
          do_prompts();
          check_modular(&oldmodmode);
          scanner(&Input, &token, &zilch);
          old_expre(&Input, n, &zilch);
          if (!(*n)->numb) 
            error(295, &oldtoken);
          aux_num_1factor = quoly_convert_to_int(*n);
          restore_modular(oldmodmode);
          if (aux_num_1factor < 300 || aux_num_1factor > maxauxnum)   /* May 1998 */
            error(295, &oldtoken);
          fprintf(stdout, " first auxiliary prime search factor: %1d\n", aux_num_1factor);
          break;
          
        case 'j':
          count_minor_stash(&r, &c);              /* Nov 2001 */   /* Jul 2008. Jun2 2009 */
          fprintf(stdout, " memavail, minor memory, garbsize, minor prime, total branches, leaf count, stash nodes, hits: %u, %u, %d, %d, %d, %d, %d, %d\n",
	              memavail(), minor_memory, fast_garbsize(), minorprime, sp_total_cnt, sp_lowcnt, r, c+purged_hits);
          
           break;
        
        case 'I':                                 /* Jul 1999 */
          mod_matrix_ok = !mod_matrix_ok;
          if (mod_matrix_ok) 
            fprintf(stdout, " Will try adjoint-CRT method to invert integer matrix.\n");
          else 
            fprintf(stdout, " No adjoint-CRT method to invert integer matrices; will use G.E.\n");
          fflush(stdout);
          break;
        
        case 'b':                                 /* Mar 2001 */
          close_inpuf = !close_inpuf;
          if (close_inpuf) 
            fprintf(stdout, " Will close input file if error occurs while loading.\n");
          else
            fprintf(stdout,
	              " Will not immediately close input file if error occurs while loading.\n");
          fflush(stdout);
          break;
        
        case 'W':
          windy = !windy;
          if (windy) 
            fprintf(stdout, " Extra verbosity turned on.\n");
          else 
            fprintf(stdout, " Extra verbosity turned off.\n");
          fflush(stdout);
          break;
         
        case 'L':                                 /*May 1996*/
          fprintf(stdout, " Enter LaGrange cut off:\n");
          do_prompts();
          check_modular(&oldmodmode);
          scanner(&Input, &token, &zilch);
          old_expre(&Input, n, &zilch);
          if (!(*n)->numb) 
            error(227, &oldtoken);
          rat_det_method_cut = quoly_convert_to_int(*n);
          if (rat_det_method_cut < 0) 
            rat_det_method_cut = two_to_31;       /* Jan 1997 */
          restore_modular(oldmodmode);
          mod_det_method_cut = rat_det_method_cut / 33;  /* Nov 1996 */
          fprintf(stdout, " LaGrange cut off \"mass\": %1d\n", rat_det_method_cut);
          break;
          
        case 'K':                                 /*June 1996*/
          fprintf(stdout, " Enter Gauss-Bareiss switch:\n");  /* Nov 1996 */
          do_prompts();
          check_modular(&oldmodmode);
          scanner(&Input, &token, &zilch);
          old_expre(&Input, n, &zilch);
          if (!(*n)->numb) 
            error(227, &oldtoken);
          gauss_cutoff = quoly_convert_to_int(*n);
          restore_modular(oldmodmode);
          fprintf(stdout, " Gauss-Bareiss: %1d means", gauss_cutoff);
          if (gauss_cutoff == 1) 
            fprintf(stdout, " will try Gauss-Bareiss.\n");
          else 
            fprintf(stdout, " will not use Gauss-Bareiss.\n");
          break;
        
        case 209:
          quoly_set(0, n);
          scanner(inf, &token, flag);
          check_modular(&oldmodmode);
          if (ustrcmp(token.name, "(") == 0) {
            scanner(inf, &token, flag);
            if (integerflag) {
              iexpre(&r, flag);
              quoly_set(r, n);
            } else 
              parse(inf, n, flag);                /* Nov 1997 */
            if (ustrcmp(token.name, ")") != 0) 
              error(1, &token);
            scanner(inf, &token, flag);  /* bug fix Jul 2004 */
            if (ustrcmp(token.name, ";") != 0 && ustrcmp(token.name, "¥") != 0 &&
                ustrcmp(token.name, "@") != 0 && ustrcmp(token.name, ":") != 0)
               error(350, &token);
            restore_modular(oldmodmode);
          } else 
            error(131, &token);
          break;
          
        case 'M':
          fprintf(stdout, " Enter prompt:\n");
          do_prompts();
          ufgets(prompt, sizeof(prompt)-1, stdin);
	  ungetc('\n',stdin); /*read below?? --AAR*/
          promptsize = ustrlen(prompt);
	  if(prompt[promptsize-1] == '\n'){ /*AAR--to get rid of <CR>*/
		prompt[promptsize-1] = 0;
		promptsize--;

	  }
          if (ustrcmp(prompt, " ") == 0) {
            prompt[0] = (char)13;
            promptsize = 0;
            fprintf(stdout, " Prompt now: <cr>\n");
          } else {
            promptsize = ustrlen(prompt);
            if (promptsize == 0) 
              prompt[0] = ' ';
            fprintf(stdout, " Prompt now:%s\n", prompt);
          }
          break;
          
        case 211:
          time_to_quit = true;     /* reduce command level; pop */
          break;
          
        case 210:
          error(-1, &blank);       /* push new command level */
		  if (tt_flag == false || *flag == NULL) {  /* Jul 2009. loading file and see &_P. Bug fix. see callscan also. */
		    ustrcpy(token.name, "@");
			token.address = -1;
		  }
          break;
          
        case '|':
          pos_mod = !pos_mod;
          if (*flag == NULL) 
            if (pos_mod) 
              fprintf(stdout, " modding must return non-negatives.\n");
            else 
              fprintf(stdout, " modding can return negatives.\n");
          break;
          
        case 'q':
          /* goto 98 */
          longjmp(buf98, 0 /*98*/);
          
        case 'Q':  /* Mar 2005 */
          /* goto 98 */
          longjmp(buf98, 0 /*98*/);

        case '@':
          error(0, &blank);           /* panic stop. Jul 2002, was bullet */
          break;
          
        case '(':
          set_switch(inf, n, flag, &colflag, &callscan);   /* Feb 2011. bug fix, maybe not needed after fixing procedure error */	
          break;
          
        case 'c':
          hen_check = !hen_check;                 /* Aug 1997 */
          if (*flag == NULL) 
            if (hen_check) 
              fprintf(stdout, " will double check hensel gcd answers.\n");
            else 
              fprintf(stdout, " will single check hensel gcd answers.\n");
          break;
          
        case 208:
          fprintf(stdout, " Enter new denominator for random:\n");
          do_prompts();
          scanner(&Input, &token, flag);
          old_expre(&Input, n, &zilch);
          if (!(*n)->numb) 
            error(143, &oldtoken);
          num_assign((*n)->variant.vc_1.ncoef, &rand_denom_n);
          fprintf(stdout, " Denominator for random is now: \n");
          dummy = 0;
          quoly_display(&Output, true, true, true, *n, &dummy, &semicolon, 
                        polynames, false, true, false);
          break;
        
        case 212:  /* Jun 2004 */
          fprintf(stdout, " Enter number of columns to display:\n");
          do_prompts();
          scanner(&Input, &token, flag);
          check_modular(&oldmodmode);  /* bug fix Jul 2004 */
          old_expre(&Input, n, &zilch);
          if (!(*n)->numb)
            error(143, &oldtoken);
          dispcutoff = quoly_convert_to_int(*n);
          restore_modular(oldmodmode);    /* bug fix Jul 2004 */
          fprintf(stdout, " Number of columns to display is now: \n");
          dummy = 0;
          quoly_display(&Output, true, true, true, *n, &dummy, &semicolon,
                        polynames, false, true, false);
          break;

        case 213:  /* Apr 2006 */
          fprintf(stdout, " Enter Karatsuba cutoff:\n");
          do_prompts();
          scanner(&Input, &token, flag);
          check_modular(&oldmodmode);
          old_expre(&Input, n, &zilch);
          if (!(*n)->numb)
            error(143, &oldtoken);
          simplest_poly_cutoff = quoly_convert_to_int(*n);
          restore_modular(oldmodmode);
          fprintf(stdout, " Karatsuba cutoff is now: \n");
          dummy = 0;
          quoly_display(&Output, true, true, true, *n, &dummy, &semicolon,
                        polynames, false, true, false);
          break;

        default:
          error(17, &token);
          break;
      }
      if (ustrcmp(oldtoken.name, "h") != 0 && ustrcmp(oldtoken.name, "n") != 0 && 
          (oldtoken.name[0] != 209) && ustrcmp(oldtoken.name, "(") != 0 && 
          ustrcmp(oldtoken.name, "T") != 0 && ustrcmp(oldtoken.name, "A") != 0 && 
          ustrcmp(oldtoken.name, "m") != 0 && ustrcmp(oldtoken.name, "a") != 0 && 
          (oldtoken.name[0] != 208) && ustrcmp(oldtoken.name, "C") != 0) 
        quoly_set(0, n);
			
	    callscan = callscan && oldtoken.name[0] != 209 && oldtoken.name[0] != 'v';   /* Feb 2011 */
	    callscan = callscan && (oldtoken.name[0] != 210 || tt_flag == true || *flag != NULL);   /* Jul 2009 */
			
      if (callscan)  /* Jul 2009 */
        scanner(inf, &token, flag);
      break;
    
    case '@':
      rubout(inf, flag);
      quoly_set(0, n);
      scanner(inf, &token, flag);
      break;
      
    case '!':
      write_out(inf, n, flag);
      break;
      
    case ';':                                     /* a comment */
      ustrcpy(token.name, "@");
      token.address = -1;
      break;
      
    case '?':                                     /* input from screen */
      scanner(inf, &oldtoken, flag);
      scanner(inf, &token, flag);
      savett = tt_flag;                           /* save it */
      quoly_set(0, n);
      
      if (ustrcmp(oldtoken.name, "[") == 0) 
        whole_arrinsert(inf, &token, flag, n, &stash, saveleft);
      else if (ustrcmp(token.name, "[") == 0) {
        scanner(inf, &token, flag);
        evalcoords(inf, &r, &c, flag, ']', ',', &colflag, false);
        scanner(inf, &token, flag);
        stash = token;
        ustrcpy(saveleft, leftover);
        lookup(&oldtoken, r, c, &q, &qp, colflag);  /*spar*/
        if (q->spar != NULL) 
          error(242, &token);                     /* Dec 1997 */
        arrinsert(oldtoken.name, qp, r, c, q, n, colflag);
      } else {
        if (oldtoken.name[0] > 'z' || oldtoken.name[0] < 'a') 
          error(3, &oldtoken);
        stash = token;
        ustrcpy(saveleft, leftover);
        if (levelcount > 1) 
          fprintf(stdout, "%1d", levelcount);
        if (promptsize > 0 || prompt[0] == (char)13) 
          fprintf(stdout, "%s", prompt);
        fprintf(stdout, "%s := ", oldtoken.name);  /* Nov 1997 */
        ustrcpy(leftover, "");
        tt_flag = true;
	getc(Input);
        scanner(&Input, &token, &zilch);
        if (ustrcmp(token.name, "@") != 0) {
          old_expre(&Input, n, &zilch);
          insert_var(&oldtoken, *n, &s);           /* don't want s */
          *n = NULL;
          quoly_assign(s->val, n);
        }
      }
      token = stash;
      ustrcpy(leftover, saveleft);
      tt_flag = savett;
      if (*flag != zilch) 
        quoly_set(0, n);
      break;
    
    
    case 'A':
      if (ustrcmp(token.name, "Adjoint") == 0 || ustrcmp(token.name, "Altmult") == 0 ||
          ustrcmp(token.name, "Altpower") == 0)
        arr_parse('A', inf, n, flag);
      else 
        old_expre(inf, n, flag);
      break;
      
    case 'M':
      if (ustrcmp(token.name, "MPowermod") == 0)   /* Mar 1999 */
        arr_parse('M', inf, n, flag);
      else 
        old_expre(inf, n, flag);
      break;
    
    default:
      expre(inf, &qp, n, &aux, &colpos, flag);    /* Nov 1997 */
      if (*n == NULL) 
        if (qp == NULL) 
          quoly_set(0, n);
        else 
          quoly_assign(*qp, n);
      break;
    
  }
}

/*****************************************************************************/

void Set_prods_for_char(void)
{
  /* start to set up characteristic poly stuff. Finish if user
     actually attaches a poly var. */
  /* Initializations for char_poly */
  
  short i;

  for (i = 1; i <= full_charpol; ++i) {
    denom[i - 1] = NULL;
    quoly_set(i, &denom[i - 1]);
  }
  
  need_to_set_char_poly = true;
  
  size_data_strucs += full_charpol*sizequoly(denom[1]);  /* Jul 2003 */
}

/*****************************************************************************/

void load_startup(char *includepath)
{
  Boolean old_tt;
  Boolean old_int;
  shortstring oldleft;
  quoly n;
  short i;
  char xx;   /* Jun 2003 */
  
  char totalpath[1080]; /*AAR---Aug2003*/
  char *totend; /*--AAR Aug2003*/
  strcpy(totalpath,includepath); /*AAR*/
  totend = &totalpath[strlen(totalpath)]; /*AAR*/

  old_tt = tt_flag;
  tt_flag = false;
  ustrcpy(oldleft, leftover);
  old_int = integerflag;
  ustrcpy(leftover, "");
  n = NULL;
 
  ferstartup = fopen("ferstart.txt", "r"); /*try in current dir*/
  if (!(ferstartup)){
      strcpy(totend,"ferstart.txt");
      ferstartup = fopen(totalpath,"r"); /*try fermat directory*/
      if(!(ferstartup)){
         fprintf(stderr,"No ferstart.txt file.\n");
      }
  }

  fscanf(ferstartup, "%ld", &initial_memory);   /* user enters number of megabytes */
  fprintf(stdout, " Amount of RAM you specified (mbytes): %d.\n", initial_memory);
     /* Feb 2004 */
  initial_memory = initial_memory * 225000;   /* convert to number of longints, take 75%. Jun2 2009, changed to 90%, i.e. 22500. was 187500. */
  virtual_cut = initial_memory / 5;         /*  20% of the original number of longints
                                             available. prod_size counts longints. Jul 2001 */
 /*  fprintf(stdout, "  ferst mems: %u, %ld\n", initial_memory, virtual_cut); */


  while (ferstartup && !feof(ferstartup)) {
    scanner(&ferstartup, &token, &zilch);
    if (feof(ferstartup)) {
      ustrcpy(leftover, "");
      break;
    }
    c_cntcount = 0;                               /* Mar 2001 */
    a_cntcount = 0;                               /* Dec 2001 */
    d_cntcount = 0;                               /* Dec 2001 */
    g_cntcount = 0;                               /* Nov 2002 */
    g_cutoff = default_gc;
    alg_c_count = 0;  /* Mar 2008 */
		original_depth = 1;   /* Feb 2011 */

    xx = token.name[0]; 
    if (ustrcmp(token.name, "Diag") == 0)
       xx = '~';
    if (ustrcmp(token.name, "Trans") == 0)
       xx = '"';
                                
    switch (xx) {   /* Jun 2003 */
      
      case '!':
      case ';':
        parse(&ferstartup, &n, &zilch);
        break;
      case '~':
      case '[':
      case '"':
        arr_parse(xx, &ferstartup, &n, &zilch);
        break;
      case 'A':
        if (ustrcmp(token.name, "Adjoint") == 0 || ustrcmp(token.name, "Altmult") == 0 ||
	    ustrcmp(token.name, "Altpower") == 0)
          arr_parse('A', &ferstartup, &n, &zilch);
        else 
          old_expre(&ferstartup, &n, &zilch);
        break;
      case 'M':
        if (ustrcmp(token.name, "MPowermod") == 0)   /* Mar 1999 */
          arr_parse('M', &ferstartup, &n, &zilch);
        else 
          old_expre(&ferstartup, &n, &zilch);
        break;
      default:
        parse(&ferstartup, &n, &zilch);           /* Nov 1997 expre(ferstartup, n, zilch)*/
        break;
    }
    zilch = NULL;               /*@@@ zilch may have been changed by error, via myzilch */
    free_quoly(&n);                               /* a failsafe; leave it */
    if (ustrcmp(token.name, ";") != 0) 
      if (ustrcmp(token.name, "¥") != 0 && ustrcmp(token.name, "@") != 0)   /*@@@*/
        error(129, &token);
    /*  if noisy then plflush(output);  BUG Dec 1996 */
    fscanf(ferstartup,"%*[^\n]");
    getc(ferstartup);
  }
  
  /* Removed mytime stuff, Nov 1996. Moved to main. */
  
  if(ferstartup) fclose(ferstartup);
  free_quoly(&n);
  tt_flag = old_tt;
  integerflag = old_int;
  ustrcpy(leftover, oldleft);
}

/********************************************************************************/

void mem_error(void)
{
  if (lookupgcd > 0 && polygcd_stack_depth == 0) {
    fprintf(stdout, "\n");
    fprintf(stdout, "*** Warning.  You are low on heap space.  Will try freeing the gcd stash.\n");
    fflush(stdout);
    free_gcd_stash();
  } else {
    fprintf(stdout, "\n");
    fprintf(stdout, "*** Warning.  You are out of heap space.  Abort this computation.\n");
    fflush(stdout);
    error(-1, &blank);
  }
}

/********************************************************************************/

void interrupt(int siglev){    /* Jun 2003  */
  signal(SIGINT, &interrupt);
  error(-1,&blank);
}

/**==========================================================================**/

#if !defined(HOST_macintosh) && !defined(HOST_windows)
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#endif
#ifdef HOST_windows
#include <windows.h>
#else
#include <sys/param.h>
#include <sys/stat.h>
#include <sys/types.h>
#endif

#if !defined(HOST_windows) && !defined(HOST_macintosh) /*i.e. unix-type*/
/*from Plexide -- Dan Kopetzky*/
static void resolve_symlink(char * fullpath)
{
   char        maybelink[1024];
   int         llen;
   if ((llen = readlink(fullpath, maybelink, sizeof maybelink - 1)) > 0) {
      char       *fsuf = strrchr(fullpath, '/');
      maybelink[llen] = 0;
      if (fsuf == 0 || maybelink[0] == '/') {
         strcpy(fullpath, maybelink);
      }
      else {
         strcpy(fsuf + 1, maybelink);
      }
   }
}

/*orig by Mark Dionne, (md@io.UUCP), 1988
adapted for Linux (2.4, libc 6) by nat@makarevitch.org, 2003
*/

#define PATHSIZE 1024

long get_file_mode(char *path);
char *getPathElement( register char *path, register char *buf);

GetExecName(char *argv0,char *buf)
{
  char *path;
  char *getenv(), *getPathElement();

  if(*argv0 == '/') {
     strcpy(buf, argv0);
     return(0);
  }

  if(*argv0 == '.' && *(argv0+1) == '/'){
     strcpy(buf,argv0+2);
     goto found;
  }
  if(*argv0 == '.' && *(argv0+1) == '.'
        && *(argv0+2) == '/'){
     strcpy(buf,argv0);
     goto found;
  }
  path = getenv("PATH");

  while(path != 0){
     path = getPathElement(path, buf);
     if(*buf == '\0') continue; /*ignore empty components*/
     strcat(buf, "/");
     strcat(buf, argv0);
     if(access(buf, X_OK) == 0){
        /*watch out for directories that happen to match*/
        if((get_file_mode(buf) & S_IFMT) == S_IFDIR) continue;
        /* Got it.  Now if it is not absolute, just prepend cwd */
        if(*buf != '/'){
           char tmpbuf[PATHSIZE];
       found:
           strncpy(tmpbuf, buf, PATHSIZE/sizeof(char));
           if(getcwd(buf, (PATHSIZE/sizeof(char))-1) == 0) break;
           strncat(buf, "/", PATHSIZE/sizeof(char));
           strncat(buf, tmpbuf, PATHSIZE/sizeof(char));

           if(realpath(buf, tmpbuf) == NULL)
              return 1;
           strncpy(buf, tmpbuf, PATHSIZE/sizeof(char));
           return 2;
        }
        return(0);
     }
  }
  /*Not found */
  *buf = 0;
  return(-1);
}

long get_file_mode(char *path){
  struct stat stats;

  if(stat (path, &stats) < 0) return(-1);
  return(stats.st_mode);
}

/* Strip off first element of path into buf.  Returns new path.*/
char *getPathElement( register char *path, register char *buf) {
   while((*buf = *path++) != '\0'){
      if(*buf == ':'){
         *buf = '\0';
         return(path);
      }
      ++buf;
   }
   return(0);
}

#endif

/********************************************************************************/

int main(int argc,char *argv[])  /*AAR -- added arguments*/
{                                    
  char includepath[1024]; /*AAR*/
  char *spot; /*AAR*/
  Input = stdin; /*AAR*/
  Output = stdout; /*AAR*/
  
  signal(SIGINT, &interrupt);
  if(sigsetjmp(buf9999,1) != 0){
     
     goto Label_9999;
  }
  if(setjmp(buf98) != 0){
     goto Label_98;
  }
  RecordTime(mytime,0);  /*AAR*/
 
  /* Jun 2011, try to expand stack. Use ulimit on the terminal. */
	const rlim_t kStackSize = 32L * 1024L * 1024L;   // stack size = 32 Mb
	struct rlimit rl;
	int result;
	
	result = getrlimit(RLIMIT_STACK, &rl);
	if (result == 0)
		if (rl.rlim_cur < kStackSize) {
			rl.rlim_cur = kStackSize;
			result = setrlimit(RLIMIT_STACK, &rl);
			if (result != 0)
				fprintf(stderr, "setrlimit returned result = %d\n", result);
		}
	
	polystash = open_stash(sizeof(polynode),"stash of polynodes");
  quolystash = open_stash(sizeof(quolynode),"stash of quolynodes");
  numstash = open_stash(sizeof(numnode),"stash of numnodes");
  imagstash = open_stash(sizeof(number),"stash of numbers");
  colmstash = open_stash(sizeof(colnode),"stash of colms");  /* Apr 2004 */

  /*find where to read init files from--AAR  Jul 2003 */
  GetExecName(argv[0],includepath);
  resolve_symlink(includepath);
  spot = strrchr(includepath,'/');
  if(spot == NULL){
     includepath[0] = '.';
     includepath[1] = '/'; 
     includepath[2] = 0;
     spot = &includepath[1];
  }
  spot++;
  strcpy(spot,"BACKWARD/");   /* Jul 2010 */

  /*end AAR*/

/*  PLHeapInit(8388608, 8388608, NULL, true, false);   Jul 2002 */
/*  PLSetHeapCheck(false);*/
/*  PLSetMErrProc((PASCALPOINTER)mem_error);*/
/*  PLSetVBuf(&Output, NULL, _IOFBF, 8192);     expanded to 8192, Sep 1997 */
/*  PLSetVBuf(&Input, NULL, _IOFBF, 8192);*/
  
  fprintf(stdout, "\n");
  fprintf(stdout, "Fermat for Linux, rational C version 3.9.998 (c)1992, 1995-2012 by Robert H. Lewis\n");
  fprintf(stdout, "                                                all rights reserved\n");
  fprintf(stdout, "\n");
  fprintf(stdout, "This software is presented \"as is,\" with no warranty expressed or implied.\n");
  fprintf(stdout, "\n");
  fprintf(stdout, "Contribution of $US 60 suggested.  U.S. currency only. \n");
  fprintf(stdout, "\n");
  fprintf(stdout, "Reading initialization data from directory %s\n",  includepath); /*AAR*/
  fprintf(stdout, " initializing...\n");
  fflush(stdout);
  
  initialize(includepath); /*arg added --AAR*/
  
  fprintf(stdout, "\n");
  fprintf(stdout, " ");
  showtime();   /* May 2010 */
  
  mincutoff = 1000000;                            /* used by int_determ */
  
  levelcount = 1;

 /* fprintf(stdout, "clocks: %u\n", CLOCKS_PER_SEC); */
 
  {
    PSet_Init(continset, sizeof(continset)/2);
    PSet_Set(continset, sizeof(continset)/2, (unsigned char)'"');  
   /* May 2004 allowable contin chars */
    /* PSet_Set(continset, sizeof(continset)/2, (unsigned char)'Å');  remove  May 2004 */
    PSet_Set(continset, sizeof(continset)/2, '`');     /* really only ` is feasible here */
  }                                               
  time_to_quit = false;
  startexpr = NULL;
  prev_expr = NULL;
  currentchar = NULL;
  zilch = NULL;
  matrix_eval = 0;         /* This is a stack of booleans implemented with an integer. */
  errorpush = false;
  noisy = true;
  laurent = false;
  uglyprint = false;
  ustrcpy(blankone, " ");
  continuation = '`';
  
  ustrcpy(input_file_name, "");
  ustrcpy(output_file_name, "");
  ustrcpy(blank.name, " ");
  ustrcpy(semicolon.name, ";");
  ustrcpy(zero.name, "0");
  ustrcpy(multsign.name, "*");
  ustrcpy(quotsign.name, "/");
  ustrcpy(minussign.name, "-");
  ustrcpy(plussign.name, "+");
  ustrcpy(comma.name, ",");
  ustrcpy(esign.name, "e");
  ustrcpy(empty.name, "");                     /*spar*/
  ustrcpy(concatsign.name, "_");   /* was Ä */
  ustrcpy(logsign.name, "_");
  ustrcpy(sqrtsign.name, "Sqrt");   /* Jun 2004 */
  ustrcpy(expsign.name, "^");
  ustrcpy(greatintsign.name, "$");
  ustrcpy(factsign.name, "!");
  ustrcpy(polysign.name, "J");
  ustrcpy(modoutsign.name, "P");
  ustrcpy(quotesign.name, "\'");
  ustrcpy(bulletsign.name, "#");   /* was the yen sign, ¥ */
  ustrcpy(arr_arrsign.name, "%");  /* new Jun 2003 */
  ustrcpy(diag_sign.name, "Diag");    /* used several places  Jun 2002 */
  ustrcpy(sys_func_tok.name, "<F"); /* Jun 2004 */
  /* the old omega is now ¥ */
  
  sys_func = NULL;
  doing_sys_func = false;
  want_sparse = false;
  modout_above_field = false;
  tripval = 20;  /* Dec 2003 */
  
  timerflag = false;
  dispcutoff = 76;        /* was 64, Sep 2002 */
  
  quol_num_0 = NULL;
  quoly_set(0, &quol_num_0);                      /*spar*/
  quol_num_0->variant.vc_1.ncoef->lint = 0;
  quol_num_1 = NULL;
  quoly_set(1, &quol_num_1);                      /* Jan 2004 */
  quol_num_1->variant.vc_1.ncoef->lint = 1;
  
  endarr = -1;
  first_available = 1;
  addresser = 1;
  detcutoff = -1;
  limit_char_arrays = full_charpol;               /* for Chpoly */
  chpoly_block = true;
  
  base_2_list[0] = 0;
  base_2_list[1] = 3;
  base_2_list[2] = 1;
  base_2_list[3] = 2;
  
  base_3_list[0] = 0;
  base_3_list[1] = 4;
  base_3_list[2] = 1;
  base_3_list[3] = 3;
  base_3_list[4] = 8;
  base_3_list[5] = 5;
  base_3_list[6] = 2;
  
  base_7_list[0] = 0;
  base_7_list[1] = 8;
  base_7_list[2] = 1;
  base_7_list[3] = 7;
  base_7_list[4] = 16;
  base_7_list[5] = 9;
  base_7_list[6] = 2;
  base_7_list[7] = 14;
  base_7_list[8] = 3;
  base_7_list[9] = 10;
  base_7_list[10] = 22;
  base_7_list[11] = 23;	
  base_7_list[12] = 17;
  base_7_list[13] = 24;
  base_7_list[14] = 32;
  base_7_list[15] = 40;
  base_7_list[16] = 31;
  base_7_list[17] = 39;
  base_7_list[18] = 48;
  base_7_list[19] = 41;
  base_7_list[20] = 26;
  
  /* tx = 16777198.0;  test of double and long long. Jul 2003
     ty = 16777198.0;
     ty = tx*ty;
     rmodulus = 16777199.0;
     fprintf(stdout, "%lf\n", ty);
     tz = Trunc(ty / rmodulus);
     tz = Round(ty - tz * rmodulus);
     fprintf(stdout, "tz: %2d\n", tz); 
  
     tll = 16777159;
     tmm = 16747199;
     tll = tll*tmm;
     modulus = 16777199;
     fprintf(stdout, "tll: %2d\n", tll);
     tll = tll / modulus;
     fprintf(stdout, "tll/mod: %2d\n", tll);  */
   
  modulus = -1;
  
  ustrcpy(prompt, ">");
  promptsize = 1;
  
  smallsize = 15;              /* these three decided by experimentation */
  smalldet = 5;                /* July 1998 */
  sizeval = 2600;

  /* colalloc = 0;   Apr 2004 */
  
  Set_prods_for_char();
  command_int = true;
  integerflag = false;
  ustrcpy(leftover, "");
  finish = NULL;
  
  initial_memory = memavail() / 4;   /* will be overridden by ferstartup.  Sep 2003. Jun 2009: should be divided by 4.  As long as load_startup is below,
                                       it will be overwritten, but still, let's be consistent.  */
									 /* Jun2 2009: NOTE: memavail is deined in 220.c, it is not a C function. It depends on totalavailablememory. */
  virtual_cut = memavail() / 5;      /*  20% of the original number of longints
                                         available. prod_size counts longints. Jul 2001 */

  totalavailablememory == -1;    /* default added Aug 2003 */

  load_startup(includepath);  /*AAR-added argument, Aug 2003*/
  
  totalavailablememory = initial_memory * 4;  /* Aug 2004, because initial_memory is in longints */
  
  { unsigned long timetemps[1][2];  /* Feb 2010. note unsigned */
    RecordTime(timetemps,0);
    mytime[0][0] = timetemps[0][0] - mytime[0][0] - time_off[0][0];
    mytime[0][1] = timetemps[0][1] - mytime[0][1] - time_off[0][1];
    time_off[0][0] = 0;
    time_off[0][1] = 0;
  }
  /* AAR
  mytime[0] = (TickCount() - mytime[0]) - time_off[0];
  time_off[0] = 0;
  */

  if (timerflag) {

 /* Feb 2010 new:   fprintf(stdout, "clock:%2u\n", clock()); */

    fprintf(stdout, "\n");                        /* Nov 1996 */
    ReportTime(mytime,0);
    /*  AAR
    fprintf(stdout, " Elapsed time: %ld\n", mytime[1]/1);
    */
  }
  
  Label_9999: fprintf(stdout, "\n");
  
  ustrcpy(leftover, "");
  /* zilch = NULL; */
  
  finish = NULL;
  if (promptsize > 0) {
    fprintf(stdout, "%s", prompt);
    rewind(stdin);

 /*   getc(stdin);  */
/* AAR
    fopen(stdin, "w");
    get(Input);
*/
    for (i = 2; i <= promptsize; ++i) 
      trash = fgetc(stdin);
  } else 
    rewind(stdin);
/* AAR
    fopen(stdin, "w");
*/

  /* prevnum is never nil. sysnum might be at any time. sysnum should always be
     passed by var to any procedure that uses it. */
  while (true) {

ddummy = 0;   /* Sep 2005 */
bozo = 0;  

    warn_cnt = 0;    /* Oct 2011 */
		
		scanner(&Input, &token, &zilch);
    c_cntcount = 0;                               /* Mar 2001 */
    a_cntcount = 0;                               /* Dec 2001 */
    d_cntcount = 0;                               /* Dec 2001 */
    g_cntcount = 0;                               /* Nov 2002 */
    g_cutoff = default_gc;                        /* Nov 2002 */
    uninit = 0;                                   /* Jul 2002 */
    alg_c_count = 0;     /* Mar 2008 */
    original_depth = 1;   /* Feb 2011 */

		RecordTime(mytime,0); /*AAR*/

    xxx = token.name[0];
    if (ustrcmp(token.name, "Diag") == 0)
       xxx = '~';
    if (ustrcmp(token.name, "Trans") == 0)
       xxx = '"';

    switch (xxx) { /* Jun 2003 */
      
      case '!':
      case ';':
        parse(&Input, &sysnum, &zilch);
        break;
      case '~':
      case '[':
      case '"':
        arr_parse(xxx, &Input, &sysnum, &zilch);  /* Jun 2003 */
        break;
      case 'A':
        if (ustrcmp(token.name, "Adjoint") == 0 || ustrcmp(token.name, "Altmult") == 0 ||
	    ustrcmp(token.name, "Altpower") == 0)
          arr_parse('A', &Input, &sysnum, &zilch);
        else 
          old_expre(&Input, &sysnum, &zilch);
        break;
      case 'M':
        if (ustrcmp(token.name, "MPowermod") == 0)   /* Mar 1999 */
          arr_parse('M', &Input, &sysnum, &zilch);
        else 
          old_expre(&Input, &sysnum, &zilch);
        break;
      default:
        parse(&Input, &sysnum, &zilch);   /* Nov 1997 expre(input, sysnum, zilch)*/
        break;
    }
    zilch = NULL;
    /*@@@ zilch may have been changed by error, via myzilch (from QFermat) */
    { unsigned long timetemps[1][2];  /* Feb 2010 note unsigned. */
      RecordTime(timetemps,0);
      mytime[0][0] = timetemps[0][0] - mytime[0][0] - time_off[0][0];
      mytime[0][1] = timetemps[0][1] - mytime[0][1] - time_off[0][1];
      time_off[0][0] = 0;
      time_off[0][1] = 0;
    }
    /*  AAR
    mytime[0] = (TickCount() - mytime[0]) - time_off[0];
    time_off[0] = 0;
    */
    
    if (sysnum == NULL) 
      quoly_set(0, &sysnum);              /* must be done here, before prevnum below */
    if (ustrcmp(token.name, ";") != 0 && ustrcmp(token.name, "¥") != 0 &&
        ustrcmp(token.name, "@") != 0 && ustrcmp(token.name, ":") != 0)
      error(129, &token);
    finish = NULL;
    if (ustrcmp(token.name, ":") != 0) {
      if (syst_dump && noisy && ustrcmp(token.name, "@") != 0)   /*spar*/
        arrdisplay(&Output, true, false, &syst->name, syst, 0, syst->rows, 
                   (syst->stop + 1) / (syst->rows), addresser, addresser, 
                   syst->rows, 4, false, false, true, stash);
      if (extra_line) 
        fprintf(stdout, "\n");
      if (noisy) 
        fflush(stdout);
      dummy = 0;
      if (ustrcmp(token.name, "@") != 0 && noisy) 
        quoly_display(&Output, true, true, true, sysnum, &dummy, &semicolon, 
                      polynames, false, true, false);
      if (polynames == NULL && noisy && extra_line) 
        fprintf(stdout, "\n");
    } else if (extra_line)
      fprintf(stdout, "\n");
    syst_dump = false;

    if (timerflag) {
      ReportTime(mytime,0);
      
 /* Feb 2010 new:   fprintf(stdout, "clock:%2u\n", clock());
		            fprintf(stdout, "time:%u\n", time(0)); */

 /* fprintf(stdout, " p alloc: %ld\n",  palloc); */
 /* clean_up_quoly(); 
   clean_up_poly();  
   if (!lintmode)
     clean_up_imp();   Jun 2006 */

      if (extra_line) 
        fprintf(stdout, "\n");
    }

  /* fprintf(stdout, " ddummy, bozo: %d, %d\n",  ddummy, bozo);  Feb 2011 */

    fflush(stdout);

    free_quoly(&prevnum);
    prevnum = sysnum;           /* prevnum must never be nil or in wrong format */
    /* writeln('totcnt ', totcnt, ' ',c_cntcount,' ',c_cntdepth,a_cntcount,' ',
          a_cntdepth,d_cntcount,' ',d_cntdepth ); Dec 2001  */
    sysnum = NULL;
    if (time_to_quit) {
      time_to_quit = false;
      fprintf(stdout, " You must use \"&q\" to quit the highest level.\n");
    }
 
    if (prompt[0] != (char)13)
      fflush(stdout);
    if (promptsize > 0) {
      fprintf(stdout, "%s", prompt);
      getc(Input);
      for (i = 2; i <= promptsize; ++i) 
        trash = fgetc(stdin);
    } else 
      trash = fgetc(stdin);
  }

  Label_98: fprintf(stdout, "\n");
  fprintf(stdout, " bye\n");
  fflush(stdout);
  return(0); /*AAR -- to quiet insure++*/
}
